/*
 * Vulkan
 *
 * Copyright (c) 2016-2020 Google Inc.
 * Copyright (c) 2016-2020 LunarG, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Author: Christophe <christophe@lunarg.com>
 */

#pragma once

static const char* vuids[] = {
    "VUID-VkAabbPositionsKHR-minX-03546",
    "VUID-VkAabbPositionsKHR-minY-03547",
    "VUID-VkAabbPositionsKHR-minZ-03548",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-commonparent",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-dstAccelerationStructure-parameter",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-flags-parameter",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-pNext-pNext",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-sType-sType",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-sType-unique",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-scratchData-03539",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-scratchData-parameter",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-srcAccelerationStructure-parameter",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-type-parameter",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-update-03537",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-update-03538",
    "VUID-VkAccelerationStructureBuildGeometryInfoKHR-update-03540",
    "VUID-VkAccelerationStructureBuildOffsetInfoKHR-primitiveOffset-03551",
    "VUID-VkAccelerationStructureBuildOffsetInfoKHR-primitiveOffset-03552",
    "VUID-VkAccelerationStructureBuildOffsetInfoKHR-primitiveOffset-03554",
    "VUID-VkAccelerationStructureBuildOffsetInfoKHR-primitiveOffset-03555",
    "VUID-VkAccelerationStructureBuildOffsetInfoKHR-transformOffset-03553",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-geometryType-03501",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-geometryType-03502",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-geometryType-parameter",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-indexType-parameter",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-pNext-pNext",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-sType-sType",
    "VUID-VkAccelerationStructureCreateGeometryTypeInfoKHR-vertexFormat-parameter",
    "VUID-VkAccelerationStructureCreateInfoKHR-compactedSize-02993",
    "VUID-VkAccelerationStructureCreateInfoKHR-compactedSize-03490",
    "VUID-VkAccelerationStructureCreateInfoKHR-deviceAddress-03500",
    "VUID-VkAccelerationStructureCreateInfoKHR-flags-03499",
    "VUID-VkAccelerationStructureCreateInfoKHR-flags-parameter",
    "VUID-VkAccelerationStructureCreateInfoKHR-maxPrimitiveCount-03493",
    "VUID-VkAccelerationStructureCreateInfoKHR-maxPrimitiveCount-03494",
    "VUID-VkAccelerationStructureCreateInfoKHR-pGeometryInfos-parameter",
    "VUID-VkAccelerationStructureCreateInfoKHR-pNext-pNext",
    "VUID-VkAccelerationStructureCreateInfoKHR-sType-sType",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-03491",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-03492",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-03495",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-03496",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-03497",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-03498",
    "VUID-VkAccelerationStructureCreateInfoKHR-type-parameter",
    "VUID-VkAccelerationStructureCreateInfoNV-compactedSize-02421",
    "VUID-VkAccelerationStructureCreateInfoNV-info-parameter",
    "VUID-VkAccelerationStructureCreateInfoNV-pNext-pNext",
    "VUID-VkAccelerationStructureCreateInfoNV-sType-sType",
    "VUID-VkAccelerationStructureDeviceAddressInfoKHR-accelerationStructure-parameter",
    "VUID-VkAccelerationStructureDeviceAddressInfoKHR-pNext-pNext",
    "VUID-VkAccelerationStructureDeviceAddressInfoKHR-sType-sType",
    "VUID-VkAccelerationStructureGeometryAabbsDataKHR-data-03544",
    "VUID-VkAccelerationStructureGeometryAabbsDataKHR-data-parameter",
    "VUID-VkAccelerationStructureGeometryAabbsDataKHR-pNext-pNext",
    "VUID-VkAccelerationStructureGeometryAabbsDataKHR-sType-sType",
    "VUID-VkAccelerationStructureGeometryAabbsDataKHR-stride-03545",
    "VUID-VkAccelerationStructureGeometryInstancesDataKHR-arrayOfPointers-03550",
    "VUID-VkAccelerationStructureGeometryInstancesDataKHR-data-03549",
    "VUID-VkAccelerationStructureGeometryInstancesDataKHR-data-parameter",
    "VUID-VkAccelerationStructureGeometryInstancesDataKHR-pNext-pNext",
    "VUID-VkAccelerationStructureGeometryInstancesDataKHR-sType-sType",
    "VUID-VkAccelerationStructureGeometryKHR-aabbs-parameter",
    "VUID-VkAccelerationStructureGeometryKHR-flags-parameter",
    "VUID-VkAccelerationStructureGeometryKHR-geometryType-03541",
    "VUID-VkAccelerationStructureGeometryKHR-geometryType-03542",
    "VUID-VkAccelerationStructureGeometryKHR-geometryType-03543",
    "VUID-VkAccelerationStructureGeometryKHR-geometryType-parameter",
    "VUID-VkAccelerationStructureGeometryKHR-instances-parameter",
    "VUID-VkAccelerationStructureGeometryKHR-pNext-pNext",
    "VUID-VkAccelerationStructureGeometryKHR-sType-sType",
    "VUID-VkAccelerationStructureGeometryKHR-triangles-parameter",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-indexData-parameter",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-indexType-parameter",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-pNext-pNext",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-sType-sType",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-transformData-parameter",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-vertexData-parameter",
    "VUID-VkAccelerationStructureGeometryTrianglesDataKHR-vertexFormat-parameter",
    "VUID-VkAccelerationStructureInfoNV-flags-02592",
    "VUID-VkAccelerationStructureInfoNV-flags-parameter",
    "VUID-VkAccelerationStructureInfoNV-geometryCount-02422",
    "VUID-VkAccelerationStructureInfoNV-instanceCount-02423",
    "VUID-VkAccelerationStructureInfoNV-instanceData-02782",
    "VUID-VkAccelerationStructureInfoNV-maxTriangleCount-02424",
    "VUID-VkAccelerationStructureInfoNV-pGeometries-parameter",
    "VUID-VkAccelerationStructureInfoNV-pNext-pNext",
    "VUID-VkAccelerationStructureInfoNV-sType-sType",
    "VUID-VkAccelerationStructureInfoNV-scratch-02781",
    "VUID-VkAccelerationStructureInfoNV-type-02425",
    "VUID-VkAccelerationStructureInfoNV-type-02426",
    "VUID-VkAccelerationStructureInfoNV-type-02786",
    "VUID-VkAccelerationStructureInfoNV-type-parameter",
    "VUID-VkAccelerationStructureInstanceKHR-flags-parameter",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoKHR-accelerationStructure-parameter",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoKHR-buildType-parameter",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoKHR-pNext-pNext",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoKHR-sType-sType",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoKHR-type-parameter",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoNV-accelerationStructure-parameter",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoNV-pNext-pNext",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoNV-sType-sType",
    "VUID-VkAccelerationStructureMemoryRequirementsInfoNV-type-parameter",
    "VUID-VkAccelerationStructureVersionKHR-pNext-pNext",
    "VUID-VkAccelerationStructureVersionKHR-sType-sType",
    "VUID-VkAccelerationStructureVersionKHR-versionData-parameter",
    "VUID-VkAcquireNextImageInfoKHR-commonparent",
    "VUID-VkAcquireNextImageInfoKHR-deviceMask-01290",
    "VUID-VkAcquireNextImageInfoKHR-deviceMask-01291",
    "VUID-VkAcquireNextImageInfoKHR-fence-01289",
    "VUID-VkAcquireNextImageInfoKHR-fence-parameter",
    "VUID-VkAcquireNextImageInfoKHR-pNext-pNext",
    "VUID-VkAcquireNextImageInfoKHR-sType-sType",
    "VUID-VkAcquireNextImageInfoKHR-semaphore-01288",
    "VUID-VkAcquireNextImageInfoKHR-semaphore-01781",
    "VUID-VkAcquireNextImageInfoKHR-semaphore-01782",
    "VUID-VkAcquireNextImageInfoKHR-semaphore-03266",
    "VUID-VkAcquireNextImageInfoKHR-semaphore-parameter",
    "VUID-VkAcquireNextImageInfoKHR-swapchain-01675",
    "VUID-VkAcquireNextImageInfoKHR-swapchain-parameter",
    "VUID-VkAcquireProfilingLockInfoKHR-flags-zerobitmask",
    "VUID-VkAcquireProfilingLockInfoKHR-pNext-pNext",
    "VUID-VkAcquireProfilingLockInfoKHR-sType-sType",
    "VUID-VkAllocationCallbacks-pfnAllocation-00632",
    "VUID-VkAllocationCallbacks-pfnFree-00634",
    "VUID-VkAllocationCallbacks-pfnInternalAllocation-00635",
    "VUID-VkAllocationCallbacks-pfnReallocation-00633",
    "VUID-VkAndroidHardwareBufferFormatPropertiesANDROID-sType-sType",
    "VUID-VkAndroidHardwareBufferPropertiesANDROID-pNext-pNext",
    "VUID-VkAndroidHardwareBufferPropertiesANDROID-sType-sType",
    "VUID-VkAndroidHardwareBufferPropertiesANDROID-sType-unique",
    "VUID-VkAndroidHardwareBufferUsageANDROID-sType-sType",
    "VUID-VkAndroidSurfaceCreateInfoKHR-flags-zerobitmask",
    "VUID-VkAndroidSurfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkAndroidSurfaceCreateInfoKHR-sType-sType",
    "VUID-VkAndroidSurfaceCreateInfoKHR-window-01248",
    "VUID-VkApplicationInfo-apiVersion-04010",
    "VUID-VkApplicationInfo-pApplicationName-parameter",
    "VUID-VkApplicationInfo-pEngineName-parameter",
    "VUID-VkApplicationInfo-pNext-pNext",
    "VUID-VkApplicationInfo-sType-sType",
    "VUID-VkAttachmentDescription-finalLayout-00843",
    "VUID-VkAttachmentDescription-finalLayout-parameter",
    "VUID-VkAttachmentDescription-flags-parameter",
    "VUID-VkAttachmentDescription-format-03280",
    "VUID-VkAttachmentDescription-format-03281",
    "VUID-VkAttachmentDescription-format-03282",
    "VUID-VkAttachmentDescription-format-03283",
    "VUID-VkAttachmentDescription-format-03286",
    "VUID-VkAttachmentDescription-format-03287",
    "VUID-VkAttachmentDescription-format-03288",
    "VUID-VkAttachmentDescription-format-03289",
    "VUID-VkAttachmentDescription-format-03290",
    "VUID-VkAttachmentDescription-format-03291",
    "VUID-VkAttachmentDescription-format-03292",
    "VUID-VkAttachmentDescription-format-03293",
    "VUID-VkAttachmentDescription-format-parameter",
    "VUID-VkAttachmentDescription-initialLayout-parameter",
    "VUID-VkAttachmentDescription-loadOp-parameter",
    "VUID-VkAttachmentDescription-samples-parameter",
    "VUID-VkAttachmentDescription-separateDepthStencilLayouts-03284",
    "VUID-VkAttachmentDescription-separateDepthStencilLayouts-03285",
    "VUID-VkAttachmentDescription-stencilLoadOp-parameter",
    "VUID-VkAttachmentDescription-stencilStoreOp-parameter",
    "VUID-VkAttachmentDescription-storeOp-parameter",
    "VUID-VkAttachmentDescription2-finalLayout-03061",
    "VUID-VkAttachmentDescription2-finalLayout-parameter",
    "VUID-VkAttachmentDescription2-flags-parameter",
    "VUID-VkAttachmentDescription2-format-03294",
    "VUID-VkAttachmentDescription2-format-03295",
    "VUID-VkAttachmentDescription2-format-03296",
    "VUID-VkAttachmentDescription2-format-03297",
    "VUID-VkAttachmentDescription2-format-03300",
    "VUID-VkAttachmentDescription2-format-03301",
    "VUID-VkAttachmentDescription2-format-03302",
    "VUID-VkAttachmentDescription2-format-03303",
    "VUID-VkAttachmentDescription2-format-03304",
    "VUID-VkAttachmentDescription2-format-03305",
    "VUID-VkAttachmentDescription2-format-03306",
    "VUID-VkAttachmentDescription2-format-03307",
    "VUID-VkAttachmentDescription2-format-parameter",
    "VUID-VkAttachmentDescription2-initialLayout-parameter",
    "VUID-VkAttachmentDescription2-loadOp-parameter",
    "VUID-VkAttachmentDescription2-sType-sType",
    "VUID-VkAttachmentDescription2-samples-parameter",
    "VUID-VkAttachmentDescription2-separateDepthStencilLayouts-03298",
    "VUID-VkAttachmentDescription2-separateDepthStencilLayouts-03299",
    "VUID-VkAttachmentDescription2-stencilLoadOp-parameter",
    "VUID-VkAttachmentDescription2-stencilStoreOp-parameter",
    "VUID-VkAttachmentDescription2-storeOp-parameter",
    "VUID-VkAttachmentDescriptionStencilLayout-sType-sType",
    "VUID-VkAttachmentDescriptionStencilLayout-stencilFinalLayout-03309",
    "VUID-VkAttachmentDescriptionStencilLayout-stencilFinalLayout-03310",
    "VUID-VkAttachmentDescriptionStencilLayout-stencilFinalLayout-parameter",
    "VUID-VkAttachmentDescriptionStencilLayout-stencilInitialLayout-03308",
    "VUID-VkAttachmentDescriptionStencilLayout-stencilInitialLayout-parameter",
    "VUID-VkAttachmentReference-layout-00857",
    "VUID-VkAttachmentReference-layout-parameter",
    "VUID-VkAttachmentReference2-attachment-03311",
    "VUID-VkAttachmentReference2-attachment-03312",
    "VUID-VkAttachmentReference2-attachment-03314",
    "VUID-VkAttachmentReference2-attachment-03315",
    "VUID-VkAttachmentReference2-attachment-03316",
    "VUID-VkAttachmentReference2-attachment-03317",
    "VUID-VkAttachmentReference2-layout-03077",
    "VUID-VkAttachmentReference2-layout-parameter",
    "VUID-VkAttachmentReference2-sType-sType",
    "VUID-VkAttachmentReference2-separateDepthStencilLayouts-03313",
    "VUID-VkAttachmentReferenceStencilLayout-sType-sType",
    "VUID-VkAttachmentReferenceStencilLayout-stencilLayout-03318",
    "VUID-VkAttachmentReferenceStencilLayout-stencilLayout-parameter",
    "VUID-VkAttachmentSampleLocationsEXT-attachmentIndex-01531",
    "VUID-VkAttachmentSampleLocationsEXT-sampleLocationsInfo-parameter",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-accelerationStructure-02450",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-accelerationStructure-parameter",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-commonparent",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-memory-02593",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-memory-parameter",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-memoryOffset-02451",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-memoryOffset-02594",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-pDeviceIndices-parameter",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-pNext-pNext",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-sType-sType",
    "VUID-VkBindAccelerationStructureMemoryInfoKHR-size-02595",
    "VUID-VkBindBufferMemoryDeviceGroupInfo-deviceIndexCount-01606",
    "VUID-VkBindBufferMemoryDeviceGroupInfo-pDeviceIndices-01607",
    "VUID-VkBindBufferMemoryDeviceGroupInfo-pDeviceIndices-parameter",
    "VUID-VkBindBufferMemoryDeviceGroupInfo-sType-sType",
    "VUID-VkBindBufferMemoryInfo-buffer-01593",
    "VUID-VkBindBufferMemoryInfo-buffer-01594",
    "VUID-VkBindBufferMemoryInfo-buffer-01602",
    "VUID-VkBindBufferMemoryInfo-buffer-01603",
    "VUID-VkBindBufferMemoryInfo-buffer-01604",
    "VUID-VkBindBufferMemoryInfo-buffer-parameter",
    "VUID-VkBindBufferMemoryInfo-bufferDeviceAddress-02838",
    "VUID-VkBindBufferMemoryInfo-commonparent",
    "VUID-VkBindBufferMemoryInfo-handleTypes-02791",
    "VUID-VkBindBufferMemoryInfo-memory-01599",
    "VUID-VkBindBufferMemoryInfo-memory-01900",
    "VUID-VkBindBufferMemoryInfo-memory-02792",
    "VUID-VkBindBufferMemoryInfo-memory-02987",
    "VUID-VkBindBufferMemoryInfo-memory-02988",
    "VUID-VkBindBufferMemoryInfo-memory-parameter",
    "VUID-VkBindBufferMemoryInfo-memoryOffset-01595",
    "VUID-VkBindBufferMemoryInfo-memoryOffset-01600",
    "VUID-VkBindBufferMemoryInfo-pNext-01605",
    "VUID-VkBindBufferMemoryInfo-pNext-pNext",
    "VUID-VkBindBufferMemoryInfo-sType-sType",
    "VUID-VkBindBufferMemoryInfo-sType-unique",
    "VUID-VkBindBufferMemoryInfo-size-01601",
    "VUID-VkBindImageMemoryDeviceGroupInfo-deviceIndexCount-01633",
    "VUID-VkBindImageMemoryDeviceGroupInfo-deviceIndexCount-01634",
    "VUID-VkBindImageMemoryDeviceGroupInfo-extent-01640",
    "VUID-VkBindImageMemoryDeviceGroupInfo-extent-01641",
    "VUID-VkBindImageMemoryDeviceGroupInfo-offset-01638",
    "VUID-VkBindImageMemoryDeviceGroupInfo-offset-01639",
    "VUID-VkBindImageMemoryDeviceGroupInfo-pDeviceIndices-01635",
    "VUID-VkBindImageMemoryDeviceGroupInfo-pDeviceIndices-parameter",
    "VUID-VkBindImageMemoryDeviceGroupInfo-pSplitInstanceBindRegions-01637",
    "VUID-VkBindImageMemoryDeviceGroupInfo-pSplitInstanceBindRegions-parameter",
    "VUID-VkBindImageMemoryDeviceGroupInfo-sType-sType",
    "VUID-VkBindImageMemoryDeviceGroupInfo-splitInstanceBindRegionCount-01636",
    "VUID-VkBindImageMemoryInfo-commonparent",
    "VUID-VkBindImageMemoryInfo-handleTypes-02793",
    "VUID-VkBindImageMemoryInfo-image-01609",
    "VUID-VkBindImageMemoryInfo-image-01610",
    "VUID-VkBindImageMemoryInfo-image-01622",
    "VUID-VkBindImageMemoryInfo-image-01623",
    "VUID-VkBindImageMemoryInfo-image-01624",
    "VUID-VkBindImageMemoryInfo-image-01630",
    "VUID-VkBindImageMemoryInfo-image-parameter",
    "VUID-VkBindImageMemoryInfo-memory-01612",
    "VUID-VkBindImageMemoryInfo-memory-01614",
    "VUID-VkBindImageMemoryInfo-memory-01625",
    "VUID-VkBindImageMemoryInfo-memory-01903",
    "VUID-VkBindImageMemoryInfo-memory-02630",
    "VUID-VkBindImageMemoryInfo-memory-02631",
    "VUID-VkBindImageMemoryInfo-memory-02794",
    "VUID-VkBindImageMemoryInfo-memory-02991",
    "VUID-VkBindImageMemoryInfo-memory-02992",
    "VUID-VkBindImageMemoryInfo-memoryOffset-01611",
    "VUID-VkBindImageMemoryInfo-memoryOffset-01613",
    "VUID-VkBindImageMemoryInfo-pNext-01615",
    "VUID-VkBindImageMemoryInfo-pNext-01616",
    "VUID-VkBindImageMemoryInfo-pNext-01617",
    "VUID-VkBindImageMemoryInfo-pNext-01618",
    "VUID-VkBindImageMemoryInfo-pNext-01619",
    "VUID-VkBindImageMemoryInfo-pNext-01620",
    "VUID-VkBindImageMemoryInfo-pNext-01621",
    "VUID-VkBindImageMemoryInfo-pNext-01626",
    "VUID-VkBindImageMemoryInfo-pNext-01627",
    "VUID-VkBindImageMemoryInfo-pNext-01628",
    "VUID-VkBindImageMemoryInfo-pNext-01629",
    "VUID-VkBindImageMemoryInfo-pNext-01631",
    "VUID-VkBindImageMemoryInfo-pNext-01632",
    "VUID-VkBindImageMemoryInfo-pNext-pNext",
    "VUID-VkBindImageMemoryInfo-sType-sType",
    "VUID-VkBindImageMemoryInfo-sType-unique",
    "VUID-VkBindImageMemorySwapchainInfoKHR-imageIndex-01644",
    "VUID-VkBindImageMemorySwapchainInfoKHR-sType-sType",
    "VUID-VkBindImageMemorySwapchainInfoKHR-swapchain-parameter",
    "VUID-VkBindImagePlaneMemoryInfo-planeAspect-02283",
    "VUID-VkBindImagePlaneMemoryInfo-planeAspect-02284",
    "VUID-VkBindImagePlaneMemoryInfo-planeAspect-parameter",
    "VUID-VkBindImagePlaneMemoryInfo-sType-sType",
    "VUID-VkBindIndexBufferIndirectCommandNV-None-02946",
    "VUID-VkBindIndexBufferIndirectCommandNV-None-02948",
    "VUID-VkBindIndexBufferIndirectCommandNV-bufferAddress-02947",
    "VUID-VkBindIndexBufferIndirectCommandNV-indexType-parameter",
    "VUID-VkBindShaderGroupIndirectCommandNV-None-02944",
    "VUID-VkBindShaderGroupIndirectCommandNV-index-02945",
    "VUID-VkBindSparseInfo-commonparent",
    "VUID-VkBindSparseInfo-pBufferBinds-parameter",
    "VUID-VkBindSparseInfo-pImageBinds-parameter",
    "VUID-VkBindSparseInfo-pImageOpaqueBinds-parameter",
    "VUID-VkBindSparseInfo-pNext-03247",
    "VUID-VkBindSparseInfo-pNext-03248",
    "VUID-VkBindSparseInfo-pNext-pNext",
    "VUID-VkBindSparseInfo-pSignalSemaphores-03249",
    "VUID-VkBindSparseInfo-pSignalSemaphores-03251",
    "VUID-VkBindSparseInfo-pSignalSemaphores-parameter",
    "VUID-VkBindSparseInfo-pWaitSemaphores-03246",
    "VUID-VkBindSparseInfo-pWaitSemaphores-03250",
    "VUID-VkBindSparseInfo-pWaitSemaphores-parameter",
    "VUID-VkBindSparseInfo-sType-sType",
    "VUID-VkBindSparseInfo-sType-unique",
    "VUID-VkBindVertexBufferIndirectCommandNV-None-02949",
    "VUID-VkBindVertexBufferIndirectCommandNV-None-02950",
    "VUID-VkBufferCopy-size-01988",
    "VUID-VkBufferCreateInfo-None-01888",
    "VUID-VkBufferCreateInfo-deviceAddress-02604",
    "VUID-VkBufferCreateInfo-flags-00915",
    "VUID-VkBufferCreateInfo-flags-00916",
    "VUID-VkBufferCreateInfo-flags-00917",
    "VUID-VkBufferCreateInfo-flags-00918",
    "VUID-VkBufferCreateInfo-flags-01887",
    "VUID-VkBufferCreateInfo-flags-03338",
    "VUID-VkBufferCreateInfo-flags-parameter",
    "VUID-VkBufferCreateInfo-opaqueCaptureAddress-03337",
    "VUID-VkBufferCreateInfo-pNext-00920",
    "VUID-VkBufferCreateInfo-pNext-01571",
    "VUID-VkBufferCreateInfo-pNext-pNext",
    "VUID-VkBufferCreateInfo-sType-sType",
    "VUID-VkBufferCreateInfo-sType-unique",
    "VUID-VkBufferCreateInfo-sharingMode-00913",
    "VUID-VkBufferCreateInfo-sharingMode-00914",
    "VUID-VkBufferCreateInfo-sharingMode-01391",
    "VUID-VkBufferCreateInfo-sharingMode-01419",
    "VUID-VkBufferCreateInfo-sharingMode-parameter",
    "VUID-VkBufferCreateInfo-size-00912",
    "VUID-VkBufferCreateInfo-usage-parameter",
    "VUID-VkBufferCreateInfo-usage-requiredbitmask",
    "VUID-VkBufferDeviceAddressCreateInfoEXT-sType-sType",
    "VUID-VkBufferDeviceAddressInfo-buffer-02600",
    "VUID-VkBufferDeviceAddressInfo-buffer-02601",
    "VUID-VkBufferDeviceAddressInfo-buffer-parameter",
    "VUID-VkBufferDeviceAddressInfo-pNext-pNext",
    "VUID-VkBufferDeviceAddressInfo-sType-sType",
    "VUID-VkBufferImageCopy-None-00214",
    "VUID-VkBufferImageCopy-None-01735",
    "VUID-VkBufferImageCopy-None-01736",
    "VUID-VkBufferImageCopy-None-01737",
    "VUID-VkBufferImageCopy-None-01738",
    "VUID-VkBufferImageCopy-None-01739",
    "VUID-VkBufferImageCopy-None-01740",
    "VUID-VkBufferImageCopy-None-01741",
    "VUID-VkBufferImageCopy-aspectMask-00211",
    "VUID-VkBufferImageCopy-aspectMask-00212",
    "VUID-VkBufferImageCopy-aspectMask-01560",
    "VUID-VkBufferImageCopy-baseArrayLayer-00213",
    "VUID-VkBufferImageCopy-bufferImageHeight-00196",
    "VUID-VkBufferImageCopy-bufferImageHeight-00204",
    "VUID-VkBufferImageCopy-bufferOffset-00193",
    "VUID-VkBufferImageCopy-bufferOffset-00206",
    "VUID-VkBufferImageCopy-bufferOffset-01558",
    "VUID-VkBufferImageCopy-bufferOffset-01559",
    "VUID-VkBufferImageCopy-bufferRowLength-00195",
    "VUID-VkBufferImageCopy-bufferRowLength-00203",
    "VUID-VkBufferImageCopy-imageExtent-00207",
    "VUID-VkBufferImageCopy-imageExtent-00208",
    "VUID-VkBufferImageCopy-imageExtent-00209",
    "VUID-VkBufferImageCopy-imageOffset-00197",
    "VUID-VkBufferImageCopy-imageOffset-00198",
    "VUID-VkBufferImageCopy-imageOffset-00200",
    "VUID-VkBufferImageCopy-imageOffset-00205",
    "VUID-VkBufferImageCopy-imageSubresource-parameter",
    "VUID-VkBufferImageCopy-srcImage-00199",
    "VUID-VkBufferImageCopy-srcImage-00201",
    "VUID-VkBufferMemoryBarrier-buffer-01190",
    "VUID-VkBufferMemoryBarrier-buffer-01191",
    "VUID-VkBufferMemoryBarrier-buffer-01931",
    "VUID-VkBufferMemoryBarrier-buffer-04086",
    "VUID-VkBufferMemoryBarrier-buffer-04088",
    "VUID-VkBufferMemoryBarrier-buffer-04089",
    "VUID-VkBufferMemoryBarrier-buffer-parameter",
    "VUID-VkBufferMemoryBarrier-offset-01187",
    "VUID-VkBufferMemoryBarrier-pNext-pNext",
    "VUID-VkBufferMemoryBarrier-sType-sType",
    "VUID-VkBufferMemoryBarrier-size-01188",
    "VUID-VkBufferMemoryBarrier-size-01189",
    "VUID-VkBufferMemoryBarrier-srcQueueFamilyIndex-04087",
    "VUID-VkBufferMemoryRequirementsInfo2-buffer-04005",
    "VUID-VkBufferMemoryRequirementsInfo2-buffer-parameter",
    "VUID-VkBufferMemoryRequirementsInfo2-pNext-pNext",
    "VUID-VkBufferMemoryRequirementsInfo2-sType-sType",
    "VUID-VkBufferOpaqueCaptureAddressCreateInfo-sType-sType",
    "VUID-VkBufferViewCreateInfo-buffer-00932",
    "VUID-VkBufferViewCreateInfo-buffer-00933",
    "VUID-VkBufferViewCreateInfo-buffer-00934",
    "VUID-VkBufferViewCreateInfo-buffer-00935",
    "VUID-VkBufferViewCreateInfo-buffer-02750",
    "VUID-VkBufferViewCreateInfo-buffer-02751",
    "VUID-VkBufferViewCreateInfo-buffer-parameter",
    "VUID-VkBufferViewCreateInfo-flags-zerobitmask",
    "VUID-VkBufferViewCreateInfo-format-parameter",
    "VUID-VkBufferViewCreateInfo-offset-00925",
    "VUID-VkBufferViewCreateInfo-offset-00926",
    "VUID-VkBufferViewCreateInfo-offset-00931",
    "VUID-VkBufferViewCreateInfo-offset-02749",
    "VUID-VkBufferViewCreateInfo-pNext-pNext",
    "VUID-VkBufferViewCreateInfo-range-00928",
    "VUID-VkBufferViewCreateInfo-range-00929",
    "VUID-VkBufferViewCreateInfo-range-00930",
    "VUID-VkBufferViewCreateInfo-range-04059",
    "VUID-VkBufferViewCreateInfo-sType-sType",
    "VUID-VkCalibratedTimestampInfoEXT-pNext-pNext",
    "VUID-VkCalibratedTimestampInfoEXT-sType-sType",
    "VUID-VkCalibratedTimestampInfoEXT-timeDomain-02354",
    "VUID-VkCalibratedTimestampInfoEXT-timeDomain-parameter",
    "VUID-VkCheckpointDataNV-pNext-pNext",
    "VUID-VkCheckpointDataNV-sType-sType",
    "VUID-VkClearAttachment-aspectMask-00019",
    "VUID-VkClearAttachment-aspectMask-00020",
    "VUID-VkClearAttachment-aspectMask-02246",
    "VUID-VkClearAttachment-aspectMask-parameter",
    "VUID-VkClearAttachment-aspectMask-requiredbitmask",
    "VUID-VkClearAttachment-clearValue-00021",
    "VUID-VkClearDepthStencilValue-depth-00022",
    "VUID-VkClearDepthStencilValue-depth-02506",
    "VUID-VkCoarseSampleLocationNV-pixelX-02078",
    "VUID-VkCoarseSampleLocationNV-pixelY-02079",
    "VUID-VkCoarseSampleLocationNV-sample-02080",
    "VUID-VkCoarseSampleOrderCustomNV-pSampleLocations-02077",
    "VUID-VkCoarseSampleOrderCustomNV-pSampleLocations-parameter",
    "VUID-VkCoarseSampleOrderCustomNV-sampleCount-02074",
    "VUID-VkCoarseSampleOrderCustomNV-sampleLocationCount-02075",
    "VUID-VkCoarseSampleOrderCustomNV-sampleLocationCount-02076",
    "VUID-VkCoarseSampleOrderCustomNV-sampleLocationCount-arraylength",
    "VUID-VkCoarseSampleOrderCustomNV-shadingRate-02073",
    "VUID-VkCoarseSampleOrderCustomNV-shadingRate-parameter",
    "VUID-VkCommandBufferAllocateInfo-commandBufferCount-00044",
    "VUID-VkCommandBufferAllocateInfo-commandPool-parameter",
    "VUID-VkCommandBufferAllocateInfo-level-parameter",
    "VUID-VkCommandBufferAllocateInfo-pNext-pNext",
    "VUID-VkCommandBufferAllocateInfo-sType-sType",
    "VUID-VkCommandBufferBeginInfo-flags-00053",
    "VUID-VkCommandBufferBeginInfo-flags-00054",
    "VUID-VkCommandBufferBeginInfo-flags-00055",
    "VUID-VkCommandBufferBeginInfo-flags-parameter",
    "VUID-VkCommandBufferBeginInfo-pNext-pNext",
    "VUID-VkCommandBufferBeginInfo-sType-sType",
    "VUID-VkCommandBufferBeginInfo-sType-unique",
    "VUID-VkCommandBufferInheritanceConditionalRenderingInfoEXT-conditionalRenderingEnable-01977",
    "VUID-VkCommandBufferInheritanceConditionalRenderingInfoEXT-sType-sType",
    "VUID-VkCommandBufferInheritanceInfo-commonparent",
    "VUID-VkCommandBufferInheritanceInfo-occlusionQueryEnable-00056",
    "VUID-VkCommandBufferInheritanceInfo-pNext-pNext",
    "VUID-VkCommandBufferInheritanceInfo-pipelineStatistics-00058",
    "VUID-VkCommandBufferInheritanceInfo-pipelineStatistics-02789",
    "VUID-VkCommandBufferInheritanceInfo-queryFlags-00057",
    "VUID-VkCommandBufferInheritanceInfo-queryFlags-02788",
    "VUID-VkCommandBufferInheritanceInfo-sType-sType",
    "VUID-VkCommandBufferInheritanceInfo-sType-unique",
    "VUID-VkCommandBufferInheritanceRenderPassTransformInfoQCOM-sType-sType",
    "VUID-VkCommandBufferInheritanceRenderPassTransformInfoQCOM-transform-02864",
    "VUID-VkCommandPoolCreateInfo-flags-02860",
    "VUID-VkCommandPoolCreateInfo-flags-parameter",
    "VUID-VkCommandPoolCreateInfo-pNext-pNext",
    "VUID-VkCommandPoolCreateInfo-sType-sType",
    "VUID-VkComponentMapping-a-parameter",
    "VUID-VkComponentMapping-b-parameter",
    "VUID-VkComponentMapping-g-parameter",
    "VUID-VkComponentMapping-r-parameter",
    "VUID-VkComputePipelineCreateInfo-commonparent",
    "VUID-VkComputePipelineCreateInfo-flags-00697",
    "VUID-VkComputePipelineCreateInfo-flags-00698",
    "VUID-VkComputePipelineCreateInfo-flags-00699",
    "VUID-VkComputePipelineCreateInfo-flags-00700",
    "VUID-VkComputePipelineCreateInfo-flags-02874",
    "VUID-VkComputePipelineCreateInfo-flags-03364",
    "VUID-VkComputePipelineCreateInfo-flags-03365",
    "VUID-VkComputePipelineCreateInfo-flags-03366",
    "VUID-VkComputePipelineCreateInfo-flags-03367",
    "VUID-VkComputePipelineCreateInfo-flags-03368",
    "VUID-VkComputePipelineCreateInfo-flags-03369",
    "VUID-VkComputePipelineCreateInfo-flags-03370",
    "VUID-VkComputePipelineCreateInfo-flags-parameter",
    "VUID-VkComputePipelineCreateInfo-layout-00703",
    "VUID-VkComputePipelineCreateInfo-layout-01687",
    "VUID-VkComputePipelineCreateInfo-layout-parameter",
    "VUID-VkComputePipelineCreateInfo-pNext-pNext",
    "VUID-VkComputePipelineCreateInfo-pipelineCreationCacheControl-02875",
    "VUID-VkComputePipelineCreateInfo-sType-sType",
    "VUID-VkComputePipelineCreateInfo-sType-unique",
    "VUID-VkComputePipelineCreateInfo-stage-00701",
    "VUID-VkComputePipelineCreateInfo-stage-00702",
    "VUID-VkComputePipelineCreateInfo-stage-parameter",
    "VUID-VkConditionalRenderingBeginInfoEXT-buffer-01981",
    "VUID-VkConditionalRenderingBeginInfoEXT-buffer-01982",
    "VUID-VkConditionalRenderingBeginInfoEXT-buffer-parameter",
    "VUID-VkConditionalRenderingBeginInfoEXT-flags-parameter",
    "VUID-VkConditionalRenderingBeginInfoEXT-offset-01983",
    "VUID-VkConditionalRenderingBeginInfoEXT-offset-01984",
    "VUID-VkConditionalRenderingBeginInfoEXT-pNext-pNext",
    "VUID-VkConditionalRenderingBeginInfoEXT-sType-sType",
    "VUID-VkCooperativeMatrixPropertiesNV-AType-parameter",
    "VUID-VkCooperativeMatrixPropertiesNV-BType-parameter",
    "VUID-VkCooperativeMatrixPropertiesNV-CType-parameter",
    "VUID-VkCooperativeMatrixPropertiesNV-DType-parameter",
    "VUID-VkCooperativeMatrixPropertiesNV-pNext-pNext",
    "VUID-VkCooperativeMatrixPropertiesNV-sType-sType",
    "VUID-VkCooperativeMatrixPropertiesNV-scope-parameter",
    "VUID-VkCopyAccelerationStructureInfoKHR-commonparent",
    "VUID-VkCopyAccelerationStructureInfoKHR-dst-parameter",
    "VUID-VkCopyAccelerationStructureInfoKHR-mode-03410",
    "VUID-VkCopyAccelerationStructureInfoKHR-mode-parameter",
    "VUID-VkCopyAccelerationStructureInfoKHR-pNext-pNext",
    "VUID-VkCopyAccelerationStructureInfoKHR-sType-sType",
    "VUID-VkCopyAccelerationStructureInfoKHR-sType-unique",
    "VUID-VkCopyAccelerationStructureInfoKHR-src-03411",
    "VUID-VkCopyAccelerationStructureInfoKHR-src-parameter",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-dst-03561",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-dst-parameter",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-mode-03412",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-mode-parameter",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-pNext-pNext",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-sType-sType",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-sType-unique",
    "VUID-VkCopyAccelerationStructureToMemoryInfoKHR-src-parameter",
    "VUID-VkCopyDescriptorSet-commonparent",
    "VUID-VkCopyDescriptorSet-dstArrayElement-00348",
    "VUID-VkCopyDescriptorSet-dstBinding-00347",
    "VUID-VkCopyDescriptorSet-dstBinding-02224",
    "VUID-VkCopyDescriptorSet-dstBinding-02632",
    "VUID-VkCopyDescriptorSet-dstBinding-02753",
    "VUID-VkCopyDescriptorSet-dstSet-parameter",
    "VUID-VkCopyDescriptorSet-pNext-pNext",
    "VUID-VkCopyDescriptorSet-sType-sType",
    "VUID-VkCopyDescriptorSet-srcArrayElement-00346",
    "VUID-VkCopyDescriptorSet-srcBinding-00345",
    "VUID-VkCopyDescriptorSet-srcBinding-02223",
    "VUID-VkCopyDescriptorSet-srcBinding-02225",
    "VUID-VkCopyDescriptorSet-srcSet-00349",
    "VUID-VkCopyDescriptorSet-srcSet-01918",
    "VUID-VkCopyDescriptorSet-srcSet-01919",
    "VUID-VkCopyDescriptorSet-srcSet-01920",
    "VUID-VkCopyDescriptorSet-srcSet-01921",
    "VUID-VkCopyDescriptorSet-srcSet-parameter",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-dst-parameter",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-mode-03413",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-mode-parameter",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-pInfo-03414",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-pNext-pNext",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-sType-sType",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-sType-unique",
    "VUID-VkCopyMemoryToAccelerationStructureInfoKHR-src-parameter",
    "VUID-VkD3D12FenceSubmitInfoKHR-pSignalSemaphoreValues-parameter",
    "VUID-VkD3D12FenceSubmitInfoKHR-pWaitSemaphoreValues-parameter",
    "VUID-VkD3D12FenceSubmitInfoKHR-sType-sType",
    "VUID-VkD3D12FenceSubmitInfoKHR-signalSemaphoreValuesCount-00080",
    "VUID-VkD3D12FenceSubmitInfoKHR-waitSemaphoreValuesCount-00079",
    "VUID-VkDebugMarkerMarkerInfoEXT-pMarkerName-parameter",
    "VUID-VkDebugMarkerMarkerInfoEXT-pNext-pNext",
    "VUID-VkDebugMarkerMarkerInfoEXT-sType-sType",
    "VUID-VkDebugMarkerObjectNameInfoEXT-object-01491",
    "VUID-VkDebugMarkerObjectNameInfoEXT-object-01492",
    "VUID-VkDebugMarkerObjectNameInfoEXT-objectType-01490",
    "VUID-VkDebugMarkerObjectNameInfoEXT-objectType-parameter",
    "VUID-VkDebugMarkerObjectNameInfoEXT-pNext-pNext",
    "VUID-VkDebugMarkerObjectNameInfoEXT-pObjectName-parameter",
    "VUID-VkDebugMarkerObjectNameInfoEXT-sType-sType",
    "VUID-VkDebugMarkerObjectTagInfoEXT-object-01494",
    "VUID-VkDebugMarkerObjectTagInfoEXT-object-01495",
    "VUID-VkDebugMarkerObjectTagInfoEXT-objectType-01493",
    "VUID-VkDebugMarkerObjectTagInfoEXT-objectType-parameter",
    "VUID-VkDebugMarkerObjectTagInfoEXT-pNext-pNext",
    "VUID-VkDebugMarkerObjectTagInfoEXT-pTag-parameter",
    "VUID-VkDebugMarkerObjectTagInfoEXT-sType-sType",
    "VUID-VkDebugMarkerObjectTagInfoEXT-tagSize-arraylength",
    "VUID-VkDebugReportCallbackCreateInfoEXT-flags-parameter",
    "VUID-VkDebugReportCallbackCreateInfoEXT-pfnCallback-parameter",
    "VUID-VkDebugReportCallbackCreateInfoEXT-sType-sType",
    "VUID-VkDebugUtilsLabelEXT-pLabelName-parameter",
    "VUID-VkDebugUtilsLabelEXT-pNext-pNext",
    "VUID-VkDebugUtilsLabelEXT-sType-sType",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-flags-zerobitmask",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-pCmdBufLabels-parameter",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-pMessage-parameter",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-pMessageIdName-parameter",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-pNext-pNext",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-pObjects-parameter",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-pQueueLabels-parameter",
    "VUID-VkDebugUtilsMessengerCallbackDataEXT-sType-sType",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-flags-zerobitmask",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-messageSeverity-parameter",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-messageSeverity-requiredbitmask",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-messageType-parameter",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-messageType-requiredbitmask",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-pfnUserCallback-01914",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-pfnUserCallback-parameter",
    "VUID-VkDebugUtilsMessengerCreateInfoEXT-sType-sType",
    "VUID-VkDebugUtilsObjectNameInfoEXT-objectType-02589",
    "VUID-VkDebugUtilsObjectNameInfoEXT-objectType-02590",
    "VUID-VkDebugUtilsObjectNameInfoEXT-objectType-parameter",
    "VUID-VkDebugUtilsObjectNameInfoEXT-pNext-pNext",
    "VUID-VkDebugUtilsObjectNameInfoEXT-pObjectName-parameter",
    "VUID-VkDebugUtilsObjectNameInfoEXT-sType-sType",
    "VUID-VkDebugUtilsObjectTagInfoEXT-objectHandle-01910",
    "VUID-VkDebugUtilsObjectTagInfoEXT-objectType-01908",
    "VUID-VkDebugUtilsObjectTagInfoEXT-objectType-parameter",
    "VUID-VkDebugUtilsObjectTagInfoEXT-pNext-pNext",
    "VUID-VkDebugUtilsObjectTagInfoEXT-pTag-parameter",
    "VUID-VkDebugUtilsObjectTagInfoEXT-sType-sType",
    "VUID-VkDebugUtilsObjectTagInfoEXT-tagSize-arraylength",
    "VUID-VkDedicatedAllocationBufferCreateInfoNV-sType-sType",
    "VUID-VkDedicatedAllocationImageCreateInfoNV-dedicatedAllocation-00994",
    "VUID-VkDedicatedAllocationImageCreateInfoNV-sType-sType",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-buffer-00651",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-buffer-00653",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-buffer-00655",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-buffer-parameter",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-commonparent",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-image-00649",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-image-00650",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-image-00652",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-image-00654",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-image-parameter",
    "VUID-VkDedicatedAllocationMemoryAllocateInfoNV-sType-sType",
    "VUID-VkDeferredOperationInfoKHR-operationHandle-03433",
    "VUID-VkDeferredOperationInfoKHR-sType-sType",
    "VUID-VkDescriptorBufferInfo-buffer-02998",
    "VUID-VkDescriptorBufferInfo-buffer-02999",
    "VUID-VkDescriptorBufferInfo-buffer-parameter",
    "VUID-VkDescriptorBufferInfo-offset-00340",
    "VUID-VkDescriptorBufferInfo-range-00341",
    "VUID-VkDescriptorBufferInfo-range-00342",
    "VUID-VkDescriptorImageInfo-commonparent",
    "VUID-VkDescriptorImageInfo-imageLayout-00344",
    "VUID-VkDescriptorImageInfo-imageView-00343",
    "VUID-VkDescriptorImageInfo-imageView-01976",
    "VUID-VkDescriptorImageInfo-sampler-01564",
    "VUID-VkDescriptorPoolCreateInfo-flags-parameter",
    "VUID-VkDescriptorPoolCreateInfo-maxSets-00301",
    "VUID-VkDescriptorPoolCreateInfo-pNext-pNext",
    "VUID-VkDescriptorPoolCreateInfo-pPoolSizes-parameter",
    "VUID-VkDescriptorPoolCreateInfo-poolSizeCount-arraylength",
    "VUID-VkDescriptorPoolCreateInfo-sType-sType",
    "VUID-VkDescriptorPoolCreateInfo-sType-unique",
    "VUID-VkDescriptorPoolInlineUniformBlockCreateInfoEXT-sType-sType",
    "VUID-VkDescriptorPoolSize-descriptorCount-00302",
    "VUID-VkDescriptorPoolSize-type-02218",
    "VUID-VkDescriptorPoolSize-type-parameter",
    "VUID-VkDescriptorSetAllocateInfo-commonparent",
    "VUID-VkDescriptorSetAllocateInfo-descriptorPool-00307",
    "VUID-VkDescriptorSetAllocateInfo-descriptorPool-parameter",
    "VUID-VkDescriptorSetAllocateInfo-descriptorSetCount-00306",
    "VUID-VkDescriptorSetAllocateInfo-descriptorSetCount-arraylength",
    "VUID-VkDescriptorSetAllocateInfo-pNext-pNext",
    "VUID-VkDescriptorSetAllocateInfo-pSetLayouts-00308",
    "VUID-VkDescriptorSetAllocateInfo-pSetLayouts-03044",
    "VUID-VkDescriptorSetAllocateInfo-pSetLayouts-parameter",
    "VUID-VkDescriptorSetAllocateInfo-sType-sType",
    "VUID-VkDescriptorSetAllocateInfo-sType-unique",
    "VUID-VkDescriptorSetLayoutBinding-descriptorCount-00283",
    "VUID-VkDescriptorSetLayoutBinding-descriptorType-00282",
    "VUID-VkDescriptorSetLayoutBinding-descriptorType-01510",
    "VUID-VkDescriptorSetLayoutBinding-descriptorType-02209",
    "VUID-VkDescriptorSetLayoutBinding-descriptorType-02210",
    "VUID-VkDescriptorSetLayoutBinding-descriptorType-parameter",
    "VUID-VkDescriptorSetLayoutBinding-pImmutableSamplers-04009",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-None-03011",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-bindingCount-03002",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingInlineUniformBlockUpdateAfterBind-02211",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingPartiallyBound-03013",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingSampledImageUpdateAfterBind-03006",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingStorageBufferUpdateAfterBind-03008",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingStorageImageUpdateAfterBind-03007",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingStorageTexelBufferUpdateAfterBind-03010",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingUniformBufferUpdateAfterBind-03005",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingUniformTexelBufferUpdateAfterBind-03009",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingUpdateUnusedWhilePending-03012",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-descriptorBindingVariableDescriptorCount-03014",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-flags-03003",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-pBindingFlags-03004",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-pBindingFlags-03015",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-pBindingFlags-parameter",
    "VUID-VkDescriptorSetLayoutBindingFlagsCreateInfo-sType-sType",
    "VUID-VkDescriptorSetLayoutCreateInfo-binding-00279",
    "VUID-VkDescriptorSetLayoutCreateInfo-descriptorType-03001",
    "VUID-VkDescriptorSetLayoutCreateInfo-flags-00280",
    "VUID-VkDescriptorSetLayoutCreateInfo-flags-00281",
    "VUID-VkDescriptorSetLayoutCreateInfo-flags-02208",
    "VUID-VkDescriptorSetLayoutCreateInfo-flags-03000",
    "VUID-VkDescriptorSetLayoutCreateInfo-flags-parameter",
    "VUID-VkDescriptorSetLayoutCreateInfo-pBindings-parameter",
    "VUID-VkDescriptorSetLayoutCreateInfo-pNext-pNext",
    "VUID-VkDescriptorSetLayoutCreateInfo-sType-sType",
    "VUID-VkDescriptorSetLayoutCreateInfo-sType-unique",
    "VUID-VkDescriptorSetLayoutSupport-pNext-pNext",
    "VUID-VkDescriptorSetLayoutSupport-sType-sType",
    "VUID-VkDescriptorSetLayoutSupport-sType-unique",
    "VUID-VkDescriptorSetVariableDescriptorCountAllocateInfo-descriptorSetCount-03045",
    "VUID-VkDescriptorSetVariableDescriptorCountAllocateInfo-pDescriptorCounts-parameter",
    "VUID-VkDescriptorSetVariableDescriptorCountAllocateInfo-pSetLayouts-03046",
    "VUID-VkDescriptorSetVariableDescriptorCountAllocateInfo-sType-sType",
    "VUID-VkDescriptorSetVariableDescriptorCountLayoutSupport-sType-sType",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-commonparent",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-descriptorUpdateEntryCount-arraylength",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-flags-zerobitmask",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-pDescriptorUpdateEntries-parameter",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-pNext-pNext",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-sType-sType",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00350",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00351",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00352",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00353",
    "VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-parameter",
    "VUID-VkDescriptorUpdateTemplateEntry-descriptor-02226",
    "VUID-VkDescriptorUpdateTemplateEntry-descriptor-02227",
    "VUID-VkDescriptorUpdateTemplateEntry-descriptorType-parameter",
    "VUID-VkDescriptorUpdateTemplateEntry-dstArrayElement-00355",
    "VUID-VkDescriptorUpdateTemplateEntry-dstBinding-00354",
    "VUID-VkDeviceCreateInfo-flags-zerobitmask",
    "VUID-VkDeviceCreateInfo-pEnabledFeatures-parameter",
    "VUID-VkDeviceCreateInfo-pNext-00373",
    "VUID-VkDeviceCreateInfo-pNext-02829",
    "VUID-VkDeviceCreateInfo-pNext-02830",
    "VUID-VkDeviceCreateInfo-pNext-pNext",
    "VUID-VkDeviceCreateInfo-pQueueCreateInfos-parameter",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensionNames-00374",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensionNames-01840",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensionNames-03328",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensionNames-parameter",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensions-02831",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensions-02832",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensions-02833",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensions-02834",
    "VUID-VkDeviceCreateInfo-ppEnabledExtensions-02835",
    "VUID-VkDeviceCreateInfo-ppEnabledLayerNames-parameter",
    "VUID-VkDeviceCreateInfo-queueCreateInfoCount-arraylength",
    "VUID-VkDeviceCreateInfo-queueFamilyIndex-00372",
    "VUID-VkDeviceCreateInfo-queueFamilyIndex-02802",
    "VUID-VkDeviceCreateInfo-sType-sType",
    "VUID-VkDeviceCreateInfo-sType-unique",
    "VUID-VkDeviceDiagnosticsConfigCreateInfoNV-flags-parameter",
    "VUID-VkDeviceDiagnosticsConfigCreateInfoNV-sType-sType",
    "VUID-VkDeviceEventInfoEXT-deviceEvent-parameter",
    "VUID-VkDeviceEventInfoEXT-pNext-pNext",
    "VUID-VkDeviceEventInfoEXT-sType-sType",
    "VUID-VkDeviceGroupBindSparseInfo-memoryDeviceIndex-01119",
    "VUID-VkDeviceGroupBindSparseInfo-resourceDeviceIndex-01118",
    "VUID-VkDeviceGroupBindSparseInfo-sType-sType",
    "VUID-VkDeviceGroupCommandBufferBeginInfo-deviceMask-00106",
    "VUID-VkDeviceGroupCommandBufferBeginInfo-deviceMask-00107",
    "VUID-VkDeviceGroupCommandBufferBeginInfo-sType-sType",
    "VUID-VkDeviceGroupDeviceCreateInfo-pPhysicalDevices-00375",
    "VUID-VkDeviceGroupDeviceCreateInfo-pPhysicalDevices-00376",
    "VUID-VkDeviceGroupDeviceCreateInfo-pPhysicalDevices-parameter",
    "VUID-VkDeviceGroupDeviceCreateInfo-physicalDeviceCount-00377",
    "VUID-VkDeviceGroupDeviceCreateInfo-sType-sType",
    "VUID-VkDeviceGroupPresentCapabilitiesKHR-pNext-pNext",
    "VUID-VkDeviceGroupPresentCapabilitiesKHR-sType-sType",
    "VUID-VkDeviceGroupPresentInfoKHR-mode-01298",
    "VUID-VkDeviceGroupPresentInfoKHR-mode-01299",
    "VUID-VkDeviceGroupPresentInfoKHR-mode-01300",
    "VUID-VkDeviceGroupPresentInfoKHR-mode-01301",
    "VUID-VkDeviceGroupPresentInfoKHR-mode-01303",
    "VUID-VkDeviceGroupPresentInfoKHR-mode-parameter",
    "VUID-VkDeviceGroupPresentInfoKHR-pDeviceMasks-01302",
    "VUID-VkDeviceGroupPresentInfoKHR-pDeviceMasks-parameter",
    "VUID-VkDeviceGroupPresentInfoKHR-sType-sType",
    "VUID-VkDeviceGroupPresentInfoKHR-swapchainCount-01297",
    "VUID-VkDeviceGroupRenderPassBeginInfo-deviceMask-00905",
    "VUID-VkDeviceGroupRenderPassBeginInfo-deviceMask-00906",
    "VUID-VkDeviceGroupRenderPassBeginInfo-deviceMask-00907",
    "VUID-VkDeviceGroupRenderPassBeginInfo-deviceRenderAreaCount-00908",
    "VUID-VkDeviceGroupRenderPassBeginInfo-pDeviceRenderAreas-parameter",
    "VUID-VkDeviceGroupRenderPassBeginInfo-sType-sType",
    "VUID-VkDeviceGroupSubmitInfo-commandBufferCount-00083",
    "VUID-VkDeviceGroupSubmitInfo-pCommandBufferDeviceMasks-00086",
    "VUID-VkDeviceGroupSubmitInfo-pCommandBufferDeviceMasks-parameter",
    "VUID-VkDeviceGroupSubmitInfo-pSignalSemaphoreDeviceIndices-parameter",
    "VUID-VkDeviceGroupSubmitInfo-pWaitSemaphoreDeviceIndices-00085",
    "VUID-VkDeviceGroupSubmitInfo-pWaitSemaphoreDeviceIndices-parameter",
    "VUID-VkDeviceGroupSubmitInfo-sType-sType",
    "VUID-VkDeviceGroupSubmitInfo-signalSemaphoreCount-00084",
    "VUID-VkDeviceGroupSubmitInfo-waitSemaphoreCount-00082",
    "VUID-VkDeviceGroupSwapchainCreateInfoKHR-modes-parameter",
    "VUID-VkDeviceGroupSwapchainCreateInfoKHR-modes-requiredbitmask",
    "VUID-VkDeviceGroupSwapchainCreateInfoKHR-sType-sType",
    "VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-memory-03336",
    "VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-memory-parameter",
    "VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-pNext-pNext",
    "VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-sType-sType",
    "VUID-VkDeviceMemoryOverallocationCreateInfoAMD-overallocationBehavior-parameter",
    "VUID-VkDeviceMemoryOverallocationCreateInfoAMD-sType-sType",
    "VUID-VkDevicePrivateDataCreateInfoEXT-sType-sType",
    "VUID-VkDeviceQueueCreateInfo-flags-02861",
    "VUID-VkDeviceQueueCreateInfo-flags-parameter",
    "VUID-VkDeviceQueueCreateInfo-pNext-pNext",
    "VUID-VkDeviceQueueCreateInfo-pQueuePriorities-00383",
    "VUID-VkDeviceQueueCreateInfo-pQueuePriorities-parameter",
    "VUID-VkDeviceQueueCreateInfo-queueCount-00382",
    "VUID-VkDeviceQueueCreateInfo-queueCount-arraylength",
    "VUID-VkDeviceQueueCreateInfo-queueFamilyIndex-00381",
    "VUID-VkDeviceQueueCreateInfo-sType-sType",
    "VUID-VkDeviceQueueCreateInfo-sType-unique",
    "VUID-VkDeviceQueueGlobalPriorityCreateInfoEXT-globalPriority-parameter",
    "VUID-VkDeviceQueueGlobalPriorityCreateInfoEXT-sType-sType",
    "VUID-VkDeviceQueueInfo2-flags-parameter",
    "VUID-VkDeviceQueueInfo2-pNext-pNext",
    "VUID-VkDeviceQueueInfo2-queueFamilyIndex-01842",
    "VUID-VkDeviceQueueInfo2-queueIndex-01843",
    "VUID-VkDeviceQueueInfo2-sType-sType",
    "VUID-VkDispatchIndirectCommand-x-00417",
    "VUID-VkDispatchIndirectCommand-y-00418",
    "VUID-VkDispatchIndirectCommand-z-00419",
    "VUID-VkDisplayEventInfoEXT-displayEvent-parameter",
    "VUID-VkDisplayEventInfoEXT-pNext-pNext",
    "VUID-VkDisplayEventInfoEXT-sType-sType",
    "VUID-VkDisplayModeCreateInfoKHR-flags-zerobitmask",
    "VUID-VkDisplayModeCreateInfoKHR-pNext-pNext",
    "VUID-VkDisplayModeCreateInfoKHR-parameters-parameter",
    "VUID-VkDisplayModeCreateInfoKHR-sType-sType",
    "VUID-VkDisplayModeParametersKHR-height-01991",
    "VUID-VkDisplayModeParametersKHR-refreshRate-01992",
    "VUID-VkDisplayModeParametersKHR-width-01990",
    "VUID-VkDisplayModeProperties2KHR-pNext-pNext",
    "VUID-VkDisplayModeProperties2KHR-sType-sType",
    "VUID-VkDisplayNativeHdrSurfaceCapabilitiesAMD-sType-sType",
    "VUID-VkDisplayPlaneCapabilities2KHR-pNext-pNext",
    "VUID-VkDisplayPlaneCapabilities2KHR-sType-sType",
    "VUID-VkDisplayPlaneInfo2KHR-mode-parameter",
    "VUID-VkDisplayPlaneInfo2KHR-pNext-pNext",
    "VUID-VkDisplayPlaneInfo2KHR-sType-sType",
    "VUID-VkDisplayPlaneProperties2KHR-pNext-pNext",
    "VUID-VkDisplayPlaneProperties2KHR-sType-sType",
    "VUID-VkDisplayPowerInfoEXT-pNext-pNext",
    "VUID-VkDisplayPowerInfoEXT-powerState-parameter",
    "VUID-VkDisplayPowerInfoEXT-sType-sType",
    "VUID-VkDisplayPresentInfoKHR-dstRect-01258",
    "VUID-VkDisplayPresentInfoKHR-persistentContent-01259",
    "VUID-VkDisplayPresentInfoKHR-sType-sType",
    "VUID-VkDisplayPresentInfoKHR-srcRect-01257",
    "VUID-VkDisplayProperties2KHR-pNext-pNext",
    "VUID-VkDisplayProperties2KHR-sType-sType",
    "VUID-VkDisplaySurfaceCreateInfoKHR-alphaMode-01254",
    "VUID-VkDisplaySurfaceCreateInfoKHR-alphaMode-01255",
    "VUID-VkDisplaySurfaceCreateInfoKHR-alphaMode-parameter",
    "VUID-VkDisplaySurfaceCreateInfoKHR-displayMode-parameter",
    "VUID-VkDisplaySurfaceCreateInfoKHR-flags-zerobitmask",
    "VUID-VkDisplaySurfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkDisplaySurfaceCreateInfoKHR-planeIndex-01252",
    "VUID-VkDisplaySurfaceCreateInfoKHR-planeReorderPossible-01253",
    "VUID-VkDisplaySurfaceCreateInfoKHR-sType-sType",
    "VUID-VkDisplaySurfaceCreateInfoKHR-transform-parameter",
    "VUID-VkDisplaySurfaceCreateInfoKHR-width-01256",
    "VUID-VkDrawIndexedIndirectCommand-None-00552",
    "VUID-VkDrawIndexedIndirectCommand-firstInstance-00554",
    "VUID-VkDrawIndexedIndirectCommand-indexSize-00553",
    "VUID-VkDrawIndirectCommand-None-00500",
    "VUID-VkDrawIndirectCommand-firstInstance-00501",
    "VUID-VkDrawMeshTasksIndirectCommandNV-taskCount-02175",
    "VUID-VkDrmFormatModifierPropertiesListEXT-sType-sType",
    "VUID-VkEventCreateInfo-flags-zerobitmask",
    "VUID-VkEventCreateInfo-pNext-pNext",
    "VUID-VkEventCreateInfo-sType-sType",
    "VUID-VkExportFenceCreateInfo-handleTypes-01446",
    "VUID-VkExportFenceCreateInfo-handleTypes-parameter",
    "VUID-VkExportFenceCreateInfo-sType-sType",
    "VUID-VkExportFenceWin32HandleInfoKHR-handleTypes-01447",
    "VUID-VkExportFenceWin32HandleInfoKHR-pAttributes-parameter",
    "VUID-VkExportFenceWin32HandleInfoKHR-sType-sType",
    "VUID-VkExportMemoryAllocateInfo-handleTypes-00656",
    "VUID-VkExportMemoryAllocateInfo-handleTypes-parameter",
    "VUID-VkExportMemoryAllocateInfo-sType-sType",
    "VUID-VkExportMemoryAllocateInfoNV-handleTypes-parameter",
    "VUID-VkExportMemoryAllocateInfoNV-sType-sType",
    "VUID-VkExportMemoryWin32HandleInfoKHR-handleTypes-00657",
    "VUID-VkExportMemoryWin32HandleInfoKHR-pAttributes-parameter",
    "VUID-VkExportMemoryWin32HandleInfoKHR-sType-sType",
    "VUID-VkExportMemoryWin32HandleInfoNV-pAttributes-parameter",
    "VUID-VkExportMemoryWin32HandleInfoNV-sType-sType",
    "VUID-VkExportSemaphoreCreateInfo-handleTypes-01124",
    "VUID-VkExportSemaphoreCreateInfo-handleTypes-parameter",
    "VUID-VkExportSemaphoreCreateInfo-sType-sType",
    "VUID-VkExportSemaphoreWin32HandleInfoKHR-handleTypes-01125",
    "VUID-VkExportSemaphoreWin32HandleInfoKHR-pAttributes-parameter",
    "VUID-VkExportSemaphoreWin32HandleInfoKHR-sType-sType",
    "VUID-VkExternalBufferProperties-pNext-pNext",
    "VUID-VkExternalBufferProperties-sType-sType",
    "VUID-VkExternalFenceProperties-pNext-pNext",
    "VUID-VkExternalFenceProperties-sType-sType",
    "VUID-VkExternalFormatANDROID-externalFormat-01894",
    "VUID-VkExternalFormatANDROID-sType-sType",
    "VUID-VkExternalImageFormatProperties-sType-sType",
    "VUID-VkExternalMemoryBufferCreateInfo-handleTypes-parameter",
    "VUID-VkExternalMemoryBufferCreateInfo-sType-sType",
    "VUID-VkExternalMemoryImageCreateInfo-handleTypes-parameter",
    "VUID-VkExternalMemoryImageCreateInfo-handleTypes-requiredbitmask",
    "VUID-VkExternalMemoryImageCreateInfo-sType-sType",
    "VUID-VkExternalMemoryImageCreateInfoNV-handleTypes-parameter",
    "VUID-VkExternalMemoryImageCreateInfoNV-sType-sType",
    "VUID-VkExternalSemaphoreProperties-pNext-pNext",
    "VUID-VkExternalSemaphoreProperties-sType-sType",
    "VUID-VkFenceCreateInfo-flags-parameter",
    "VUID-VkFenceCreateInfo-pNext-pNext",
    "VUID-VkFenceCreateInfo-sType-sType",
    "VUID-VkFenceCreateInfo-sType-unique",
    "VUID-VkFenceGetFdInfoKHR-fence-01455",
    "VUID-VkFenceGetFdInfoKHR-fence-parameter",
    "VUID-VkFenceGetFdInfoKHR-handleType-01453",
    "VUID-VkFenceGetFdInfoKHR-handleType-01454",
    "VUID-VkFenceGetFdInfoKHR-handleType-01456",
    "VUID-VkFenceGetFdInfoKHR-handleType-parameter",
    "VUID-VkFenceGetFdInfoKHR-pNext-pNext",
    "VUID-VkFenceGetFdInfoKHR-sType-sType",
    "VUID-VkFenceGetWin32HandleInfoKHR-fence-01450",
    "VUID-VkFenceGetWin32HandleInfoKHR-fence-parameter",
    "VUID-VkFenceGetWin32HandleInfoKHR-handleType-01448",
    "VUID-VkFenceGetWin32HandleInfoKHR-handleType-01449",
    "VUID-VkFenceGetWin32HandleInfoKHR-handleType-01451",
    "VUID-VkFenceGetWin32HandleInfoKHR-handleType-01452",
    "VUID-VkFenceGetWin32HandleInfoKHR-handleType-parameter",
    "VUID-VkFenceGetWin32HandleInfoKHR-pNext-pNext",
    "VUID-VkFenceGetWin32HandleInfoKHR-sType-sType",
    "VUID-VkFilterCubicImageViewImageFormatPropertiesEXT-pNext-02627",
    "VUID-VkFilterCubicImageViewImageFormatPropertiesEXT-sType-sType",
    "VUID-VkFormatProperties2-pNext-pNext",
    "VUID-VkFormatProperties2-sType-sType",
    "VUID-VkFormatProperties2-sType-unique",
    "VUID-VkFramebufferAttachmentImageInfo-flags-parameter",
    "VUID-VkFramebufferAttachmentImageInfo-pNext-pNext",
    "VUID-VkFramebufferAttachmentImageInfo-pViewFormats-parameter",
    "VUID-VkFramebufferAttachmentImageInfo-sType-sType",
    "VUID-VkFramebufferAttachmentImageInfo-usage-parameter",
    "VUID-VkFramebufferAttachmentImageInfo-usage-requiredbitmask",
    "VUID-VkFramebufferAttachmentsCreateInfo-pAttachmentImageInfos-parameter",
    "VUID-VkFramebufferAttachmentsCreateInfo-sType-sType",
    "VUID-VkFramebufferCreateInfo-attachmentCount-00876",
    "VUID-VkFramebufferCreateInfo-commonparent",
    "VUID-VkFramebufferCreateInfo-flags-02778",
    "VUID-VkFramebufferCreateInfo-flags-03188",
    "VUID-VkFramebufferCreateInfo-flags-03189",
    "VUID-VkFramebufferCreateInfo-flags-03190",
    "VUID-VkFramebufferCreateInfo-flags-03191",
    "VUID-VkFramebufferCreateInfo-flags-03192",
    "VUID-VkFramebufferCreateInfo-flags-03193",
    "VUID-VkFramebufferCreateInfo-flags-03194",
    "VUID-VkFramebufferCreateInfo-flags-03195",
    "VUID-VkFramebufferCreateInfo-flags-03196",
    "VUID-VkFramebufferCreateInfo-flags-03197",
    "VUID-VkFramebufferCreateInfo-flags-03200",
    "VUID-VkFramebufferCreateInfo-flags-03201",
    "VUID-VkFramebufferCreateInfo-flags-03202",
    "VUID-VkFramebufferCreateInfo-flags-03203",
    "VUID-VkFramebufferCreateInfo-flags-03204",
    "VUID-VkFramebufferCreateInfo-flags-03205",
    "VUID-VkFramebufferCreateInfo-flags-parameter",
    "VUID-VkFramebufferCreateInfo-height-00887",
    "VUID-VkFramebufferCreateInfo-height-00888",
    "VUID-VkFramebufferCreateInfo-layers-00889",
    "VUID-VkFramebufferCreateInfo-layers-00890",
    "VUID-VkFramebufferCreateInfo-pAttachments-00877",
    "VUID-VkFramebufferCreateInfo-pAttachments-00879",
    "VUID-VkFramebufferCreateInfo-pAttachments-00880",
    "VUID-VkFramebufferCreateInfo-pAttachments-00881",
    "VUID-VkFramebufferCreateInfo-pAttachments-00882",
    "VUID-VkFramebufferCreateInfo-pAttachments-00883",
    "VUID-VkFramebufferCreateInfo-pAttachments-00884",
    "VUID-VkFramebufferCreateInfo-pAttachments-00891",
    "VUID-VkFramebufferCreateInfo-pAttachments-02552",
    "VUID-VkFramebufferCreateInfo-pAttachments-02554",
    "VUID-VkFramebufferCreateInfo-pAttachments-02555",
    "VUID-VkFramebufferCreateInfo-pAttachments-02556",
    "VUID-VkFramebufferCreateInfo-pAttachments-02633",
    "VUID-VkFramebufferCreateInfo-pAttachments-02634",
    "VUID-VkFramebufferCreateInfo-pAttachments-02744",
    "VUID-VkFramebufferCreateInfo-pNext-pNext",
    "VUID-VkFramebufferCreateInfo-renderPass-02531",
    "VUID-VkFramebufferCreateInfo-renderPass-02553",
    "VUID-VkFramebufferCreateInfo-renderPass-02743",
    "VUID-VkFramebufferCreateInfo-renderPass-02745",
    "VUID-VkFramebufferCreateInfo-renderPass-02746",
    "VUID-VkFramebufferCreateInfo-renderPass-02747",
    "VUID-VkFramebufferCreateInfo-renderPass-03198",
    "VUID-VkFramebufferCreateInfo-renderPass-03199",
    "VUID-VkFramebufferCreateInfo-renderPass-parameter",
    "VUID-VkFramebufferCreateInfo-sType-sType",
    "VUID-VkFramebufferCreateInfo-sType-unique",
    "VUID-VkFramebufferCreateInfo-width-00885",
    "VUID-VkFramebufferCreateInfo-width-00886",
    "VUID-VkFramebufferMixedSamplesCombinationNV-pNext-pNext",
    "VUID-VkFramebufferMixedSamplesCombinationNV-sType-sType",
    "VUID-VkGeneratedCommandsInfoNV-commonparent",
    "VUID-VkGeneratedCommandsInfoNV-indirectCommandsLayout-02913",
    "VUID-VkGeneratedCommandsInfoNV-indirectCommandsLayout-02914",
    "VUID-VkGeneratedCommandsInfoNV-indirectCommandsLayout-02915",
    "VUID-VkGeneratedCommandsInfoNV-indirectCommandsLayout-parameter",
    "VUID-VkGeneratedCommandsInfoNV-pNext-pNext",
    "VUID-VkGeneratedCommandsInfoNV-pStreams-parameter",
    "VUID-VkGeneratedCommandsInfoNV-pipeline-02912",
    "VUID-VkGeneratedCommandsInfoNV-pipeline-parameter",
    "VUID-VkGeneratedCommandsInfoNV-pipelineBindPoint-parameter",
    "VUID-VkGeneratedCommandsInfoNV-preprocessBuffer-02918",
    "VUID-VkGeneratedCommandsInfoNV-preprocessBuffer-02971",
    "VUID-VkGeneratedCommandsInfoNV-preprocessBuffer-parameter",
    "VUID-VkGeneratedCommandsInfoNV-preprocessOffset-02919",
    "VUID-VkGeneratedCommandsInfoNV-preprocessSize-02920",
    "VUID-VkGeneratedCommandsInfoNV-sType-sType",
    "VUID-VkGeneratedCommandsInfoNV-sequencesCount-02917",
    "VUID-VkGeneratedCommandsInfoNV-sequencesCountBuffer-02921",
    "VUID-VkGeneratedCommandsInfoNV-sequencesCountBuffer-02922",
    "VUID-VkGeneratedCommandsInfoNV-sequencesCountBuffer-02923",
    "VUID-VkGeneratedCommandsInfoNV-sequencesCountBuffer-02972",
    "VUID-VkGeneratedCommandsInfoNV-sequencesCountBuffer-parameter",
    "VUID-VkGeneratedCommandsInfoNV-sequencesIndexBuffer-02924",
    "VUID-VkGeneratedCommandsInfoNV-sequencesIndexBuffer-02925",
    "VUID-VkGeneratedCommandsInfoNV-sequencesIndexBuffer-02926",
    "VUID-VkGeneratedCommandsInfoNV-sequencesIndexBuffer-02973",
    "VUID-VkGeneratedCommandsInfoNV-sequencesIndexBuffer-parameter",
    "VUID-VkGeneratedCommandsInfoNV-streamCount-02916",
    "VUID-VkGeneratedCommandsInfoNV-streamCount-arraylength",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-commonparent",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-indirectCommandsLayout-parameter",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-maxSequencesCount-02907",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-pNext-pNext",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-pipeline-parameter",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-pipelineBindPoint-parameter",
    "VUID-VkGeneratedCommandsMemoryRequirementsInfoNV-sType-sType",
    "VUID-VkGeometryAABBNV-aabbData-parameter",
    "VUID-VkGeometryAABBNV-offset-02439",
    "VUID-VkGeometryAABBNV-offset-02440",
    "VUID-VkGeometryAABBNV-pNext-pNext",
    "VUID-VkGeometryAABBNV-sType-sType",
    "VUID-VkGeometryAABBNV-stride-02441",
    "VUID-VkGeometryDataNV-aabbs-parameter",
    "VUID-VkGeometryDataNV-triangles-parameter",
    "VUID-VkGeometryNV-flags-parameter",
    "VUID-VkGeometryNV-geometry-parameter",
    "VUID-VkGeometryNV-geometryType-03503",
    "VUID-VkGeometryNV-geometryType-parameter",
    "VUID-VkGeometryNV-pNext-pNext",
    "VUID-VkGeometryNV-sType-sType",
    "VUID-VkGeometryTrianglesNV-commonparent",
    "VUID-VkGeometryTrianglesNV-indexCount-02436",
    "VUID-VkGeometryTrianglesNV-indexData-02434",
    "VUID-VkGeometryTrianglesNV-indexData-02435",
    "VUID-VkGeometryTrianglesNV-indexData-parameter",
    "VUID-VkGeometryTrianglesNV-indexOffset-02431",
    "VUID-VkGeometryTrianglesNV-indexOffset-02432",
    "VUID-VkGeometryTrianglesNV-indexType-02433",
    "VUID-VkGeometryTrianglesNV-indexType-parameter",
    "VUID-VkGeometryTrianglesNV-pNext-pNext",
    "VUID-VkGeometryTrianglesNV-sType-sType",
    "VUID-VkGeometryTrianglesNV-transformData-parameter",
    "VUID-VkGeometryTrianglesNV-transformOffset-02437",
    "VUID-VkGeometryTrianglesNV-transformOffset-02438",
    "VUID-VkGeometryTrianglesNV-vertexData-parameter",
    "VUID-VkGeometryTrianglesNV-vertexFormat-02430",
    "VUID-VkGeometryTrianglesNV-vertexFormat-parameter",
    "VUID-VkGeometryTrianglesNV-vertexOffset-02428",
    "VUID-VkGeometryTrianglesNV-vertexOffset-02429",
    "VUID-VkGraphicsPipelineCreateInfo-None-02322",
    "VUID-VkGraphicsPipelineCreateInfo-attachmentCount-00746",
    "VUID-VkGraphicsPipelineCreateInfo-blendEnable-02023",
    "VUID-VkGraphicsPipelineCreateInfo-commonparent",
    "VUID-VkGraphicsPipelineCreateInfo-coverageReductionMode-02722",
    "VUID-VkGraphicsPipelineCreateInfo-flags-00722",
    "VUID-VkGraphicsPipelineCreateInfo-flags-00723",
    "VUID-VkGraphicsPipelineCreateInfo-flags-00724",
    "VUID-VkGraphicsPipelineCreateInfo-flags-00725",
    "VUID-VkGraphicsPipelineCreateInfo-flags-00764",
    "VUID-VkGraphicsPipelineCreateInfo-flags-02877",
    "VUID-VkGraphicsPipelineCreateInfo-flags-02966",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03371",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03372",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03373",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03374",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03375",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03376",
    "VUID-VkGraphicsPipelineCreateInfo-flags-03377",
    "VUID-VkGraphicsPipelineCreateInfo-flags-parameter",
    "VUID-VkGraphicsPipelineCreateInfo-geometryStreams-02321",
    "VUID-VkGraphicsPipelineCreateInfo-layout-00756",
    "VUID-VkGraphicsPipelineCreateInfo-layout-01688",
    "VUID-VkGraphicsPipelineCreateInfo-layout-parameter",
    "VUID-VkGraphicsPipelineCreateInfo-lineRasterizationMode-02766",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicState-parameter",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-00747",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-00748",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-00749",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-00754",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-00755",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-01521",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-01522",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-01523",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-01715",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-02510",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-04056",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-04057",
    "VUID-VkGraphicsPipelineCreateInfo-pDynamicStates-04058",
    "VUID-VkGraphicsPipelineCreateInfo-pNext-pNext",
    "VUID-VkGraphicsPipelineCreateInfo-pRasterizationState-parameter",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00729",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00730",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00731",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00732",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00733",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00734",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00735",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00736",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00738",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00739",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00740",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00741",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-00742",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-01565",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-02095",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-02097",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-02098",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-02317",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-02318",
    "VUID-VkGraphicsPipelineCreateInfo-pStages-parameter",
    "VUID-VkGraphicsPipelineCreateInfo-pipelineCreationCacheControl-02878",
    "VUID-VkGraphicsPipelineCreateInfo-rasterizationStream-02319",
    "VUID-VkGraphicsPipelineCreateInfo-rasterizationStream-02320",
    "VUID-VkGraphicsPipelineCreateInfo-rasterizerDiscardEnable-00750",
    "VUID-VkGraphicsPipelineCreateInfo-rasterizerDiscardEnable-00751",
    "VUID-VkGraphicsPipelineCreateInfo-rasterizerDiscardEnable-00752",
    "VUID-VkGraphicsPipelineCreateInfo-rasterizerDiscardEnable-00753",
    "VUID-VkGraphicsPipelineCreateInfo-renderPass-00760",
    "VUID-VkGraphicsPipelineCreateInfo-renderPass-00761",
    "VUID-VkGraphicsPipelineCreateInfo-renderPass-00762",
    "VUID-VkGraphicsPipelineCreateInfo-renderPass-00763",
    "VUID-VkGraphicsPipelineCreateInfo-renderPass-parameter",
    "VUID-VkGraphicsPipelineCreateInfo-sType-sType",
    "VUID-VkGraphicsPipelineCreateInfo-sType-unique",
    "VUID-VkGraphicsPipelineCreateInfo-sampleLocationsEnable-01524",
    "VUID-VkGraphicsPipelineCreateInfo-stage-00726",
    "VUID-VkGraphicsPipelineCreateInfo-stage-00727",
    "VUID-VkGraphicsPipelineCreateInfo-stage-00728",
    "VUID-VkGraphicsPipelineCreateInfo-stage-02096",
    "VUID-VkGraphicsPipelineCreateInfo-stageCount-arraylength",
    "VUID-VkGraphicsPipelineCreateInfo-stippledLineEnable-02767",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-00743",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-00744",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-00757",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-00758",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-00759",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-01411",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-01412",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-01505",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-01756",
    "VUID-VkGraphicsPipelineCreateInfo-subpass-01757",
    "VUID-VkGraphicsPipelineCreateInfo-topology-00737",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-deviceGeneratedCommands-02887",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-groupCount-02879",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-groupCount-02880",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-groupCount-arraylength",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pGroups-02881",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pGroups-02882",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pGroups-02883",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pGroups-02884",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pGroups-02885",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pGroups-parameter",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pPipelines-02886",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-pPipelines-parameter",
    "VUID-VkGraphicsPipelineShaderGroupsCreateInfoNV-sType-sType",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-pNext-pNext",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-pStages-02889",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-pStages-parameter",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-pTessellationState-02891",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-pVertexInputState-02890",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-sType-sType",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-stageCount-02888",
    "VUID-VkGraphicsShaderGroupCreateInfoNV-stageCount-arraylength",
    "VUID-VkHdrMetadataEXT-pNext-pNext",
    "VUID-VkHdrMetadataEXT-sType-sType",
    "VUID-VkHeadlessSurfaceCreateInfoEXT-flags-zerobitmask",
    "VUID-VkHeadlessSurfaceCreateInfoEXT-pNext-pNext",
    "VUID-VkHeadlessSurfaceCreateInfoEXT-sType-sType",
    "VUID-VkIOSSurfaceCreateInfoMVK-flags-zerobitmask",
    "VUID-VkIOSSurfaceCreateInfoMVK-pNext-pNext",
    "VUID-VkIOSSurfaceCreateInfoMVK-pView-01316",
    "VUID-VkIOSSurfaceCreateInfoMVK-sType-sType",
    "VUID-VkImageBlit-aspectMask-00238",
    "VUID-VkImageBlit-aspectMask-00241",
    "VUID-VkImageBlit-aspectMask-00242",
    "VUID-VkImageBlit-dstImage-00250",
    "VUID-VkImageBlit-dstImage-00252",
    "VUID-VkImageBlit-dstOffset-00248",
    "VUID-VkImageBlit-dstOffset-00249",
    "VUID-VkImageBlit-dstOffset-00251",
    "VUID-VkImageBlit-dstSubresource-parameter",
    "VUID-VkImageBlit-layerCount-00239",
    "VUID-VkImageBlit-srcImage-00240",
    "VUID-VkImageBlit-srcImage-00245",
    "VUID-VkImageBlit-srcImage-00247",
    "VUID-VkImageBlit-srcOffset-00243",
    "VUID-VkImageBlit-srcOffset-00244",
    "VUID-VkImageBlit-srcOffset-00246",
    "VUID-VkImageBlit-srcSubresource-parameter",
    "VUID-VkImageCopy-aspectMask-00137",
    "VUID-VkImageCopy-aspectMask-00142",
    "VUID-VkImageCopy-aspectMask-00143",
    "VUID-VkImageCopy-dstImage-00152",
    "VUID-VkImageCopy-dstImage-01554",
    "VUID-VkImageCopy-dstImage-01555",
    "VUID-VkImageCopy-dstImage-01557",
    "VUID-VkImageCopy-dstImage-01731",
    "VUID-VkImageCopy-dstImage-01732",
    "VUID-VkImageCopy-dstImage-01733",
    "VUID-VkImageCopy-dstImage-01734",
    "VUID-VkImageCopy-dstImage-01786",
    "VUID-VkImageCopy-dstImage-01788",
    "VUID-VkImageCopy-dstImage-01792",
    "VUID-VkImageCopy-dstOffset-00150",
    "VUID-VkImageCopy-dstOffset-00151",
    "VUID-VkImageCopy-dstOffset-00153",
    "VUID-VkImageCopy-dstOffset-00162",
    "VUID-VkImageCopy-dstSubresource-parameter",
    "VUID-VkImageCopy-extent-00140",
    "VUID-VkImageCopy-extent-00158",
    "VUID-VkImageCopy-extent-00159",
    "VUID-VkImageCopy-extent-00160",
    "VUID-VkImageCopy-extent-00163",
    "VUID-VkImageCopy-extent-00164",
    "VUID-VkImageCopy-extent-00165",
    "VUID-VkImageCopy-layerCount-00138",
    "VUID-VkImageCopy-srcImage-00139",
    "VUID-VkImageCopy-srcImage-00141",
    "VUID-VkImageCopy-srcImage-00146",
    "VUID-VkImageCopy-srcImage-01551",
    "VUID-VkImageCopy-srcImage-01552",
    "VUID-VkImageCopy-srcImage-01553",
    "VUID-VkImageCopy-srcImage-01556",
    "VUID-VkImageCopy-srcImage-01727",
    "VUID-VkImageCopy-srcImage-01728",
    "VUID-VkImageCopy-srcImage-01729",
    "VUID-VkImageCopy-srcImage-01730",
    "VUID-VkImageCopy-srcImage-01785",
    "VUID-VkImageCopy-srcImage-01787",
    "VUID-VkImageCopy-srcImage-01789",
    "VUID-VkImageCopy-srcImage-01790",
    "VUID-VkImageCopy-srcImage-01791",
    "VUID-VkImageCopy-srcOffset-00144",
    "VUID-VkImageCopy-srcOffset-00145",
    "VUID-VkImageCopy-srcOffset-00147",
    "VUID-VkImageCopy-srcOffset-00157",
    "VUID-VkImageCopy-srcSubresource-parameter",
    "VUID-VkImageCreateInfo-Format-02536",
    "VUID-VkImageCreateInfo-None-01891",
    "VUID-VkImageCreateInfo-None-01925",
    "VUID-VkImageCreateInfo-arrayLayers-00948",
    "VUID-VkImageCreateInfo-arrayLayers-02256",
    "VUID-VkImageCreateInfo-extent-00944",
    "VUID-VkImageCreateInfo-extent-00945",
    "VUID-VkImageCreateInfo-extent-00946",
    "VUID-VkImageCreateInfo-extent-02252",
    "VUID-VkImageCreateInfo-extent-02253",
    "VUID-VkImageCreateInfo-extent-02254",
    "VUID-VkImageCreateInfo-flags-00949",
    "VUID-VkImageCreateInfo-flags-00950",
    "VUID-VkImageCreateInfo-flags-00969",
    "VUID-VkImageCreateInfo-flags-00987",
    "VUID-VkImageCreateInfo-flags-01533",
    "VUID-VkImageCreateInfo-flags-01572",
    "VUID-VkImageCreateInfo-flags-01573",
    "VUID-VkImageCreateInfo-flags-01890",
    "VUID-VkImageCreateInfo-flags-01924",
    "VUID-VkImageCreateInfo-flags-02050",
    "VUID-VkImageCreateInfo-flags-02051",
    "VUID-VkImageCreateInfo-flags-02052",
    "VUID-VkImageCreateInfo-flags-02053",
    "VUID-VkImageCreateInfo-flags-02259",
    "VUID-VkImageCreateInfo-flags-02557",
    "VUID-VkImageCreateInfo-flags-02565",
    "VUID-VkImageCreateInfo-flags-02566",
    "VUID-VkImageCreateInfo-flags-02567",
    "VUID-VkImageCreateInfo-flags-02568",
    "VUID-VkImageCreateInfo-flags-parameter",
    "VUID-VkImageCreateInfo-format-00943",
    "VUID-VkImageCreateInfo-format-01577",
    "VUID-VkImageCreateInfo-format-02537",
    "VUID-VkImageCreateInfo-format-02538",
    "VUID-VkImageCreateInfo-format-02561",
    "VUID-VkImageCreateInfo-format-02562",
    "VUID-VkImageCreateInfo-format-02563",
    "VUID-VkImageCreateInfo-format-02564",
    "VUID-VkImageCreateInfo-format-02653",
    "VUID-VkImageCreateInfo-format-02795",
    "VUID-VkImageCreateInfo-format-02796",
    "VUID-VkImageCreateInfo-format-02797",
    "VUID-VkImageCreateInfo-format-02798",
    "VUID-VkImageCreateInfo-format-parameter",
    "VUID-VkImageCreateInfo-imageCreateFormatFeatures-02260",
    "VUID-VkImageCreateInfo-imageCreateMaxMipLevels-02251",
    "VUID-VkImageCreateInfo-imageType-00954",
    "VUID-VkImageCreateInfo-imageType-00956",
    "VUID-VkImageCreateInfo-imageType-00957",
    "VUID-VkImageCreateInfo-imageType-00961",
    "VUID-VkImageCreateInfo-imageType-00970",
    "VUID-VkImageCreateInfo-imageType-00971",
    "VUID-VkImageCreateInfo-imageType-00972",
    "VUID-VkImageCreateInfo-imageType-00973",
    "VUID-VkImageCreateInfo-imageType-00974",
    "VUID-VkImageCreateInfo-imageType-00975",
    "VUID-VkImageCreateInfo-imageType-00976",
    "VUID-VkImageCreateInfo-imageType-02082",
    "VUID-VkImageCreateInfo-imageType-parameter",
    "VUID-VkImageCreateInfo-initialLayout-00993",
    "VUID-VkImageCreateInfo-initialLayout-parameter",
    "VUID-VkImageCreateInfo-mipLevels-00947",
    "VUID-VkImageCreateInfo-mipLevels-00958",
    "VUID-VkImageCreateInfo-mipLevels-02255",
    "VUID-VkImageCreateInfo-pNext-00988",
    "VUID-VkImageCreateInfo-pNext-00990",
    "VUID-VkImageCreateInfo-pNext-00991",
    "VUID-VkImageCreateInfo-pNext-01443",
    "VUID-VkImageCreateInfo-pNext-01974",
    "VUID-VkImageCreateInfo-pNext-01975",
    "VUID-VkImageCreateInfo-pNext-02262",
    "VUID-VkImageCreateInfo-pNext-02393",
    "VUID-VkImageCreateInfo-pNext-02394",
    "VUID-VkImageCreateInfo-pNext-02396",
    "VUID-VkImageCreateInfo-pNext-02397",
    "VUID-VkImageCreateInfo-pNext-02398",
    "VUID-VkImageCreateInfo-pNext-pNext",
    "VUID-VkImageCreateInfo-physicalDeviceCount-01421",
    "VUID-VkImageCreateInfo-sType-sType",
    "VUID-VkImageCreateInfo-sType-unique",
    "VUID-VkImageCreateInfo-samples-02083",
    "VUID-VkImageCreateInfo-samples-02257",
    "VUID-VkImageCreateInfo-samples-02258",
    "VUID-VkImageCreateInfo-samples-02558",
    "VUID-VkImageCreateInfo-samples-parameter",
    "VUID-VkImageCreateInfo-sharingMode-00941",
    "VUID-VkImageCreateInfo-sharingMode-00942",
    "VUID-VkImageCreateInfo-sharingMode-01392",
    "VUID-VkImageCreateInfo-sharingMode-01420",
    "VUID-VkImageCreateInfo-sharingMode-parameter",
    "VUID-VkImageCreateInfo-tiling-02084",
    "VUID-VkImageCreateInfo-tiling-02261",
    "VUID-VkImageCreateInfo-tiling-02353",
    "VUID-VkImageCreateInfo-tiling-parameter",
    "VUID-VkImageCreateInfo-usage-00963",
    "VUID-VkImageCreateInfo-usage-00964",
    "VUID-VkImageCreateInfo-usage-00965",
    "VUID-VkImageCreateInfo-usage-00966",
    "VUID-VkImageCreateInfo-usage-00968",
    "VUID-VkImageCreateInfo-usage-02559",
    "VUID-VkImageCreateInfo-usage-02560",
    "VUID-VkImageCreateInfo-usage-parameter",
    "VUID-VkImageCreateInfo-usage-requiredbitmask",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-arrayPitch-02268",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-depthPitch-02269",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-drmFormatModifier-02264",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-drmFormatModifierPlaneCount-02265",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-pPlaneLayouts-parameter",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-sType-sType",
    "VUID-VkImageDrmFormatModifierExplicitCreateInfoEXT-size-02267",
    "VUID-VkImageDrmFormatModifierListCreateInfoEXT-drmFormatModifierCount-arraylength",
    "VUID-VkImageDrmFormatModifierListCreateInfoEXT-pDrmFormatModifiers-02263",
    "VUID-VkImageDrmFormatModifierListCreateInfoEXT-pDrmFormatModifiers-parameter",
    "VUID-VkImageDrmFormatModifierListCreateInfoEXT-sType-sType",
    "VUID-VkImageDrmFormatModifierPropertiesEXT-pNext-pNext",
    "VUID-VkImageDrmFormatModifierPropertiesEXT-sType-sType",
    "VUID-VkImageFormatListCreateInfo-pViewFormats-parameter",
    "VUID-VkImageFormatListCreateInfo-sType-sType",
    "VUID-VkImageFormatProperties2-pNext-pNext",
    "VUID-VkImageFormatProperties2-sType-sType",
    "VUID-VkImageFormatProperties2-sType-unique",
    "VUID-VkImageMemoryBarrier-image-01199",
    "VUID-VkImageMemoryBarrier-image-01207",
    "VUID-VkImageMemoryBarrier-image-01381",
    "VUID-VkImageMemoryBarrier-image-01671",
    "VUID-VkImageMemoryBarrier-image-01672",
    "VUID-VkImageMemoryBarrier-image-01673",
    "VUID-VkImageMemoryBarrier-image-01932",
    "VUID-VkImageMemoryBarrier-image-02902",
    "VUID-VkImageMemoryBarrier-image-03319",
    "VUID-VkImageMemoryBarrier-image-03320",
    "VUID-VkImageMemoryBarrier-image-04069",
    "VUID-VkImageMemoryBarrier-image-04071",
    "VUID-VkImageMemoryBarrier-image-04072",
    "VUID-VkImageMemoryBarrier-image-parameter",
    "VUID-VkImageMemoryBarrier-newLayout-01198",
    "VUID-VkImageMemoryBarrier-newLayout-parameter",
    "VUID-VkImageMemoryBarrier-oldLayout-01197",
    "VUID-VkImageMemoryBarrier-oldLayout-01208",
    "VUID-VkImageMemoryBarrier-oldLayout-01209",
    "VUID-VkImageMemoryBarrier-oldLayout-01210",
    "VUID-VkImageMemoryBarrier-oldLayout-01211",
    "VUID-VkImageMemoryBarrier-oldLayout-01212",
    "VUID-VkImageMemoryBarrier-oldLayout-01213",
    "VUID-VkImageMemoryBarrier-oldLayout-01658",
    "VUID-VkImageMemoryBarrier-oldLayout-01659",
    "VUID-VkImageMemoryBarrier-oldLayout-02088",
    "VUID-VkImageMemoryBarrier-oldLayout-parameter",
    "VUID-VkImageMemoryBarrier-pNext-pNext",
    "VUID-VkImageMemoryBarrier-sType-sType",
    "VUID-VkImageMemoryBarrier-sType-unique",
    "VUID-VkImageMemoryBarrier-srcQueueFamilyIndex-04065",
    "VUID-VkImageMemoryBarrier-srcQueueFamilyIndex-04066",
    "VUID-VkImageMemoryBarrier-srcQueueFamilyIndex-04067",
    "VUID-VkImageMemoryBarrier-srcQueueFamilyIndex-04068",
    "VUID-VkImageMemoryBarrier-srcQueueFamilyIndex-04070",
    "VUID-VkImageMemoryBarrier-subresourceRange-01486",
    "VUID-VkImageMemoryBarrier-subresourceRange-01488",
    "VUID-VkImageMemoryBarrier-subresourceRange-01724",
    "VUID-VkImageMemoryBarrier-subresourceRange-01725",
    "VUID-VkImageMemoryBarrier-subresourceRange-parameter",
    "VUID-VkImageMemoryRequirementsInfo2-image-01589",
    "VUID-VkImageMemoryRequirementsInfo2-image-01590",
    "VUID-VkImageMemoryRequirementsInfo2-image-01591",
    "VUID-VkImageMemoryRequirementsInfo2-image-01897",
    "VUID-VkImageMemoryRequirementsInfo2-image-02279",
    "VUID-VkImageMemoryRequirementsInfo2-image-02280",
    "VUID-VkImageMemoryRequirementsInfo2-image-parameter",
    "VUID-VkImageMemoryRequirementsInfo2-pNext-pNext",
    "VUID-VkImageMemoryRequirementsInfo2-sType-sType",
    "VUID-VkImageMemoryRequirementsInfo2-sType-unique",
    "VUID-VkImagePipeSurfaceCreateInfoFUCHSIA-flags-zerobitmask",
    "VUID-VkImagePipeSurfaceCreateInfoFUCHSIA-imagePipeHandle-00000",
    "VUID-VkImagePipeSurfaceCreateInfoFUCHSIA-pNext-pNext",
    "VUID-VkImagePipeSurfaceCreateInfoFUCHSIA-sType-sType",
    "VUID-VkImagePlaneMemoryRequirementsInfo-planeAspect-02281",
    "VUID-VkImagePlaneMemoryRequirementsInfo-planeAspect-02282",
    "VUID-VkImagePlaneMemoryRequirementsInfo-planeAspect-parameter",
    "VUID-VkImagePlaneMemoryRequirementsInfo-sType-sType",
    "VUID-VkImageResolve-aspectMask-00266",
    "VUID-VkImageResolve-dstImage-00276",
    "VUID-VkImageResolve-dstImage-00278",
    "VUID-VkImageResolve-dstOffset-00274",
    "VUID-VkImageResolve-dstOffset-00275",
    "VUID-VkImageResolve-dstOffset-00277",
    "VUID-VkImageResolve-dstSubresource-parameter",
    "VUID-VkImageResolve-layerCount-00267",
    "VUID-VkImageResolve-srcImage-00268",
    "VUID-VkImageResolve-srcImage-00271",
    "VUID-VkImageResolve-srcImage-00273",
    "VUID-VkImageResolve-srcOffset-00269",
    "VUID-VkImageResolve-srcOffset-00270",
    "VUID-VkImageResolve-srcOffset-00272",
    "VUID-VkImageResolve-srcSubresource-parameter",
    "VUID-VkImageSparseMemoryRequirementsInfo2-image-parameter",
    "VUID-VkImageSparseMemoryRequirementsInfo2-pNext-pNext",
    "VUID-VkImageSparseMemoryRequirementsInfo2-sType-sType",
    "VUID-VkImageStencilUsageCreateInfo-sType-sType",
    "VUID-VkImageStencilUsageCreateInfo-stencilUsage-02539",
    "VUID-VkImageStencilUsageCreateInfo-stencilUsage-parameter",
    "VUID-VkImageStencilUsageCreateInfo-stencilUsage-requiredbitmask",
    "VUID-VkImageSubresource-aspectMask-parameter",
    "VUID-VkImageSubresource-aspectMask-requiredbitmask",
    "VUID-VkImageSubresourceLayers-aspectMask-00167",
    "VUID-VkImageSubresourceLayers-aspectMask-00168",
    "VUID-VkImageSubresourceLayers-aspectMask-02247",
    "VUID-VkImageSubresourceLayers-aspectMask-parameter",
    "VUID-VkImageSubresourceLayers-aspectMask-requiredbitmask",
    "VUID-VkImageSubresourceLayers-layerCount-01700",
    "VUID-VkImageSubresourceRange-aspectMask-01670",
    "VUID-VkImageSubresourceRange-aspectMask-02278",
    "VUID-VkImageSubresourceRange-aspectMask-parameter",
    "VUID-VkImageSubresourceRange-aspectMask-requiredbitmask",
    "VUID-VkImageSubresourceRange-layerCount-01721",
    "VUID-VkImageSubresourceRange-levelCount-01720",
    "VUID-VkImageSwapchainCreateInfoKHR-sType-sType",
    "VUID-VkImageSwapchainCreateInfoKHR-swapchain-00995",
    "VUID-VkImageSwapchainCreateInfoKHR-swapchain-parameter",
    "VUID-VkImageViewASTCDecodeModeEXT-decodeMode-02230",
    "VUID-VkImageViewASTCDecodeModeEXT-decodeMode-02231",
    "VUID-VkImageViewASTCDecodeModeEXT-decodeMode-02232",
    "VUID-VkImageViewASTCDecodeModeEXT-decodeMode-parameter",
    "VUID-VkImageViewASTCDecodeModeEXT-format-04084",
    "VUID-VkImageViewASTCDecodeModeEXT-sType-sType",
    "VUID-VkImageViewAddressPropertiesNVX-pNext-pNext",
    "VUID-VkImageViewAddressPropertiesNVX-sType-sType",
    "VUID-VkImageViewCreateInfo-None-02273",
    "VUID-VkImageViewCreateInfo-components-parameter",
    "VUID-VkImageViewCreateInfo-flags-02572",
    "VUID-VkImageViewCreateInfo-flags-04083",
    "VUID-VkImageViewCreateInfo-flags-parameter",
    "VUID-VkImageViewCreateInfo-format-parameter",
    "VUID-VkImageViewCreateInfo-image-01003",
    "VUID-VkImageViewCreateInfo-image-01005",
    "VUID-VkImageViewCreateInfo-image-01007",
    "VUID-VkImageViewCreateInfo-image-01018",
    "VUID-VkImageViewCreateInfo-image-01019",
    "VUID-VkImageViewCreateInfo-image-01020",
    "VUID-VkImageViewCreateInfo-image-01482",
    "VUID-VkImageViewCreateInfo-image-01583",
    "VUID-VkImageViewCreateInfo-image-01584",
    "VUID-VkImageViewCreateInfo-image-01586",
    "VUID-VkImageViewCreateInfo-image-01759",
    "VUID-VkImageViewCreateInfo-image-01760",
    "VUID-VkImageViewCreateInfo-image-01761",
    "VUID-VkImageViewCreateInfo-image-01762",
    "VUID-VkImageViewCreateInfo-image-02085",
    "VUID-VkImageViewCreateInfo-image-02086",
    "VUID-VkImageViewCreateInfo-image-02087",
    "VUID-VkImageViewCreateInfo-image-02399",
    "VUID-VkImageViewCreateInfo-image-02400",
    "VUID-VkImageViewCreateInfo-image-02401",
    "VUID-VkImageViewCreateInfo-image-02569",
    "VUID-VkImageViewCreateInfo-image-02570",
    "VUID-VkImageViewCreateInfo-image-02571",
    "VUID-VkImageViewCreateInfo-image-02573",
    "VUID-VkImageViewCreateInfo-image-02724",
    "VUID-VkImageViewCreateInfo-image-parameter",
    "VUID-VkImageViewCreateInfo-pNext-01585",
    "VUID-VkImageViewCreateInfo-pNext-01970",
    "VUID-VkImageViewCreateInfo-pNext-02661",
    "VUID-VkImageViewCreateInfo-pNext-02662",
    "VUID-VkImageViewCreateInfo-pNext-02663",
    "VUID-VkImageViewCreateInfo-pNext-02664",
    "VUID-VkImageViewCreateInfo-pNext-04082",
    "VUID-VkImageViewCreateInfo-pNext-pNext",
    "VUID-VkImageViewCreateInfo-sType-sType",
    "VUID-VkImageViewCreateInfo-sType-unique",
    "VUID-VkImageViewCreateInfo-subResourceRange-01021",
    "VUID-VkImageViewCreateInfo-subresourceRange-01478",
    "VUID-VkImageViewCreateInfo-subresourceRange-01480",
    "VUID-VkImageViewCreateInfo-subresourceRange-01483",
    "VUID-VkImageViewCreateInfo-subresourceRange-01718",
    "VUID-VkImageViewCreateInfo-subresourceRange-01719",
    "VUID-VkImageViewCreateInfo-subresourceRange-02725",
    "VUID-VkImageViewCreateInfo-subresourceRange-parameter",
    "VUID-VkImageViewCreateInfo-usage-02274",
    "VUID-VkImageViewCreateInfo-usage-02275",
    "VUID-VkImageViewCreateInfo-usage-02276",
    "VUID-VkImageViewCreateInfo-usage-02277",
    "VUID-VkImageViewCreateInfo-usage-02652",
    "VUID-VkImageViewCreateInfo-viewType-01004",
    "VUID-VkImageViewCreateInfo-viewType-02960",
    "VUID-VkImageViewCreateInfo-viewType-02961",
    "VUID-VkImageViewCreateInfo-viewType-02962",
    "VUID-VkImageViewCreateInfo-viewType-02963",
    "VUID-VkImageViewCreateInfo-viewType-parameter",
    "VUID-VkImageViewHandleInfoNVX-commonparent",
    "VUID-VkImageViewHandleInfoNVX-descriptorType-02654",
    "VUID-VkImageViewHandleInfoNVX-descriptorType-parameter",
    "VUID-VkImageViewHandleInfoNVX-imageView-02656",
    "VUID-VkImageViewHandleInfoNVX-imageView-02657",
    "VUID-VkImageViewHandleInfoNVX-imageView-parameter",
    "VUID-VkImageViewHandleInfoNVX-pNext-pNext",
    "VUID-VkImageViewHandleInfoNVX-sType-sType",
    "VUID-VkImageViewHandleInfoNVX-sampler-02655",
    "VUID-VkImageViewHandleInfoNVX-sampler-parameter",
    "VUID-VkImageViewUsageCreateInfo-sType-sType",
    "VUID-VkImageViewUsageCreateInfo-usage-parameter",
    "VUID-VkImageViewUsageCreateInfo-usage-requiredbitmask",
    "VUID-VkImportAndroidHardwareBufferInfoANDROID-buffer-01880",
    "VUID-VkImportAndroidHardwareBufferInfoANDROID-buffer-01881",
    "VUID-VkImportAndroidHardwareBufferInfoANDROID-buffer-parameter",
    "VUID-VkImportAndroidHardwareBufferInfoANDROID-sType-sType",
    "VUID-VkImportFenceFdInfoKHR-fd-01541",
    "VUID-VkImportFenceFdInfoKHR-fence-parameter",
    "VUID-VkImportFenceFdInfoKHR-flags-parameter",
    "VUID-VkImportFenceFdInfoKHR-handleType-01464",
    "VUID-VkImportFenceFdInfoKHR-handleType-parameter",
    "VUID-VkImportFenceFdInfoKHR-pNext-pNext",
    "VUID-VkImportFenceFdInfoKHR-sType-sType",
    "VUID-VkImportFenceWin32HandleInfoKHR-fence-parameter",
    "VUID-VkImportFenceWin32HandleInfoKHR-flags-parameter",
    "VUID-VkImportFenceWin32HandleInfoKHR-handle-01462",
    "VUID-VkImportFenceWin32HandleInfoKHR-handle-01539",
    "VUID-VkImportFenceWin32HandleInfoKHR-handleType-01457",
    "VUID-VkImportFenceWin32HandleInfoKHR-handleType-01459",
    "VUID-VkImportFenceWin32HandleInfoKHR-handleType-01460",
    "VUID-VkImportFenceWin32HandleInfoKHR-handleType-01461",
    "VUID-VkImportFenceWin32HandleInfoKHR-handleType-parameter",
    "VUID-VkImportFenceWin32HandleInfoKHR-name-01540",
    "VUID-VkImportFenceWin32HandleInfoKHR-pNext-pNext",
    "VUID-VkImportFenceWin32HandleInfoKHR-sType-sType",
    "VUID-VkImportMemoryFdInfoKHR-fd-00668",
    "VUID-VkImportMemoryFdInfoKHR-fd-01520",
    "VUID-VkImportMemoryFdInfoKHR-fd-01746",
    "VUID-VkImportMemoryFdInfoKHR-handleType-00667",
    "VUID-VkImportMemoryFdInfoKHR-handleType-00669",
    "VUID-VkImportMemoryFdInfoKHR-handleType-00670",
    "VUID-VkImportMemoryFdInfoKHR-handleType-parameter",
    "VUID-VkImportMemoryFdInfoKHR-sType-sType",
    "VUID-VkImportMemoryHostPointerInfoEXT-handleType-01747",
    "VUID-VkImportMemoryHostPointerInfoEXT-handleType-01748",
    "VUID-VkImportMemoryHostPointerInfoEXT-handleType-01750",
    "VUID-VkImportMemoryHostPointerInfoEXT-handleType-01751",
    "VUID-VkImportMemoryHostPointerInfoEXT-handleType-parameter",
    "VUID-VkImportMemoryHostPointerInfoEXT-pHostPointer-01749",
    "VUID-VkImportMemoryHostPointerInfoEXT-sType-sType",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handle-00659",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handle-01441",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handle-01518",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handleType-00658",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handleType-00660",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handleType-00661",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handleType-01439",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handleType-01440",
    "VUID-VkImportMemoryWin32HandleInfoKHR-handleType-parameter",
    "VUID-VkImportMemoryWin32HandleInfoKHR-name-01519",
    "VUID-VkImportMemoryWin32HandleInfoKHR-sType-sType",
    "VUID-VkImportMemoryWin32HandleInfoNV-handle-01328",
    "VUID-VkImportMemoryWin32HandleInfoNV-handleType-01327",
    "VUID-VkImportMemoryWin32HandleInfoNV-handleType-parameter",
    "VUID-VkImportMemoryWin32HandleInfoNV-sType-sType",
    "VUID-VkImportSemaphoreFdInfoKHR-fd-01544",
    "VUID-VkImportSemaphoreFdInfoKHR-flags-03323",
    "VUID-VkImportSemaphoreFdInfoKHR-flags-parameter",
    "VUID-VkImportSemaphoreFdInfoKHR-handleType-01143",
    "VUID-VkImportSemaphoreFdInfoKHR-handleType-03263",
    "VUID-VkImportSemaphoreFdInfoKHR-handleType-03264",
    "VUID-VkImportSemaphoreFdInfoKHR-handleType-parameter",
    "VUID-VkImportSemaphoreFdInfoKHR-pNext-pNext",
    "VUID-VkImportSemaphoreFdInfoKHR-sType-sType",
    "VUID-VkImportSemaphoreFdInfoKHR-semaphore-parameter",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-flags-03322",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-flags-parameter",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handle-01469",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handle-01542",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-01140",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-01466",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-01467",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-01468",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-03261",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-03262",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-handleType-parameter",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-name-01543",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-pNext-pNext",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-sType-sType",
    "VUID-VkImportSemaphoreWin32HandleInfoKHR-semaphore-parameter",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-flags-parameter",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-flags-requiredbitmask",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pNext-pNext",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pStreamStrides-02937",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pStreamStrides-parameter",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pTokens-02932",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pTokens-02933",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pTokens-02934",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pTokens-02935",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pTokens-parameter",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pipelineBindPoint-02930",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-pipelineBindPoint-parameter",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-sType-sType",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-streamCount-02936",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-streamCount-arraylength",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-tokenCount-02931",
    "VUID-VkIndirectCommandsLayoutCreateInfoNV-tokenCount-arraylength",
    "VUID-VkIndirectCommandsLayoutTokenNV-indirectStateFlags-parameter",
    "VUID-VkIndirectCommandsLayoutTokenNV-offset-02952",
    "VUID-VkIndirectCommandsLayoutTokenNV-pIndexTypeValues-parameter",
    "VUID-VkIndirectCommandsLayoutTokenNV-pIndexTypes-parameter",
    "VUID-VkIndirectCommandsLayoutTokenNV-pNext-pNext",
    "VUID-VkIndirectCommandsLayoutTokenNV-pushconstantPipelineLayout-parameter",
    "VUID-VkIndirectCommandsLayoutTokenNV-pushconstantShaderStageFlags-parameter",
    "VUID-VkIndirectCommandsLayoutTokenNV-sType-sType",
    "VUID-VkIndirectCommandsLayoutTokenNV-stream-02951",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02976",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02977",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02978",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02979",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02980",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02981",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02982",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02983",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-02984",
    "VUID-VkIndirectCommandsLayoutTokenNV-tokenType-parameter",
    "VUID-VkIndirectCommandsStreamNV-buffer-02942",
    "VUID-VkIndirectCommandsStreamNV-buffer-02975",
    "VUID-VkIndirectCommandsStreamNV-buffer-parameter",
    "VUID-VkIndirectCommandsStreamNV-offset-02943",
    "VUID-VkInitializePerformanceApiInfoINTEL-pNext-pNext",
    "VUID-VkInitializePerformanceApiInfoINTEL-sType-sType",
    "VUID-VkInputAttachmentAspectReference-aspectMask-01964",
    "VUID-VkInputAttachmentAspectReference-aspectMask-02250",
    "VUID-VkInputAttachmentAspectReference-aspectMask-parameter",
    "VUID-VkInputAttachmentAspectReference-aspectMask-requiredbitmask",
    "VUID-VkInstanceCreateInfo-flags-zerobitmask",
    "VUID-VkInstanceCreateInfo-pApplicationInfo-parameter",
    "VUID-VkInstanceCreateInfo-pNext-pNext",
    "VUID-VkInstanceCreateInfo-ppEnabledExtensionNames-parameter",
    "VUID-VkInstanceCreateInfo-ppEnabledLayerNames-parameter",
    "VUID-VkInstanceCreateInfo-sType-sType",
    "VUID-VkInstanceCreateInfo-sType-unique",
    "VUID-VkMacOSSurfaceCreateInfoMVK-flags-zerobitmask",
    "VUID-VkMacOSSurfaceCreateInfoMVK-pNext-pNext",
    "VUID-VkMacOSSurfaceCreateInfoMVK-pView-01317",
    "VUID-VkMacOSSurfaceCreateInfoMVK-sType-sType",
    "VUID-VkMappedMemoryRange-memory-00684",
    "VUID-VkMappedMemoryRange-memory-parameter",
    "VUID-VkMappedMemoryRange-offset-00687",
    "VUID-VkMappedMemoryRange-pNext-pNext",
    "VUID-VkMappedMemoryRange-sType-sType",
    "VUID-VkMappedMemoryRange-size-00685",
    "VUID-VkMappedMemoryRange-size-00686",
    "VUID-VkMappedMemoryRange-size-01389",
    "VUID-VkMappedMemoryRange-size-01390",
    "VUID-VkMemoryAllocateFlagsInfo-deviceMask-00675",
    "VUID-VkMemoryAllocateFlagsInfo-deviceMask-00676",
    "VUID-VkMemoryAllocateFlagsInfo-flags-parameter",
    "VUID-VkMemoryAllocateFlagsInfo-sType-sType",
    "VUID-VkMemoryAllocateInfo-None-00643",
    "VUID-VkMemoryAllocateInfo-None-00644",
    "VUID-VkMemoryAllocateInfo-allocationSize-00638",
    "VUID-VkMemoryAllocateInfo-allocationSize-00646",
    "VUID-VkMemoryAllocateInfo-allocationSize-00647",
    "VUID-VkMemoryAllocateInfo-allocationSize-01742",
    "VUID-VkMemoryAllocateInfo-allocationSize-01743",
    "VUID-VkMemoryAllocateInfo-allocationSize-01745",
    "VUID-VkMemoryAllocateInfo-allocationSize-02383",
    "VUID-VkMemoryAllocateInfo-flags-03330",
    "VUID-VkMemoryAllocateInfo-flags-03331",
    "VUID-VkMemoryAllocateInfo-memoryTypeIndex-00645",
    "VUID-VkMemoryAllocateInfo-memoryTypeIndex-00648",
    "VUID-VkMemoryAllocateInfo-memoryTypeIndex-01744",
    "VUID-VkMemoryAllocateInfo-memoryTypeIndex-01872",
    "VUID-VkMemoryAllocateInfo-memoryTypeIndex-02385",
    "VUID-VkMemoryAllocateInfo-opaqueCaptureAddress-03329",
    "VUID-VkMemoryAllocateInfo-opaqueCaptureAddress-03333",
    "VUID-VkMemoryAllocateInfo-pNext-00639",
    "VUID-VkMemoryAllocateInfo-pNext-00640",
    "VUID-VkMemoryAllocateInfo-pNext-00641",
    "VUID-VkMemoryAllocateInfo-pNext-01874",
    "VUID-VkMemoryAllocateInfo-pNext-02384",
    "VUID-VkMemoryAllocateInfo-pNext-02386",
    "VUID-VkMemoryAllocateInfo-pNext-02387",
    "VUID-VkMemoryAllocateInfo-pNext-02388",
    "VUID-VkMemoryAllocateInfo-pNext-02389",
    "VUID-VkMemoryAllocateInfo-pNext-02390",
    "VUID-VkMemoryAllocateInfo-pNext-02586",
    "VUID-VkMemoryAllocateInfo-pNext-02805",
    "VUID-VkMemoryAllocateInfo-pNext-02806",
    "VUID-VkMemoryAllocateInfo-pNext-03332",
    "VUID-VkMemoryAllocateInfo-pNext-pNext",
    "VUID-VkMemoryAllocateInfo-sType-sType",
    "VUID-VkMemoryAllocateInfo-sType-unique",
    "VUID-VkMemoryBarrier-dstAccessMask-parameter",
    "VUID-VkMemoryBarrier-pNext-pNext",
    "VUID-VkMemoryBarrier-sType-sType",
    "VUID-VkMemoryBarrier-srcAccessMask-parameter",
    "VUID-VkMemoryDedicatedAllocateInfo-buffer-01435",
    "VUID-VkMemoryDedicatedAllocateInfo-buffer-01436",
    "VUID-VkMemoryDedicatedAllocateInfo-buffer-01877",
    "VUID-VkMemoryDedicatedAllocateInfo-buffer-01879",
    "VUID-VkMemoryDedicatedAllocateInfo-buffer-02965",
    "VUID-VkMemoryDedicatedAllocateInfo-buffer-parameter",
    "VUID-VkMemoryDedicatedAllocateInfo-commonparent",
    "VUID-VkMemoryDedicatedAllocateInfo-image-01432",
    "VUID-VkMemoryDedicatedAllocateInfo-image-01433",
    "VUID-VkMemoryDedicatedAllocateInfo-image-01434",
    "VUID-VkMemoryDedicatedAllocateInfo-image-01797",
    "VUID-VkMemoryDedicatedAllocateInfo-image-01876",
    "VUID-VkMemoryDedicatedAllocateInfo-image-01878",
    "VUID-VkMemoryDedicatedAllocateInfo-image-02964",
    "VUID-VkMemoryDedicatedAllocateInfo-image-parameter",
    "VUID-VkMemoryDedicatedAllocateInfo-sType-sType",
    "VUID-VkMemoryDedicatedRequirements-sType-sType",
    "VUID-VkMemoryFdPropertiesKHR-pNext-pNext",
    "VUID-VkMemoryFdPropertiesKHR-sType-sType",
    "VUID-VkMemoryGetAndroidHardwareBufferInfoANDROID-handleTypes-01882",
    "VUID-VkMemoryGetAndroidHardwareBufferInfoANDROID-memory-parameter",
    "VUID-VkMemoryGetAndroidHardwareBufferInfoANDROID-pNext-01883",
    "VUID-VkMemoryGetAndroidHardwareBufferInfoANDROID-pNext-pNext",
    "VUID-VkMemoryGetAndroidHardwareBufferInfoANDROID-sType-sType",
    "VUID-VkMemoryGetFdInfoKHR-handleType-00671",
    "VUID-VkMemoryGetFdInfoKHR-handleType-00672",
    "VUID-VkMemoryGetFdInfoKHR-handleType-parameter",
    "VUID-VkMemoryGetFdInfoKHR-memory-parameter",
    "VUID-VkMemoryGetFdInfoKHR-pNext-pNext",
    "VUID-VkMemoryGetFdInfoKHR-sType-sType",
    "VUID-VkMemoryGetWin32HandleInfoKHR-handleType-00662",
    "VUID-VkMemoryGetWin32HandleInfoKHR-handleType-00663",
    "VUID-VkMemoryGetWin32HandleInfoKHR-handleType-00664",
    "VUID-VkMemoryGetWin32HandleInfoKHR-handleType-parameter",
    "VUID-VkMemoryGetWin32HandleInfoKHR-memory-parameter",
    "VUID-VkMemoryGetWin32HandleInfoKHR-pNext-pNext",
    "VUID-VkMemoryGetWin32HandleInfoKHR-sType-sType",
    "VUID-VkMemoryHostPointerPropertiesEXT-pNext-pNext",
    "VUID-VkMemoryHostPointerPropertiesEXT-sType-sType",
    "VUID-VkMemoryOpaqueCaptureAddressAllocateInfo-sType-sType",
    "VUID-VkMemoryPriorityAllocateInfoEXT-priority-02602",
    "VUID-VkMemoryPriorityAllocateInfoEXT-sType-sType",
    "VUID-VkMemoryRequirements2-pNext-pNext",
    "VUID-VkMemoryRequirements2-sType-sType",
    "VUID-VkMemoryRequirements2-sType-unique",
    "VUID-VkMemoryWin32HandlePropertiesKHR-pNext-pNext",
    "VUID-VkMemoryWin32HandlePropertiesKHR-sType-sType",
    "VUID-VkMetalSurfaceCreateInfoEXT-flags-zerobitmask",
    "VUID-VkMetalSurfaceCreateInfoEXT-pNext-pNext",
    "VUID-VkMetalSurfaceCreateInfoEXT-sType-sType",
    "VUID-VkMultisamplePropertiesEXT-pNext-pNext",
    "VUID-VkMultisamplePropertiesEXT-sType-sType",
    "VUID-VkPerformanceConfigurationAcquireInfoINTEL-pNext-pNext",
    "VUID-VkPerformanceConfigurationAcquireInfoINTEL-sType-sType",
    "VUID-VkPerformanceConfigurationAcquireInfoINTEL-type-parameter",
    "VUID-VkPerformanceCounterDescriptionKHR-pNext-pNext",
    "VUID-VkPerformanceCounterDescriptionKHR-sType-sType",
    "VUID-VkPerformanceCounterKHR-pNext-pNext",
    "VUID-VkPerformanceCounterKHR-sType-sType",
    "VUID-VkPerformanceMarkerInfoINTEL-pNext-pNext",
    "VUID-VkPerformanceMarkerInfoINTEL-sType-sType",
    "VUID-VkPerformanceOverrideInfoINTEL-pNext-pNext",
    "VUID-VkPerformanceOverrideInfoINTEL-sType-sType",
    "VUID-VkPerformanceOverrideInfoINTEL-type-parameter",
    "VUID-VkPerformanceQuerySubmitInfoKHR-counterPassIndex-03221",
    "VUID-VkPerformanceQuerySubmitInfoKHR-sType-sType",
    "VUID-VkPerformanceStreamMarkerInfoINTEL-marker-02735",
    "VUID-VkPerformanceStreamMarkerInfoINTEL-pNext-pNext",
    "VUID-VkPerformanceStreamMarkerInfoINTEL-sType-sType",
    "VUID-VkPerformanceValueINTEL-type-parameter",
    "VUID-VkPerformanceValueINTEL-valueString-parameter",
    "VUID-VkPhysicalDevice16BitStorageFeatures-sType-sType",
    "VUID-VkPhysicalDevice8BitStorageFeatures-sType-sType",
    "VUID-VkPhysicalDeviceASTCDecodeFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceBlendOperationAdvancedFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceBlendOperationAdvancedPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceBufferDeviceAddressFeatures-sType-sType",
    "VUID-VkPhysicalDeviceBufferDeviceAddressFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceCoherentMemoryFeaturesAMD-sType-sType",
    "VUID-VkPhysicalDeviceComputeShaderDerivativesFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceConditionalRenderingFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceConservativeRasterizationPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceCooperativeMatrixFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceCooperativeMatrixPropertiesNV-sType-sType",
    "VUID-VkPhysicalDeviceCornerSampledImageFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceCoverageReductionModeFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceCustomBorderColorFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceCustomBorderColorPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceDedicatedAllocationImageAliasingFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceDepthClipEnableFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceDepthStencilResolveProperties-sType-sType",
    "VUID-VkPhysicalDeviceDescriptorIndexingFeatures-sType-sType",
    "VUID-VkPhysicalDeviceDescriptorIndexingProperties-sType-sType",
    "VUID-VkPhysicalDeviceDeviceGeneratedCommandsFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceDeviceGeneratedCommandsPropertiesNV-sType-sType",
    "VUID-VkPhysicalDeviceDiagnosticsConfigFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceDiscardRectanglePropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceDriverProperties-sType-sType",
    "VUID-VkPhysicalDeviceExclusiveScissorFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceExternalBufferInfo-flags-parameter",
    "VUID-VkPhysicalDeviceExternalBufferInfo-handleType-parameter",
    "VUID-VkPhysicalDeviceExternalBufferInfo-pNext-pNext",
    "VUID-VkPhysicalDeviceExternalBufferInfo-sType-sType",
    "VUID-VkPhysicalDeviceExternalBufferInfo-usage-parameter",
    "VUID-VkPhysicalDeviceExternalBufferInfo-usage-requiredbitmask",
    "VUID-VkPhysicalDeviceExternalFenceInfo-handleType-parameter",
    "VUID-VkPhysicalDeviceExternalFenceInfo-pNext-pNext",
    "VUID-VkPhysicalDeviceExternalFenceInfo-sType-sType",
    "VUID-VkPhysicalDeviceExternalImageFormatInfo-handleType-parameter",
    "VUID-VkPhysicalDeviceExternalImageFormatInfo-sType-sType",
    "VUID-VkPhysicalDeviceExternalMemoryHostPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceExternalSemaphoreInfo-handleType-parameter",
    "VUID-VkPhysicalDeviceExternalSemaphoreInfo-pNext-pNext",
    "VUID-VkPhysicalDeviceExternalSemaphoreInfo-sType-sType",
    "VUID-VkPhysicalDeviceExternalSemaphoreInfo-sType-unique",
    "VUID-VkPhysicalDeviceFeatures2-sType-sType",
    "VUID-VkPhysicalDeviceFloatControlsProperties-sType-sType",
    "VUID-VkPhysicalDeviceFragmentDensityMapFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceFragmentDensityMapPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceFragmentShaderBarycentricFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceFragmentShaderInterlockFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceGroupProperties-pNext-pNext",
    "VUID-VkPhysicalDeviceGroupProperties-sType-sType",
    "VUID-VkPhysicalDeviceHostQueryResetFeatures-sType-sType",
    "VUID-VkPhysicalDeviceIDProperties-sType-sType",
    "VUID-VkPhysicalDeviceImageDrmFormatModifierInfoEXT-sType-sType",
    "VUID-VkPhysicalDeviceImageDrmFormatModifierInfoEXT-sharingMode-02314",
    "VUID-VkPhysicalDeviceImageDrmFormatModifierInfoEXT-sharingMode-02315",
    "VUID-VkPhysicalDeviceImageDrmFormatModifierInfoEXT-sharingMode-02316",
    "VUID-VkPhysicalDeviceImageDrmFormatModifierInfoEXT-sharingMode-parameter",
    "VUID-VkPhysicalDeviceImageFormatInfo2-flags-parameter",
    "VUID-VkPhysicalDeviceImageFormatInfo2-format-parameter",
    "VUID-VkPhysicalDeviceImageFormatInfo2-pNext-pNext",
    "VUID-VkPhysicalDeviceImageFormatInfo2-sType-sType",
    "VUID-VkPhysicalDeviceImageFormatInfo2-sType-unique",
    "VUID-VkPhysicalDeviceImageFormatInfo2-tiling-02249",
    "VUID-VkPhysicalDeviceImageFormatInfo2-tiling-02313",
    "VUID-VkPhysicalDeviceImageFormatInfo2-tiling-parameter",
    "VUID-VkPhysicalDeviceImageFormatInfo2-type-parameter",
    "VUID-VkPhysicalDeviceImageFormatInfo2-usage-parameter",
    "VUID-VkPhysicalDeviceImageFormatInfo2-usage-requiredbitmask",
    "VUID-VkPhysicalDeviceImageViewImageFormatInfoEXT-imageViewType-parameter",
    "VUID-VkPhysicalDeviceImageViewImageFormatInfoEXT-sType-sType",
    "VUID-VkPhysicalDeviceImagelessFramebufferFeatures-sType-sType",
    "VUID-VkPhysicalDeviceIndexTypeUint8FeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceInlineUniformBlockFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceInlineUniformBlockPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceLineRasterizationFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceLineRasterizationPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceMaintenance3Properties-sType-sType",
    "VUID-VkPhysicalDeviceMemoryBudgetPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceMemoryPriorityFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceMemoryProperties2-pNext-pNext",
    "VUID-VkPhysicalDeviceMemoryProperties2-sType-sType",
    "VUID-VkPhysicalDeviceMemoryProperties2-sType-unique",
    "VUID-VkPhysicalDeviceMeshShaderFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceMeshShaderPropertiesNV-sType-sType",
    "VUID-VkPhysicalDeviceMultiviewFeatures-multiviewGeometryShader-00580",
    "VUID-VkPhysicalDeviceMultiviewFeatures-multiviewTessellationShader-00581",
    "VUID-VkPhysicalDeviceMultiviewFeatures-sType-sType",
    "VUID-VkPhysicalDeviceMultiviewPerViewAttributesPropertiesNVX-sType-sType",
    "VUID-VkPhysicalDeviceMultiviewProperties-sType-sType",
    "VUID-VkPhysicalDevicePCIBusInfoPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDevicePerformanceQueryFeaturesKHR-sType-sType",
    "VUID-VkPhysicalDevicePerformanceQueryPropertiesKHR-sType-sType",
    "VUID-VkPhysicalDevicePipelineCreationCacheControlFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDevicePipelineExecutablePropertiesFeaturesKHR-sType-sType",
    "VUID-VkPhysicalDevicePointClippingProperties-sType-sType",
    "VUID-VkPhysicalDevicePrivateDataFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceProperties2-pNext-pNext",
    "VUID-VkPhysicalDeviceProperties2-sType-sType",
    "VUID-VkPhysicalDeviceProperties2-sType-unique",
    "VUID-VkPhysicalDeviceProtectedMemoryFeatures-sType-sType",
    "VUID-VkPhysicalDeviceProtectedMemoryProperties-sType-sType",
    "VUID-VkPhysicalDevicePushDescriptorPropertiesKHR-sType-sType",
    "VUID-VkPhysicalDeviceRayTracingFeaturesKHR-rayTracingShaderGroupHandleCaptureReplayMixed-03348",
    "VUID-VkPhysicalDeviceRayTracingFeaturesKHR-sType-sType",
    "VUID-VkPhysicalDeviceRayTracingPropertiesKHR-sType-sType",
    "VUID-VkPhysicalDeviceRayTracingPropertiesNV-sType-sType",
    "VUID-VkPhysicalDeviceRepresentativeFragmentTestFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceRobustness2FeaturesEXT-robustBufferAccess2-04000",
    "VUID-VkPhysicalDeviceRobustness2FeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceRobustness2PropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceSampleLocationsPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceSamplerFilterMinmaxProperties-sType-sType",
    "VUID-VkPhysicalDeviceSamplerYcbcrConversionFeatures-sType-sType",
    "VUID-VkPhysicalDeviceScalarBlockLayoutFeatures-sType-sType",
    "VUID-VkPhysicalDeviceSeparateDepthStencilLayoutsFeatures-sType-sType",
    "VUID-VkPhysicalDeviceShaderAtomicInt64Features-sType-sType",
    "VUID-VkPhysicalDeviceShaderClockFeaturesKHR-sType-sType",
    "VUID-VkPhysicalDeviceShaderCoreProperties2AMD-sType-sType",
    "VUID-VkPhysicalDeviceShaderCorePropertiesAMD-sType-sType",
    "VUID-VkPhysicalDeviceShaderDemoteToHelperInvocationFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceShaderDrawParametersFeatures-sType-sType",
    "VUID-VkPhysicalDeviceShaderFloat16Int8Features-sType-sType",
    "VUID-VkPhysicalDeviceShaderImageFootprintFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceShaderIntegerFunctions2FeaturesINTEL-sType-sType",
    "VUID-VkPhysicalDeviceShaderSMBuiltinsFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceShaderSMBuiltinsPropertiesNV-sType-sType",
    "VUID-VkPhysicalDeviceShaderSubgroupExtendedTypesFeatures-sType-sType",
    "VUID-VkPhysicalDeviceShadingRateImageFeaturesNV-sType-sType",
    "VUID-VkPhysicalDeviceShadingRateImagePropertiesNV-sType-sType",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-format-parameter",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-pNext-pNext",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-sType-sType",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-samples-01095",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-samples-parameter",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-tiling-parameter",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-type-parameter",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-usage-parameter",
    "VUID-VkPhysicalDeviceSparseImageFormatInfo2-usage-requiredbitmask",
    "VUID-VkPhysicalDeviceSubgroupProperties-sType-sType",
    "VUID-VkPhysicalDeviceSubgroupSizeControlFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceSubgroupSizeControlPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceSurfaceInfo2KHR-pNext-02672",
    "VUID-VkPhysicalDeviceSurfaceInfo2KHR-pNext-pNext",
    "VUID-VkPhysicalDeviceSurfaceInfo2KHR-sType-sType",
    "VUID-VkPhysicalDeviceSurfaceInfo2KHR-sType-unique",
    "VUID-VkPhysicalDeviceSurfaceInfo2KHR-surface-parameter",
    "VUID-VkPhysicalDeviceTexelBufferAlignmentFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceTexelBufferAlignmentPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceTextureCompressionASTCHDRFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceTimelineSemaphoreFeatures-sType-sType",
    "VUID-VkPhysicalDeviceTimelineSemaphoreProperties-sType-sType",
    "VUID-VkPhysicalDeviceToolPropertiesEXT-pNext-pNext",
    "VUID-VkPhysicalDeviceToolPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceTransformFeedbackFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceTransformFeedbackPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceUniformBufferStandardLayoutFeatures-sType-sType",
    "VUID-VkPhysicalDeviceVariablePointersFeatures-sType-sType",
    "VUID-VkPhysicalDeviceVariablePointersFeatures-variablePointers-01431",
    "VUID-VkPhysicalDeviceVertexAttributeDivisorFeaturesEXT-sType-sType",
    "VUID-VkPhysicalDeviceVertexAttributeDivisorPropertiesEXT-sType-sType",
    "VUID-VkPhysicalDeviceVulkan11Features-sType-sType",
    "VUID-VkPhysicalDeviceVulkan11Properties-sType-sType",
    "VUID-VkPhysicalDeviceVulkan12Features-sType-sType",
    "VUID-VkPhysicalDeviceVulkan12Properties-sType-sType",
    "VUID-VkPhysicalDeviceVulkanMemoryModelFeatures-sType-sType",
    "VUID-VkPhysicalDeviceYcbcrImageArraysFeaturesEXT-sType-sType",
    "VUID-VkPipelineCacheCreateInfo-flags-parameter",
    "VUID-VkPipelineCacheCreateInfo-initialDataSize-00768",
    "VUID-VkPipelineCacheCreateInfo-initialDataSize-00769",
    "VUID-VkPipelineCacheCreateInfo-pInitialData-parameter",
    "VUID-VkPipelineCacheCreateInfo-pNext-pNext",
    "VUID-VkPipelineCacheCreateInfo-pipelineCreationCacheControl-02892",
    "VUID-VkPipelineCacheCreateInfo-sType-sType",
    "VUID-VkPipelineColorBlendAdvancedStateCreateInfoEXT-blendOverlap-01426",
    "VUID-VkPipelineColorBlendAdvancedStateCreateInfoEXT-blendOverlap-parameter",
    "VUID-VkPipelineColorBlendAdvancedStateCreateInfoEXT-dstPremultiplied-01425",
    "VUID-VkPipelineColorBlendAdvancedStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineColorBlendAdvancedStateCreateInfoEXT-srcPremultiplied-01424",
    "VUID-VkPipelineColorBlendAttachmentState-advancedBlendAllOperations-01409",
    "VUID-VkPipelineColorBlendAttachmentState-advancedBlendIndependentBlend-01407",
    "VUID-VkPipelineColorBlendAttachmentState-advancedBlendIndependentBlend-01408",
    "VUID-VkPipelineColorBlendAttachmentState-alphaBlendOp-parameter",
    "VUID-VkPipelineColorBlendAttachmentState-colorBlendOp-01406",
    "VUID-VkPipelineColorBlendAttachmentState-colorBlendOp-01410",
    "VUID-VkPipelineColorBlendAttachmentState-colorBlendOp-parameter",
    "VUID-VkPipelineColorBlendAttachmentState-colorWriteMask-parameter",
    "VUID-VkPipelineColorBlendAttachmentState-dstAlphaBlendFactor-00611",
    "VUID-VkPipelineColorBlendAttachmentState-dstAlphaBlendFactor-parameter",
    "VUID-VkPipelineColorBlendAttachmentState-dstColorBlendFactor-00609",
    "VUID-VkPipelineColorBlendAttachmentState-dstColorBlendFactor-parameter",
    "VUID-VkPipelineColorBlendAttachmentState-srcAlphaBlendFactor-00610",
    "VUID-VkPipelineColorBlendAttachmentState-srcAlphaBlendFactor-parameter",
    "VUID-VkPipelineColorBlendAttachmentState-srcColorBlendFactor-00608",
    "VUID-VkPipelineColorBlendAttachmentState-srcColorBlendFactor-parameter",
    "VUID-VkPipelineColorBlendStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineColorBlendStateCreateInfo-logicOpEnable-00606",
    "VUID-VkPipelineColorBlendStateCreateInfo-logicOpEnable-00607",
    "VUID-VkPipelineColorBlendStateCreateInfo-pAttachments-00605",
    "VUID-VkPipelineColorBlendStateCreateInfo-pAttachments-parameter",
    "VUID-VkPipelineColorBlendStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineColorBlendStateCreateInfo-sType-sType",
    "VUID-VkPipelineColorBlendStateCreateInfo-sType-unique",
    "VUID-VkPipelineCompilerControlCreateInfoAMD-compilerControlFlags-zerobitmask",
    "VUID-VkPipelineCompilerControlCreateInfoAMD-sType-sType",
    "VUID-VkPipelineCoverageModulationStateCreateInfoNV-coverageModulationMode-parameter",
    "VUID-VkPipelineCoverageModulationStateCreateInfoNV-coverageModulationTableEnable-01405",
    "VUID-VkPipelineCoverageModulationStateCreateInfoNV-flags-zerobitmask",
    "VUID-VkPipelineCoverageModulationStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineCoverageReductionStateCreateInfoNV-coverageReductionMode-parameter",
    "VUID-VkPipelineCoverageReductionStateCreateInfoNV-flags-zerobitmask",
    "VUID-VkPipelineCoverageReductionStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineCoverageToColorStateCreateInfoNV-coverageToColorEnable-01404",
    "VUID-VkPipelineCoverageToColorStateCreateInfoNV-flags-zerobitmask",
    "VUID-VkPipelineCoverageToColorStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pPipelineCreationFeedback-parameter",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pPipelineStageCreationFeedbacks-parameter",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pipelineStageCreationFeedbackCount-02668",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pipelineStageCreationFeedbackCount-02669",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pipelineStageCreationFeedbackCount-02670",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pipelineStageCreationFeedbackCount-02969",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-pipelineStageCreationFeedbackCount-arraylength",
    "VUID-VkPipelineCreationFeedbackCreateInfoEXT-sType-sType",
    "VUID-VkPipelineDepthStencilStateCreateInfo-back-parameter",
    "VUID-VkPipelineDepthStencilStateCreateInfo-depthBoundsTestEnable-00598",
    "VUID-VkPipelineDepthStencilStateCreateInfo-depthCompareOp-parameter",
    "VUID-VkPipelineDepthStencilStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineDepthStencilStateCreateInfo-front-parameter",
    "VUID-VkPipelineDepthStencilStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineDepthStencilStateCreateInfo-sType-sType",
    "VUID-VkPipelineDiscardRectangleStateCreateInfoEXT-discardRectangleCount-00582",
    "VUID-VkPipelineDiscardRectangleStateCreateInfoEXT-discardRectangleMode-parameter",
    "VUID-VkPipelineDiscardRectangleStateCreateInfoEXT-flags-zerobitmask",
    "VUID-VkPipelineDiscardRectangleStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineDynamicStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineDynamicStateCreateInfo-pDynamicStates-01442",
    "VUID-VkPipelineDynamicStateCreateInfo-pDynamicStates-parameter",
    "VUID-VkPipelineDynamicStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineDynamicStateCreateInfo-sType-sType",
    "VUID-VkPipelineExecutableInfoKHR-executableIndex-03275",
    "VUID-VkPipelineExecutableInfoKHR-pNext-pNext",
    "VUID-VkPipelineExecutableInfoKHR-pipeline-parameter",
    "VUID-VkPipelineExecutableInfoKHR-sType-sType",
    "VUID-VkPipelineExecutableInternalRepresentationKHR-pNext-pNext",
    "VUID-VkPipelineExecutableInternalRepresentationKHR-sType-sType",
    "VUID-VkPipelineExecutablePropertiesKHR-pNext-pNext",
    "VUID-VkPipelineExecutablePropertiesKHR-sType-sType",
    "VUID-VkPipelineExecutableStatisticKHR-pNext-pNext",
    "VUID-VkPipelineExecutableStatisticKHR-sType-sType",
    "VUID-VkPipelineInfoKHR-pNext-pNext",
    "VUID-VkPipelineInfoKHR-pipeline-parameter",
    "VUID-VkPipelineInfoKHR-sType-sType",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-sType-sType",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-topology-00428",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-topology-00429",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-topology-00430",
    "VUID-VkPipelineInputAssemblyStateCreateInfo-topology-parameter",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02212",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02213",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02214",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02215",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02216",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02217",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-02381",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03016",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03017",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03018",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03019",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03020",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03021",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03022",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03023",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03024",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03025",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03026",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03027",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03028",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03029",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03030",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03031",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03032",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03033",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03034",
    "VUID-VkPipelineLayoutCreateInfo-descriptorType-03035",
    "VUID-VkPipelineLayoutCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineLayoutCreateInfo-pNext-pNext",
    "VUID-VkPipelineLayoutCreateInfo-pPushConstantRanges-00292",
    "VUID-VkPipelineLayoutCreateInfo-pPushConstantRanges-parameter",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-00287",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-00288",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-00289",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-00290",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-00291",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-00293",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01676",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01677",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01678",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01679",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01680",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01681",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01682",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01683",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-01684",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03036",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03037",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03038",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03039",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03040",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03041",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03042",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-03043",
    "VUID-VkPipelineLayoutCreateInfo-pSetLayouts-parameter",
    "VUID-VkPipelineLayoutCreateInfo-sType-sType",
    "VUID-VkPipelineLayoutCreateInfo-setLayoutCount-00286",
    "VUID-VkPipelineLibraryCreateInfoKHR-pLibraries-03381",
    "VUID-VkPipelineLibraryCreateInfoKHR-pLibraries-parameter",
    "VUID-VkPipelineLibraryCreateInfoKHR-pNext-pNext",
    "VUID-VkPipelineLibraryCreateInfoKHR-sType-sType",
    "VUID-VkPipelineMultisampleStateCreateInfo-alphaToOneEnable-00785",
    "VUID-VkPipelineMultisampleStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineMultisampleStateCreateInfo-minSampleShading-00786",
    "VUID-VkPipelineMultisampleStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineMultisampleStateCreateInfo-pSampleMask-parameter",
    "VUID-VkPipelineMultisampleStateCreateInfo-rasterizationSamples-01415",
    "VUID-VkPipelineMultisampleStateCreateInfo-rasterizationSamples-parameter",
    "VUID-VkPipelineMultisampleStateCreateInfo-sType-sType",
    "VUID-VkPipelineMultisampleStateCreateInfo-sType-unique",
    "VUID-VkPipelineMultisampleStateCreateInfo-sampleShadingEnable-00784",
    "VUID-VkPipelineRasterizationConservativeStateCreateInfoEXT-conservativeRasterizationMode-parameter",
    "VUID-VkPipelineRasterizationConservativeStateCreateInfoEXT-extraPrimitiveOverestimationSize-01769",
    "VUID-VkPipelineRasterizationConservativeStateCreateInfoEXT-flags-zerobitmask",
    "VUID-VkPipelineRasterizationConservativeStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineRasterizationDepthClipStateCreateInfoEXT-flags-zerobitmask",
    "VUID-VkPipelineRasterizationDepthClipStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-lineRasterizationMode-02768",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-lineRasterizationMode-02769",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-lineRasterizationMode-02770",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-lineRasterizationMode-parameter",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-stippledLineEnable-02771",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-stippledLineEnable-02772",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-stippledLineEnable-02773",
    "VUID-VkPipelineRasterizationLineStateCreateInfoEXT-stippledLineEnable-02774",
    "VUID-VkPipelineRasterizationStateCreateInfo-cullMode-parameter",
    "VUID-VkPipelineRasterizationStateCreateInfo-depthClampEnable-00782",
    "VUID-VkPipelineRasterizationStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineRasterizationStateCreateInfo-frontFace-parameter",
    "VUID-VkPipelineRasterizationStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineRasterizationStateCreateInfo-polygonMode-01413",
    "VUID-VkPipelineRasterizationStateCreateInfo-polygonMode-01414",
    "VUID-VkPipelineRasterizationStateCreateInfo-polygonMode-01507",
    "VUID-VkPipelineRasterizationStateCreateInfo-polygonMode-parameter",
    "VUID-VkPipelineRasterizationStateCreateInfo-sType-sType",
    "VUID-VkPipelineRasterizationStateCreateInfo-sType-unique",
    "VUID-VkPipelineRasterizationStateRasterizationOrderAMD-rasterizationOrder-parameter",
    "VUID-VkPipelineRasterizationStateRasterizationOrderAMD-sType-sType",
    "VUID-VkPipelineRasterizationStateStreamCreateInfoEXT-flags-zerobitmask",
    "VUID-VkPipelineRasterizationStateStreamCreateInfoEXT-geometryStreams-02324",
    "VUID-VkPipelineRasterizationStateStreamCreateInfoEXT-rasterizationStream-02325",
    "VUID-VkPipelineRasterizationStateStreamCreateInfoEXT-rasterizationStream-02326",
    "VUID-VkPipelineRasterizationStateStreamCreateInfoEXT-sType-sType",
    "VUID-VkPipelineRepresentativeFragmentTestStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineSampleLocationsStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineSampleLocationsStateCreateInfoEXT-sampleLocationsInfo-parameter",
    "VUID-VkPipelineShaderStageCreateInfo-flags-02758",
    "VUID-VkPipelineShaderStageCreateInfo-flags-02759",
    "VUID-VkPipelineShaderStageCreateInfo-flags-02784",
    "VUID-VkPipelineShaderStageCreateInfo-flags-02785",
    "VUID-VkPipelineShaderStageCreateInfo-flags-parameter",
    "VUID-VkPipelineShaderStageCreateInfo-maxClipDistances-00708",
    "VUID-VkPipelineShaderStageCreateInfo-maxCombinedClipAndCullDistances-00710",
    "VUID-VkPipelineShaderStageCreateInfo-maxCullDistances-00709",
    "VUID-VkPipelineShaderStageCreateInfo-maxSampleMaskWords-00711",
    "VUID-VkPipelineShaderStageCreateInfo-module-parameter",
    "VUID-VkPipelineShaderStageCreateInfo-pName-00707",
    "VUID-VkPipelineShaderStageCreateInfo-pName-parameter",
    "VUID-VkPipelineShaderStageCreateInfo-pNext-02754",
    "VUID-VkPipelineShaderStageCreateInfo-pNext-02755",
    "VUID-VkPipelineShaderStageCreateInfo-pNext-02756",
    "VUID-VkPipelineShaderStageCreateInfo-pNext-02757",
    "VUID-VkPipelineShaderStageCreateInfo-pNext-pNext",
    "VUID-VkPipelineShaderStageCreateInfo-pSpecializationInfo-parameter",
    "VUID-VkPipelineShaderStageCreateInfo-sType-sType",
    "VUID-VkPipelineShaderStageCreateInfo-sType-unique",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00704",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00705",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00706",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00712",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00713",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00714",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00715",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00718",
    "VUID-VkPipelineShaderStageCreateInfo-stage-00719",
    "VUID-VkPipelineShaderStageCreateInfo-stage-01511",
    "VUID-VkPipelineShaderStageCreateInfo-stage-02091",
    "VUID-VkPipelineShaderStageCreateInfo-stage-02092",
    "VUID-VkPipelineShaderStageCreateInfo-stage-02093",
    "VUID-VkPipelineShaderStageCreateInfo-stage-02094",
    "VUID-VkPipelineShaderStageCreateInfo-stage-02596",
    "VUID-VkPipelineShaderStageCreateInfo-stage-02597",
    "VUID-VkPipelineShaderStageCreateInfo-stage-parameter",
    "VUID-VkPipelineShaderStageRequiredSubgroupSizeCreateInfoEXT-requiredSubgroupSize-02760",
    "VUID-VkPipelineShaderStageRequiredSubgroupSizeCreateInfoEXT-requiredSubgroupSize-02761",
    "VUID-VkPipelineShaderStageRequiredSubgroupSizeCreateInfoEXT-requiredSubgroupSize-02762",
    "VUID-VkPipelineShaderStageRequiredSubgroupSizeCreateInfoEXT-sType-sType",
    "VUID-VkPipelineTessellationDomainOriginStateCreateInfo-domainOrigin-parameter",
    "VUID-VkPipelineTessellationDomainOriginStateCreateInfo-sType-sType",
    "VUID-VkPipelineTessellationStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineTessellationStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineTessellationStateCreateInfo-patchControlPoints-01214",
    "VUID-VkPipelineTessellationStateCreateInfo-sType-sType",
    "VUID-VkPipelineTessellationStateCreateInfo-sType-unique",
    "VUID-VkPipelineVertexInputDivisorStateCreateInfoEXT-pVertexBindingDivisors-parameter",
    "VUID-VkPipelineVertexInputDivisorStateCreateInfoEXT-sType-sType",
    "VUID-VkPipelineVertexInputDivisorStateCreateInfoEXT-vertexBindingDivisorCount-arraylength",
    "VUID-VkPipelineVertexInputStateCreateInfo-binding-00615",
    "VUID-VkPipelineVertexInputStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineVertexInputStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineVertexInputStateCreateInfo-pVertexAttributeDescriptions-00617",
    "VUID-VkPipelineVertexInputStateCreateInfo-pVertexAttributeDescriptions-parameter",
    "VUID-VkPipelineVertexInputStateCreateInfo-pVertexBindingDescriptions-00616",
    "VUID-VkPipelineVertexInputStateCreateInfo-pVertexBindingDescriptions-parameter",
    "VUID-VkPipelineVertexInputStateCreateInfo-sType-sType",
    "VUID-VkPipelineVertexInputStateCreateInfo-sType-unique",
    "VUID-VkPipelineVertexInputStateCreateInfo-vertexAttributeDescriptionCount-00614",
    "VUID-VkPipelineVertexInputStateCreateInfo-vertexBindingDescriptionCount-00613",
    "VUID-VkPipelineViewportCoarseSampleOrderStateCreateInfoNV-pCustomSampleOrders-02234",
    "VUID-VkPipelineViewportCoarseSampleOrderStateCreateInfoNV-pCustomSampleOrders-parameter",
    "VUID-VkPipelineViewportCoarseSampleOrderStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineViewportCoarseSampleOrderStateCreateInfoNV-sampleOrderType-02072",
    "VUID-VkPipelineViewportCoarseSampleOrderStateCreateInfoNV-sampleOrderType-parameter",
    "VUID-VkPipelineViewportExclusiveScissorStateCreateInfoNV-exclusiveScissorCount-02027",
    "VUID-VkPipelineViewportExclusiveScissorStateCreateInfoNV-exclusiveScissorCount-02028",
    "VUID-VkPipelineViewportExclusiveScissorStateCreateInfoNV-exclusiveScissorCount-02029",
    "VUID-VkPipelineViewportExclusiveScissorStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineViewportShadingRateImageStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineViewportShadingRateImageStateCreateInfoNV-shadingRateImageEnable-02056",
    "VUID-VkPipelineViewportShadingRateImageStateCreateInfoNV-viewportCount-02054",
    "VUID-VkPipelineViewportShadingRateImageStateCreateInfoNV-viewportCount-02055",
    "VUID-VkPipelineViewportShadingRateImageStateCreateInfoNV-viewportCount-arraylength",
    "VUID-VkPipelineViewportStateCreateInfo-flags-zerobitmask",
    "VUID-VkPipelineViewportStateCreateInfo-offset-02822",
    "VUID-VkPipelineViewportStateCreateInfo-offset-02823",
    "VUID-VkPipelineViewportStateCreateInfo-pNext-pNext",
    "VUID-VkPipelineViewportStateCreateInfo-sType-sType",
    "VUID-VkPipelineViewportStateCreateInfo-sType-unique",
    "VUID-VkPipelineViewportStateCreateInfo-scissorCount-01217",
    "VUID-VkPipelineViewportStateCreateInfo-scissorCount-01219",
    "VUID-VkPipelineViewportStateCreateInfo-scissorCount-01220",
    "VUID-VkPipelineViewportStateCreateInfo-scissorCount-arraylength",
    "VUID-VkPipelineViewportStateCreateInfo-viewportCount-01216",
    "VUID-VkPipelineViewportStateCreateInfo-viewportCount-01218",
    "VUID-VkPipelineViewportStateCreateInfo-viewportCount-arraylength",
    "VUID-VkPipelineViewportStateCreateInfo-viewportWScalingEnable-01726",
    "VUID-VkPipelineViewportStateCreateInfo-x-02821",
    "VUID-VkPipelineViewportSwizzleStateCreateInfoNV-flags-zerobitmask",
    "VUID-VkPipelineViewportSwizzleStateCreateInfoNV-pViewportSwizzles-parameter",
    "VUID-VkPipelineViewportSwizzleStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineViewportSwizzleStateCreateInfoNV-viewportCount-01215",
    "VUID-VkPipelineViewportSwizzleStateCreateInfoNV-viewportCount-arraylength",
    "VUID-VkPipelineViewportWScalingStateCreateInfoNV-sType-sType",
    "VUID-VkPipelineViewportWScalingStateCreateInfoNV-viewportCount-arraylength",
    "VUID-VkPresentFrameTokenGGP-frameToken-02680",
    "VUID-VkPresentFrameTokenGGP-sType-sType",
    "VUID-VkPresentInfoKHR-commonparent",
    "VUID-VkPresentInfoKHR-pImageIndices-01296",
    "VUID-VkPresentInfoKHR-pImageIndices-01430",
    "VUID-VkPresentInfoKHR-pImageIndices-parameter",
    "VUID-VkPresentInfoKHR-pNext-pNext",
    "VUID-VkPresentInfoKHR-pResults-parameter",
    "VUID-VkPresentInfoKHR-pSwapchains-parameter",
    "VUID-VkPresentInfoKHR-pWaitSemaphores-03269",
    "VUID-VkPresentInfoKHR-pWaitSemaphores-parameter",
    "VUID-VkPresentInfoKHR-sType-sType",
    "VUID-VkPresentInfoKHR-sType-unique",
    "VUID-VkPresentInfoKHR-swapchainCount-arraylength",
    "VUID-VkPresentRegionKHR-pRectangles-parameter",
    "VUID-VkPresentRegionsKHR-pRegions-parameter",
    "VUID-VkPresentRegionsKHR-sType-sType",
    "VUID-VkPresentRegionsKHR-swapchainCount-01260",
    "VUID-VkPresentRegionsKHR-swapchainCount-arraylength",
    "VUID-VkPresentTimesInfoGOOGLE-pTimes-parameter",
    "VUID-VkPresentTimesInfoGOOGLE-sType-sType",
    "VUID-VkPresentTimesInfoGOOGLE-swapchainCount-01247",
    "VUID-VkPresentTimesInfoGOOGLE-swapchainCount-arraylength",
    "VUID-VkPrivateDataSlotCreateInfoEXT-flags-zerobitmask",
    "VUID-VkPrivateDataSlotCreateInfoEXT-pNext-pNext",
    "VUID-VkPrivateDataSlotCreateInfoEXT-sType-sType",
    "VUID-VkProtectedSubmitInfo-pNext-01819",
    "VUID-VkProtectedSubmitInfo-protectedSubmit-01816",
    "VUID-VkProtectedSubmitInfo-protectedSubmit-01817",
    "VUID-VkProtectedSubmitInfo-protectedSubmit-01818",
    "VUID-VkProtectedSubmitInfo-sType-sType",
    "VUID-VkPushConstantRange-offset-00294",
    "VUID-VkPushConstantRange-offset-00295",
    "VUID-VkPushConstantRange-size-00296",
    "VUID-VkPushConstantRange-size-00297",
    "VUID-VkPushConstantRange-size-00298",
    "VUID-VkPushConstantRange-stageFlags-parameter",
    "VUID-VkPushConstantRange-stageFlags-requiredbitmask",
    "VUID-VkQueryPoolCreateInfo-flags-zerobitmask",
    "VUID-VkQueryPoolCreateInfo-pNext-pNext",
    "VUID-VkQueryPoolCreateInfo-queryCount-02763",
    "VUID-VkQueryPoolCreateInfo-queryType-00791",
    "VUID-VkQueryPoolCreateInfo-queryType-00792",
    "VUID-VkQueryPoolCreateInfo-queryType-03222",
    "VUID-VkQueryPoolCreateInfo-queryType-parameter",
    "VUID-VkQueryPoolCreateInfo-sType-sType",
    "VUID-VkQueryPoolCreateInfo-sType-unique",
    "VUID-VkQueryPoolPerformanceCreateInfoKHR-counterIndexCount-arraylength",
    "VUID-VkQueryPoolPerformanceCreateInfoKHR-pCounterIndices-03321",
    "VUID-VkQueryPoolPerformanceCreateInfoKHR-pCounterIndices-parameter",
    "VUID-VkQueryPoolPerformanceCreateInfoKHR-performanceCounterQueryPools-03237",
    "VUID-VkQueryPoolPerformanceCreateInfoKHR-queueFamilyIndex-03236",
    "VUID-VkQueryPoolPerformanceCreateInfoKHR-sType-sType",
    "VUID-VkQueryPoolPerformanceQueryCreateInfoINTEL-performanceCountersSampling-parameter",
    "VUID-VkQueryPoolPerformanceQueryCreateInfoINTEL-sType-sType",
    "VUID-VkQueueFamilyCheckpointPropertiesNV-sType-sType",
    "VUID-VkQueueFamilyProperties2-pNext-pNext",
    "VUID-VkQueueFamilyProperties2-sType-sType",
    "VUID-VkQueueFamilyProperties2-sType-unique",
    "VUID-VkRayTracingPipelineCreateInfoKHR-commonparent",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-02904",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03421",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03422",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03423",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03424",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03465",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03470",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-03471",
    "VUID-VkRayTracingPipelineCreateInfoKHR-flags-parameter",
    "VUID-VkRayTracingPipelineCreateInfoKHR-layout-03427",
    "VUID-VkRayTracingPipelineCreateInfoKHR-layout-03428",
    "VUID-VkRayTracingPipelineCreateInfoKHR-layout-parameter",
    "VUID-VkRayTracingPipelineCreateInfoKHR-libraries-02958",
    "VUID-VkRayTracingPipelineCreateInfoKHR-libraries-02959",
    "VUID-VkRayTracingPipelineCreateInfoKHR-libraries-parameter",
    "VUID-VkRayTracingPipelineCreateInfoKHR-libraryCount-03466",
    "VUID-VkRayTracingPipelineCreateInfoKHR-maxRecursionDepth-03464",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pGroups-parameter",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pLibraries-03467",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pLibraries-03468",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pLibraries-03469",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pLibraryInterface-parameter",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pNext-pNext",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pStages-03426",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pStages-parameter",
    "VUID-VkRayTracingPipelineCreateInfoKHR-pipelineCreationCacheControl-02905",
    "VUID-VkRayTracingPipelineCreateInfoKHR-rayTracingPrimitiveCulling-03472",
    "VUID-VkRayTracingPipelineCreateInfoKHR-rayTracingPrimitiveCulling-03473",
    "VUID-VkRayTracingPipelineCreateInfoKHR-sType-sType",
    "VUID-VkRayTracingPipelineCreateInfoKHR-sType-unique",
    "VUID-VkRayTracingPipelineCreateInfoKHR-stage-03425",
    "VUID-VkRayTracingPipelineCreateInfoNV-commonparent",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-02904",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-02957",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03421",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03422",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03423",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03424",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03456",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03458",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03459",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03460",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03461",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03462",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-03463",
    "VUID-VkRayTracingPipelineCreateInfoNV-flags-parameter",
    "VUID-VkRayTracingPipelineCreateInfoNV-groupCount-arraylength",
    "VUID-VkRayTracingPipelineCreateInfoNV-layout-03427",
    "VUID-VkRayTracingPipelineCreateInfoNV-layout-03428",
    "VUID-VkRayTracingPipelineCreateInfoNV-layout-parameter",
    "VUID-VkRayTracingPipelineCreateInfoNV-maxRecursionDepth-03457",
    "VUID-VkRayTracingPipelineCreateInfoNV-pGroups-parameter",
    "VUID-VkRayTracingPipelineCreateInfoNV-pNext-pNext",
    "VUID-VkRayTracingPipelineCreateInfoNV-pStages-03426",
    "VUID-VkRayTracingPipelineCreateInfoNV-pStages-parameter",
    "VUID-VkRayTracingPipelineCreateInfoNV-pipelineCreationCacheControl-02905",
    "VUID-VkRayTracingPipelineCreateInfoNV-sType-sType",
    "VUID-VkRayTracingPipelineCreateInfoNV-sType-unique",
    "VUID-VkRayTracingPipelineCreateInfoNV-stage-03425",
    "VUID-VkRayTracingPipelineCreateInfoNV-stageCount-arraylength",
    "VUID-VkRayTracingPipelineInterfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkRayTracingPipelineInterfaceCreateInfoKHR-sType-sType",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-anyHitShader-03479",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-closestHitShader-03478",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-pNext-pNext",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-rayTracingShaderGroupHandleCaptureReplayMixed-03480",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-rayTracingShaderGroupHandleCaptureReplayMixed-03481",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-sType-sType",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-type-03474",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-type-03475",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-type-03476",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-type-03477",
    "VUID-VkRayTracingShaderGroupCreateInfoKHR-type-parameter",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-anyHitShader-02418",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-closestHitShader-02417",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-pNext-pNext",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-sType-sType",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-type-02413",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-type-02414",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-type-02415",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-type-02416",
    "VUID-VkRayTracingShaderGroupCreateInfoNV-type-parameter",
    "VUID-VkRectLayerKHR-layer-01262",
    "VUID-VkRectLayerKHR-offset-01261",
    "VUID-VkRenderPassAttachmentBeginInfo-pAttachments-03218",
    "VUID-VkRenderPassAttachmentBeginInfo-pAttachments-03219",
    "VUID-VkRenderPassAttachmentBeginInfo-pAttachments-parameter",
    "VUID-VkRenderPassAttachmentBeginInfo-sType-sType",
    "VUID-VkRenderPassBeginInfo-clearValueCount-00902",
    "VUID-VkRenderPassBeginInfo-commonparent",
    "VUID-VkRenderPassBeginInfo-framebuffer-02780",
    "VUID-VkRenderPassBeginInfo-framebuffer-03207",
    "VUID-VkRenderPassBeginInfo-framebuffer-03208",
    "VUID-VkRenderPassBeginInfo-framebuffer-03209",
    "VUID-VkRenderPassBeginInfo-framebuffer-03210",
    "VUID-VkRenderPassBeginInfo-framebuffer-03211",
    "VUID-VkRenderPassBeginInfo-framebuffer-03212",
    "VUID-VkRenderPassBeginInfo-framebuffer-03213",
    "VUID-VkRenderPassBeginInfo-framebuffer-03214",
    "VUID-VkRenderPassBeginInfo-framebuffer-03215",
    "VUID-VkRenderPassBeginInfo-framebuffer-03216",
    "VUID-VkRenderPassBeginInfo-framebuffer-03217",
    "VUID-VkRenderPassBeginInfo-framebuffer-parameter",
    "VUID-VkRenderPassBeginInfo-pClearValues-parameter",
    "VUID-VkRenderPassBeginInfo-pNext-02850",
    "VUID-VkRenderPassBeginInfo-pNext-02851",
    "VUID-VkRenderPassBeginInfo-pNext-02852",
    "VUID-VkRenderPassBeginInfo-pNext-02853",
    "VUID-VkRenderPassBeginInfo-pNext-02854",
    "VUID-VkRenderPassBeginInfo-pNext-02855",
    "VUID-VkRenderPassBeginInfo-pNext-02856",
    "VUID-VkRenderPassBeginInfo-pNext-02857",
    "VUID-VkRenderPassBeginInfo-pNext-02869",
    "VUID-VkRenderPassBeginInfo-pNext-02870",
    "VUID-VkRenderPassBeginInfo-pNext-pNext",
    "VUID-VkRenderPassBeginInfo-renderArea-02846",
    "VUID-VkRenderPassBeginInfo-renderArea-02847",
    "VUID-VkRenderPassBeginInfo-renderArea-02848",
    "VUID-VkRenderPassBeginInfo-renderArea-02849",
    "VUID-VkRenderPassBeginInfo-renderPass-00904",
    "VUID-VkRenderPassBeginInfo-renderPass-parameter",
    "VUID-VkRenderPassBeginInfo-sType-sType",
    "VUID-VkRenderPassBeginInfo-sType-unique",
    "VUID-VkRenderPassCreateInfo-attachment-00834",
    "VUID-VkRenderPassCreateInfo-dstSubpass-02518",
    "VUID-VkRenderPassCreateInfo-flags-parameter",
    "VUID-VkRenderPassCreateInfo-pAttachments-00836",
    "VUID-VkRenderPassCreateInfo-pAttachments-01566",
    "VUID-VkRenderPassCreateInfo-pAttachments-01567",
    "VUID-VkRenderPassCreateInfo-pAttachments-02511",
    "VUID-VkRenderPassCreateInfo-pAttachments-parameter",
    "VUID-VkRenderPassCreateInfo-pDependencies-00837",
    "VUID-VkRenderPassCreateInfo-pDependencies-00838",
    "VUID-VkRenderPassCreateInfo-pDependencies-parameter",
    "VUID-VkRenderPassCreateInfo-pNext-01926",
    "VUID-VkRenderPassCreateInfo-pNext-01927",
    "VUID-VkRenderPassCreateInfo-pNext-01928",
    "VUID-VkRenderPassCreateInfo-pNext-01929",
    "VUID-VkRenderPassCreateInfo-pNext-01930",
    "VUID-VkRenderPassCreateInfo-pNext-01963",
    "VUID-VkRenderPassCreateInfo-pNext-02512",
    "VUID-VkRenderPassCreateInfo-pNext-02513",
    "VUID-VkRenderPassCreateInfo-pNext-02514",
    "VUID-VkRenderPassCreateInfo-pNext-02515",
    "VUID-VkRenderPassCreateInfo-pNext-02516",
    "VUID-VkRenderPassCreateInfo-pNext-pNext",
    "VUID-VkRenderPassCreateInfo-pSubpasses-parameter",
    "VUID-VkRenderPassCreateInfo-sType-sType",
    "VUID-VkRenderPassCreateInfo-sType-unique",
    "VUID-VkRenderPassCreateInfo-srcSubpass-02517",
    "VUID-VkRenderPassCreateInfo-subpassCount-arraylength",
    "VUID-VkRenderPassCreateInfo2-None-03049",
    "VUID-VkRenderPassCreateInfo2-attachment-02525",
    "VUID-VkRenderPassCreateInfo2-attachment-03050",
    "VUID-VkRenderPassCreateInfo2-attachment-03051",
    "VUID-VkRenderPassCreateInfo2-dstSubpass-02527",
    "VUID-VkRenderPassCreateInfo2-flags-parameter",
    "VUID-VkRenderPassCreateInfo2-pAttachments-02522",
    "VUID-VkRenderPassCreateInfo2-pAttachments-02523",
    "VUID-VkRenderPassCreateInfo2-pAttachments-parameter",
    "VUID-VkRenderPassCreateInfo2-pCorrelatedViewMasks-03056",
    "VUID-VkRenderPassCreateInfo2-pCorrelatedViewMasks-parameter",
    "VUID-VkRenderPassCreateInfo2-pDependencies-03054",
    "VUID-VkRenderPassCreateInfo2-pDependencies-03055",
    "VUID-VkRenderPassCreateInfo2-pDependencies-03060",
    "VUID-VkRenderPassCreateInfo2-pDependencies-parameter",
    "VUID-VkRenderPassCreateInfo2-pNext-pNext",
    "VUID-VkRenderPassCreateInfo2-pSubpasses-parameter",
    "VUID-VkRenderPassCreateInfo2-sType-sType",
    "VUID-VkRenderPassCreateInfo2-sType-unique",
    "VUID-VkRenderPassCreateInfo2-srcSubpass-02526",
    "VUID-VkRenderPassCreateInfo2-subpassCount-arraylength",
    "VUID-VkRenderPassCreateInfo2-viewMask-02524",
    "VUID-VkRenderPassCreateInfo2-viewMask-03057",
    "VUID-VkRenderPassCreateInfo2-viewMask-03058",
    "VUID-VkRenderPassCreateInfo2-viewMask-03059",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-fragmentDensityMapAttachment-02547",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-fragmentDensityMapAttachment-02548",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-fragmentDensityMapAttachment-02549",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-fragmentDensityMapAttachment-02550",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-fragmentDensityMapAttachment-02551",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-fragmentDensityMapAttachment-parameter",
    "VUID-VkRenderPassFragmentDensityMapCreateInfoEXT-sType-sType",
    "VUID-VkRenderPassInputAttachmentAspectCreateInfo-aspectReferenceCount-arraylength",
    "VUID-VkRenderPassInputAttachmentAspectCreateInfo-pAspectReferences-parameter",
    "VUID-VkRenderPassInputAttachmentAspectCreateInfo-sType-sType",
    "VUID-VkRenderPassMultiviewCreateInfo-pCorrelationMasks-00841",
    "VUID-VkRenderPassMultiviewCreateInfo-pCorrelationMasks-parameter",
    "VUID-VkRenderPassMultiviewCreateInfo-pViewMasks-parameter",
    "VUID-VkRenderPassMultiviewCreateInfo-pViewOffsets-parameter",
    "VUID-VkRenderPassMultiviewCreateInfo-sType-sType",
    "VUID-VkRenderPassSampleLocationsBeginInfoEXT-pAttachmentInitialSampleLocations-parameter",
    "VUID-VkRenderPassSampleLocationsBeginInfoEXT-pPostSubpassSampleLocations-parameter",
    "VUID-VkRenderPassSampleLocationsBeginInfoEXT-sType-sType",
    "VUID-VkRenderPassTransformBeginInfoQCOM-flags-02872",
    "VUID-VkRenderPassTransformBeginInfoQCOM-sType-sType",
    "VUID-VkRenderPassTransformBeginInfoQCOM-transform-02871",
    "VUID-VkSampleLocationsInfoEXT-pSampleLocations-parameter",
    "VUID-VkSampleLocationsInfoEXT-sType-sType",
    "VUID-VkSampleLocationsInfoEXT-sampleLocationsCount-01527",
    "VUID-VkSampleLocationsInfoEXT-sampleLocationsPerPixel-01526",
    "VUID-VkSampleLocationsInfoEXT-sampleLocationsPerPixel-parameter",
    "VUID-VkSamplerCreateInfo-None-01647",
    "VUID-VkSamplerCreateInfo-None-04012",
    "VUID-VkSamplerCreateInfo-addressModeU-01078",
    "VUID-VkSamplerCreateInfo-addressModeU-01079",
    "VUID-VkSamplerCreateInfo-addressModeU-01646",
    "VUID-VkSamplerCreateInfo-addressModeU-parameter",
    "VUID-VkSamplerCreateInfo-addressModeV-parameter",
    "VUID-VkSamplerCreateInfo-addressModeW-parameter",
    "VUID-VkSamplerCreateInfo-anisotropyEnable-01070",
    "VUID-VkSamplerCreateInfo-anisotropyEnable-01071",
    "VUID-VkSamplerCreateInfo-borderColor-04011",
    "VUID-VkSamplerCreateInfo-compareEnable-01080",
    "VUID-VkSamplerCreateInfo-compareEnable-01423",
    "VUID-VkSamplerCreateInfo-customBorderColors-04085",
    "VUID-VkSamplerCreateInfo-flags-02574",
    "VUID-VkSamplerCreateInfo-flags-02575",
    "VUID-VkSamplerCreateInfo-flags-02576",
    "VUID-VkSamplerCreateInfo-flags-02577",
    "VUID-VkSamplerCreateInfo-flags-02578",
    "VUID-VkSamplerCreateInfo-flags-02579",
    "VUID-VkSamplerCreateInfo-flags-02580",
    "VUID-VkSamplerCreateInfo-flags-parameter",
    "VUID-VkSamplerCreateInfo-magFilter-01081",
    "VUID-VkSamplerCreateInfo-magFilter-01422",
    "VUID-VkSamplerCreateInfo-magFilter-parameter",
    "VUID-VkSamplerCreateInfo-maxLod-01973",
    "VUID-VkSamplerCreateInfo-minFilter-01645",
    "VUID-VkSamplerCreateInfo-minFilter-parameter",
    "VUID-VkSamplerCreateInfo-mipLodBias-01069",
    "VUID-VkSamplerCreateInfo-mipmapMode-parameter",
    "VUID-VkSamplerCreateInfo-pNext-pNext",
    "VUID-VkSamplerCreateInfo-sType-sType",
    "VUID-VkSamplerCreateInfo-sType-unique",
    "VUID-VkSamplerCreateInfo-unnormalizedCoordinates-01072",
    "VUID-VkSamplerCreateInfo-unnormalizedCoordinates-01073",
    "VUID-VkSamplerCreateInfo-unnormalizedCoordinates-01074",
    "VUID-VkSamplerCreateInfo-unnormalizedCoordinates-01075",
    "VUID-VkSamplerCreateInfo-unnormalizedCoordinates-01076",
    "VUID-VkSamplerCreateInfo-unnormalizedCoordinates-01077",
    "VUID-VkSamplerCustomBorderColorCreateInfoEXT-format-04013",
    "VUID-VkSamplerCustomBorderColorCreateInfoEXT-format-04014",
    "VUID-VkSamplerCustomBorderColorCreateInfoEXT-format-04015",
    "VUID-VkSamplerCustomBorderColorCreateInfoEXT-format-parameter",
    "VUID-VkSamplerCustomBorderColorCreateInfoEXT-sType-sType",
    "VUID-VkSamplerReductionModeCreateInfo-reductionMode-parameter",
    "VUID-VkSamplerReductionModeCreateInfo-sType-sType",
    "VUID-VkSamplerYcbcrConversionCreateInfo-chromaFilter-01657",
    "VUID-VkSamplerYcbcrConversionCreateInfo-chromaFilter-parameter",
    "VUID-VkSamplerYcbcrConversionCreateInfo-components-02581",
    "VUID-VkSamplerYcbcrConversionCreateInfo-components-02582",
    "VUID-VkSamplerYcbcrConversionCreateInfo-components-02583",
    "VUID-VkSamplerYcbcrConversionCreateInfo-components-02584",
    "VUID-VkSamplerYcbcrConversionCreateInfo-components-02585",
    "VUID-VkSamplerYcbcrConversionCreateInfo-components-parameter",
    "VUID-VkSamplerYcbcrConversionCreateInfo-forceExplicitReconstruction-01656",
    "VUID-VkSamplerYcbcrConversionCreateInfo-format-01650",
    "VUID-VkSamplerYcbcrConversionCreateInfo-format-01904",
    "VUID-VkSamplerYcbcrConversionCreateInfo-format-04060",
    "VUID-VkSamplerYcbcrConversionCreateInfo-format-04061",
    "VUID-VkSamplerYcbcrConversionCreateInfo-format-parameter",
    "VUID-VkSamplerYcbcrConversionCreateInfo-pNext-pNext",
    "VUID-VkSamplerYcbcrConversionCreateInfo-sType-sType",
    "VUID-VkSamplerYcbcrConversionCreateInfo-sType-unique",
    "VUID-VkSamplerYcbcrConversionCreateInfo-xChromaOffset-01651",
    "VUID-VkSamplerYcbcrConversionCreateInfo-xChromaOffset-01652",
    "VUID-VkSamplerYcbcrConversionCreateInfo-xChromaOffset-parameter",
    "VUID-VkSamplerYcbcrConversionCreateInfo-yChromaOffset-parameter",
    "VUID-VkSamplerYcbcrConversionCreateInfo-ycbcrModel-01655",
    "VUID-VkSamplerYcbcrConversionCreateInfo-ycbcrModel-parameter",
    "VUID-VkSamplerYcbcrConversionCreateInfo-ycbcrRange-02748",
    "VUID-VkSamplerYcbcrConversionCreateInfo-ycbcrRange-parameter",
    "VUID-VkSamplerYcbcrConversionImageFormatProperties-sType-sType",
    "VUID-VkSamplerYcbcrConversionInfo-conversion-parameter",
    "VUID-VkSamplerYcbcrConversionInfo-sType-sType",
    "VUID-VkSemaphoreCreateInfo-flags-zerobitmask",
    "VUID-VkSemaphoreCreateInfo-pNext-pNext",
    "VUID-VkSemaphoreCreateInfo-sType-sType",
    "VUID-VkSemaphoreCreateInfo-sType-unique",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-01132",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-01134",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-01135",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-01136",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-03253",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-03254",
    "VUID-VkSemaphoreGetFdInfoKHR-handleType-parameter",
    "VUID-VkSemaphoreGetFdInfoKHR-pNext-pNext",
    "VUID-VkSemaphoreGetFdInfoKHR-sType-sType",
    "VUID-VkSemaphoreGetFdInfoKHR-semaphore-01133",
    "VUID-VkSemaphoreGetFdInfoKHR-semaphore-parameter",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-handleType-01126",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-handleType-01127",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-handleType-01129",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-handleType-01130",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-handleType-01131",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-handleType-parameter",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-pNext-pNext",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-sType-sType",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-semaphore-01128",
    "VUID-VkSemaphoreGetWin32HandleInfoKHR-semaphore-parameter",
    "VUID-VkSemaphoreSignalInfo-pNext-pNext",
    "VUID-VkSemaphoreSignalInfo-sType-sType",
    "VUID-VkSemaphoreSignalInfo-semaphore-03257",
    "VUID-VkSemaphoreSignalInfo-semaphore-parameter",
    "VUID-VkSemaphoreSignalInfo-value-03258",
    "VUID-VkSemaphoreSignalInfo-value-03259",
    "VUID-VkSemaphoreSignalInfo-value-03260",
    "VUID-VkSemaphoreTypeCreateInfo-sType-sType",
    "VUID-VkSemaphoreTypeCreateInfo-semaphoreType-03279",
    "VUID-VkSemaphoreTypeCreateInfo-semaphoreType-parameter",
    "VUID-VkSemaphoreTypeCreateInfo-timelineSemaphore-03252",
    "VUID-VkSemaphoreWaitInfo-flags-parameter",
    "VUID-VkSemaphoreWaitInfo-pNext-pNext",
    "VUID-VkSemaphoreWaitInfo-pSemaphores-03256",
    "VUID-VkSemaphoreWaitInfo-pSemaphores-parameter",
    "VUID-VkSemaphoreWaitInfo-pValues-parameter",
    "VUID-VkSemaphoreWaitInfo-sType-sType",
    "VUID-VkSemaphoreWaitInfo-semaphoreCount-arraylength",
    "VUID-VkShaderModuleCreateInfo-codeSize-01085",
    "VUID-VkShaderModuleCreateInfo-codeSize-01086",
    "VUID-VkShaderModuleCreateInfo-flags-zerobitmask",
    "VUID-VkShaderModuleCreateInfo-pCode-01087",
    "VUID-VkShaderModuleCreateInfo-pCode-01088",
    "VUID-VkShaderModuleCreateInfo-pCode-01089",
    "VUID-VkShaderModuleCreateInfo-pCode-01090",
    "VUID-VkShaderModuleCreateInfo-pCode-01091",
    "VUID-VkShaderModuleCreateInfo-pCode-01376",
    "VUID-VkShaderModuleCreateInfo-pCode-01377",
    "VUID-VkShaderModuleCreateInfo-pCode-01378",
    "VUID-VkShaderModuleCreateInfo-pCode-01379",
    "VUID-VkShaderModuleCreateInfo-pCode-parameter",
    "VUID-VkShaderModuleCreateInfo-pNext-pNext",
    "VUID-VkShaderModuleCreateInfo-sType-sType",
    "VUID-VkShaderModuleCreateInfo-sType-unique",
    "VUID-VkShaderModuleValidationCacheCreateInfoEXT-sType-sType",
    "VUID-VkShaderModuleValidationCacheCreateInfoEXT-validationCache-parameter",
    "VUID-VkShadingRatePaletteNV-pShadingRatePaletteEntries-parameter",
    "VUID-VkShadingRatePaletteNV-shadingRatePaletteEntryCount-02071",
    "VUID-VkShadingRatePaletteNV-shadingRatePaletteEntryCount-arraylength",
    "VUID-VkSharedPresentSurfaceCapabilitiesKHR-sType-sType",
    "VUID-VkSparseBufferMemoryBindInfo-bindCount-arraylength",
    "VUID-VkSparseBufferMemoryBindInfo-buffer-parameter",
    "VUID-VkSparseBufferMemoryBindInfo-pBinds-parameter",
    "VUID-VkSparseImageFormatProperties2-pNext-pNext",
    "VUID-VkSparseImageFormatProperties2-sType-sType",
    "VUID-VkSparseImageMemoryBind-extent-01108",
    "VUID-VkSparseImageMemoryBind-extent-01110",
    "VUID-VkSparseImageMemoryBind-extent-01112",
    "VUID-VkSparseImageMemoryBind-flags-parameter",
    "VUID-VkSparseImageMemoryBind-memory-01104",
    "VUID-VkSparseImageMemoryBind-memory-01105",
    "VUID-VkSparseImageMemoryBind-memory-02732",
    "VUID-VkSparseImageMemoryBind-memory-02733",
    "VUID-VkSparseImageMemoryBind-memory-parameter",
    "VUID-VkSparseImageMemoryBind-offset-01107",
    "VUID-VkSparseImageMemoryBind-offset-01109",
    "VUID-VkSparseImageMemoryBind-offset-01111",
    "VUID-VkSparseImageMemoryBind-subresource-01106",
    "VUID-VkSparseImageMemoryBind-subresource-parameter",
    "VUID-VkSparseImageMemoryBindInfo-bindCount-arraylength",
    "VUID-VkSparseImageMemoryBindInfo-image-02901",
    "VUID-VkSparseImageMemoryBindInfo-image-parameter",
    "VUID-VkSparseImageMemoryBindInfo-pBinds-parameter",
    "VUID-VkSparseImageMemoryBindInfo-subresource-01722",
    "VUID-VkSparseImageMemoryBindInfo-subresource-01723",
    "VUID-VkSparseImageMemoryRequirements2-pNext-pNext",
    "VUID-VkSparseImageMemoryRequirements2-sType-sType",
    "VUID-VkSparseImageOpaqueMemoryBindInfo-bindCount-arraylength",
    "VUID-VkSparseImageOpaqueMemoryBindInfo-image-parameter",
    "VUID-VkSparseImageOpaqueMemoryBindInfo-pBinds-01103",
    "VUID-VkSparseImageOpaqueMemoryBindInfo-pBinds-parameter",
    "VUID-VkSparseMemoryBind-flags-parameter",
    "VUID-VkSparseMemoryBind-memory-01096",
    "VUID-VkSparseMemoryBind-memory-01097",
    "VUID-VkSparseMemoryBind-memory-02730",
    "VUID-VkSparseMemoryBind-memory-02731",
    "VUID-VkSparseMemoryBind-memory-parameter",
    "VUID-VkSparseMemoryBind-memoryOffset-01101",
    "VUID-VkSparseMemoryBind-resourceOffset-01099",
    "VUID-VkSparseMemoryBind-size-01098",
    "VUID-VkSparseMemoryBind-size-01100",
    "VUID-VkSparseMemoryBind-size-01102",
    "VUID-VkSpecializationInfo-offset-00773",
    "VUID-VkSpecializationInfo-pData-parameter",
    "VUID-VkSpecializationInfo-pMapEntries-00774",
    "VUID-VkSpecializationInfo-pMapEntries-parameter",
    "VUID-VkSpecializationMapEntry-constantID-00776",
    "VUID-VkStencilOpState-compareOp-parameter",
    "VUID-VkStencilOpState-depthFailOp-parameter",
    "VUID-VkStencilOpState-failOp-parameter",
    "VUID-VkStencilOpState-passOp-parameter",
    "VUID-VkStreamDescriptorSurfaceCreateInfoGGP-flags-zerobitmask",
    "VUID-VkStreamDescriptorSurfaceCreateInfoGGP-pNext-pNext",
    "VUID-VkStreamDescriptorSurfaceCreateInfoGGP-sType-sType",
    "VUID-VkStreamDescriptorSurfaceCreateInfoGGP-streamDescriptor-02681",
    "VUID-VkStridedBufferRegionKHR-buffer-03515",
    "VUID-VkStridedBufferRegionKHR-buffer-03516",
    "VUID-VkStridedBufferRegionKHR-buffer-parameter",
    "VUID-VkSubmitInfo-commonparent",
    "VUID-VkSubmitInfo-pCommandBuffers-00075",
    "VUID-VkSubmitInfo-pCommandBuffers-parameter",
    "VUID-VkSubmitInfo-pNext-03240",
    "VUID-VkSubmitInfo-pNext-03241",
    "VUID-VkSubmitInfo-pNext-pNext",
    "VUID-VkSubmitInfo-pSignalSemaphores-03242",
    "VUID-VkSubmitInfo-pSignalSemaphores-03244",
    "VUID-VkSubmitInfo-pSignalSemaphores-parameter",
    "VUID-VkSubmitInfo-pWaitDstStageMask-00076",
    "VUID-VkSubmitInfo-pWaitDstStageMask-00077",
    "VUID-VkSubmitInfo-pWaitDstStageMask-00078",
    "VUID-VkSubmitInfo-pWaitDstStageMask-02089",
    "VUID-VkSubmitInfo-pWaitDstStageMask-02090",
    "VUID-VkSubmitInfo-pWaitDstStageMask-parameter",
    "VUID-VkSubmitInfo-pWaitDstStageMask-requiredbitmask",
    "VUID-VkSubmitInfo-pWaitSemaphores-03239",
    "VUID-VkSubmitInfo-pWaitSemaphores-03243",
    "VUID-VkSubmitInfo-pWaitSemaphores-parameter",
    "VUID-VkSubmitInfo-sType-sType",
    "VUID-VkSubmitInfo-sType-unique",
    "VUID-VkSubpassBeginInfo-contents-parameter",
    "VUID-VkSubpassBeginInfo-pNext-pNext",
    "VUID-VkSubpassBeginInfo-sType-sType",
    "VUID-VkSubpassDependency-dependencyFlags-02520",
    "VUID-VkSubpassDependency-dependencyFlags-02521",
    "VUID-VkSubpassDependency-dependencyFlags-parameter",
    "VUID-VkSubpassDependency-dstAccessMask-00869",
    "VUID-VkSubpassDependency-dstAccessMask-parameter",
    "VUID-VkSubpassDependency-dstStageMask-00861",
    "VUID-VkSubpassDependency-dstStageMask-00863",
    "VUID-VkSubpassDependency-dstStageMask-02101",
    "VUID-VkSubpassDependency-dstStageMask-02102",
    "VUID-VkSubpassDependency-dstStageMask-parameter",
    "VUID-VkSubpassDependency-dstStageMask-requiredbitmask",
    "VUID-VkSubpassDependency-srcAccessMask-00868",
    "VUID-VkSubpassDependency-srcAccessMask-parameter",
    "VUID-VkSubpassDependency-srcStageMask-00860",
    "VUID-VkSubpassDependency-srcStageMask-00862",
    "VUID-VkSubpassDependency-srcStageMask-02099",
    "VUID-VkSubpassDependency-srcStageMask-02100",
    "VUID-VkSubpassDependency-srcStageMask-parameter",
    "VUID-VkSubpassDependency-srcStageMask-requiredbitmask",
    "VUID-VkSubpassDependency-srcSubpass-00864",
    "VUID-VkSubpassDependency-srcSubpass-00865",
    "VUID-VkSubpassDependency-srcSubpass-00867",
    "VUID-VkSubpassDependency-srcSubpass-00872",
    "VUID-VkSubpassDependency-srcSubpass-02243",
    "VUID-VkSubpassDependency2-dependencyFlags-03090",
    "VUID-VkSubpassDependency2-dependencyFlags-03091",
    "VUID-VkSubpassDependency2-dependencyFlags-03092",
    "VUID-VkSubpassDependency2-dependencyFlags-parameter",
    "VUID-VkSubpassDependency2-dstAccessMask-03089",
    "VUID-VkSubpassDependency2-dstAccessMask-parameter",
    "VUID-VkSubpassDependency2-dstStageMask-02105",
    "VUID-VkSubpassDependency2-dstStageMask-02106",
    "VUID-VkSubpassDependency2-dstStageMask-03081",
    "VUID-VkSubpassDependency2-dstStageMask-03083",
    "VUID-VkSubpassDependency2-dstStageMask-parameter",
    "VUID-VkSubpassDependency2-dstStageMask-requiredbitmask",
    "VUID-VkSubpassDependency2-sType-sType",
    "VUID-VkSubpassDependency2-srcAccessMask-03088",
    "VUID-VkSubpassDependency2-srcAccessMask-parameter",
    "VUID-VkSubpassDependency2-srcStageMask-02103",
    "VUID-VkSubpassDependency2-srcStageMask-02104",
    "VUID-VkSubpassDependency2-srcStageMask-03080",
    "VUID-VkSubpassDependency2-srcStageMask-03082",
    "VUID-VkSubpassDependency2-srcStageMask-parameter",
    "VUID-VkSubpassDependency2-srcStageMask-requiredbitmask",
    "VUID-VkSubpassDependency2-srcSubpass-02245",
    "VUID-VkSubpassDependency2-srcSubpass-03084",
    "VUID-VkSubpassDependency2-srcSubpass-03085",
    "VUID-VkSubpassDependency2-srcSubpass-03087",
    "VUID-VkSubpassDependency2-viewOffset-02530",
    "VUID-VkSubpassDescription-attachment-00853",
    "VUID-VkSubpassDescription-colorAttachmentCount-00845",
    "VUID-VkSubpassDescription-flags-00856",
    "VUID-VkSubpassDescription-flags-03341",
    "VUID-VkSubpassDescription-flags-03342",
    "VUID-VkSubpassDescription-flags-03343",
    "VUID-VkSubpassDescription-flags-03344",
    "VUID-VkSubpassDescription-flags-03345",
    "VUID-VkSubpassDescription-flags-parameter",
    "VUID-VkSubpassDescription-layout-02519",
    "VUID-VkSubpassDescription-loadOp-00846",
    "VUID-VkSubpassDescription-pColorAttachments-01417",
    "VUID-VkSubpassDescription-pColorAttachments-01506",
    "VUID-VkSubpassDescription-pColorAttachments-02648",
    "VUID-VkSubpassDescription-pColorAttachments-parameter",
    "VUID-VkSubpassDescription-pDepthStencilAttachment-01418",
    "VUID-VkSubpassDescription-pDepthStencilAttachment-02650",
    "VUID-VkSubpassDescription-pDepthStencilAttachment-parameter",
    "VUID-VkSubpassDescription-pInputAttachments-02647",
    "VUID-VkSubpassDescription-pInputAttachments-02868",
    "VUID-VkSubpassDescription-pInputAttachments-parameter",
    "VUID-VkSubpassDescription-pPreserveAttachments-00854",
    "VUID-VkSubpassDescription-pPreserveAttachments-parameter",
    "VUID-VkSubpassDescription-pResolveAttachments-00847",
    "VUID-VkSubpassDescription-pResolveAttachments-00848",
    "VUID-VkSubpassDescription-pResolveAttachments-00849",
    "VUID-VkSubpassDescription-pResolveAttachments-00850",
    "VUID-VkSubpassDescription-pResolveAttachments-02649",
    "VUID-VkSubpassDescription-pResolveAttachments-parameter",
    "VUID-VkSubpassDescription-pipelineBindPoint-00844",
    "VUID-VkSubpassDescription-pipelineBindPoint-parameter",
    "VUID-VkSubpassDescription2-attachment-02799",
    "VUID-VkSubpassDescription2-attachment-02800",
    "VUID-VkSubpassDescription2-attachment-02801",
    "VUID-VkSubpassDescription2-attachment-03073",
    "VUID-VkSubpassDescription2-colorAttachmentCount-03063",
    "VUID-VkSubpassDescription2-flags-03076",
    "VUID-VkSubpassDescription2-flags-parameter",
    "VUID-VkSubpassDescription2-layout-02528",
    "VUID-VkSubpassDescription2-loadOp-03064",
    "VUID-VkSubpassDescription2-pColorAttachments-02898",
    "VUID-VkSubpassDescription2-pColorAttachments-03069",
    "VUID-VkSubpassDescription2-pColorAttachments-03070",
    "VUID-VkSubpassDescription2-pColorAttachments-parameter",
    "VUID-VkSubpassDescription2-pDepthStencilAttachment-02900",
    "VUID-VkSubpassDescription2-pDepthStencilAttachment-03071",
    "VUID-VkSubpassDescription2-pDepthStencilAttachment-parameter",
    "VUID-VkSubpassDescription2-pInputAttachments-02897",
    "VUID-VkSubpassDescription2-pInputAttachments-parameter",
    "VUID-VkSubpassDescription2-pPreserveAttachments-03074",
    "VUID-VkSubpassDescription2-pPreserveAttachments-parameter",
    "VUID-VkSubpassDescription2-pResolveAttachments-02899",
    "VUID-VkSubpassDescription2-pResolveAttachments-03065",
    "VUID-VkSubpassDescription2-pResolveAttachments-03066",
    "VUID-VkSubpassDescription2-pResolveAttachments-03067",
    "VUID-VkSubpassDescription2-pResolveAttachments-03068",
    "VUID-VkSubpassDescription2-pResolveAttachments-parameter",
    "VUID-VkSubpassDescription2-pipelineBindPoint-03062",
    "VUID-VkSubpassDescription2-pipelineBindPoint-parameter",
    "VUID-VkSubpassDescription2-sType-sType",
    "VUID-VkSubpassDescriptionDepthStencilResolve-depthResolveMode-03183",
    "VUID-VkSubpassDescriptionDepthStencilResolve-depthResolveMode-parameter",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-02651",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03177",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03178",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03179",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03180",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03181",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03182",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03185",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-03186",
    "VUID-VkSubpassDescriptionDepthStencilResolve-pDepthStencilResolveAttachment-parameter",
    "VUID-VkSubpassDescriptionDepthStencilResolve-sType-sType",
    "VUID-VkSubpassDescriptionDepthStencilResolve-stencilResolveMode-03184",
    "VUID-VkSubpassDescriptionDepthStencilResolve-stencilResolveMode-parameter",
    "VUID-VkSubpassEndInfo-pNext-pNext",
    "VUID-VkSubpassEndInfo-sType-sType",
    "VUID-VkSubpassSampleLocationsEXT-sampleLocationsInfo-parameter",
    "VUID-VkSubpassSampleLocationsEXT-subpassIndex-01532",
    "VUID-VkSurfaceCapabilities2EXT-pNext-pNext",
    "VUID-VkSurfaceCapabilities2EXT-sType-sType",
    "VUID-VkSurfaceCapabilities2EXT-supportedSurfaceCounters-01246",
    "VUID-VkSurfaceCapabilities2KHR-pNext-pNext",
    "VUID-VkSurfaceCapabilities2KHR-sType-sType",
    "VUID-VkSurfaceCapabilities2KHR-sType-unique",
    "VUID-VkSurfaceCapabilitiesFullScreenExclusiveEXT-sType-sType",
    "VUID-VkSurfaceFormat2KHR-pNext-pNext",
    "VUID-VkSurfaceFormat2KHR-sType-sType",
    "VUID-VkSurfaceFullScreenExclusiveInfoEXT-fullScreenExclusive-parameter",
    "VUID-VkSurfaceFullScreenExclusiveInfoEXT-sType-sType",
    "VUID-VkSurfaceFullScreenExclusiveWin32InfoEXT-hmonitor-02673",
    "VUID-VkSurfaceFullScreenExclusiveWin32InfoEXT-sType-sType",
    "VUID-VkSurfaceProtectedCapabilitiesKHR-sType-sType",
    "VUID-VkSwapchainCounterCreateInfoEXT-sType-sType",
    "VUID-VkSwapchainCounterCreateInfoEXT-surfaceCounters-01244",
    "VUID-VkSwapchainCounterCreateInfoEXT-surfaceCounters-parameter",
    "VUID-VkSwapchainCreateInfoKHR-commonparent",
    "VUID-VkSwapchainCreateInfoKHR-compositeAlpha-01280",
    "VUID-VkSwapchainCreateInfoKHR-compositeAlpha-parameter",
    "VUID-VkSwapchainCreateInfoKHR-flags-03168",
    "VUID-VkSwapchainCreateInfoKHR-flags-03187",
    "VUID-VkSwapchainCreateInfoKHR-flags-04100",
    "VUID-VkSwapchainCreateInfoKHR-flags-parameter",
    "VUID-VkSwapchainCreateInfoKHR-imageArrayLayers-01275",
    "VUID-VkSwapchainCreateInfoKHR-imageColorSpace-parameter",
    "VUID-VkSwapchainCreateInfoKHR-imageExtent-01274",
    "VUID-VkSwapchainCreateInfoKHR-imageExtent-01689",
    "VUID-VkSwapchainCreateInfoKHR-imageFormat-01273",
    "VUID-VkSwapchainCreateInfoKHR-imageFormat-01778",
    "VUID-VkSwapchainCreateInfoKHR-imageFormat-parameter",
    "VUID-VkSwapchainCreateInfoKHR-imageSharingMode-01277",
    "VUID-VkSwapchainCreateInfoKHR-imageSharingMode-01278",
    "VUID-VkSwapchainCreateInfoKHR-imageSharingMode-01393",
    "VUID-VkSwapchainCreateInfoKHR-imageSharingMode-01428",
    "VUID-VkSwapchainCreateInfoKHR-imageSharingMode-parameter",
    "VUID-VkSwapchainCreateInfoKHR-imageUsage-01276",
    "VUID-VkSwapchainCreateInfoKHR-imageUsage-01384",
    "VUID-VkSwapchainCreateInfoKHR-imageUsage-parameter",
    "VUID-VkSwapchainCreateInfoKHR-imageUsage-requiredbitmask",
    "VUID-VkSwapchainCreateInfoKHR-minImageCount-01271",
    "VUID-VkSwapchainCreateInfoKHR-minImageCount-01272",
    "VUID-VkSwapchainCreateInfoKHR-minImageCount-01383",
    "VUID-VkSwapchainCreateInfoKHR-oldSwapchain-01933",
    "VUID-VkSwapchainCreateInfoKHR-oldSwapchain-parameter",
    "VUID-VkSwapchainCreateInfoKHR-oldSwapchain-parent",
    "VUID-VkSwapchainCreateInfoKHR-pNext-02679",
    "VUID-VkSwapchainCreateInfoKHR-pNext-04099",
    "VUID-VkSwapchainCreateInfoKHR-pNext-pNext",
    "VUID-VkSwapchainCreateInfoKHR-physicalDeviceCount-01429",
    "VUID-VkSwapchainCreateInfoKHR-preTransform-01279",
    "VUID-VkSwapchainCreateInfoKHR-preTransform-parameter",
    "VUID-VkSwapchainCreateInfoKHR-presentMode-01281",
    "VUID-VkSwapchainCreateInfoKHR-presentMode-01427",
    "VUID-VkSwapchainCreateInfoKHR-presentMode-02839",
    "VUID-VkSwapchainCreateInfoKHR-presentMode-parameter",
    "VUID-VkSwapchainCreateInfoKHR-sType-sType",
    "VUID-VkSwapchainCreateInfoKHR-sType-unique",
    "VUID-VkSwapchainCreateInfoKHR-surface-01270",
    "VUID-VkSwapchainCreateInfoKHR-surface-parameter",
    "VUID-VkSwapchainDisplayNativeHdrCreateInfoAMD-localDimmingEnable-XXXXX",
    "VUID-VkSwapchainDisplayNativeHdrCreateInfoAMD-sType-sType",
    "VUID-VkTextureLODGatherFormatPropertiesAMD-sType-sType",
    "VUID-VkTimelineSemaphoreSubmitInfo-pSignalSemaphoreValues-parameter",
    "VUID-VkTimelineSemaphoreSubmitInfo-pWaitSemaphoreValues-parameter",
    "VUID-VkTimelineSemaphoreSubmitInfo-sType-sType",
    "VUID-VkTraceRaysIndirectCommandKHR-depth-03521",
    "VUID-VkTraceRaysIndirectCommandKHR-height-03520",
    "VUID-VkTraceRaysIndirectCommandKHR-width-03519",
    "VUID-VkValidationCacheCreateInfoEXT-flags-zerobitmask",
    "VUID-VkValidationCacheCreateInfoEXT-initialDataSize-01534",
    "VUID-VkValidationCacheCreateInfoEXT-initialDataSize-01535",
    "VUID-VkValidationCacheCreateInfoEXT-pInitialData-parameter",
    "VUID-VkValidationCacheCreateInfoEXT-pNext-pNext",
    "VUID-VkValidationCacheCreateInfoEXT-sType-sType",
    "VUID-VkValidationFeaturesEXT-pDisabledValidationFeatures-parameter",
    "VUID-VkValidationFeaturesEXT-pEnabledValidationFeatures-02967",
    "VUID-VkValidationFeaturesEXT-pEnabledValidationFeatures-02968",
    "VUID-VkValidationFeaturesEXT-pEnabledValidationFeatures-parameter",
    "VUID-VkValidationFeaturesEXT-sType-sType",
    "VUID-VkValidationFlagsEXT-disabledValidationCheckCount-arraylength",
    "VUID-VkValidationFlagsEXT-pDisabledValidationChecks-parameter",
    "VUID-VkValidationFlagsEXT-sType-sType",
    "VUID-VkVertexInputAttributeDescription-binding-00621",
    "VUID-VkVertexInputAttributeDescription-format-00623",
    "VUID-VkVertexInputAttributeDescription-format-parameter",
    "VUID-VkVertexInputAttributeDescription-location-00620",
    "VUID-VkVertexInputAttributeDescription-offset-00622",
    "VUID-VkVertexInputBindingDescription-binding-00618",
    "VUID-VkVertexInputBindingDescription-inputRate-parameter",
    "VUID-VkVertexInputBindingDescription-stride-00619",
    "VUID-VkVertexInputBindingDivisorDescriptionEXT-binding-01869",
    "VUID-VkVertexInputBindingDivisorDescriptionEXT-divisor-01870",
    "VUID-VkVertexInputBindingDivisorDescriptionEXT-inputRate-01871",
    "VUID-VkVertexInputBindingDivisorDescriptionEXT-vertexAttributeInstanceRateDivisor-02229",
    "VUID-VkVertexInputBindingDivisorDescriptionEXT-vertexAttributeInstanceRateZeroDivisor-02228",
    "VUID-VkViSurfaceCreateInfoNN-flags-zerobitmask",
    "VUID-VkViSurfaceCreateInfoNN-pNext-pNext",
    "VUID-VkViSurfaceCreateInfoNN-sType-sType",
    "VUID-VkViSurfaceCreateInfoNN-window-01318",
    "VUID-VkViewport-height-01772",
    "VUID-VkViewport-height-01773",
    "VUID-VkViewport-maxDepth-01235",
    "VUID-VkViewport-maxDepth-02541",
    "VUID-VkViewport-minDepth-01234",
    "VUID-VkViewport-minDepth-02540",
    "VUID-VkViewport-width-01770",
    "VUID-VkViewport-width-01771",
    "VUID-VkViewport-x-01232",
    "VUID-VkViewport-x-01774",
    "VUID-VkViewport-y-01233",
    "VUID-VkViewport-y-01775",
    "VUID-VkViewport-y-01776",
    "VUID-VkViewport-y-01777",
    "VUID-VkViewportSwizzleNV-w-parameter",
    "VUID-VkViewportSwizzleNV-x-parameter",
    "VUID-VkViewportSwizzleNV-y-parameter",
    "VUID-VkViewportSwizzleNV-z-parameter",
    "VUID-VkWaylandSurfaceCreateInfoKHR-display-01304",
    "VUID-VkWaylandSurfaceCreateInfoKHR-flags-zerobitmask",
    "VUID-VkWaylandSurfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkWaylandSurfaceCreateInfoKHR-sType-sType",
    "VUID-VkWaylandSurfaceCreateInfoKHR-surface-01305",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-commonparent",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-pAcquireKeys-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-pAcquireSyncs-00081",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-pAcquireSyncs-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-pAcquireTimeouts-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-pReleaseKeys-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-pReleaseSyncs-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoKHR-sType-sType",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-commonparent",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-pAcquireKeys-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-pAcquireSyncs-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-pAcquireTimeoutMilliseconds-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-pReleaseKeys-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-pReleaseSyncs-parameter",
    "VUID-VkWin32KeyedMutexAcquireReleaseInfoNV-sType-sType",
    "VUID-VkWin32SurfaceCreateInfoKHR-flags-zerobitmask",
    "VUID-VkWin32SurfaceCreateInfoKHR-hinstance-01307",
    "VUID-VkWin32SurfaceCreateInfoKHR-hwnd-01308",
    "VUID-VkWin32SurfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkWin32SurfaceCreateInfoKHR-sType-sType",
    "VUID-VkWriteDescriptorSet-commonparent",
    "VUID-VkWriteDescriptorSet-descriptorCount-00317",
    "VUID-VkWriteDescriptorSet-descriptorCount-00318",
    "VUID-VkWriteDescriptorSet-descriptorCount-03048",
    "VUID-VkWriteDescriptorSet-descriptorCount-arraylength",
    "VUID-VkWriteDescriptorSet-descriptorType-00319",
    "VUID-VkWriteDescriptorSet-descriptorType-00322",
    "VUID-VkWriteDescriptorSet-descriptorType-00324",
    "VUID-VkWriteDescriptorSet-descriptorType-00325",
    "VUID-VkWriteDescriptorSet-descriptorType-00327",
    "VUID-VkWriteDescriptorSet-descriptorType-00328",
    "VUID-VkWriteDescriptorSet-descriptorType-00329",
    "VUID-VkWriteDescriptorSet-descriptorType-00330",
    "VUID-VkWriteDescriptorSet-descriptorType-00331",
    "VUID-VkWriteDescriptorSet-descriptorType-00332",
    "VUID-VkWriteDescriptorSet-descriptorType-00333",
    "VUID-VkWriteDescriptorSet-descriptorType-00334",
    "VUID-VkWriteDescriptorSet-descriptorType-00335",
    "VUID-VkWriteDescriptorSet-descriptorType-00336",
    "VUID-VkWriteDescriptorSet-descriptorType-00337",
    "VUID-VkWriteDescriptorSet-descriptorType-00338",
    "VUID-VkWriteDescriptorSet-descriptorType-00339",
    "VUID-VkWriteDescriptorSet-descriptorType-01402",
    "VUID-VkWriteDescriptorSet-descriptorType-01403",
    "VUID-VkWriteDescriptorSet-descriptorType-01946",
    "VUID-VkWriteDescriptorSet-descriptorType-01948",
    "VUID-VkWriteDescriptorSet-descriptorType-02219",
    "VUID-VkWriteDescriptorSet-descriptorType-02220",
    "VUID-VkWriteDescriptorSet-descriptorType-02221",
    "VUID-VkWriteDescriptorSet-descriptorType-02382",
    "VUID-VkWriteDescriptorSet-descriptorType-02738",
    "VUID-VkWriteDescriptorSet-descriptorType-02752",
    "VUID-VkWriteDescriptorSet-descriptorType-02994",
    "VUID-VkWriteDescriptorSet-descriptorType-02995",
    "VUID-VkWriteDescriptorSet-descriptorType-02996",
    "VUID-VkWriteDescriptorSet-descriptorType-02997",
    "VUID-VkWriteDescriptorSet-descriptorType-parameter",
    "VUID-VkWriteDescriptorSet-dstArrayElement-00321",
    "VUID-VkWriteDescriptorSet-dstBinding-00315",
    "VUID-VkWriteDescriptorSet-dstBinding-00316",
    "VUID-VkWriteDescriptorSet-dstSet-00320",
    "VUID-VkWriteDescriptorSet-pNext-pNext",
    "VUID-VkWriteDescriptorSet-sType-sType",
    "VUID-VkWriteDescriptorSet-sType-unique",
    "VUID-VkWriteDescriptorSetAccelerationStructureKHR-accelerationStructureCount-02236",
    "VUID-VkWriteDescriptorSetAccelerationStructureKHR-accelerationStructureCount-arraylength",
    "VUID-VkWriteDescriptorSetAccelerationStructureKHR-pAccelerationStructures-02764",
    "VUID-VkWriteDescriptorSetAccelerationStructureKHR-pAccelerationStructures-parameter",
    "VUID-VkWriteDescriptorSetAccelerationStructureKHR-sType-sType",
    "VUID-VkWriteDescriptorSetInlineUniformBlockEXT-dataSize-02222",
    "VUID-VkWriteDescriptorSetInlineUniformBlockEXT-dataSize-arraylength",
    "VUID-VkWriteDescriptorSetInlineUniformBlockEXT-pData-parameter",
    "VUID-VkWriteDescriptorSetInlineUniformBlockEXT-sType-sType",
    "VUID-VkXcbSurfaceCreateInfoKHR-connection-01310",
    "VUID-VkXcbSurfaceCreateInfoKHR-flags-zerobitmask",
    "VUID-VkXcbSurfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkXcbSurfaceCreateInfoKHR-sType-sType",
    "VUID-VkXcbSurfaceCreateInfoKHR-window-01311",
    "VUID-VkXlibSurfaceCreateInfoKHR-dpy-01313",
    "VUID-VkXlibSurfaceCreateInfoKHR-flags-zerobitmask",
    "VUID-VkXlibSurfaceCreateInfoKHR-pNext-pNext",
    "VUID-VkXlibSurfaceCreateInfoKHR-sType-sType",
    "VUID-VkXlibSurfaceCreateInfoKHR-window-01314",
    "VUID-vkAcquireFullScreenExclusiveModeEXT-commonparent",
    "VUID-vkAcquireFullScreenExclusiveModeEXT-device-parameter",
    "VUID-vkAcquireFullScreenExclusiveModeEXT-swapchain-02674",
    "VUID-vkAcquireFullScreenExclusiveModeEXT-swapchain-02675",
    "VUID-vkAcquireFullScreenExclusiveModeEXT-swapchain-02676",
    "VUID-vkAcquireFullScreenExclusiveModeEXT-swapchain-parameter",
    "VUID-vkAcquireNextImage2KHR-device-parameter",
    "VUID-vkAcquireNextImage2KHR-pAcquireInfo-parameter",
    "VUID-vkAcquireNextImage2KHR-pImageIndex-parameter",
    "VUID-vkAcquireNextImage2KHR-swapchain-01803",
    "VUID-vkAcquireNextImageKHR-commonparent",
    "VUID-vkAcquireNextImageKHR-device-parameter",
    "VUID-vkAcquireNextImageKHR-fence-01287",
    "VUID-vkAcquireNextImageKHR-fence-parameter",
    "VUID-vkAcquireNextImageKHR-fence-parent",
    "VUID-vkAcquireNextImageKHR-pImageIndex-parameter",
    "VUID-vkAcquireNextImageKHR-semaphore-01286",
    "VUID-vkAcquireNextImageKHR-semaphore-01779",
    "VUID-vkAcquireNextImageKHR-semaphore-01780",
    "VUID-vkAcquireNextImageKHR-semaphore-03265",
    "VUID-vkAcquireNextImageKHR-semaphore-parameter",
    "VUID-vkAcquireNextImageKHR-semaphore-parent",
    "VUID-vkAcquireNextImageKHR-swapchain-01285",
    "VUID-vkAcquireNextImageKHR-swapchain-01802",
    "VUID-vkAcquireNextImageKHR-swapchain-parameter",
    "VUID-vkAcquirePerformanceConfigurationINTEL-device-parameter",
    "VUID-vkAcquirePerformanceConfigurationINTEL-pAcquireInfo-parameter",
    "VUID-vkAcquirePerformanceConfigurationINTEL-pConfiguration-parameter",
    "VUID-vkAcquireProfilingLockKHR-device-parameter",
    "VUID-vkAcquireProfilingLockKHR-pInfo-parameter",
    "VUID-vkAcquireXlibDisplayEXT-display-parameter",
    "VUID-vkAcquireXlibDisplayEXT-display-parent",
    "VUID-vkAcquireXlibDisplayEXT-dpy-parameter",
    "VUID-vkAcquireXlibDisplayEXT-physicalDevice-parameter",
    "VUID-vkAllocateCommandBuffers-device-parameter",
    "VUID-vkAllocateCommandBuffers-pAllocateInfo-parameter",
    "VUID-vkAllocateCommandBuffers-pAllocateInfo::commandBufferCount-arraylength",
    "VUID-vkAllocateCommandBuffers-pCommandBuffers-parameter",
    "VUID-vkAllocateDescriptorSets-device-parameter",
    "VUID-vkAllocateDescriptorSets-pAllocateInfo-parameter",
    "VUID-vkAllocateDescriptorSets-pAllocateInfo::descriptorSetCount-arraylength",
    "VUID-vkAllocateDescriptorSets-pDescriptorSets-parameter",
    "VUID-vkAllocateMemory-device-parameter",
    "VUID-vkAllocateMemory-deviceCoherentMemory-02790",
    "VUID-vkAllocateMemory-maxMemoryAllocationCount-04101",
    "VUID-vkAllocateMemory-pAllocateInfo-01713",
    "VUID-vkAllocateMemory-pAllocateInfo-01714",
    "VUID-vkAllocateMemory-pAllocateInfo-parameter",
    "VUID-vkAllocateMemory-pAllocator-parameter",
    "VUID-vkAllocateMemory-pMemory-parameter",
    "VUID-vkBeginCommandBuffer-commandBuffer-00049",
    "VUID-vkBeginCommandBuffer-commandBuffer-00050",
    "VUID-vkBeginCommandBuffer-commandBuffer-00051",
    "VUID-vkBeginCommandBuffer-commandBuffer-00052",
    "VUID-vkBeginCommandBuffer-commandBuffer-02840",
    "VUID-vkBeginCommandBuffer-commandBuffer-parameter",
    "VUID-vkBeginCommandBuffer-pBeginInfo-parameter",
    "VUID-vkBindAccelerationStructureMemoryKHR-bindInfoCount-arraylength",
    "VUID-vkBindAccelerationStructureMemoryKHR-device-parameter",
    "VUID-vkBindAccelerationStructureMemoryKHR-pBindInfos-parameter",
    "VUID-vkBindBufferMemory-None-01898",
    "VUID-vkBindBufferMemory-None-01899",
    "VUID-vkBindBufferMemory-buffer-01029",
    "VUID-vkBindBufferMemory-buffer-01030",
    "VUID-vkBindBufferMemory-buffer-01038",
    "VUID-vkBindBufferMemory-buffer-01039",
    "VUID-vkBindBufferMemory-buffer-01444",
    "VUID-vkBindBufferMemory-buffer-parameter",
    "VUID-vkBindBufferMemory-buffer-parent",
    "VUID-vkBindBufferMemory-bufferDeviceAddress-03339",
    "VUID-vkBindBufferMemory-device-parameter",
    "VUID-vkBindBufferMemory-memory-01035",
    "VUID-vkBindBufferMemory-memory-01508",
    "VUID-vkBindBufferMemory-memory-02726",
    "VUID-vkBindBufferMemory-memory-02727",
    "VUID-vkBindBufferMemory-memory-02985",
    "VUID-vkBindBufferMemory-memory-02986",
    "VUID-vkBindBufferMemory-memory-parameter",
    "VUID-vkBindBufferMemory-memory-parent",
    "VUID-vkBindBufferMemory-memoryOffset-01031",
    "VUID-vkBindBufferMemory-memoryOffset-01036",
    "VUID-vkBindBufferMemory-size-01037",
    "VUID-vkBindBufferMemory2-bindInfoCount-arraylength",
    "VUID-vkBindBufferMemory2-device-parameter",
    "VUID-vkBindBufferMemory2-pBindInfos-parameter",
    "VUID-vkBindImageMemory-None-01901",
    "VUID-vkBindImageMemory-None-01902",
    "VUID-vkBindImageMemory-device-parameter",
    "VUID-vkBindImageMemory-image-01044",
    "VUID-vkBindImageMemory-image-01045",
    "VUID-vkBindImageMemory-image-01050",
    "VUID-vkBindImageMemory-image-01051",
    "VUID-vkBindImageMemory-image-01445",
    "VUID-vkBindImageMemory-image-01608",
    "VUID-vkBindImageMemory-image-parameter",
    "VUID-vkBindImageMemory-image-parent",
    "VUID-vkBindImageMemory-memory-01047",
    "VUID-vkBindImageMemory-memory-01509",
    "VUID-vkBindImageMemory-memory-02628",
    "VUID-vkBindImageMemory-memory-02629",
    "VUID-vkBindImageMemory-memory-02728",
    "VUID-vkBindImageMemory-memory-02729",
    "VUID-vkBindImageMemory-memory-02989",
    "VUID-vkBindImageMemory-memory-02990",
    "VUID-vkBindImageMemory-memory-parameter",
    "VUID-vkBindImageMemory-memory-parent",
    "VUID-vkBindImageMemory-memoryOffset-01046",
    "VUID-vkBindImageMemory-memoryOffset-01048",
    "VUID-vkBindImageMemory-size-01049",
    "VUID-vkBindImageMemory2-bindInfoCount-arraylength",
    "VUID-vkBindImageMemory2-device-parameter",
    "VUID-vkBindImageMemory2-pBindInfos-02858",
    "VUID-vkBindImageMemory2-pBindInfos-04006",
    "VUID-vkBindImageMemory2-pBindInfos-parameter",
    "VUID-vkBuildAccelerationStructureKHR-None-03407",
    "VUID-vkBuildAccelerationStructureKHR-None-03409",
    "VUID-vkBuildAccelerationStructureKHR-None-03437",
    "VUID-vkBuildAccelerationStructureKHR-None-03438",
    "VUID-vkBuildAccelerationStructureKHR-device-parameter",
    "VUID-vkBuildAccelerationStructureKHR-infoCount-arraylength",
    "VUID-vkBuildAccelerationStructureKHR-pInfos-03403",
    "VUID-vkBuildAccelerationStructureKHR-pInfos-03404",
    "VUID-vkBuildAccelerationStructureKHR-pInfos-03405",
    "VUID-vkBuildAccelerationStructureKHR-pInfos-03406",
    "VUID-vkBuildAccelerationStructureKHR-pInfos-03408",
    "VUID-vkBuildAccelerationStructureKHR-pInfos-parameter",
    "VUID-vkBuildAccelerationStructureKHR-pOffsetInfos-03402",
    "VUID-vkBuildAccelerationStructureKHR-ppOffsetInfos-parameter",
    "VUID-vkBuildAccelerationStructureKHR-rayTracingHostAccelerationStructureCommands-03439",
    "VUID-vkCmdBeginConditionalRenderingEXT-None-01980",
    "VUID-vkCmdBeginConditionalRenderingEXT-commandBuffer-cmdpool",
    "VUID-vkCmdBeginConditionalRenderingEXT-commandBuffer-parameter",
    "VUID-vkCmdBeginConditionalRenderingEXT-commandBuffer-recording",
    "VUID-vkCmdBeginConditionalRenderingEXT-pConditionalRenderingBegin-parameter",
    "VUID-vkCmdBeginDebugUtilsLabelEXT-commandBuffer-cmdpool",
    "VUID-vkCmdBeginDebugUtilsLabelEXT-commandBuffer-parameter",
    "VUID-vkCmdBeginDebugUtilsLabelEXT-commandBuffer-recording",
    "VUID-vkCmdBeginDebugUtilsLabelEXT-pLabelInfo-parameter",
    "VUID-vkCmdBeginQuery-None-00807",
    "VUID-vkCmdBeginQuery-None-02863",
    "VUID-vkCmdBeginQuery-commandBuffer-01885",
    "VUID-vkCmdBeginQuery-commandBuffer-cmdpool",
    "VUID-vkCmdBeginQuery-commandBuffer-parameter",
    "VUID-vkCmdBeginQuery-commandBuffer-recording",
    "VUID-vkCmdBeginQuery-commonparent",
    "VUID-vkCmdBeginQuery-flags-parameter",
    "VUID-vkCmdBeginQuery-query-00802",
    "VUID-vkCmdBeginQuery-query-00808",
    "VUID-vkCmdBeginQuery-queryPool-01922",
    "VUID-vkCmdBeginQuery-queryPool-03223",
    "VUID-vkCmdBeginQuery-queryPool-03224",
    "VUID-vkCmdBeginQuery-queryPool-03225",
    "VUID-vkCmdBeginQuery-queryPool-03226",
    "VUID-vkCmdBeginQuery-queryPool-parameter",
    "VUID-vkCmdBeginQuery-queryType-00800",
    "VUID-vkCmdBeginQuery-queryType-00803",
    "VUID-vkCmdBeginQuery-queryType-00804",
    "VUID-vkCmdBeginQuery-queryType-00805",
    "VUID-vkCmdBeginQuery-queryType-02327",
    "VUID-vkCmdBeginQuery-queryType-02328",
    "VUID-vkCmdBeginQuery-queryType-02804",
    "VUID-vkCmdBeginQueryIndexedEXT-None-00807",
    "VUID-vkCmdBeginQueryIndexedEXT-None-02863",
    "VUID-vkCmdBeginQueryIndexedEXT-commandBuffer-01885",
    "VUID-vkCmdBeginQueryIndexedEXT-commandBuffer-cmdpool",
    "VUID-vkCmdBeginQueryIndexedEXT-commandBuffer-parameter",
    "VUID-vkCmdBeginQueryIndexedEXT-commandBuffer-recording",
    "VUID-vkCmdBeginQueryIndexedEXT-commonparent",
    "VUID-vkCmdBeginQueryIndexedEXT-flags-parameter",
    "VUID-vkCmdBeginQueryIndexedEXT-query-00802",
    "VUID-vkCmdBeginQueryIndexedEXT-query-00808",
    "VUID-vkCmdBeginQueryIndexedEXT-queryPool-01922",
    "VUID-vkCmdBeginQueryIndexedEXT-queryPool-03223",
    "VUID-vkCmdBeginQueryIndexedEXT-queryPool-03224",
    "VUID-vkCmdBeginQueryIndexedEXT-queryPool-03225",
    "VUID-vkCmdBeginQueryIndexedEXT-queryPool-03226",
    "VUID-vkCmdBeginQueryIndexedEXT-queryPool-parameter",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-00800",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-00803",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-00804",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-00805",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-02338",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-02339",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-02340",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-02341",
    "VUID-vkCmdBeginQueryIndexedEXT-queryType-02804",
    "VUID-vkCmdBeginRenderPass-bufferlevel",
    "VUID-vkCmdBeginRenderPass-commandBuffer-cmdpool",
    "VUID-vkCmdBeginRenderPass-commandBuffer-parameter",
    "VUID-vkCmdBeginRenderPass-commandBuffer-recording",
    "VUID-vkCmdBeginRenderPass-contents-parameter",
    "VUID-vkCmdBeginRenderPass-framebuffer-02532",
    "VUID-vkCmdBeginRenderPass-initialLayout-00895",
    "VUID-vkCmdBeginRenderPass-initialLayout-00896",
    "VUID-vkCmdBeginRenderPass-initialLayout-00897",
    "VUID-vkCmdBeginRenderPass-initialLayout-00898",
    "VUID-vkCmdBeginRenderPass-initialLayout-00899",
    "VUID-vkCmdBeginRenderPass-initialLayout-00900",
    "VUID-vkCmdBeginRenderPass-initialLayout-01758",
    "VUID-vkCmdBeginRenderPass-initialLayout-02842",
    "VUID-vkCmdBeginRenderPass-pAttachments-04102",
    "VUID-vkCmdBeginRenderPass-pAttachments-04103",
    "VUID-vkCmdBeginRenderPass-pAttachments-04104",
    "VUID-vkCmdBeginRenderPass-pAttachments-04105",
    "VUID-vkCmdBeginRenderPass-pRenderPassBegin-parameter",
    "VUID-vkCmdBeginRenderPass-renderpass",
    "VUID-vkCmdBeginRenderPass-srcStageMask-00901",
    "VUID-vkCmdBeginRenderPass-stencilInitialLayout-02843",
    "VUID-vkCmdBeginRenderPass2-bufferlevel",
    "VUID-vkCmdBeginRenderPass2-commandBuffer-cmdpool",
    "VUID-vkCmdBeginRenderPass2-commandBuffer-parameter",
    "VUID-vkCmdBeginRenderPass2-commandBuffer-recording",
    "VUID-vkCmdBeginRenderPass2-framebuffer-02533",
    "VUID-vkCmdBeginRenderPass2-framebuffer-02779",
    "VUID-vkCmdBeginRenderPass2-initialLayout-02844",
    "VUID-vkCmdBeginRenderPass2-initialLayout-03094",
    "VUID-vkCmdBeginRenderPass2-initialLayout-03096",
    "VUID-vkCmdBeginRenderPass2-initialLayout-03097",
    "VUID-vkCmdBeginRenderPass2-initialLayout-03098",
    "VUID-vkCmdBeginRenderPass2-initialLayout-03099",
    "VUID-vkCmdBeginRenderPass2-initialLayout-03100",
    "VUID-vkCmdBeginRenderPass2-pAttachments-04106",
    "VUID-vkCmdBeginRenderPass2-pAttachments-04107",
    "VUID-vkCmdBeginRenderPass2-pAttachments-04108",
    "VUID-vkCmdBeginRenderPass2-pAttachments-04109",
    "VUID-vkCmdBeginRenderPass2-pRenderPassBegin-parameter",
    "VUID-vkCmdBeginRenderPass2-pSubpassBeginInfo-parameter",
    "VUID-vkCmdBeginRenderPass2-renderpass",
    "VUID-vkCmdBeginRenderPass2-srcStageMask-03101",
    "VUID-vkCmdBeginRenderPass2-stencilInitialLayout-02845",
    "VUID-vkCmdBeginTransformFeedbackEXT-None-02367",
    "VUID-vkCmdBeginTransformFeedbackEXT-None-02373",
    "VUID-vkCmdBeginTransformFeedbackEXT-commandBuffer-cmdpool",
    "VUID-vkCmdBeginTransformFeedbackEXT-commandBuffer-parameter",
    "VUID-vkCmdBeginTransformFeedbackEXT-commandBuffer-recording",
    "VUID-vkCmdBeginTransformFeedbackEXT-commonparent",
    "VUID-vkCmdBeginTransformFeedbackEXT-counterBufferCount-02607",
    "VUID-vkCmdBeginTransformFeedbackEXT-firstCounterBuffer-02368",
    "VUID-vkCmdBeginTransformFeedbackEXT-firstCounterBuffer-02369",
    "VUID-vkCmdBeginTransformFeedbackEXT-pCounterBuffer-02371",
    "VUID-vkCmdBeginTransformFeedbackEXT-pCounterBufferOffsets-02370",
    "VUID-vkCmdBeginTransformFeedbackEXT-pCounterBufferOffsets-parameter",
    "VUID-vkCmdBeginTransformFeedbackEXT-pCounterBuffers-02372",
    "VUID-vkCmdBeginTransformFeedbackEXT-renderpass",
    "VUID-vkCmdBeginTransformFeedbackEXT-transformFeedback-02366",
    "VUID-vkCmdBindDescriptorSets-commandBuffer-cmdpool",
    "VUID-vkCmdBindDescriptorSets-commandBuffer-parameter",
    "VUID-vkCmdBindDescriptorSets-commandBuffer-recording",
    "VUID-vkCmdBindDescriptorSets-commonparent",
    "VUID-vkCmdBindDescriptorSets-descriptorSetCount-arraylength",
    "VUID-vkCmdBindDescriptorSets-dynamicOffsetCount-00359",
    "VUID-vkCmdBindDescriptorSets-firstSet-00360",
    "VUID-vkCmdBindDescriptorSets-layout-parameter",
    "VUID-vkCmdBindDescriptorSets-pDescriptorSets-00358",
    "VUID-vkCmdBindDescriptorSets-pDescriptorSets-01979",
    "VUID-vkCmdBindDescriptorSets-pDescriptorSets-parameter",
    "VUID-vkCmdBindDescriptorSets-pDynamicOffsets-01971",
    "VUID-vkCmdBindDescriptorSets-pDynamicOffsets-01972",
    "VUID-vkCmdBindDescriptorSets-pDynamicOffsets-parameter",
    "VUID-vkCmdBindDescriptorSets-pipelineBindPoint-00361",
    "VUID-vkCmdBindDescriptorSets-pipelineBindPoint-parameter",
    "VUID-vkCmdBindIndexBuffer-buffer-00433",
    "VUID-vkCmdBindIndexBuffer-buffer-00434",
    "VUID-vkCmdBindIndexBuffer-buffer-parameter",
    "VUID-vkCmdBindIndexBuffer-commandBuffer-cmdpool",
    "VUID-vkCmdBindIndexBuffer-commandBuffer-parameter",
    "VUID-vkCmdBindIndexBuffer-commandBuffer-recording",
    "VUID-vkCmdBindIndexBuffer-commonparent",
    "VUID-vkCmdBindIndexBuffer-indexType-02507",
    "VUID-vkCmdBindIndexBuffer-indexType-02765",
    "VUID-vkCmdBindIndexBuffer-indexType-parameter",
    "VUID-vkCmdBindIndexBuffer-offset-00431",
    "VUID-vkCmdBindIndexBuffer-offset-00432",
    "VUID-vkCmdBindPipeline-None-02323",
    "VUID-vkCmdBindPipeline-commandBuffer-cmdpool",
    "VUID-vkCmdBindPipeline-commandBuffer-parameter",
    "VUID-vkCmdBindPipeline-commandBuffer-recording",
    "VUID-vkCmdBindPipeline-commonparent",
    "VUID-vkCmdBindPipeline-pipeline-00781",
    "VUID-vkCmdBindPipeline-pipeline-03382",
    "VUID-vkCmdBindPipeline-pipeline-parameter",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-00777",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-00778",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-00779",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-00780",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-02391",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-02392",
    "VUID-vkCmdBindPipeline-pipelineBindPoint-parameter",
    "VUID-vkCmdBindPipeline-variableSampleLocations-01525",
    "VUID-vkCmdBindPipelineShaderGroupNV-commandBuffer-cmdpool",
    "VUID-vkCmdBindPipelineShaderGroupNV-commandBuffer-parameter",
    "VUID-vkCmdBindPipelineShaderGroupNV-commandBuffer-recording",
    "VUID-vkCmdBindPipelineShaderGroupNV-commonparent",
    "VUID-vkCmdBindPipelineShaderGroupNV-deviceGeneratedCommands-02896",
    "VUID-vkCmdBindPipelineShaderGroupNV-groupIndex-02893",
    "VUID-vkCmdBindPipelineShaderGroupNV-groupIndex-02895",
    "VUID-vkCmdBindPipelineShaderGroupNV-pipeline-parameter",
    "VUID-vkCmdBindPipelineShaderGroupNV-pipelineBindPoint-02894",
    "VUID-vkCmdBindPipelineShaderGroupNV-pipelineBindPoint-parameter",
    "VUID-vkCmdBindShadingRateImageNV-None-02058",
    "VUID-vkCmdBindShadingRateImageNV-commandBuffer-cmdpool",
    "VUID-vkCmdBindShadingRateImageNV-commandBuffer-parameter",
    "VUID-vkCmdBindShadingRateImageNV-commandBuffer-recording",
    "VUID-vkCmdBindShadingRateImageNV-commonparent",
    "VUID-vkCmdBindShadingRateImageNV-imageLayout-02063",
    "VUID-vkCmdBindShadingRateImageNV-imageLayout-parameter",
    "VUID-vkCmdBindShadingRateImageNV-imageView-02059",
    "VUID-vkCmdBindShadingRateImageNV-imageView-02060",
    "VUID-vkCmdBindShadingRateImageNV-imageView-02061",
    "VUID-vkCmdBindShadingRateImageNV-imageView-02062",
    "VUID-vkCmdBindShadingRateImageNV-imageView-parameter",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-None-02365",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-bindingCount-arraylength",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-commandBuffer-cmdpool",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-commandBuffer-parameter",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-commandBuffer-recording",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-commonparent",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-firstBinding-02356",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-firstBinding-02357",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pBuffers-02360",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pBuffers-02364",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pBuffers-parameter",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pOffsets-02358",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pOffsets-02359",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pOffsets-02363",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pOffsets-parameter",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pSize-02361",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-pSizes-02362",
    "VUID-vkCmdBindTransformFeedbackBuffersEXT-transformFeedback-02355",
    "VUID-vkCmdBindVertexBuffers-bindingCount-arraylength",
    "VUID-vkCmdBindVertexBuffers-commandBuffer-cmdpool",
    "VUID-vkCmdBindVertexBuffers-commandBuffer-parameter",
    "VUID-vkCmdBindVertexBuffers-commandBuffer-recording",
    "VUID-vkCmdBindVertexBuffers-commonparent",
    "VUID-vkCmdBindVertexBuffers-firstBinding-00624",
    "VUID-vkCmdBindVertexBuffers-firstBinding-00625",
    "VUID-vkCmdBindVertexBuffers-pBuffers-00627",
    "VUID-vkCmdBindVertexBuffers-pBuffers-00628",
    "VUID-vkCmdBindVertexBuffers-pBuffers-04001",
    "VUID-vkCmdBindVertexBuffers-pBuffers-04002",
    "VUID-vkCmdBindVertexBuffers-pBuffers-parameter",
    "VUID-vkCmdBindVertexBuffers-pOffsets-00626",
    "VUID-vkCmdBindVertexBuffers-pOffsets-parameter",
    "VUID-vkCmdBlitImage-commandBuffer-01834",
    "VUID-vkCmdBlitImage-commandBuffer-01835",
    "VUID-vkCmdBlitImage-commandBuffer-01836",
    "VUID-vkCmdBlitImage-commandBuffer-cmdpool",
    "VUID-vkCmdBlitImage-commandBuffer-parameter",
    "VUID-vkCmdBlitImage-commandBuffer-recording",
    "VUID-vkCmdBlitImage-commonparent",
    "VUID-vkCmdBlitImage-dstImage-00224",
    "VUID-vkCmdBlitImage-dstImage-00225",
    "VUID-vkCmdBlitImage-dstImage-00234",
    "VUID-vkCmdBlitImage-dstImage-01562",
    "VUID-vkCmdBlitImage-dstImage-02000",
    "VUID-vkCmdBlitImage-dstImage-02545",
    "VUID-vkCmdBlitImage-dstImage-parameter",
    "VUID-vkCmdBlitImage-dstImageLayout-00226",
    "VUID-vkCmdBlitImage-dstImageLayout-00227",
    "VUID-vkCmdBlitImage-dstImageLayout-01399",
    "VUID-vkCmdBlitImage-dstImageLayout-parameter",
    "VUID-vkCmdBlitImage-dstSubresource-01706",
    "VUID-vkCmdBlitImage-dstSubresource-01708",
    "VUID-vkCmdBlitImage-filter-00237",
    "VUID-vkCmdBlitImage-filter-02001",
    "VUID-vkCmdBlitImage-filter-02002",
    "VUID-vkCmdBlitImage-filter-parameter",
    "VUID-vkCmdBlitImage-pRegions-00215",
    "VUID-vkCmdBlitImage-pRegions-00216",
    "VUID-vkCmdBlitImage-pRegions-00217",
    "VUID-vkCmdBlitImage-pRegions-parameter",
    "VUID-vkCmdBlitImage-regionCount-arraylength",
    "VUID-vkCmdBlitImage-renderpass",
    "VUID-vkCmdBlitImage-srcImage-00219",
    "VUID-vkCmdBlitImage-srcImage-00220",
    "VUID-vkCmdBlitImage-srcImage-00229",
    "VUID-vkCmdBlitImage-srcImage-00230",
    "VUID-vkCmdBlitImage-srcImage-00231",
    "VUID-vkCmdBlitImage-srcImage-00232",
    "VUID-vkCmdBlitImage-srcImage-00233",
    "VUID-vkCmdBlitImage-srcImage-01561",
    "VUID-vkCmdBlitImage-srcImage-01999",
    "VUID-vkCmdBlitImage-srcImage-parameter",
    "VUID-vkCmdBlitImage-srcImageLayout-00221",
    "VUID-vkCmdBlitImage-srcImageLayout-00222",
    "VUID-vkCmdBlitImage-srcImageLayout-01398",
    "VUID-vkCmdBlitImage-srcImageLayout-parameter",
    "VUID-vkCmdBlitImage-srcSubresource-01705",
    "VUID-vkCmdBlitImage-srcSubresource-01707",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-None-03534",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-None-04047",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-commandBuffer-cmdpool",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-commandBuffer-parameter",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-commandBuffer-recording",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-commonparent",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-indirectBuffer-parameter",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-pInfo-parameter",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-pNext-03536",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-rayTracingIndirectAccelerationStructureBuild-03535",
    "VUID-vkCmdBuildAccelerationStructureIndirectKHR-renderpass",
    "VUID-vkCmdBuildAccelerationStructureKHR-None-03407",
    "VUID-vkCmdBuildAccelerationStructureKHR-None-03409",
    "VUID-vkCmdBuildAccelerationStructureKHR-None-03531",
    "VUID-vkCmdBuildAccelerationStructureKHR-None-04046",
    "VUID-vkCmdBuildAccelerationStructureKHR-commandBuffer-cmdpool",
    "VUID-vkCmdBuildAccelerationStructureKHR-commandBuffer-parameter",
    "VUID-vkCmdBuildAccelerationStructureKHR-commandBuffer-recording",
    "VUID-vkCmdBuildAccelerationStructureKHR-infoCount-arraylength",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-03403",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-03404",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-03405",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-03406",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-03408",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-03529",
    "VUID-vkCmdBuildAccelerationStructureKHR-pInfos-parameter",
    "VUID-vkCmdBuildAccelerationStructureKHR-pNext-03532",
    "VUID-vkCmdBuildAccelerationStructureKHR-pOffsetInfos-03402",
    "VUID-vkCmdBuildAccelerationStructureKHR-ppOffsetInfos-parameter",
    "VUID-vkCmdBuildAccelerationStructureKHR-renderpass",
    "VUID-vkCmdBuildAccelerationStructureKHR-update-03527",
    "VUID-vkCmdBuildAccelerationStructureKHR-update-03528",
    "VUID-vkCmdBuildAccelerationStructureNV-commandBuffer-cmdpool",
    "VUID-vkCmdBuildAccelerationStructureNV-commandBuffer-parameter",
    "VUID-vkCmdBuildAccelerationStructureNV-commandBuffer-recording",
    "VUID-vkCmdBuildAccelerationStructureNV-commonparent",
    "VUID-vkCmdBuildAccelerationStructureNV-dst-02488",
    "VUID-vkCmdBuildAccelerationStructureNV-dst-parameter",
    "VUID-vkCmdBuildAccelerationStructureNV-geometryCount-02241",
    "VUID-vkCmdBuildAccelerationStructureNV-instanceData-03523",
    "VUID-vkCmdBuildAccelerationStructureNV-instanceData-parameter",
    "VUID-vkCmdBuildAccelerationStructureNV-pInfo-parameter",
    "VUID-vkCmdBuildAccelerationStructureNV-renderpass",
    "VUID-vkCmdBuildAccelerationStructureNV-scratch-03522",
    "VUID-vkCmdBuildAccelerationStructureNV-scratch-parameter",
    "VUID-vkCmdBuildAccelerationStructureNV-src-parameter",
    "VUID-vkCmdBuildAccelerationStructureNV-update-02489",
    "VUID-vkCmdBuildAccelerationStructureNV-update-02490",
    "VUID-vkCmdBuildAccelerationStructureNV-update-02491",
    "VUID-vkCmdBuildAccelerationStructureNV-update-02492",
    "VUID-vkCmdBuildAccelerationStructureNV-update-03524",
    "VUID-vkCmdBuildAccelerationStructureNV-update-03525",
    "VUID-vkCmdBuildAccelerationStructureNV-update-03526",
    "VUID-vkCmdClearAttachments-aspectMask-02501",
    "VUID-vkCmdClearAttachments-aspectMask-02502",
    "VUID-vkCmdClearAttachments-aspectMask-02503",
    "VUID-vkCmdClearAttachments-attachmentCount-arraylength",
    "VUID-vkCmdClearAttachments-baseArrayLayer-00018",
    "VUID-vkCmdClearAttachments-commandBuffer-02504",
    "VUID-vkCmdClearAttachments-commandBuffer-02505",
    "VUID-vkCmdClearAttachments-commandBuffer-cmdpool",
    "VUID-vkCmdClearAttachments-commandBuffer-parameter",
    "VUID-vkCmdClearAttachments-commandBuffer-recording",
    "VUID-vkCmdClearAttachments-layerCount-01934",
    "VUID-vkCmdClearAttachments-pAttachments-parameter",
    "VUID-vkCmdClearAttachments-pRects-00016",
    "VUID-vkCmdClearAttachments-pRects-00017",
    "VUID-vkCmdClearAttachments-pRects-parameter",
    "VUID-vkCmdClearAttachments-rect-02682",
    "VUID-vkCmdClearAttachments-rect-02683",
    "VUID-vkCmdClearAttachments-rectCount-arraylength",
    "VUID-vkCmdClearAttachments-renderpass",
    "VUID-vkCmdClearColorImage-aspectMask-02498",
    "VUID-vkCmdClearColorImage-baseArrayLayer-01472",
    "VUID-vkCmdClearColorImage-baseMipLevel-01470",
    "VUID-vkCmdClearColorImage-commandBuffer-01805",
    "VUID-vkCmdClearColorImage-commandBuffer-01806",
    "VUID-vkCmdClearColorImage-commandBuffer-cmdpool",
    "VUID-vkCmdClearColorImage-commandBuffer-parameter",
    "VUID-vkCmdClearColorImage-commandBuffer-recording",
    "VUID-vkCmdClearColorImage-commonparent",
    "VUID-vkCmdClearColorImage-image-00002",
    "VUID-vkCmdClearColorImage-image-00003",
    "VUID-vkCmdClearColorImage-image-00007",
    "VUID-vkCmdClearColorImage-image-01545",
    "VUID-vkCmdClearColorImage-image-01993",
    "VUID-vkCmdClearColorImage-image-parameter",
    "VUID-vkCmdClearColorImage-imageLayout-00004",
    "VUID-vkCmdClearColorImage-imageLayout-00005",
    "VUID-vkCmdClearColorImage-imageLayout-01394",
    "VUID-vkCmdClearColorImage-imageLayout-parameter",
    "VUID-vkCmdClearColorImage-pColor-parameter",
    "VUID-vkCmdClearColorImage-pRanges-01692",
    "VUID-vkCmdClearColorImage-pRanges-01693",
    "VUID-vkCmdClearColorImage-pRanges-parameter",
    "VUID-vkCmdClearColorImage-rangeCount-arraylength",
    "VUID-vkCmdClearColorImage-renderpass",
    "VUID-vkCmdClearDepthStencilImage-aspectMask-02824",
    "VUID-vkCmdClearDepthStencilImage-baseArrayLayer-01476",
    "VUID-vkCmdClearDepthStencilImage-baseMipLevel-01474",
    "VUID-vkCmdClearDepthStencilImage-commandBuffer-01807",
    "VUID-vkCmdClearDepthStencilImage-commandBuffer-01808",
    "VUID-vkCmdClearDepthStencilImage-commandBuffer-cmdpool",
    "VUID-vkCmdClearDepthStencilImage-commandBuffer-parameter",
    "VUID-vkCmdClearDepthStencilImage-commandBuffer-recording",
    "VUID-vkCmdClearDepthStencilImage-commonparent",
    "VUID-vkCmdClearDepthStencilImage-image-00009",
    "VUID-vkCmdClearDepthStencilImage-image-00010",
    "VUID-vkCmdClearDepthStencilImage-image-00014",
    "VUID-vkCmdClearDepthStencilImage-image-01994",
    "VUID-vkCmdClearDepthStencilImage-image-02825",
    "VUID-vkCmdClearDepthStencilImage-image-02826",
    "VUID-vkCmdClearDepthStencilImage-image-parameter",
    "VUID-vkCmdClearDepthStencilImage-imageLayout-00011",
    "VUID-vkCmdClearDepthStencilImage-imageLayout-00012",
    "VUID-vkCmdClearDepthStencilImage-imageLayout-parameter",
    "VUID-vkCmdClearDepthStencilImage-pDepthStencil-parameter",
    "VUID-vkCmdClearDepthStencilImage-pRanges-01694",
    "VUID-vkCmdClearDepthStencilImage-pRanges-01695",
    "VUID-vkCmdClearDepthStencilImage-pRanges-02658",
    "VUID-vkCmdClearDepthStencilImage-pRanges-02659",
    "VUID-vkCmdClearDepthStencilImage-pRanges-02660",
    "VUID-vkCmdClearDepthStencilImage-pRanges-parameter",
    "VUID-vkCmdClearDepthStencilImage-rangeCount-arraylength",
    "VUID-vkCmdClearDepthStencilImage-renderpass",
    "VUID-vkCmdCopyAccelerationStructureKHR-None-03556",
    "VUID-vkCmdCopyAccelerationStructureKHR-commandBuffer-cmdpool",
    "VUID-vkCmdCopyAccelerationStructureKHR-commandBuffer-parameter",
    "VUID-vkCmdCopyAccelerationStructureKHR-commandBuffer-recording",
    "VUID-vkCmdCopyAccelerationStructureKHR-pInfo-parameter",
    "VUID-vkCmdCopyAccelerationStructureKHR-pNext-03557",
    "VUID-vkCmdCopyAccelerationStructureKHR-renderpass",
    "VUID-vkCmdCopyAccelerationStructureNV-commandBuffer-cmdpool",
    "VUID-vkCmdCopyAccelerationStructureNV-commandBuffer-parameter",
    "VUID-vkCmdCopyAccelerationStructureNV-commandBuffer-recording",
    "VUID-vkCmdCopyAccelerationStructureNV-commonparent",
    "VUID-vkCmdCopyAccelerationStructureNV-dst-parameter",
    "VUID-vkCmdCopyAccelerationStructureNV-mode-03410",
    "VUID-vkCmdCopyAccelerationStructureNV-mode-parameter",
    "VUID-vkCmdCopyAccelerationStructureNV-renderpass",
    "VUID-vkCmdCopyAccelerationStructureNV-src-03411",
    "VUID-vkCmdCopyAccelerationStructureNV-src-parameter",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-None-03559",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-None-04048",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-commandBuffer-cmdpool",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-commandBuffer-parameter",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-commandBuffer-recording",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-mode-03412",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-pInfo-parameter",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-pNext-03560",
    "VUID-vkCmdCopyAccelerationStructureToMemoryKHR-renderpass",
    "VUID-vkCmdCopyBuffer-commandBuffer-01822",
    "VUID-vkCmdCopyBuffer-commandBuffer-01823",
    "VUID-vkCmdCopyBuffer-commandBuffer-01824",
    "VUID-vkCmdCopyBuffer-commandBuffer-cmdpool",
    "VUID-vkCmdCopyBuffer-commandBuffer-parameter",
    "VUID-vkCmdCopyBuffer-commandBuffer-recording",
    "VUID-vkCmdCopyBuffer-commonparent",
    "VUID-vkCmdCopyBuffer-dstBuffer-00120",
    "VUID-vkCmdCopyBuffer-dstBuffer-00121",
    "VUID-vkCmdCopyBuffer-dstBuffer-parameter",
    "VUID-vkCmdCopyBuffer-dstOffset-00114",
    "VUID-vkCmdCopyBuffer-pRegions-00117",
    "VUID-vkCmdCopyBuffer-pRegions-parameter",
    "VUID-vkCmdCopyBuffer-regionCount-arraylength",
    "VUID-vkCmdCopyBuffer-renderpass",
    "VUID-vkCmdCopyBuffer-size-00115",
    "VUID-vkCmdCopyBuffer-size-00116",
    "VUID-vkCmdCopyBuffer-srcBuffer-00118",
    "VUID-vkCmdCopyBuffer-srcBuffer-00119",
    "VUID-vkCmdCopyBuffer-srcBuffer-parameter",
    "VUID-vkCmdCopyBuffer-srcOffset-00113",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-01828",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-01829",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-01830",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-04052",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-cmdpool",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-parameter",
    "VUID-vkCmdCopyBufferToImage-commandBuffer-recording",
    "VUID-vkCmdCopyBufferToImage-commonparent",
    "VUID-vkCmdCopyBufferToImage-dstImage-00177",
    "VUID-vkCmdCopyBufferToImage-dstImage-00178",
    "VUID-vkCmdCopyBufferToImage-dstImage-00179",
    "VUID-vkCmdCopyBufferToImage-dstImage-01997",
    "VUID-vkCmdCopyBufferToImage-dstImage-02543",
    "VUID-vkCmdCopyBufferToImage-dstImage-04053",
    "VUID-vkCmdCopyBufferToImage-dstImage-parameter",
    "VUID-vkCmdCopyBufferToImage-dstImageLayout-00180",
    "VUID-vkCmdCopyBufferToImage-dstImageLayout-00181",
    "VUID-vkCmdCopyBufferToImage-dstImageLayout-01396",
    "VUID-vkCmdCopyBufferToImage-dstImageLayout-parameter",
    "VUID-vkCmdCopyBufferToImage-imageOffset-01793",
    "VUID-vkCmdCopyBufferToImage-imageSubresource-01701",
    "VUID-vkCmdCopyBufferToImage-imageSubresource-01702",
    "VUID-vkCmdCopyBufferToImage-pRegions-00171",
    "VUID-vkCmdCopyBufferToImage-pRegions-00172",
    "VUID-vkCmdCopyBufferToImage-pRegions-00173",
    "VUID-vkCmdCopyBufferToImage-pRegions-parameter",
    "VUID-vkCmdCopyBufferToImage-regionCount-arraylength",
    "VUID-vkCmdCopyBufferToImage-renderpass",
    "VUID-vkCmdCopyBufferToImage-srcBuffer-00174",
    "VUID-vkCmdCopyBufferToImage-srcBuffer-00176",
    "VUID-vkCmdCopyBufferToImage-srcBuffer-parameter",
    "VUID-vkCmdCopyImage-None-01549",
    "VUID-vkCmdCopyImage-commandBuffer-01825",
    "VUID-vkCmdCopyImage-commandBuffer-01826",
    "VUID-vkCmdCopyImage-commandBuffer-01827",
    "VUID-vkCmdCopyImage-commandBuffer-cmdpool",
    "VUID-vkCmdCopyImage-commandBuffer-parameter",
    "VUID-vkCmdCopyImage-commandBuffer-recording",
    "VUID-vkCmdCopyImage-commonparent",
    "VUID-vkCmdCopyImage-dstImage-00131",
    "VUID-vkCmdCopyImage-dstImage-00132",
    "VUID-vkCmdCopyImage-dstImage-01547",
    "VUID-vkCmdCopyImage-dstImage-01996",
    "VUID-vkCmdCopyImage-dstImage-02542",
    "VUID-vkCmdCopyImage-dstImage-parameter",
    "VUID-vkCmdCopyImage-dstImageLayout-00133",
    "VUID-vkCmdCopyImage-dstImageLayout-00134",
    "VUID-vkCmdCopyImage-dstImageLayout-01395",
    "VUID-vkCmdCopyImage-dstImageLayout-parameter",
    "VUID-vkCmdCopyImage-dstOffset-01784",
    "VUID-vkCmdCopyImage-dstSubresource-01697",
    "VUID-vkCmdCopyImage-dstSubresource-01699",
    "VUID-vkCmdCopyImage-pRegions-00124",
    "VUID-vkCmdCopyImage-pRegions-parameter",
    "VUID-vkCmdCopyImage-regionCount-arraylength",
    "VUID-vkCmdCopyImage-renderpass",
    "VUID-vkCmdCopyImage-srcImage-00126",
    "VUID-vkCmdCopyImage-srcImage-00127",
    "VUID-vkCmdCopyImage-srcImage-00135",
    "VUID-vkCmdCopyImage-srcImage-00136",
    "VUID-vkCmdCopyImage-srcImage-01546",
    "VUID-vkCmdCopyImage-srcImage-01548",
    "VUID-vkCmdCopyImage-srcImage-01995",
    "VUID-vkCmdCopyImage-srcImage-parameter",
    "VUID-vkCmdCopyImage-srcImageLayout-00128",
    "VUID-vkCmdCopyImage-srcImageLayout-00129",
    "VUID-vkCmdCopyImage-srcImageLayout-01917",
    "VUID-vkCmdCopyImage-srcImageLayout-parameter",
    "VUID-vkCmdCopyImage-srcOffset-01783",
    "VUID-vkCmdCopyImage-srcSubresource-01696",
    "VUID-vkCmdCopyImage-srcSubresource-01698",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-01831",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-01832",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-01833",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-04054",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-cmdpool",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-parameter",
    "VUID-vkCmdCopyImageToBuffer-commandBuffer-recording",
    "VUID-vkCmdCopyImageToBuffer-commonparent",
    "VUID-vkCmdCopyImageToBuffer-dstBuffer-00191",
    "VUID-vkCmdCopyImageToBuffer-dstBuffer-00192",
    "VUID-vkCmdCopyImageToBuffer-dstBuffer-parameter",
    "VUID-vkCmdCopyImageToBuffer-imageOffset-01794",
    "VUID-vkCmdCopyImageToBuffer-imageSubresource-01703",
    "VUID-vkCmdCopyImageToBuffer-imageSubresource-01704",
    "VUID-vkCmdCopyImageToBuffer-pRegions-00182",
    "VUID-vkCmdCopyImageToBuffer-pRegions-00183",
    "VUID-vkCmdCopyImageToBuffer-pRegions-00184",
    "VUID-vkCmdCopyImageToBuffer-pRegions-parameter",
    "VUID-vkCmdCopyImageToBuffer-regionCount-arraylength",
    "VUID-vkCmdCopyImageToBuffer-renderpass",
    "VUID-vkCmdCopyImageToBuffer-srcImage-00186",
    "VUID-vkCmdCopyImageToBuffer-srcImage-00187",
    "VUID-vkCmdCopyImageToBuffer-srcImage-00188",
    "VUID-vkCmdCopyImageToBuffer-srcImage-01998",
    "VUID-vkCmdCopyImageToBuffer-srcImage-02544",
    "VUID-vkCmdCopyImageToBuffer-srcImage-04055",
    "VUID-vkCmdCopyImageToBuffer-srcImage-parameter",
    "VUID-vkCmdCopyImageToBuffer-srcImageLayout-00189",
    "VUID-vkCmdCopyImageToBuffer-srcImageLayout-00190",
    "VUID-vkCmdCopyImageToBuffer-srcImageLayout-01397",
    "VUID-vkCmdCopyImageToBuffer-srcImageLayout-parameter",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-None-03563",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-None-04049",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-commandBuffer-cmdpool",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-commandBuffer-parameter",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-commandBuffer-recording",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-mode-03413",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-pInfo-03414",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-pInfo-parameter",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-pNext-03564",
    "VUID-vkCmdCopyMemoryToAccelerationStructureKHR-renderpass",
    "VUID-vkCmdCopyQueryPoolResults-commandBuffer-cmdpool",
    "VUID-vkCmdCopyQueryPoolResults-commandBuffer-parameter",
    "VUID-vkCmdCopyQueryPoolResults-commandBuffer-recording",
    "VUID-vkCmdCopyQueryPoolResults-commonparent",
    "VUID-vkCmdCopyQueryPoolResults-dstBuffer-00824",
    "VUID-vkCmdCopyQueryPoolResults-dstBuffer-00825",
    "VUID-vkCmdCopyQueryPoolResults-dstBuffer-00826",
    "VUID-vkCmdCopyQueryPoolResults-dstBuffer-parameter",
    "VUID-vkCmdCopyQueryPoolResults-dstOffset-00819",
    "VUID-vkCmdCopyQueryPoolResults-firstQuery-00820",
    "VUID-vkCmdCopyQueryPoolResults-firstQuery-00821",
    "VUID-vkCmdCopyQueryPoolResults-flags-00822",
    "VUID-vkCmdCopyQueryPoolResults-flags-00823",
    "VUID-vkCmdCopyQueryPoolResults-flags-parameter",
    "VUID-vkCmdCopyQueryPoolResults-queryPool-parameter",
    "VUID-vkCmdCopyQueryPoolResults-queryType-00827",
    "VUID-vkCmdCopyQueryPoolResults-queryType-02734",
    "VUID-vkCmdCopyQueryPoolResults-queryType-03232",
    "VUID-vkCmdCopyQueryPoolResults-queryType-03233",
    "VUID-vkCmdCopyQueryPoolResults-queryType-03234",
    "VUID-vkCmdCopyQueryPoolResults-renderpass",
    "VUID-vkCmdDebugMarkerBeginEXT-commandBuffer-cmdpool",
    "VUID-vkCmdDebugMarkerBeginEXT-commandBuffer-parameter",
    "VUID-vkCmdDebugMarkerBeginEXT-commandBuffer-recording",
    "VUID-vkCmdDebugMarkerBeginEXT-pMarkerInfo-parameter",
    "VUID-vkCmdDebugMarkerEndEXT-commandBuffer-01239",
    "VUID-vkCmdDebugMarkerEndEXT-commandBuffer-01240",
    "VUID-vkCmdDebugMarkerEndEXT-commandBuffer-cmdpool",
    "VUID-vkCmdDebugMarkerEndEXT-commandBuffer-parameter",
    "VUID-vkCmdDebugMarkerEndEXT-commandBuffer-recording",
    "VUID-vkCmdDebugMarkerInsertEXT-commandBuffer-cmdpool",
    "VUID-vkCmdDebugMarkerInsertEXT-commandBuffer-parameter",
    "VUID-vkCmdDebugMarkerInsertEXT-commandBuffer-recording",
    "VUID-vkCmdDebugMarkerInsertEXT-pMarkerInfo-parameter",
    "VUID-vkCmdDispatch-None-02690",
    "VUID-vkCmdDispatch-None-02691",
    "VUID-vkCmdDispatch-None-02692",
    "VUID-vkCmdDispatch-None-02693",
    "VUID-vkCmdDispatch-None-02697",
    "VUID-vkCmdDispatch-None-02698",
    "VUID-vkCmdDispatch-None-02699",
    "VUID-vkCmdDispatch-None-02700",
    "VUID-vkCmdDispatch-None-02702",
    "VUID-vkCmdDispatch-None-02703",
    "VUID-vkCmdDispatch-None-02704",
    "VUID-vkCmdDispatch-None-02705",
    "VUID-vkCmdDispatch-None-02706",
    "VUID-vkCmdDispatch-None-02859",
    "VUID-vkCmdDispatch-commandBuffer-02701",
    "VUID-vkCmdDispatch-commandBuffer-02707",
    "VUID-vkCmdDispatch-commandBuffer-02712",
    "VUID-vkCmdDispatch-commandBuffer-02713",
    "VUID-vkCmdDispatch-commandBuffer-cmdpool",
    "VUID-vkCmdDispatch-commandBuffer-parameter",
    "VUID-vkCmdDispatch-commandBuffer-recording",
    "VUID-vkCmdDispatch-filterCubic-02694",
    "VUID-vkCmdDispatch-filterCubicMinmax-02695",
    "VUID-vkCmdDispatch-flags-02696",
    "VUID-vkCmdDispatch-groupCountX-00386",
    "VUID-vkCmdDispatch-groupCountY-00387",
    "VUID-vkCmdDispatch-groupCountZ-00388",
    "VUID-vkCmdDispatch-renderpass",
    "VUID-vkCmdDispatchBase-None-02690",
    "VUID-vkCmdDispatchBase-None-02691",
    "VUID-vkCmdDispatchBase-None-02692",
    "VUID-vkCmdDispatchBase-None-02693",
    "VUID-vkCmdDispatchBase-None-02697",
    "VUID-vkCmdDispatchBase-None-02698",
    "VUID-vkCmdDispatchBase-None-02699",
    "VUID-vkCmdDispatchBase-None-02700",
    "VUID-vkCmdDispatchBase-None-02702",
    "VUID-vkCmdDispatchBase-None-02703",
    "VUID-vkCmdDispatchBase-None-02704",
    "VUID-vkCmdDispatchBase-None-02705",
    "VUID-vkCmdDispatchBase-None-02706",
    "VUID-vkCmdDispatchBase-None-02859",
    "VUID-vkCmdDispatchBase-baseGroupX-00421",
    "VUID-vkCmdDispatchBase-baseGroupX-00422",
    "VUID-vkCmdDispatchBase-baseGroupX-00427",
    "VUID-vkCmdDispatchBase-baseGroupZ-00423",
    "VUID-vkCmdDispatchBase-commandBuffer-02701",
    "VUID-vkCmdDispatchBase-commandBuffer-02707",
    "VUID-vkCmdDispatchBase-commandBuffer-cmdpool",
    "VUID-vkCmdDispatchBase-commandBuffer-parameter",
    "VUID-vkCmdDispatchBase-commandBuffer-recording",
    "VUID-vkCmdDispatchBase-filterCubic-02694",
    "VUID-vkCmdDispatchBase-filterCubicMinmax-02695",
    "VUID-vkCmdDispatchBase-flags-02696",
    "VUID-vkCmdDispatchBase-groupCountX-00424",
    "VUID-vkCmdDispatchBase-groupCountY-00425",
    "VUID-vkCmdDispatchBase-groupCountZ-00426",
    "VUID-vkCmdDispatchBase-renderpass",
    "VUID-vkCmdDispatchIndirect-None-02690",
    "VUID-vkCmdDispatchIndirect-None-02691",
    "VUID-vkCmdDispatchIndirect-None-02692",
    "VUID-vkCmdDispatchIndirect-None-02693",
    "VUID-vkCmdDispatchIndirect-None-02697",
    "VUID-vkCmdDispatchIndirect-None-02698",
    "VUID-vkCmdDispatchIndirect-None-02699",
    "VUID-vkCmdDispatchIndirect-None-02700",
    "VUID-vkCmdDispatchIndirect-None-02702",
    "VUID-vkCmdDispatchIndirect-None-02703",
    "VUID-vkCmdDispatchIndirect-None-02704",
    "VUID-vkCmdDispatchIndirect-None-02705",
    "VUID-vkCmdDispatchIndirect-None-02706",
    "VUID-vkCmdDispatchIndirect-None-02859",
    "VUID-vkCmdDispatchIndirect-buffer-02708",
    "VUID-vkCmdDispatchIndirect-buffer-02709",
    "VUID-vkCmdDispatchIndirect-buffer-parameter",
    "VUID-vkCmdDispatchIndirect-commandBuffer-02701",
    "VUID-vkCmdDispatchIndirect-commandBuffer-02707",
    "VUID-vkCmdDispatchIndirect-commandBuffer-02711",
    "VUID-vkCmdDispatchIndirect-commandBuffer-cmdpool",
    "VUID-vkCmdDispatchIndirect-commandBuffer-parameter",
    "VUID-vkCmdDispatchIndirect-commandBuffer-recording",
    "VUID-vkCmdDispatchIndirect-commonparent",
    "VUID-vkCmdDispatchIndirect-filterCubic-02694",
    "VUID-vkCmdDispatchIndirect-filterCubicMinmax-02695",
    "VUID-vkCmdDispatchIndirect-flags-02696",
    "VUID-vkCmdDispatchIndirect-offset-00407",
    "VUID-vkCmdDispatchIndirect-offset-02710",
    "VUID-vkCmdDispatchIndirect-renderpass",
    "VUID-vkCmdDraw-None-02686",
    "VUID-vkCmdDraw-None-02687",
    "VUID-vkCmdDraw-None-02690",
    "VUID-vkCmdDraw-None-02691",
    "VUID-vkCmdDraw-None-02692",
    "VUID-vkCmdDraw-None-02693",
    "VUID-vkCmdDraw-None-02697",
    "VUID-vkCmdDraw-None-02698",
    "VUID-vkCmdDraw-None-02699",
    "VUID-vkCmdDraw-None-02700",
    "VUID-vkCmdDraw-None-02702",
    "VUID-vkCmdDraw-None-02703",
    "VUID-vkCmdDraw-None-02704",
    "VUID-vkCmdDraw-None-02705",
    "VUID-vkCmdDraw-None-02706",
    "VUID-vkCmdDraw-None-02721",
    "VUID-vkCmdDraw-None-02859",
    "VUID-vkCmdDraw-None-04007",
    "VUID-vkCmdDraw-None-04008",
    "VUID-vkCmdDraw-commandBuffer-02701",
    "VUID-vkCmdDraw-commandBuffer-02707",
    "VUID-vkCmdDraw-commandBuffer-02712",
    "VUID-vkCmdDraw-commandBuffer-02713",
    "VUID-vkCmdDraw-commandBuffer-cmdpool",
    "VUID-vkCmdDraw-commandBuffer-parameter",
    "VUID-vkCmdDraw-commandBuffer-recording",
    "VUID-vkCmdDraw-filterCubic-02694",
    "VUID-vkCmdDraw-filterCubicMinmax-02695",
    "VUID-vkCmdDraw-flags-02696",
    "VUID-vkCmdDraw-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDraw-renderPass-02684",
    "VUID-vkCmdDraw-renderpass",
    "VUID-vkCmdDraw-sampleLocationsEnable-02689",
    "VUID-vkCmdDraw-subpass-02685",
    "VUID-vkCmdDrawIndexed-None-02686",
    "VUID-vkCmdDrawIndexed-None-02687",
    "VUID-vkCmdDrawIndexed-None-02690",
    "VUID-vkCmdDrawIndexed-None-02691",
    "VUID-vkCmdDrawIndexed-None-02692",
    "VUID-vkCmdDrawIndexed-None-02693",
    "VUID-vkCmdDrawIndexed-None-02697",
    "VUID-vkCmdDrawIndexed-None-02698",
    "VUID-vkCmdDrawIndexed-None-02699",
    "VUID-vkCmdDrawIndexed-None-02700",
    "VUID-vkCmdDrawIndexed-None-02702",
    "VUID-vkCmdDrawIndexed-None-02703",
    "VUID-vkCmdDrawIndexed-None-02704",
    "VUID-vkCmdDrawIndexed-None-02705",
    "VUID-vkCmdDrawIndexed-None-02706",
    "VUID-vkCmdDrawIndexed-None-02721",
    "VUID-vkCmdDrawIndexed-None-02859",
    "VUID-vkCmdDrawIndexed-None-04007",
    "VUID-vkCmdDrawIndexed-None-04008",
    "VUID-vkCmdDrawIndexed-commandBuffer-02701",
    "VUID-vkCmdDrawIndexed-commandBuffer-02707",
    "VUID-vkCmdDrawIndexed-commandBuffer-02712",
    "VUID-vkCmdDrawIndexed-commandBuffer-02713",
    "VUID-vkCmdDrawIndexed-commandBuffer-cmdpool",
    "VUID-vkCmdDrawIndexed-commandBuffer-parameter",
    "VUID-vkCmdDrawIndexed-commandBuffer-recording",
    "VUID-vkCmdDrawIndexed-filterCubic-02694",
    "VUID-vkCmdDrawIndexed-filterCubicMinmax-02695",
    "VUID-vkCmdDrawIndexed-flags-02696",
    "VUID-vkCmdDrawIndexed-indexSize-00463",
    "VUID-vkCmdDrawIndexed-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawIndexed-renderPass-02684",
    "VUID-vkCmdDrawIndexed-renderpass",
    "VUID-vkCmdDrawIndexed-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawIndexed-subpass-02685",
    "VUID-vkCmdDrawIndexedIndirect-None-02686",
    "VUID-vkCmdDrawIndexedIndirect-None-02687",
    "VUID-vkCmdDrawIndexedIndirect-None-02690",
    "VUID-vkCmdDrawIndexedIndirect-None-02691",
    "VUID-vkCmdDrawIndexedIndirect-None-02692",
    "VUID-vkCmdDrawIndexedIndirect-None-02693",
    "VUID-vkCmdDrawIndexedIndirect-None-02697",
    "VUID-vkCmdDrawIndexedIndirect-None-02698",
    "VUID-vkCmdDrawIndexedIndirect-None-02699",
    "VUID-vkCmdDrawIndexedIndirect-None-02700",
    "VUID-vkCmdDrawIndexedIndirect-None-02702",
    "VUID-vkCmdDrawIndexedIndirect-None-02703",
    "VUID-vkCmdDrawIndexedIndirect-None-02704",
    "VUID-vkCmdDrawIndexedIndirect-None-02705",
    "VUID-vkCmdDrawIndexedIndirect-None-02706",
    "VUID-vkCmdDrawIndexedIndirect-None-02721",
    "VUID-vkCmdDrawIndexedIndirect-None-02837",
    "VUID-vkCmdDrawIndexedIndirect-None-02859",
    "VUID-vkCmdDrawIndexedIndirect-None-04007",
    "VUID-vkCmdDrawIndexedIndirect-None-04008",
    "VUID-vkCmdDrawIndexedIndirect-buffer-02708",
    "VUID-vkCmdDrawIndexedIndirect-buffer-02709",
    "VUID-vkCmdDrawIndexedIndirect-buffer-parameter",
    "VUID-vkCmdDrawIndexedIndirect-commandBuffer-02701",
    "VUID-vkCmdDrawIndexedIndirect-commandBuffer-02707",
    "VUID-vkCmdDrawIndexedIndirect-commandBuffer-02711",
    "VUID-vkCmdDrawIndexedIndirect-commandBuffer-cmdpool",
    "VUID-vkCmdDrawIndexedIndirect-commandBuffer-parameter",
    "VUID-vkCmdDrawIndexedIndirect-commandBuffer-recording",
    "VUID-vkCmdDrawIndexedIndirect-commonparent",
    "VUID-vkCmdDrawIndexedIndirect-drawCount-00528",
    "VUID-vkCmdDrawIndexedIndirect-drawCount-00539",
    "VUID-vkCmdDrawIndexedIndirect-drawCount-00540",
    "VUID-vkCmdDrawIndexedIndirect-drawCount-02718",
    "VUID-vkCmdDrawIndexedIndirect-drawCount-02719",
    "VUID-vkCmdDrawIndexedIndirect-filterCubic-02694",
    "VUID-vkCmdDrawIndexedIndirect-filterCubicMinmax-02695",
    "VUID-vkCmdDrawIndexedIndirect-firstInstance-00530",
    "VUID-vkCmdDrawIndexedIndirect-flags-02696",
    "VUID-vkCmdDrawIndexedIndirect-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawIndexedIndirect-offset-02710",
    "VUID-vkCmdDrawIndexedIndirect-renderPass-02684",
    "VUID-vkCmdDrawIndexedIndirect-renderpass",
    "VUID-vkCmdDrawIndexedIndirect-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawIndexedIndirect-subpass-02685",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02686",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02687",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02690",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02691",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02692",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02693",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02697",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02698",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02699",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02700",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02702",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02703",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02704",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02705",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02706",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02721",
    "VUID-vkCmdDrawIndexedIndirectCount-None-02859",
    "VUID-vkCmdDrawIndexedIndirectCount-None-04007",
    "VUID-vkCmdDrawIndexedIndirectCount-None-04008",
    "VUID-vkCmdDrawIndexedIndirectCount-buffer-02708",
    "VUID-vkCmdDrawIndexedIndirectCount-buffer-02709",
    "VUID-vkCmdDrawIndexedIndirectCount-buffer-parameter",
    "VUID-vkCmdDrawIndexedIndirectCount-commandBuffer-02701",
    "VUID-vkCmdDrawIndexedIndirectCount-commandBuffer-02707",
    "VUID-vkCmdDrawIndexedIndirectCount-commandBuffer-02711",
    "VUID-vkCmdDrawIndexedIndirectCount-commandBuffer-cmdpool",
    "VUID-vkCmdDrawIndexedIndirectCount-commandBuffer-parameter",
    "VUID-vkCmdDrawIndexedIndirectCount-commandBuffer-recording",
    "VUID-vkCmdDrawIndexedIndirectCount-commonparent",
    "VUID-vkCmdDrawIndexedIndirectCount-countBuffer-02714",
    "VUID-vkCmdDrawIndexedIndirectCount-countBuffer-02715",
    "VUID-vkCmdDrawIndexedIndirectCount-countBuffer-02717",
    "VUID-vkCmdDrawIndexedIndirectCount-countBuffer-03153",
    "VUID-vkCmdDrawIndexedIndirectCount-countBuffer-03154",
    "VUID-vkCmdDrawIndexedIndirectCount-countBuffer-parameter",
    "VUID-vkCmdDrawIndexedIndirectCount-countBufferOffset-02716",
    "VUID-vkCmdDrawIndexedIndirectCount-filterCubic-02694",
    "VUID-vkCmdDrawIndexedIndirectCount-filterCubicMinmax-02695",
    "VUID-vkCmdDrawIndexedIndirectCount-flags-02696",
    "VUID-vkCmdDrawIndexedIndirectCount-maxDrawCount-03143",
    "VUID-vkCmdDrawIndexedIndirectCount-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawIndexedIndirectCount-offset-02710",
    "VUID-vkCmdDrawIndexedIndirectCount-renderPass-02684",
    "VUID-vkCmdDrawIndexedIndirectCount-renderpass",
    "VUID-vkCmdDrawIndexedIndirectCount-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawIndexedIndirectCount-stride-03142",
    "VUID-vkCmdDrawIndexedIndirectCount-subpass-02685",
    "VUID-vkCmdDrawIndirect-None-02686",
    "VUID-vkCmdDrawIndirect-None-02687",
    "VUID-vkCmdDrawIndirect-None-02690",
    "VUID-vkCmdDrawIndirect-None-02691",
    "VUID-vkCmdDrawIndirect-None-02692",
    "VUID-vkCmdDrawIndirect-None-02693",
    "VUID-vkCmdDrawIndirect-None-02697",
    "VUID-vkCmdDrawIndirect-None-02698",
    "VUID-vkCmdDrawIndirect-None-02699",
    "VUID-vkCmdDrawIndirect-None-02700",
    "VUID-vkCmdDrawIndirect-None-02702",
    "VUID-vkCmdDrawIndirect-None-02703",
    "VUID-vkCmdDrawIndirect-None-02704",
    "VUID-vkCmdDrawIndirect-None-02705",
    "VUID-vkCmdDrawIndirect-None-02706",
    "VUID-vkCmdDrawIndirect-None-02721",
    "VUID-vkCmdDrawIndirect-None-02859",
    "VUID-vkCmdDrawIndirect-None-04007",
    "VUID-vkCmdDrawIndirect-None-04008",
    "VUID-vkCmdDrawIndirect-buffer-02708",
    "VUID-vkCmdDrawIndirect-buffer-02709",
    "VUID-vkCmdDrawIndirect-buffer-parameter",
    "VUID-vkCmdDrawIndirect-commandBuffer-02701",
    "VUID-vkCmdDrawIndirect-commandBuffer-02707",
    "VUID-vkCmdDrawIndirect-commandBuffer-02711",
    "VUID-vkCmdDrawIndirect-commandBuffer-cmdpool",
    "VUID-vkCmdDrawIndirect-commandBuffer-parameter",
    "VUID-vkCmdDrawIndirect-commandBuffer-recording",
    "VUID-vkCmdDrawIndirect-commonparent",
    "VUID-vkCmdDrawIndirect-drawCount-00476",
    "VUID-vkCmdDrawIndirect-drawCount-00487",
    "VUID-vkCmdDrawIndirect-drawCount-00488",
    "VUID-vkCmdDrawIndirect-drawCount-02718",
    "VUID-vkCmdDrawIndirect-drawCount-02719",
    "VUID-vkCmdDrawIndirect-filterCubic-02694",
    "VUID-vkCmdDrawIndirect-filterCubicMinmax-02695",
    "VUID-vkCmdDrawIndirect-firstInstance-00478",
    "VUID-vkCmdDrawIndirect-flags-02696",
    "VUID-vkCmdDrawIndirect-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawIndirect-offset-02710",
    "VUID-vkCmdDrawIndirect-renderPass-02684",
    "VUID-vkCmdDrawIndirect-renderpass",
    "VUID-vkCmdDrawIndirect-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawIndirect-subpass-02685",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02686",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02687",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02690",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02691",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02692",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02693",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02697",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02698",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02699",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02700",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02702",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02703",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02704",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02705",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02706",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02721",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-02859",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-04007",
    "VUID-vkCmdDrawIndirectByteCountEXT-None-04008",
    "VUID-vkCmdDrawIndirectByteCountEXT-commandBuffer-02646",
    "VUID-vkCmdDrawIndirectByteCountEXT-commandBuffer-02701",
    "VUID-vkCmdDrawIndirectByteCountEXT-commandBuffer-02707",
    "VUID-vkCmdDrawIndirectByteCountEXT-commandBuffer-cmdpool",
    "VUID-vkCmdDrawIndirectByteCountEXT-commandBuffer-parameter",
    "VUID-vkCmdDrawIndirectByteCountEXT-commandBuffer-recording",
    "VUID-vkCmdDrawIndirectByteCountEXT-commonparent",
    "VUID-vkCmdDrawIndirectByteCountEXT-counterBuffer-02290",
    "VUID-vkCmdDrawIndirectByteCountEXT-counterBuffer-parameter",
    "VUID-vkCmdDrawIndirectByteCountEXT-filterCubic-02694",
    "VUID-vkCmdDrawIndirectByteCountEXT-filterCubicMinmax-02695",
    "VUID-vkCmdDrawIndirectByteCountEXT-flags-02696",
    "VUID-vkCmdDrawIndirectByteCountEXT-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawIndirectByteCountEXT-renderPass-02684",
    "VUID-vkCmdDrawIndirectByteCountEXT-renderpass",
    "VUID-vkCmdDrawIndirectByteCountEXT-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawIndirectByteCountEXT-subpass-02685",
    "VUID-vkCmdDrawIndirectByteCountEXT-transformFeedback-02287",
    "VUID-vkCmdDrawIndirectByteCountEXT-transformFeedbackDraw-02288",
    "VUID-vkCmdDrawIndirectByteCountEXT-vertexStride-02289",
    "VUID-vkCmdDrawIndirectCount-None-02686",
    "VUID-vkCmdDrawIndirectCount-None-02687",
    "VUID-vkCmdDrawIndirectCount-None-02690",
    "VUID-vkCmdDrawIndirectCount-None-02691",
    "VUID-vkCmdDrawIndirectCount-None-02692",
    "VUID-vkCmdDrawIndirectCount-None-02693",
    "VUID-vkCmdDrawIndirectCount-None-02697",
    "VUID-vkCmdDrawIndirectCount-None-02698",
    "VUID-vkCmdDrawIndirectCount-None-02699",
    "VUID-vkCmdDrawIndirectCount-None-02700",
    "VUID-vkCmdDrawIndirectCount-None-02702",
    "VUID-vkCmdDrawIndirectCount-None-02703",
    "VUID-vkCmdDrawIndirectCount-None-02704",
    "VUID-vkCmdDrawIndirectCount-None-02705",
    "VUID-vkCmdDrawIndirectCount-None-02706",
    "VUID-vkCmdDrawIndirectCount-None-02721",
    "VUID-vkCmdDrawIndirectCount-None-02836",
    "VUID-vkCmdDrawIndirectCount-None-02859",
    "VUID-vkCmdDrawIndirectCount-None-04007",
    "VUID-vkCmdDrawIndirectCount-None-04008",
    "VUID-vkCmdDrawIndirectCount-buffer-02708",
    "VUID-vkCmdDrawIndirectCount-buffer-02709",
    "VUID-vkCmdDrawIndirectCount-buffer-parameter",
    "VUID-vkCmdDrawIndirectCount-commandBuffer-02701",
    "VUID-vkCmdDrawIndirectCount-commandBuffer-02707",
    "VUID-vkCmdDrawIndirectCount-commandBuffer-02711",
    "VUID-vkCmdDrawIndirectCount-commandBuffer-cmdpool",
    "VUID-vkCmdDrawIndirectCount-commandBuffer-parameter",
    "VUID-vkCmdDrawIndirectCount-commandBuffer-recording",
    "VUID-vkCmdDrawIndirectCount-commonparent",
    "VUID-vkCmdDrawIndirectCount-countBuffer-02714",
    "VUID-vkCmdDrawIndirectCount-countBuffer-02715",
    "VUID-vkCmdDrawIndirectCount-countBuffer-02717",
    "VUID-vkCmdDrawIndirectCount-countBuffer-03121",
    "VUID-vkCmdDrawIndirectCount-countBuffer-03122",
    "VUID-vkCmdDrawIndirectCount-countBuffer-parameter",
    "VUID-vkCmdDrawIndirectCount-countBufferOffset-02716",
    "VUID-vkCmdDrawIndirectCount-filterCubic-02694",
    "VUID-vkCmdDrawIndirectCount-filterCubicMinmax-02695",
    "VUID-vkCmdDrawIndirectCount-flags-02696",
    "VUID-vkCmdDrawIndirectCount-maxDrawCount-03111",
    "VUID-vkCmdDrawIndirectCount-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawIndirectCount-offset-02710",
    "VUID-vkCmdDrawIndirectCount-renderPass-02684",
    "VUID-vkCmdDrawIndirectCount-renderpass",
    "VUID-vkCmdDrawIndirectCount-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawIndirectCount-stride-03110",
    "VUID-vkCmdDrawIndirectCount-subpass-02685",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02686",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02687",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02690",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02691",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02692",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02693",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02697",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02698",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02699",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02700",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02702",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02703",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02704",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02705",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02706",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-None-02859",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-buffer-02708",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-buffer-02709",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-buffer-parameter",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commandBuffer-02701",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commandBuffer-02707",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commandBuffer-02711",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commandBuffer-cmdpool",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commandBuffer-parameter",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commandBuffer-recording",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-commonparent",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBuffer-02191",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBuffer-02192",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBuffer-02714",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBuffer-02715",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBuffer-02717",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBuffer-parameter",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-countBufferOffset-02716",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-filterCubic-02694",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-filterCubicMinmax-02695",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-flags-02696",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-maxDrawCount-02183",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-offset-02710",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-renderPass-02684",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-renderpass",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-stride-02182",
    "VUID-vkCmdDrawMeshTasksIndirectCountNV-subpass-02685",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02686",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02687",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02690",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02691",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02692",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02693",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02697",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02698",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02699",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02700",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02702",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02703",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02704",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02705",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02706",
    "VUID-vkCmdDrawMeshTasksIndirectNV-None-02859",
    "VUID-vkCmdDrawMeshTasksIndirectNV-buffer-02708",
    "VUID-vkCmdDrawMeshTasksIndirectNV-buffer-02709",
    "VUID-vkCmdDrawMeshTasksIndirectNV-buffer-parameter",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commandBuffer-02701",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commandBuffer-02707",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commandBuffer-02711",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commandBuffer-cmdpool",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commandBuffer-parameter",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commandBuffer-recording",
    "VUID-vkCmdDrawMeshTasksIndirectNV-commonparent",
    "VUID-vkCmdDrawMeshTasksIndirectNV-drawCount-02146",
    "VUID-vkCmdDrawMeshTasksIndirectNV-drawCount-02156",
    "VUID-vkCmdDrawMeshTasksIndirectNV-drawCount-02157",
    "VUID-vkCmdDrawMeshTasksIndirectNV-drawCount-02718",
    "VUID-vkCmdDrawMeshTasksIndirectNV-drawCount-02719",
    "VUID-vkCmdDrawMeshTasksIndirectNV-filterCubic-02694",
    "VUID-vkCmdDrawMeshTasksIndirectNV-filterCubicMinmax-02695",
    "VUID-vkCmdDrawMeshTasksIndirectNV-flags-02696",
    "VUID-vkCmdDrawMeshTasksIndirectNV-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawMeshTasksIndirectNV-offset-02710",
    "VUID-vkCmdDrawMeshTasksIndirectNV-renderPass-02684",
    "VUID-vkCmdDrawMeshTasksIndirectNV-renderpass",
    "VUID-vkCmdDrawMeshTasksIndirectNV-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawMeshTasksIndirectNV-subpass-02685",
    "VUID-vkCmdDrawMeshTasksNV-None-02686",
    "VUID-vkCmdDrawMeshTasksNV-None-02687",
    "VUID-vkCmdDrawMeshTasksNV-None-02690",
    "VUID-vkCmdDrawMeshTasksNV-None-02691",
    "VUID-vkCmdDrawMeshTasksNV-None-02692",
    "VUID-vkCmdDrawMeshTasksNV-None-02693",
    "VUID-vkCmdDrawMeshTasksNV-None-02697",
    "VUID-vkCmdDrawMeshTasksNV-None-02698",
    "VUID-vkCmdDrawMeshTasksNV-None-02699",
    "VUID-vkCmdDrawMeshTasksNV-None-02700",
    "VUID-vkCmdDrawMeshTasksNV-None-02702",
    "VUID-vkCmdDrawMeshTasksNV-None-02703",
    "VUID-vkCmdDrawMeshTasksNV-None-02704",
    "VUID-vkCmdDrawMeshTasksNV-None-02705",
    "VUID-vkCmdDrawMeshTasksNV-None-02706",
    "VUID-vkCmdDrawMeshTasksNV-None-02859",
    "VUID-vkCmdDrawMeshTasksNV-commandBuffer-02701",
    "VUID-vkCmdDrawMeshTasksNV-commandBuffer-02707",
    "VUID-vkCmdDrawMeshTasksNV-commandBuffer-cmdpool",
    "VUID-vkCmdDrawMeshTasksNV-commandBuffer-parameter",
    "VUID-vkCmdDrawMeshTasksNV-commandBuffer-recording",
    "VUID-vkCmdDrawMeshTasksNV-filterCubic-02694",
    "VUID-vkCmdDrawMeshTasksNV-filterCubicMinmax-02695",
    "VUID-vkCmdDrawMeshTasksNV-flags-02696",
    "VUID-vkCmdDrawMeshTasksNV-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdDrawMeshTasksNV-renderPass-02684",
    "VUID-vkCmdDrawMeshTasksNV-renderpass",
    "VUID-vkCmdDrawMeshTasksNV-sampleLocationsEnable-02689",
    "VUID-vkCmdDrawMeshTasksNV-subpass-02685",
    "VUID-vkCmdDrawMeshTasksNV-taskCount-02119",
    "VUID-vkCmdEndConditionalRenderingEXT-None-01985",
    "VUID-vkCmdEndConditionalRenderingEXT-None-01986",
    "VUID-vkCmdEndConditionalRenderingEXT-None-01987",
    "VUID-vkCmdEndConditionalRenderingEXT-commandBuffer-cmdpool",
    "VUID-vkCmdEndConditionalRenderingEXT-commandBuffer-parameter",
    "VUID-vkCmdEndConditionalRenderingEXT-commandBuffer-recording",
    "VUID-vkCmdEndDebugUtilsLabelEXT-commandBuffer-01912",
    "VUID-vkCmdEndDebugUtilsLabelEXT-commandBuffer-01913",
    "VUID-vkCmdEndDebugUtilsLabelEXT-commandBuffer-cmdpool",
    "VUID-vkCmdEndDebugUtilsLabelEXT-commandBuffer-parameter",
    "VUID-vkCmdEndDebugUtilsLabelEXT-commandBuffer-recording",
    "VUID-vkCmdEndQuery-None-01923",
    "VUID-vkCmdEndQuery-commandBuffer-01886",
    "VUID-vkCmdEndQuery-commandBuffer-cmdpool",
    "VUID-vkCmdEndQuery-commandBuffer-parameter",
    "VUID-vkCmdEndQuery-commandBuffer-recording",
    "VUID-vkCmdEndQuery-commonparent",
    "VUID-vkCmdEndQuery-query-00810",
    "VUID-vkCmdEndQuery-query-00812",
    "VUID-vkCmdEndQuery-queryPool-03227",
    "VUID-vkCmdEndQuery-queryPool-03228",
    "VUID-vkCmdEndQuery-queryPool-parameter",
    "VUID-vkCmdEndQueryIndexedEXT-None-02342",
    "VUID-vkCmdEndQueryIndexedEXT-commandBuffer-02344",
    "VUID-vkCmdEndQueryIndexedEXT-commandBuffer-cmdpool",
    "VUID-vkCmdEndQueryIndexedEXT-commandBuffer-parameter",
    "VUID-vkCmdEndQueryIndexedEXT-commandBuffer-recording",
    "VUID-vkCmdEndQueryIndexedEXT-commonparent",
    "VUID-vkCmdEndQueryIndexedEXT-query-02343",
    "VUID-vkCmdEndQueryIndexedEXT-query-02345",
    "VUID-vkCmdEndQueryIndexedEXT-queryPool-parameter",
    "VUID-vkCmdEndQueryIndexedEXT-queryType-02346",
    "VUID-vkCmdEndQueryIndexedEXT-queryType-02347",
    "VUID-vkCmdEndQueryIndexedEXT-queryType-02723",
    "VUID-vkCmdEndRenderPass-None-00910",
    "VUID-vkCmdEndRenderPass-None-02351",
    "VUID-vkCmdEndRenderPass-bufferlevel",
    "VUID-vkCmdEndRenderPass-commandBuffer-cmdpool",
    "VUID-vkCmdEndRenderPass-commandBuffer-parameter",
    "VUID-vkCmdEndRenderPass-commandBuffer-recording",
    "VUID-vkCmdEndRenderPass-renderpass",
    "VUID-vkCmdEndRenderPass2-None-02352",
    "VUID-vkCmdEndRenderPass2-None-03103",
    "VUID-vkCmdEndRenderPass2-bufferlevel",
    "VUID-vkCmdEndRenderPass2-commandBuffer-cmdpool",
    "VUID-vkCmdEndRenderPass2-commandBuffer-parameter",
    "VUID-vkCmdEndRenderPass2-commandBuffer-recording",
    "VUID-vkCmdEndRenderPass2-pSubpassEndInfo-parameter",
    "VUID-vkCmdEndRenderPass2-renderpass",
    "VUID-vkCmdEndTransformFeedbackEXT-None-02375",
    "VUID-vkCmdEndTransformFeedbackEXT-commandBuffer-cmdpool",
    "VUID-vkCmdEndTransformFeedbackEXT-commandBuffer-parameter",
    "VUID-vkCmdEndTransformFeedbackEXT-commandBuffer-recording",
    "VUID-vkCmdEndTransformFeedbackEXT-commonparent",
    "VUID-vkCmdEndTransformFeedbackEXT-counterBufferCount-02608",
    "VUID-vkCmdEndTransformFeedbackEXT-firstCounterBuffer-02376",
    "VUID-vkCmdEndTransformFeedbackEXT-firstCounterBuffer-02377",
    "VUID-vkCmdEndTransformFeedbackEXT-pCounterBuffer-02379",
    "VUID-vkCmdEndTransformFeedbackEXT-pCounterBufferOffsets-02378",
    "VUID-vkCmdEndTransformFeedbackEXT-pCounterBufferOffsets-parameter",
    "VUID-vkCmdEndTransformFeedbackEXT-pCounterBuffers-02380",
    "VUID-vkCmdEndTransformFeedbackEXT-renderpass",
    "VUID-vkCmdEndTransformFeedbackEXT-transformFeedback-02374",
    "VUID-vkCmdExecuteCommands-None-02286",
    "VUID-vkCmdExecuteCommands-bufferlevel",
    "VUID-vkCmdExecuteCommands-commandBuffer-00101",
    "VUID-vkCmdExecuteCommands-commandBuffer-00102",
    "VUID-vkCmdExecuteCommands-commandBuffer-00103",
    "VUID-vkCmdExecuteCommands-commandBuffer-00104",
    "VUID-vkCmdExecuteCommands-commandBuffer-01820",
    "VUID-vkCmdExecuteCommands-commandBuffer-01821",
    "VUID-vkCmdExecuteCommands-commandBuffer-cmdpool",
    "VUID-vkCmdExecuteCommands-commandBuffer-parameter",
    "VUID-vkCmdExecuteCommands-commandBuffer-recording",
    "VUID-vkCmdExecuteCommands-commandBufferCount-arraylength",
    "VUID-vkCmdExecuteCommands-commonparent",
    "VUID-vkCmdExecuteCommands-contents-00095",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00088",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00089",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00091",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00092",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00093",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00094",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00096",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00097",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00099",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00100",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-00105",
    "VUID-vkCmdExecuteCommands-pCommandBuffers-parameter",
    "VUID-vkCmdExecuteCommands-pInheritanceInfo-00098",
    "VUID-vkCmdExecuteCommands-pNext-02865",
    "VUID-vkCmdExecuteCommands-pNext-02866",
    "VUID-vkCmdExecuteCommands-pNext-02867",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02686",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02687",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02690",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02691",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02692",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02693",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02697",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02698",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02699",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02700",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02702",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02703",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02704",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02705",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02706",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02721",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02859",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-02910",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-04007",
    "VUID-vkCmdExecuteGeneratedCommandsNV-None-04008",
    "VUID-vkCmdExecuteGeneratedCommandsNV-commandBuffer-02701",
    "VUID-vkCmdExecuteGeneratedCommandsNV-commandBuffer-02707",
    "VUID-vkCmdExecuteGeneratedCommandsNV-commandBuffer-02970",
    "VUID-vkCmdExecuteGeneratedCommandsNV-commandBuffer-cmdpool",
    "VUID-vkCmdExecuteGeneratedCommandsNV-commandBuffer-parameter",
    "VUID-vkCmdExecuteGeneratedCommandsNV-commandBuffer-recording",
    "VUID-vkCmdExecuteGeneratedCommandsNV-deviceGeneratedCommands-02911",
    "VUID-vkCmdExecuteGeneratedCommandsNV-filterCubic-02694",
    "VUID-vkCmdExecuteGeneratedCommandsNV-filterCubicMinmax-02695",
    "VUID-vkCmdExecuteGeneratedCommandsNV-flags-02696",
    "VUID-vkCmdExecuteGeneratedCommandsNV-isPreprocessed-02908",
    "VUID-vkCmdExecuteGeneratedCommandsNV-maxMultiviewInstanceIndex-02688",
    "VUID-vkCmdExecuteGeneratedCommandsNV-pGeneratedCommandsInfo-parameter",
    "VUID-vkCmdExecuteGeneratedCommandsNV-pipeline-02909",
    "VUID-vkCmdExecuteGeneratedCommandsNV-renderPass-02684",
    "VUID-vkCmdExecuteGeneratedCommandsNV-renderpass",
    "VUID-vkCmdExecuteGeneratedCommandsNV-sampleLocationsEnable-02689",
    "VUID-vkCmdExecuteGeneratedCommandsNV-subpass-02685",
    "VUID-vkCmdFillBuffer-commandBuffer-00030",
    "VUID-vkCmdFillBuffer-commandBuffer-01811",
    "VUID-vkCmdFillBuffer-commandBuffer-01812",
    "VUID-vkCmdFillBuffer-commandBuffer-cmdpool",
    "VUID-vkCmdFillBuffer-commandBuffer-parameter",
    "VUID-vkCmdFillBuffer-commandBuffer-recording",
    "VUID-vkCmdFillBuffer-commonparent",
    "VUID-vkCmdFillBuffer-dstBuffer-00029",
    "VUID-vkCmdFillBuffer-dstBuffer-00031",
    "VUID-vkCmdFillBuffer-dstBuffer-parameter",
    "VUID-vkCmdFillBuffer-dstOffset-00024",
    "VUID-vkCmdFillBuffer-dstOffset-00025",
    "VUID-vkCmdFillBuffer-renderpass",
    "VUID-vkCmdFillBuffer-size-00026",
    "VUID-vkCmdFillBuffer-size-00027",
    "VUID-vkCmdFillBuffer-size-00028",
    "VUID-vkCmdInsertDebugUtilsLabelEXT-commandBuffer-cmdpool",
    "VUID-vkCmdInsertDebugUtilsLabelEXT-commandBuffer-parameter",
    "VUID-vkCmdInsertDebugUtilsLabelEXT-commandBuffer-recording",
    "VUID-vkCmdInsertDebugUtilsLabelEXT-pLabelInfo-parameter",
    "VUID-vkCmdNextSubpass-None-00909",
    "VUID-vkCmdNextSubpass-None-02349",
    "VUID-vkCmdNextSubpass-bufferlevel",
    "VUID-vkCmdNextSubpass-commandBuffer-cmdpool",
    "VUID-vkCmdNextSubpass-commandBuffer-parameter",
    "VUID-vkCmdNextSubpass-commandBuffer-recording",
    "VUID-vkCmdNextSubpass-contents-parameter",
    "VUID-vkCmdNextSubpass-renderpass",
    "VUID-vkCmdNextSubpass2-None-02350",
    "VUID-vkCmdNextSubpass2-None-03102",
    "VUID-vkCmdNextSubpass2-bufferlevel",
    "VUID-vkCmdNextSubpass2-commandBuffer-cmdpool",
    "VUID-vkCmdNextSubpass2-commandBuffer-parameter",
    "VUID-vkCmdNextSubpass2-commandBuffer-recording",
    "VUID-vkCmdNextSubpass2-pSubpassBeginInfo-parameter",
    "VUID-vkCmdNextSubpass2-pSubpassEndInfo-parameter",
    "VUID-vkCmdNextSubpass2-renderpass",
    "VUID-vkCmdPipelineBarrier-bufferMemoryBarrierCount-01178",
    "VUID-vkCmdPipelineBarrier-commandBuffer-cmdpool",
    "VUID-vkCmdPipelineBarrier-commandBuffer-parameter",
    "VUID-vkCmdPipelineBarrier-commandBuffer-recording",
    "VUID-vkCmdPipelineBarrier-dependencyFlags-01186",
    "VUID-vkCmdPipelineBarrier-dependencyFlags-parameter",
    "VUID-vkCmdPipelineBarrier-dstAccessMask-02816",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04090",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04091",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04092",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04093",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04094",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04095",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04096",
    "VUID-vkCmdPipelineBarrier-dstStageMask-04097",
    "VUID-vkCmdPipelineBarrier-dstStageMask-4098",
    "VUID-vkCmdPipelineBarrier-dstStageMask-parameter",
    "VUID-vkCmdPipelineBarrier-dstStageMask-requiredbitmask",
    "VUID-vkCmdPipelineBarrier-image-04073",
    "VUID-vkCmdPipelineBarrier-oldLayout-01181",
    "VUID-vkCmdPipelineBarrier-pBufferMemoryBarriers-02817",
    "VUID-vkCmdPipelineBarrier-pBufferMemoryBarriers-02818",
    "VUID-vkCmdPipelineBarrier-pBufferMemoryBarriers-parameter",
    "VUID-vkCmdPipelineBarrier-pDependencies-02285",
    "VUID-vkCmdPipelineBarrier-pImageMemoryBarriers-02819",
    "VUID-vkCmdPipelineBarrier-pImageMemoryBarriers-02820",
    "VUID-vkCmdPipelineBarrier-pImageMemoryBarriers-parameter",
    "VUID-vkCmdPipelineBarrier-pMemoryBarriers-parameter",
    "VUID-vkCmdPipelineBarrier-srcAccessMask-02815",
    "VUID-vkCmdPipelineBarrier-srcQueueFamilyIndex-01182",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04090",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04091",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04092",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04093",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04094",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04095",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04096",
    "VUID-vkCmdPipelineBarrier-srcStageMask-04097",
    "VUID-vkCmdPipelineBarrier-srcStageMask-4098",
    "VUID-vkCmdPipelineBarrier-srcStageMask-parameter",
    "VUID-vkCmdPipelineBarrier-srcStageMask-requiredbitmask",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-commandBuffer-02974",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-commandBuffer-cmdpool",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-commandBuffer-parameter",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-commandBuffer-recording",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-deviceGeneratedCommands-02928",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-pGeneratedCommandsInfo-02927",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-pGeneratedCommandsInfo-parameter",
    "VUID-vkCmdPreprocessGeneratedCommandsNV-renderpass",
    "VUID-vkCmdPushConstants-commandBuffer-cmdpool",
    "VUID-vkCmdPushConstants-commandBuffer-parameter",
    "VUID-vkCmdPushConstants-commandBuffer-recording",
    "VUID-vkCmdPushConstants-commonparent",
    "VUID-vkCmdPushConstants-layout-parameter",
    "VUID-vkCmdPushConstants-offset-00368",
    "VUID-vkCmdPushConstants-offset-00370",
    "VUID-vkCmdPushConstants-offset-01795",
    "VUID-vkCmdPushConstants-offset-01796",
    "VUID-vkCmdPushConstants-pValues-parameter",
    "VUID-vkCmdPushConstants-size-00369",
    "VUID-vkCmdPushConstants-size-00371",
    "VUID-vkCmdPushConstants-size-arraylength",
    "VUID-vkCmdPushConstants-stageFlags-parameter",
    "VUID-vkCmdPushConstants-stageFlags-requiredbitmask",
    "VUID-vkCmdPushDescriptorSetKHR-commandBuffer-cmdpool",
    "VUID-vkCmdPushDescriptorSetKHR-commandBuffer-parameter",
    "VUID-vkCmdPushDescriptorSetKHR-commandBuffer-recording",
    "VUID-vkCmdPushDescriptorSetKHR-commonparent",
    "VUID-vkCmdPushDescriptorSetKHR-descriptorWriteCount-arraylength",
    "VUID-vkCmdPushDescriptorSetKHR-layout-parameter",
    "VUID-vkCmdPushDescriptorSetKHR-pDescriptorWrites-parameter",
    "VUID-vkCmdPushDescriptorSetKHR-pipelineBindPoint-00363",
    "VUID-vkCmdPushDescriptorSetKHR-pipelineBindPoint-parameter",
    "VUID-vkCmdPushDescriptorSetKHR-set-00364",
    "VUID-vkCmdPushDescriptorSetKHR-set-00365",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-00366",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-cmdpool",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-parameter",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-recording",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-commonparent",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-descriptorUpdateTemplate-parameter",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-layout-parameter",
    "VUID-vkCmdPushDescriptorSetWithTemplateKHR-pData-01686",
    "VUID-vkCmdResetEvent-commandBuffer-01157",
    "VUID-vkCmdResetEvent-commandBuffer-cmdpool",
    "VUID-vkCmdResetEvent-commandBuffer-parameter",
    "VUID-vkCmdResetEvent-commandBuffer-recording",
    "VUID-vkCmdResetEvent-commonparent",
    "VUID-vkCmdResetEvent-event-01156",
    "VUID-vkCmdResetEvent-event-parameter",
    "VUID-vkCmdResetEvent-renderpass",
    "VUID-vkCmdResetEvent-stageMask-01153",
    "VUID-vkCmdResetEvent-stageMask-04090",
    "VUID-vkCmdResetEvent-stageMask-04091",
    "VUID-vkCmdResetEvent-stageMask-04092",
    "VUID-vkCmdResetEvent-stageMask-04093",
    "VUID-vkCmdResetEvent-stageMask-04094",
    "VUID-vkCmdResetEvent-stageMask-04095",
    "VUID-vkCmdResetEvent-stageMask-04096",
    "VUID-vkCmdResetEvent-stageMask-04097",
    "VUID-vkCmdResetEvent-stageMask-4098",
    "VUID-vkCmdResetEvent-stageMask-parameter",
    "VUID-vkCmdResetEvent-stageMask-requiredbitmask",
    "VUID-vkCmdResetQueryPool-None-02841",
    "VUID-vkCmdResetQueryPool-commandBuffer-cmdpool",
    "VUID-vkCmdResetQueryPool-commandBuffer-parameter",
    "VUID-vkCmdResetQueryPool-commandBuffer-recording",
    "VUID-vkCmdResetQueryPool-commonparent",
    "VUID-vkCmdResetQueryPool-firstQuery-00796",
    "VUID-vkCmdResetQueryPool-firstQuery-00797",
    "VUID-vkCmdResetQueryPool-firstQuery-02862",
    "VUID-vkCmdResetQueryPool-queryPool-parameter",
    "VUID-vkCmdResetQueryPool-renderpass",
    "VUID-vkCmdResolveImage-commandBuffer-01837",
    "VUID-vkCmdResolveImage-commandBuffer-01838",
    "VUID-vkCmdResolveImage-commandBuffer-01839",
    "VUID-vkCmdResolveImage-commandBuffer-cmdpool",
    "VUID-vkCmdResolveImage-commandBuffer-parameter",
    "VUID-vkCmdResolveImage-commandBuffer-recording",
    "VUID-vkCmdResolveImage-commonparent",
    "VUID-vkCmdResolveImage-dstImage-00258",
    "VUID-vkCmdResolveImage-dstImage-00259",
    "VUID-vkCmdResolveImage-dstImage-02003",
    "VUID-vkCmdResolveImage-dstImage-02546",
    "VUID-vkCmdResolveImage-dstImage-parameter",
    "VUID-vkCmdResolveImage-dstImageLayout-00262",
    "VUID-vkCmdResolveImage-dstImageLayout-00263",
    "VUID-vkCmdResolveImage-dstImageLayout-01401",
    "VUID-vkCmdResolveImage-dstImageLayout-parameter",
    "VUID-vkCmdResolveImage-dstSubresource-01710",
    "VUID-vkCmdResolveImage-dstSubresource-01712",
    "VUID-vkCmdResolveImage-pRegions-00255",
    "VUID-vkCmdResolveImage-pRegions-parameter",
    "VUID-vkCmdResolveImage-regionCount-arraylength",
    "VUID-vkCmdResolveImage-renderpass",
    "VUID-vkCmdResolveImage-srcImage-00256",
    "VUID-vkCmdResolveImage-srcImage-00257",
    "VUID-vkCmdResolveImage-srcImage-01386",
    "VUID-vkCmdResolveImage-srcImage-parameter",
    "VUID-vkCmdResolveImage-srcImageLayout-00260",
    "VUID-vkCmdResolveImage-srcImageLayout-00261",
    "VUID-vkCmdResolveImage-srcImageLayout-01400",
    "VUID-vkCmdResolveImage-srcImageLayout-parameter",
    "VUID-vkCmdResolveImage-srcSubresource-01709",
    "VUID-vkCmdResolveImage-srcSubresource-01711",
    "VUID-vkCmdSetBlendConstants-commandBuffer-cmdpool",
    "VUID-vkCmdSetBlendConstants-commandBuffer-parameter",
    "VUID-vkCmdSetBlendConstants-commandBuffer-recording",
    "VUID-vkCmdSetCheckpointNV-commandBuffer-cmdpool",
    "VUID-vkCmdSetCheckpointNV-commandBuffer-parameter",
    "VUID-vkCmdSetCheckpointNV-commandBuffer-recording",
    "VUID-vkCmdSetCoarseSampleOrderNV-commandBuffer-cmdpool",
    "VUID-vkCmdSetCoarseSampleOrderNV-commandBuffer-parameter",
    "VUID-vkCmdSetCoarseSampleOrderNV-commandBuffer-recording",
    "VUID-vkCmdSetCoarseSampleOrderNV-pCustomSampleOrders-02235",
    "VUID-vkCmdSetCoarseSampleOrderNV-pCustomSampleOrders-parameter",
    "VUID-vkCmdSetCoarseSampleOrderNV-sampleOrderType-02081",
    "VUID-vkCmdSetCoarseSampleOrderNV-sampleOrderType-parameter",
    "VUID-vkCmdSetDepthBias-commandBuffer-cmdpool",
    "VUID-vkCmdSetDepthBias-commandBuffer-parameter",
    "VUID-vkCmdSetDepthBias-commandBuffer-recording",
    "VUID-vkCmdSetDepthBias-depthBiasClamp-00790",
    "VUID-vkCmdSetDepthBounds-commandBuffer-cmdpool",
    "VUID-vkCmdSetDepthBounds-commandBuffer-parameter",
    "VUID-vkCmdSetDepthBounds-commandBuffer-recording",
    "VUID-vkCmdSetDepthBounds-maxDepthBounds-00601",
    "VUID-vkCmdSetDepthBounds-maxDepthBounds-02509",
    "VUID-vkCmdSetDepthBounds-minDepthBounds-00600",
    "VUID-vkCmdSetDepthBounds-minDepthBounds-02508",
    "VUID-vkCmdSetDeviceMask-commandBuffer-cmdpool",
    "VUID-vkCmdSetDeviceMask-commandBuffer-parameter",
    "VUID-vkCmdSetDeviceMask-commandBuffer-recording",
    "VUID-vkCmdSetDeviceMask-deviceMask-00108",
    "VUID-vkCmdSetDeviceMask-deviceMask-00109",
    "VUID-vkCmdSetDeviceMask-deviceMask-00110",
    "VUID-vkCmdSetDeviceMask-deviceMask-00111",
    "VUID-vkCmdSetDiscardRectangleEXT-commandBuffer-cmdpool",
    "VUID-vkCmdSetDiscardRectangleEXT-commandBuffer-parameter",
    "VUID-vkCmdSetDiscardRectangleEXT-commandBuffer-recording",
    "VUID-vkCmdSetDiscardRectangleEXT-discardRectangleCount-arraylength",
    "VUID-vkCmdSetDiscardRectangleEXT-firstDiscardRectangle-00585",
    "VUID-vkCmdSetDiscardRectangleEXT-offset-00588",
    "VUID-vkCmdSetDiscardRectangleEXT-offset-00589",
    "VUID-vkCmdSetDiscardRectangleEXT-pDiscardRectangles-parameter",
    "VUID-vkCmdSetDiscardRectangleEXT-x-00587",
    "VUID-vkCmdSetEvent-commandBuffer-01152",
    "VUID-vkCmdSetEvent-commandBuffer-cmdpool",
    "VUID-vkCmdSetEvent-commandBuffer-parameter",
    "VUID-vkCmdSetEvent-commandBuffer-recording",
    "VUID-vkCmdSetEvent-commonparent",
    "VUID-vkCmdSetEvent-event-parameter",
    "VUID-vkCmdSetEvent-renderpass",
    "VUID-vkCmdSetEvent-stageMask-01149",
    "VUID-vkCmdSetEvent-stageMask-04090",
    "VUID-vkCmdSetEvent-stageMask-04091",
    "VUID-vkCmdSetEvent-stageMask-04092",
    "VUID-vkCmdSetEvent-stageMask-04093",
    "VUID-vkCmdSetEvent-stageMask-04094",
    "VUID-vkCmdSetEvent-stageMask-04095",
    "VUID-vkCmdSetEvent-stageMask-04096",
    "VUID-vkCmdSetEvent-stageMask-04097",
    "VUID-vkCmdSetEvent-stageMask-4098",
    "VUID-vkCmdSetEvent-stageMask-parameter",
    "VUID-vkCmdSetEvent-stageMask-requiredbitmask",
    "VUID-vkCmdSetExclusiveScissorNV-None-02031",
    "VUID-vkCmdSetExclusiveScissorNV-commandBuffer-cmdpool",
    "VUID-vkCmdSetExclusiveScissorNV-commandBuffer-parameter",
    "VUID-vkCmdSetExclusiveScissorNV-commandBuffer-recording",
    "VUID-vkCmdSetExclusiveScissorNV-exclusiveScissorCount-02036",
    "VUID-vkCmdSetExclusiveScissorNV-exclusiveScissorCount-arraylength",
    "VUID-vkCmdSetExclusiveScissorNV-firstExclusiveScissor-02033",
    "VUID-vkCmdSetExclusiveScissorNV-firstExclusiveScissor-02034",
    "VUID-vkCmdSetExclusiveScissorNV-firstExclusiveScissor-02035",
    "VUID-vkCmdSetExclusiveScissorNV-offset-02038",
    "VUID-vkCmdSetExclusiveScissorNV-offset-02039",
    "VUID-vkCmdSetExclusiveScissorNV-pExclusiveScissors-parameter",
    "VUID-vkCmdSetExclusiveScissorNV-x-02037",
    "VUID-vkCmdSetLineStippleEXT-commandBuffer-cmdpool",
    "VUID-vkCmdSetLineStippleEXT-commandBuffer-parameter",
    "VUID-vkCmdSetLineStippleEXT-commandBuffer-recording",
    "VUID-vkCmdSetLineStippleEXT-lineStippleFactor-02776",
    "VUID-vkCmdSetLineWidth-commandBuffer-cmdpool",
    "VUID-vkCmdSetLineWidth-commandBuffer-parameter",
    "VUID-vkCmdSetLineWidth-commandBuffer-recording",
    "VUID-vkCmdSetLineWidth-lineWidth-00788",
    "VUID-vkCmdSetPerformanceMarkerINTEL-commandBuffer-cmdpool",
    "VUID-vkCmdSetPerformanceMarkerINTEL-commandBuffer-parameter",
    "VUID-vkCmdSetPerformanceMarkerINTEL-commandBuffer-recording",
    "VUID-vkCmdSetPerformanceMarkerINTEL-pMarkerInfo-parameter",
    "VUID-vkCmdSetPerformanceOverrideINTEL-commandBuffer-cmdpool",
    "VUID-vkCmdSetPerformanceOverrideINTEL-commandBuffer-parameter",
    "VUID-vkCmdSetPerformanceOverrideINTEL-commandBuffer-recording",
    "VUID-vkCmdSetPerformanceOverrideINTEL-pOverrideInfo-02736",
    "VUID-vkCmdSetPerformanceOverrideINTEL-pOverrideInfo-parameter",
    "VUID-vkCmdSetPerformanceStreamMarkerINTEL-commandBuffer-cmdpool",
    "VUID-vkCmdSetPerformanceStreamMarkerINTEL-commandBuffer-parameter",
    "VUID-vkCmdSetPerformanceStreamMarkerINTEL-commandBuffer-recording",
    "VUID-vkCmdSetPerformanceStreamMarkerINTEL-pMarkerInfo-parameter",
    "VUID-vkCmdSetSampleLocationsEXT-commandBuffer-cmdpool",
    "VUID-vkCmdSetSampleLocationsEXT-commandBuffer-parameter",
    "VUID-vkCmdSetSampleLocationsEXT-commandBuffer-recording",
    "VUID-vkCmdSetSampleLocationsEXT-pSampleLocationsInfo-parameter",
    "VUID-vkCmdSetSampleLocationsEXT-sampleLocationsPerPixel-01529",
    "VUID-vkCmdSetSampleLocationsEXT-variableSampleLocations-01530",
    "VUID-vkCmdSetScissor-commandBuffer-cmdpool",
    "VUID-vkCmdSetScissor-commandBuffer-parameter",
    "VUID-vkCmdSetScissor-commandBuffer-recording",
    "VUID-vkCmdSetScissor-firstScissor-00591",
    "VUID-vkCmdSetScissor-firstScissor-00592",
    "VUID-vkCmdSetScissor-firstScissor-00593",
    "VUID-vkCmdSetScissor-offset-00596",
    "VUID-vkCmdSetScissor-offset-00597",
    "VUID-vkCmdSetScissor-pScissors-parameter",
    "VUID-vkCmdSetScissor-scissorCount-00594",
    "VUID-vkCmdSetScissor-scissorCount-arraylength",
    "VUID-vkCmdSetScissor-x-00595",
    "VUID-vkCmdSetStencilCompareMask-commandBuffer-cmdpool",
    "VUID-vkCmdSetStencilCompareMask-commandBuffer-parameter",
    "VUID-vkCmdSetStencilCompareMask-commandBuffer-recording",
    "VUID-vkCmdSetStencilCompareMask-faceMask-parameter",
    "VUID-vkCmdSetStencilCompareMask-faceMask-requiredbitmask",
    "VUID-vkCmdSetStencilReference-commandBuffer-cmdpool",
    "VUID-vkCmdSetStencilReference-commandBuffer-parameter",
    "VUID-vkCmdSetStencilReference-commandBuffer-recording",
    "VUID-vkCmdSetStencilReference-faceMask-parameter",
    "VUID-vkCmdSetStencilReference-faceMask-requiredbitmask",
    "VUID-vkCmdSetStencilWriteMask-commandBuffer-cmdpool",
    "VUID-vkCmdSetStencilWriteMask-commandBuffer-parameter",
    "VUID-vkCmdSetStencilWriteMask-commandBuffer-recording",
    "VUID-vkCmdSetStencilWriteMask-faceMask-parameter",
    "VUID-vkCmdSetStencilWriteMask-faceMask-requiredbitmask",
    "VUID-vkCmdSetViewport-commandBuffer-cmdpool",
    "VUID-vkCmdSetViewport-commandBuffer-parameter",
    "VUID-vkCmdSetViewport-commandBuffer-recording",
    "VUID-vkCmdSetViewport-firstViewport-01222",
    "VUID-vkCmdSetViewport-firstViewport-01223",
    "VUID-vkCmdSetViewport-firstViewport-01224",
    "VUID-vkCmdSetViewport-pViewports-parameter",
    "VUID-vkCmdSetViewport-viewportCount-01225",
    "VUID-vkCmdSetViewport-viewportCount-arraylength",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-None-02064",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-commandBuffer-cmdpool",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-commandBuffer-parameter",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-commandBuffer-recording",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-firstViewport-02066",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-firstViewport-02067",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-firstViewport-02068",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-pShadingRatePalettes-parameter",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-viewportCount-02069",
    "VUID-vkCmdSetViewportShadingRatePaletteNV-viewportCount-arraylength",
    "VUID-vkCmdSetViewportWScalingNV-commandBuffer-cmdpool",
    "VUID-vkCmdSetViewportWScalingNV-commandBuffer-parameter",
    "VUID-vkCmdSetViewportWScalingNV-commandBuffer-recording",
    "VUID-vkCmdSetViewportWScalingNV-firstViewport-01323",
    "VUID-vkCmdSetViewportWScalingNV-firstViewport-01324",
    "VUID-vkCmdSetViewportWScalingNV-pViewportWScalings-parameter",
    "VUID-vkCmdSetViewportWScalingNV-viewportCount-arraylength",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02690",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02691",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02692",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02693",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02697",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02698",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02699",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02700",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02702",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02703",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02704",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02705",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02706",
    "VUID-vkCmdTraceRaysIndirectKHR-None-02859",
    "VUID-vkCmdTraceRaysIndirectKHR-None-03429",
    "VUID-vkCmdTraceRaysIndirectKHR-buffer-02708",
    "VUID-vkCmdTraceRaysIndirectKHR-buffer-02709",
    "VUID-vkCmdTraceRaysIndirectKHR-buffer-parameter",
    "VUID-vkCmdTraceRaysIndirectKHR-commandBuffer-02701",
    "VUID-vkCmdTraceRaysIndirectKHR-commandBuffer-02707",
    "VUID-vkCmdTraceRaysIndirectKHR-commandBuffer-02711",
    "VUID-vkCmdTraceRaysIndirectKHR-commandBuffer-cmdpool",
    "VUID-vkCmdTraceRaysIndirectKHR-commandBuffer-parameter",
    "VUID-vkCmdTraceRaysIndirectKHR-commandBuffer-recording",
    "VUID-vkCmdTraceRaysIndirectKHR-commonparent",
    "VUID-vkCmdTraceRaysIndirectKHR-filterCubic-02694",
    "VUID-vkCmdTraceRaysIndirectKHR-filterCubicMinmax-02695",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-02696",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03508",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03509",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03510",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03511",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03512",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03513",
    "VUID-vkCmdTraceRaysIndirectKHR-flags-03514",
    "VUID-vkCmdTraceRaysIndirectKHR-maxRecursionDepth-03430",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-02710",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-03517",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04020",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04025",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04026",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04031",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04032",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04037",
    "VUID-vkCmdTraceRaysIndirectKHR-offset-04038",
    "VUID-vkCmdTraceRaysIndirectKHR-pCallableShaderBindingTable-04036",
    "VUID-vkCmdTraceRaysIndirectKHR-pCallableShaderBindingTable-04039",
    "VUID-vkCmdTraceRaysIndirectKHR-pCallableShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysIndirectKHR-pHitShaderBindingTable-04030",
    "VUID-vkCmdTraceRaysIndirectKHR-pHitShaderBindingTable-04033",
    "VUID-vkCmdTraceRaysIndirectKHR-pHitShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysIndirectKHR-pMissShaderBindingTable-04024",
    "VUID-vkCmdTraceRaysIndirectKHR-pMissShaderBindingTable-04027",
    "VUID-vkCmdTraceRaysIndirectKHR-pMissShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysIndirectKHR-pRayGenShaderBindingTable-04019",
    "VUID-vkCmdTraceRaysIndirectKHR-pRayGenShaderBindingTable-04021",
    "VUID-vkCmdTraceRaysIndirectKHR-pRayGenShaderBindingTable-04022",
    "VUID-vkCmdTraceRaysIndirectKHR-pRaygenShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysIndirectKHR-rayTracingIndirectTraceRays-03518",
    "VUID-vkCmdTraceRaysIndirectKHR-renderpass",
    "VUID-vkCmdTraceRaysIndirectKHR-size-04023",
    "VUID-vkCmdTraceRaysIndirectKHR-stride-04028",
    "VUID-vkCmdTraceRaysIndirectKHR-stride-04029",
    "VUID-vkCmdTraceRaysIndirectKHR-stride-04034",
    "VUID-vkCmdTraceRaysIndirectKHR-stride-04035",
    "VUID-vkCmdTraceRaysIndirectKHR-stride-04040",
    "VUID-vkCmdTraceRaysIndirectKHR-stride-04041",
    "VUID-vkCmdTraceRaysKHR-None-02690",
    "VUID-vkCmdTraceRaysKHR-None-02691",
    "VUID-vkCmdTraceRaysKHR-None-02692",
    "VUID-vkCmdTraceRaysKHR-None-02693",
    "VUID-vkCmdTraceRaysKHR-None-02697",
    "VUID-vkCmdTraceRaysKHR-None-02698",
    "VUID-vkCmdTraceRaysKHR-None-02699",
    "VUID-vkCmdTraceRaysKHR-None-02700",
    "VUID-vkCmdTraceRaysKHR-None-02702",
    "VUID-vkCmdTraceRaysKHR-None-02703",
    "VUID-vkCmdTraceRaysKHR-None-02704",
    "VUID-vkCmdTraceRaysKHR-None-02705",
    "VUID-vkCmdTraceRaysKHR-None-02706",
    "VUID-vkCmdTraceRaysKHR-None-02859",
    "VUID-vkCmdTraceRaysKHR-None-03429",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-02701",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-02707",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-02712",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-02713",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-cmdpool",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-parameter",
    "VUID-vkCmdTraceRaysKHR-commandBuffer-recording",
    "VUID-vkCmdTraceRaysKHR-depth-03507",
    "VUID-vkCmdTraceRaysKHR-filterCubic-02694",
    "VUID-vkCmdTraceRaysKHR-filterCubicMinmax-02695",
    "VUID-vkCmdTraceRaysKHR-flags-02696",
    "VUID-vkCmdTraceRaysKHR-flags-03508",
    "VUID-vkCmdTraceRaysKHR-flags-03509",
    "VUID-vkCmdTraceRaysKHR-flags-03510",
    "VUID-vkCmdTraceRaysKHR-flags-03511",
    "VUID-vkCmdTraceRaysKHR-flags-03512",
    "VUID-vkCmdTraceRaysKHR-flags-03513",
    "VUID-vkCmdTraceRaysKHR-flags-03514",
    "VUID-vkCmdTraceRaysKHR-height-03506",
    "VUID-vkCmdTraceRaysKHR-maxRecursionDepth-03430",
    "VUID-vkCmdTraceRaysKHR-offset-04020",
    "VUID-vkCmdTraceRaysKHR-offset-04025",
    "VUID-vkCmdTraceRaysKHR-offset-04026",
    "VUID-vkCmdTraceRaysKHR-offset-04031",
    "VUID-vkCmdTraceRaysKHR-offset-04032",
    "VUID-vkCmdTraceRaysKHR-offset-04037",
    "VUID-vkCmdTraceRaysKHR-offset-04038",
    "VUID-vkCmdTraceRaysKHR-pCallableShaderBindingTable-04036",
    "VUID-vkCmdTraceRaysKHR-pCallableShaderBindingTable-04039",
    "VUID-vkCmdTraceRaysKHR-pCallableShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysKHR-pHitShaderBindingTable-04030",
    "VUID-vkCmdTraceRaysKHR-pHitShaderBindingTable-04033",
    "VUID-vkCmdTraceRaysKHR-pHitShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysKHR-pMissShaderBindingTable-04024",
    "VUID-vkCmdTraceRaysKHR-pMissShaderBindingTable-04027",
    "VUID-vkCmdTraceRaysKHR-pMissShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysKHR-pRayGenShaderBindingTable-04019",
    "VUID-vkCmdTraceRaysKHR-pRayGenShaderBindingTable-04021",
    "VUID-vkCmdTraceRaysKHR-pRayGenShaderBindingTable-04022",
    "VUID-vkCmdTraceRaysKHR-pRaygenShaderBindingTable-parameter",
    "VUID-vkCmdTraceRaysKHR-renderpass",
    "VUID-vkCmdTraceRaysKHR-size-04023",
    "VUID-vkCmdTraceRaysKHR-stride-04028",
    "VUID-vkCmdTraceRaysKHR-stride-04029",
    "VUID-vkCmdTraceRaysKHR-stride-04034",
    "VUID-vkCmdTraceRaysKHR-stride-04035",
    "VUID-vkCmdTraceRaysKHR-stride-04040",
    "VUID-vkCmdTraceRaysKHR-stride-04041",
    "VUID-vkCmdTraceRaysKHR-width-03505",
    "VUID-vkCmdTraceRaysNV-None-02690",
    "VUID-vkCmdTraceRaysNV-None-02691",
    "VUID-vkCmdTraceRaysNV-None-02692",
    "VUID-vkCmdTraceRaysNV-None-02693",
    "VUID-vkCmdTraceRaysNV-None-02697",
    "VUID-vkCmdTraceRaysNV-None-02698",
    "VUID-vkCmdTraceRaysNV-None-02699",
    "VUID-vkCmdTraceRaysNV-None-02700",
    "VUID-vkCmdTraceRaysNV-None-02702",
    "VUID-vkCmdTraceRaysNV-None-02703",
    "VUID-vkCmdTraceRaysNV-None-02704",
    "VUID-vkCmdTraceRaysNV-None-02705",
    "VUID-vkCmdTraceRaysNV-None-02706",
    "VUID-vkCmdTraceRaysNV-None-02859",
    "VUID-vkCmdTraceRaysNV-None-03429",
    "VUID-vkCmdTraceRaysNV-callableShaderBindingOffset-02461",
    "VUID-vkCmdTraceRaysNV-callableShaderBindingOffset-02462",
    "VUID-vkCmdTraceRaysNV-callableShaderBindingStride-02465",
    "VUID-vkCmdTraceRaysNV-callableShaderBindingStride-02468",
    "VUID-vkCmdTraceRaysNV-callableShaderBindingTableBuffer-04045",
    "VUID-vkCmdTraceRaysNV-callableShaderBindingTableBuffer-parameter",
    "VUID-vkCmdTraceRaysNV-commandBuffer-02701",
    "VUID-vkCmdTraceRaysNV-commandBuffer-02707",
    "VUID-vkCmdTraceRaysNV-commandBuffer-02712",
    "VUID-vkCmdTraceRaysNV-commandBuffer-02713",
    "VUID-vkCmdTraceRaysNV-commandBuffer-cmdpool",
    "VUID-vkCmdTraceRaysNV-commandBuffer-parameter",
    "VUID-vkCmdTraceRaysNV-commandBuffer-recording",
    "VUID-vkCmdTraceRaysNV-commonparent",
    "VUID-vkCmdTraceRaysNV-depth-02471",
    "VUID-vkCmdTraceRaysNV-filterCubic-02694",
    "VUID-vkCmdTraceRaysNV-filterCubicMinmax-02695",
    "VUID-vkCmdTraceRaysNV-flags-02696",
    "VUID-vkCmdTraceRaysNV-height-02470",
    "VUID-vkCmdTraceRaysNV-hitShaderBindingOffset-02459",
    "VUID-vkCmdTraceRaysNV-hitShaderBindingOffset-02460",
    "VUID-vkCmdTraceRaysNV-hitShaderBindingStride-02464",
    "VUID-vkCmdTraceRaysNV-hitShaderBindingStride-02467",
    "VUID-vkCmdTraceRaysNV-hitShaderBindingTableBuffer-04044",
    "VUID-vkCmdTraceRaysNV-hitShaderBindingTableBuffer-parameter",
    "VUID-vkCmdTraceRaysNV-maxRecursionDepth-03430",
    "VUID-vkCmdTraceRaysNV-missShaderBindingOffset-02457",
    "VUID-vkCmdTraceRaysNV-missShaderBindingOffset-02458",
    "VUID-vkCmdTraceRaysNV-missShaderBindingStride-02463",
    "VUID-vkCmdTraceRaysNV-missShaderBindingStride-02466",
    "VUID-vkCmdTraceRaysNV-missShaderBindingTableBuffer-04043",
    "VUID-vkCmdTraceRaysNV-missShaderBindingTableBuffer-parameter",
    "VUID-vkCmdTraceRaysNV-raygenShaderBindingOffset-02455",
    "VUID-vkCmdTraceRaysNV-raygenShaderBindingOffset-02456",
    "VUID-vkCmdTraceRaysNV-raygenShaderBindingTableBuffer-04042",
    "VUID-vkCmdTraceRaysNV-raygenShaderBindingTableBuffer-parameter",
    "VUID-vkCmdTraceRaysNV-renderpass",
    "VUID-vkCmdTraceRaysNV-width-02469",
    "VUID-vkCmdUpdateBuffer-commandBuffer-01813",
    "VUID-vkCmdUpdateBuffer-commandBuffer-01814",
    "VUID-vkCmdUpdateBuffer-commandBuffer-cmdpool",
    "VUID-vkCmdUpdateBuffer-commandBuffer-parameter",
    "VUID-vkCmdUpdateBuffer-commandBuffer-recording",
    "VUID-vkCmdUpdateBuffer-commonparent",
    "VUID-vkCmdUpdateBuffer-dataSize-00033",
    "VUID-vkCmdUpdateBuffer-dataSize-00037",
    "VUID-vkCmdUpdateBuffer-dataSize-00038",
    "VUID-vkCmdUpdateBuffer-dataSize-arraylength",
    "VUID-vkCmdUpdateBuffer-dstBuffer-00034",
    "VUID-vkCmdUpdateBuffer-dstBuffer-00035",
    "VUID-vkCmdUpdateBuffer-dstBuffer-parameter",
    "VUID-vkCmdUpdateBuffer-dstOffset-00032",
    "VUID-vkCmdUpdateBuffer-dstOffset-00036",
    "VUID-vkCmdUpdateBuffer-pData-parameter",
    "VUID-vkCmdUpdateBuffer-renderpass",
    "VUID-vkCmdWaitEvents-commandBuffer-01167",
    "VUID-vkCmdWaitEvents-commandBuffer-cmdpool",
    "VUID-vkCmdWaitEvents-commandBuffer-parameter",
    "VUID-vkCmdWaitEvents-commandBuffer-recording",
    "VUID-vkCmdWaitEvents-commonparent",
    "VUID-vkCmdWaitEvents-dstAccessMask-02816",
    "VUID-vkCmdWaitEvents-dstStageMask-04090",
    "VUID-vkCmdWaitEvents-dstStageMask-04091",
    "VUID-vkCmdWaitEvents-dstStageMask-04092",
    "VUID-vkCmdWaitEvents-dstStageMask-04093",
    "VUID-vkCmdWaitEvents-dstStageMask-04094",
    "VUID-vkCmdWaitEvents-dstStageMask-04095",
    "VUID-vkCmdWaitEvents-dstStageMask-04096",
    "VUID-vkCmdWaitEvents-dstStageMask-04097",
    "VUID-vkCmdWaitEvents-dstStageMask-4098",
    "VUID-vkCmdWaitEvents-dstStageMask-parameter",
    "VUID-vkCmdWaitEvents-dstStageMask-requiredbitmask",
    "VUID-vkCmdWaitEvents-eventCount-arraylength",
    "VUID-vkCmdWaitEvents-pBufferMemoryBarriers-02817",
    "VUID-vkCmdWaitEvents-pBufferMemoryBarriers-02818",
    "VUID-vkCmdWaitEvents-pBufferMemoryBarriers-parameter",
    "VUID-vkCmdWaitEvents-pEvents-01163",
    "VUID-vkCmdWaitEvents-pEvents-parameter",
    "VUID-vkCmdWaitEvents-pImageMemoryBarriers-02819",
    "VUID-vkCmdWaitEvents-pImageMemoryBarriers-02820",
    "VUID-vkCmdWaitEvents-pImageMemoryBarriers-parameter",
    "VUID-vkCmdWaitEvents-pMemoryBarriers-parameter",
    "VUID-vkCmdWaitEvents-srcAccessMask-02815",
    "VUID-vkCmdWaitEvents-srcQueueFamilyIndex-02803",
    "VUID-vkCmdWaitEvents-srcStageMask-01158",
    "VUID-vkCmdWaitEvents-srcStageMask-04090",
    "VUID-vkCmdWaitEvents-srcStageMask-04091",
    "VUID-vkCmdWaitEvents-srcStageMask-04092",
    "VUID-vkCmdWaitEvents-srcStageMask-04093",
    "VUID-vkCmdWaitEvents-srcStageMask-04094",
    "VUID-vkCmdWaitEvents-srcStageMask-04095",
    "VUID-vkCmdWaitEvents-srcStageMask-04096",
    "VUID-vkCmdWaitEvents-srcStageMask-04097",
    "VUID-vkCmdWaitEvents-srcStageMask-4098",
    "VUID-vkCmdWaitEvents-srcStageMask-parameter",
    "VUID-vkCmdWaitEvents-srcStageMask-requiredbitmask",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-accelerationStructureCount-arraylength",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-accelerationStructures-03431",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-commandBuffer-cmdpool",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-commandBuffer-parameter",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-commandBuffer-recording",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-commonparent",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-pAccelerationStructures-parameter",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-queryPool-02493",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-queryPool-02494",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-queryPool-parameter",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-queryType-03432",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-queryType-parameter",
    "VUID-vkCmdWriteAccelerationStructuresPropertiesKHR-renderpass",
    "VUID-vkCmdWriteBufferMarkerAMD-commandBuffer-cmdpool",
    "VUID-vkCmdWriteBufferMarkerAMD-commandBuffer-parameter",
    "VUID-vkCmdWriteBufferMarkerAMD-commandBuffer-recording",
    "VUID-vkCmdWriteBufferMarkerAMD-commonparent",
    "VUID-vkCmdWriteBufferMarkerAMD-dstBuffer-01799",
    "VUID-vkCmdWriteBufferMarkerAMD-dstBuffer-01800",
    "VUID-vkCmdWriteBufferMarkerAMD-dstBuffer-parameter",
    "VUID-vkCmdWriteBufferMarkerAMD-dstOffset-01798",
    "VUID-vkCmdWriteBufferMarkerAMD-dstOffset-01801",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04074",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04075",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04076",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04077",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04078",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04079",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04080",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-04081",
    "VUID-vkCmdWriteBufferMarkerAMD-pipelineStage-parameter",
    "VUID-vkCmdWriteTimestamp-None-00830",
    "VUID-vkCmdWriteTimestamp-commandBuffer-cmdpool",
    "VUID-vkCmdWriteTimestamp-commandBuffer-parameter",
    "VUID-vkCmdWriteTimestamp-commandBuffer-recording",
    "VUID-vkCmdWriteTimestamp-commonparent",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04074",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04075",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04076",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04077",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04078",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04079",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04080",
    "VUID-vkCmdWriteTimestamp-pipelineStage-04081",
    "VUID-vkCmdWriteTimestamp-pipelineStage-parameter",
    "VUID-vkCmdWriteTimestamp-query-00831",
    "VUID-vkCmdWriteTimestamp-queryPool-00828",
    "VUID-vkCmdWriteTimestamp-queryPool-01416",
    "VUID-vkCmdWriteTimestamp-queryPool-parameter",
    "VUID-vkCmdWriteTimestamp-timestampValidBits-00829",
    "VUID-vkCompileDeferredNV-device-parameter",
    "VUID-vkCompileDeferredNV-pipeline-02237",
    "VUID-vkCompileDeferredNV-pipeline-parameter",
    "VUID-vkCompileDeferredNV-pipeline-parent",
    "VUID-vkCompileDeferredNV-shader-02238",
    "VUID-vkCopyAccelerationStructureKHR-None-03440",
    "VUID-vkCopyAccelerationStructureKHR-device-parameter",
    "VUID-vkCopyAccelerationStructureKHR-pInfo-parameter",
    "VUID-vkCopyAccelerationStructureKHR-rayTracingHostAccelerationStructureCommands-03441",
    "VUID-vkCopyAccelerationStructureToMemoryKHR-None-03445",
    "VUID-vkCopyAccelerationStructureToMemoryKHR-None-03446",
    "VUID-vkCopyAccelerationStructureToMemoryKHR-device-parameter",
    "VUID-vkCopyAccelerationStructureToMemoryKHR-pInfo-parameter",
    "VUID-vkCopyAccelerationStructureToMemoryKHR-rayTracingHostAccelerationStructureCommands-03447",
    "VUID-vkCopyMemoryToAccelerationStructureKHR-None-03442",
    "VUID-vkCopyMemoryToAccelerationStructureKHR-None-03443",
    "VUID-vkCopyMemoryToAccelerationStructureKHR-device-parameter",
    "VUID-vkCopyMemoryToAccelerationStructureKHR-pInfo-parameter",
    "VUID-vkCopyMemoryToAccelerationStructureKHR-rayTracingHostAccelerationStructureCommands-03444",
    "VUID-vkCreateAccelerationStructureKHR-device-03489",
    "VUID-vkCreateAccelerationStructureKHR-device-parameter",
    "VUID-vkCreateAccelerationStructureKHR-deviceAddress-03488",
    "VUID-vkCreateAccelerationStructureKHR-pAccelerationStructure-parameter",
    "VUID-vkCreateAccelerationStructureKHR-pAllocator-parameter",
    "VUID-vkCreateAccelerationStructureKHR-pCreateInfo-parameter",
    "VUID-vkCreateAccelerationStructureKHR-rayTracing-03487",
    "VUID-vkCreateAccelerationStructureNV-device-parameter",
    "VUID-vkCreateAccelerationStructureNV-pAccelerationStructure-parameter",
    "VUID-vkCreateAccelerationStructureNV-pAllocator-parameter",
    "VUID-vkCreateAccelerationStructureNV-pCreateInfo-parameter",
    "VUID-vkCreateAndroidSurfaceKHR-instance-parameter",
    "VUID-vkCreateAndroidSurfaceKHR-pAllocator-parameter",
    "VUID-vkCreateAndroidSurfaceKHR-pCreateInfo-parameter",
    "VUID-vkCreateAndroidSurfaceKHR-pSurface-parameter",
    "VUID-vkCreateBuffer-device-parameter",
    "VUID-vkCreateBuffer-flags-00911",
    "VUID-vkCreateBuffer-pAllocator-parameter",
    "VUID-vkCreateBuffer-pBuffer-parameter",
    "VUID-vkCreateBuffer-pCreateInfo-parameter",
    "VUID-vkCreateBufferView-device-parameter",
    "VUID-vkCreateBufferView-pAllocator-parameter",
    "VUID-vkCreateBufferView-pCreateInfo-parameter",
    "VUID-vkCreateBufferView-pView-parameter",
    "VUID-vkCreateCommandPool-device-parameter",
    "VUID-vkCreateCommandPool-pAllocator-parameter",
    "VUID-vkCreateCommandPool-pCommandPool-parameter",
    "VUID-vkCreateCommandPool-pCreateInfo-parameter",
    "VUID-vkCreateCommandPool-queueFamilyIndex-01937",
    "VUID-vkCreateComputePipelines-createInfoCount-arraylength",
    "VUID-vkCreateComputePipelines-device-parameter",
    "VUID-vkCreateComputePipelines-flags-00695",
    "VUID-vkCreateComputePipelines-flags-00696",
    "VUID-vkCreateComputePipelines-pAllocator-parameter",
    "VUID-vkCreateComputePipelines-pCreateInfos-parameter",
    "VUID-vkCreateComputePipelines-pPipelines-parameter",
    "VUID-vkCreateComputePipelines-pipelineCache-02873",
    "VUID-vkCreateComputePipelines-pipelineCache-parameter",
    "VUID-vkCreateComputePipelines-pipelineCache-parent",
    "VUID-vkCreateDebugReportCallbackEXT-instance-parameter",
    "VUID-vkCreateDebugReportCallbackEXT-pAllocator-parameter",
    "VUID-vkCreateDebugReportCallbackEXT-pCallback-parameter",
    "VUID-vkCreateDebugReportCallbackEXT-pCreateInfo-parameter",
    "VUID-vkCreateDebugUtilsMessengerEXT-instance-parameter",
    "VUID-vkCreateDebugUtilsMessengerEXT-pAllocator-parameter",
    "VUID-vkCreateDebugUtilsMessengerEXT-pCreateInfo-parameter",
    "VUID-vkCreateDebugUtilsMessengerEXT-pMessenger-parameter",
    "VUID-vkCreateDeferredOperationKHR-device-parameter",
    "VUID-vkCreateDeferredOperationKHR-pAllocator-parameter",
    "VUID-vkCreateDeferredOperationKHR-pDeferredOperation-parameter",
    "VUID-vkCreateDescriptorPool-device-parameter",
    "VUID-vkCreateDescriptorPool-pAllocator-parameter",
    "VUID-vkCreateDescriptorPool-pCreateInfo-parameter",
    "VUID-vkCreateDescriptorPool-pDescriptorPool-parameter",
    "VUID-vkCreateDescriptorSetLayout-device-parameter",
    "VUID-vkCreateDescriptorSetLayout-pAllocator-parameter",
    "VUID-vkCreateDescriptorSetLayout-pCreateInfo-parameter",
    "VUID-vkCreateDescriptorSetLayout-pSetLayout-parameter",
    "VUID-vkCreateDescriptorUpdateTemplate-device-parameter",
    "VUID-vkCreateDescriptorUpdateTemplate-pAllocator-parameter",
    "VUID-vkCreateDescriptorUpdateTemplate-pCreateInfo-parameter",
    "VUID-vkCreateDescriptorUpdateTemplate-pDescriptorUpdateTemplate-parameter",
    "VUID-vkCreateDevice-pAllocator-parameter",
    "VUID-vkCreateDevice-pCreateInfo-parameter",
    "VUID-vkCreateDevice-pDevice-parameter",
    "VUID-vkCreateDevice-physicalDevice-parameter",
    "VUID-vkCreateDevice-ppEnabledExtensionNames-01387",
    "VUID-vkCreateDisplayModeKHR-display-parameter",
    "VUID-vkCreateDisplayModeKHR-display-parent",
    "VUID-vkCreateDisplayModeKHR-pAllocator-parameter",
    "VUID-vkCreateDisplayModeKHR-pCreateInfo-parameter",
    "VUID-vkCreateDisplayModeKHR-pMode-parameter",
    "VUID-vkCreateDisplayModeKHR-physicalDevice-parameter",
    "VUID-vkCreateDisplayPlaneSurfaceKHR-instance-parameter",
    "VUID-vkCreateDisplayPlaneSurfaceKHR-pAllocator-parameter",
    "VUID-vkCreateDisplayPlaneSurfaceKHR-pCreateInfo-parameter",
    "VUID-vkCreateDisplayPlaneSurfaceKHR-pSurface-parameter",
    "VUID-vkCreateEvent-device-parameter",
    "VUID-vkCreateEvent-pAllocator-parameter",
    "VUID-vkCreateEvent-pCreateInfo-parameter",
    "VUID-vkCreateEvent-pEvent-parameter",
    "VUID-vkCreateFence-device-parameter",
    "VUID-vkCreateFence-pAllocator-parameter",
    "VUID-vkCreateFence-pCreateInfo-parameter",
    "VUID-vkCreateFence-pFence-parameter",
    "VUID-vkCreateFramebuffer-device-parameter",
    "VUID-vkCreateFramebuffer-pAllocator-parameter",
    "VUID-vkCreateFramebuffer-pCreateInfo-02777",
    "VUID-vkCreateFramebuffer-pCreateInfo-parameter",
    "VUID-vkCreateFramebuffer-pFramebuffer-parameter",
    "VUID-vkCreateGraphicsPipelines-createInfoCount-arraylength",
    "VUID-vkCreateGraphicsPipelines-device-parameter",
    "VUID-vkCreateGraphicsPipelines-flags-00720",
    "VUID-vkCreateGraphicsPipelines-flags-00721",
    "VUID-vkCreateGraphicsPipelines-pAllocator-parameter",
    "VUID-vkCreateGraphicsPipelines-pCreateInfos-parameter",
    "VUID-vkCreateGraphicsPipelines-pPipelines-parameter",
    "VUID-vkCreateGraphicsPipelines-pipelineCache-02876",
    "VUID-vkCreateGraphicsPipelines-pipelineCache-parameter",
    "VUID-vkCreateGraphicsPipelines-pipelineCache-parent",
    "VUID-vkCreateHeadlessSurfaceEXT-instance-parameter",
    "VUID-vkCreateHeadlessSurfaceEXT-pAllocator-parameter",
    "VUID-vkCreateHeadlessSurfaceEXT-pCreateInfo-parameter",
    "VUID-vkCreateHeadlessSurfaceEXT-pSurface-parameter",
    "VUID-vkCreateIOSSurfaceMVK-instance-parameter",
    "VUID-vkCreateIOSSurfaceMVK-pAllocator-parameter",
    "VUID-vkCreateIOSSurfaceMVK-pCreateInfo-parameter",
    "VUID-vkCreateIOSSurfaceMVK-pSurface-parameter",
    "VUID-vkCreateImage-device-parameter",
    "VUID-vkCreateImage-flags-00939",
    "VUID-vkCreateImage-pAllocator-parameter",
    "VUID-vkCreateImage-pCreateInfo-parameter",
    "VUID-vkCreateImage-pImage-parameter",
    "VUID-vkCreateImagePipeSurfaceFUCHSIA-instance-parameter",
    "VUID-vkCreateImagePipeSurfaceFUCHSIA-pAllocator-parameter",
    "VUID-vkCreateImagePipeSurfaceFUCHSIA-pCreateInfo-parameter",
    "VUID-vkCreateImagePipeSurfaceFUCHSIA-pSurface-parameter",
    "VUID-vkCreateImageView-device-parameter",
    "VUID-vkCreateImageView-pAllocator-parameter",
    "VUID-vkCreateImageView-pCreateInfo-parameter",
    "VUID-vkCreateImageView-pView-parameter",
    "VUID-vkCreateIndirectCommandsLayoutNV-device-parameter",
    "VUID-vkCreateIndirectCommandsLayoutNV-deviceGeneratedCommands-02929",
    "VUID-vkCreateIndirectCommandsLayoutNV-pAllocator-parameter",
    "VUID-vkCreateIndirectCommandsLayoutNV-pCreateInfo-parameter",
    "VUID-vkCreateIndirectCommandsLayoutNV-pIndirectCommandsLayout-parameter",
    "VUID-vkCreateInstance-pAllocator-parameter",
    "VUID-vkCreateInstance-pCreateInfo-parameter",
    "VUID-vkCreateInstance-pInstance-parameter",
    "VUID-vkCreateInstance-ppEnabledExtensionNames-01388",
    "VUID-vkCreateMacOSSurfaceMVK-instance-parameter",
    "VUID-vkCreateMacOSSurfaceMVK-pAllocator-parameter",
    "VUID-vkCreateMacOSSurfaceMVK-pCreateInfo-parameter",
    "VUID-vkCreateMacOSSurfaceMVK-pSurface-parameter",
    "VUID-vkCreateMetalSurfaceEXT-instance-parameter",
    "VUID-vkCreateMetalSurfaceEXT-pAllocator-parameter",
    "VUID-vkCreateMetalSurfaceEXT-pCreateInfo-parameter",
    "VUID-vkCreateMetalSurfaceEXT-pSurface-parameter",
    "VUID-vkCreatePipelineCache-device-parameter",
    "VUID-vkCreatePipelineCache-pAllocator-parameter",
    "VUID-vkCreatePipelineCache-pCreateInfo-parameter",
    "VUID-vkCreatePipelineCache-pPipelineCache-parameter",
    "VUID-vkCreatePipelineLayout-device-parameter",
    "VUID-vkCreatePipelineLayout-pAllocator-parameter",
    "VUID-vkCreatePipelineLayout-pCreateInfo-parameter",
    "VUID-vkCreatePipelineLayout-pPipelineLayout-parameter",
    "VUID-vkCreatePrivateDataSlotEXT-device-parameter",
    "VUID-vkCreatePrivateDataSlotEXT-pAllocator-parameter",
    "VUID-vkCreatePrivateDataSlotEXT-pCreateInfo-parameter",
    "VUID-vkCreatePrivateDataSlotEXT-pPrivateDataSlot-parameter",
    "VUID-vkCreateQueryPool-device-parameter",
    "VUID-vkCreateQueryPool-pAllocator-parameter",
    "VUID-vkCreateQueryPool-pCreateInfo-parameter",
    "VUID-vkCreateQueryPool-pQueryPool-parameter",
    "VUID-vkCreateRayTracingPipelinesKHR-createInfoCount-arraylength",
    "VUID-vkCreateRayTracingPipelinesKHR-device-parameter",
    "VUID-vkCreateRayTracingPipelinesKHR-flags-03415",
    "VUID-vkCreateRayTracingPipelinesKHR-flags-03416",
    "VUID-vkCreateRayTracingPipelinesKHR-pAllocator-parameter",
    "VUID-vkCreateRayTracingPipelinesKHR-pCreateInfos-parameter",
    "VUID-vkCreateRayTracingPipelinesKHR-pPipelines-parameter",
    "VUID-vkCreateRayTracingPipelinesKHR-pipelineCache-02903",
    "VUID-vkCreateRayTracingPipelinesKHR-pipelineCache-parameter",
    "VUID-vkCreateRayTracingPipelinesKHR-pipelineCache-parent",
    "VUID-vkCreateRayTracingPipelinesKHR-rayTracing-03455",
    "VUID-vkCreateRayTracingPipelinesNV-createInfoCount-arraylength",
    "VUID-vkCreateRayTracingPipelinesNV-device-parameter",
    "VUID-vkCreateRayTracingPipelinesNV-flags-03415",
    "VUID-vkCreateRayTracingPipelinesNV-flags-03416",
    "VUID-vkCreateRayTracingPipelinesNV-pAllocator-parameter",
    "VUID-vkCreateRayTracingPipelinesNV-pCreateInfos-parameter",
    "VUID-vkCreateRayTracingPipelinesNV-pPipelines-parameter",
    "VUID-vkCreateRayTracingPipelinesNV-pipelineCache-02903",
    "VUID-vkCreateRayTracingPipelinesNV-pipelineCache-parameter",
    "VUID-vkCreateRayTracingPipelinesNV-pipelineCache-parent",
    "VUID-vkCreateRenderPass-device-parameter",
    "VUID-vkCreateRenderPass-pAllocator-parameter",
    "VUID-vkCreateRenderPass-pCreateInfo-parameter",
    "VUID-vkCreateRenderPass-pRenderPass-parameter",
    "VUID-vkCreateRenderPass2-device-parameter",
    "VUID-vkCreateRenderPass2-pAllocator-parameter",
    "VUID-vkCreateRenderPass2-pCreateInfo-parameter",
    "VUID-vkCreateRenderPass2-pRenderPass-parameter",
    "VUID-vkCreateSampler-device-parameter",
    "VUID-vkCreateSampler-maxSamplerAllocationCount-04110",
    "VUID-vkCreateSampler-pAllocator-parameter",
    "VUID-vkCreateSampler-pCreateInfo-parameter",
    "VUID-vkCreateSampler-pSampler-parameter",
    "VUID-vkCreateSamplerYcbcrConversion-None-01648",
    "VUID-vkCreateSamplerYcbcrConversion-device-parameter",
    "VUID-vkCreateSamplerYcbcrConversion-pAllocator-parameter",
    "VUID-vkCreateSamplerYcbcrConversion-pCreateInfo-parameter",
    "VUID-vkCreateSamplerYcbcrConversion-pYcbcrConversion-parameter",
    "VUID-vkCreateSemaphore-device-parameter",
    "VUID-vkCreateSemaphore-pAllocator-parameter",
    "VUID-vkCreateSemaphore-pCreateInfo-parameter",
    "VUID-vkCreateSemaphore-pSemaphore-parameter",
    "VUID-vkCreateShaderModule-device-parameter",
    "VUID-vkCreateShaderModule-pAllocator-parameter",
    "VUID-vkCreateShaderModule-pCreateInfo-parameter",
    "VUID-vkCreateShaderModule-pShaderModule-parameter",
    "VUID-vkCreateSharedSwapchainsKHR-device-parameter",
    "VUID-vkCreateSharedSwapchainsKHR-pAllocator-parameter",
    "VUID-vkCreateSharedSwapchainsKHR-pCreateInfos-parameter",
    "VUID-vkCreateSharedSwapchainsKHR-pSwapchains-parameter",
    "VUID-vkCreateSharedSwapchainsKHR-swapchainCount-arraylength",
    "VUID-vkCreateStreamDescriptorSurfaceGGP-instance-parameter",
    "VUID-vkCreateStreamDescriptorSurfaceGGP-pAllocator-parameter",
    "VUID-vkCreateStreamDescriptorSurfaceGGP-pCreateInfo-parameter",
    "VUID-vkCreateStreamDescriptorSurfaceGGP-pSurface-parameter",
    "VUID-vkCreateSwapchainKHR-device-parameter",
    "VUID-vkCreateSwapchainKHR-pAllocator-parameter",
    "VUID-vkCreateSwapchainKHR-pCreateInfo-parameter",
    "VUID-vkCreateSwapchainKHR-pSwapchain-parameter",
    "VUID-vkCreateValidationCacheEXT-device-parameter",
    "VUID-vkCreateValidationCacheEXT-pAllocator-parameter",
    "VUID-vkCreateValidationCacheEXT-pCreateInfo-parameter",
    "VUID-vkCreateValidationCacheEXT-pValidationCache-parameter",
    "VUID-vkCreateViSurfaceNN-instance-parameter",
    "VUID-vkCreateViSurfaceNN-pAllocator-parameter",
    "VUID-vkCreateViSurfaceNN-pCreateInfo-parameter",
    "VUID-vkCreateViSurfaceNN-pSurface-parameter",
    "VUID-vkCreateWaylandSurfaceKHR-instance-parameter",
    "VUID-vkCreateWaylandSurfaceKHR-pAllocator-parameter",
    "VUID-vkCreateWaylandSurfaceKHR-pCreateInfo-parameter",
    "VUID-vkCreateWaylandSurfaceKHR-pSurface-parameter",
    "VUID-vkCreateWin32SurfaceKHR-instance-parameter",
    "VUID-vkCreateWin32SurfaceKHR-pAllocator-parameter",
    "VUID-vkCreateWin32SurfaceKHR-pCreateInfo-parameter",
    "VUID-vkCreateWin32SurfaceKHR-pSurface-parameter",
    "VUID-vkCreateXcbSurfaceKHR-instance-parameter",
    "VUID-vkCreateXcbSurfaceKHR-pAllocator-parameter",
    "VUID-vkCreateXcbSurfaceKHR-pCreateInfo-parameter",
    "VUID-vkCreateXcbSurfaceKHR-pSurface-parameter",
    "VUID-vkCreateXlibSurfaceKHR-instance-parameter",
    "VUID-vkCreateXlibSurfaceKHR-pAllocator-parameter",
    "VUID-vkCreateXlibSurfaceKHR-pCreateInfo-parameter",
    "VUID-vkCreateXlibSurfaceKHR-pSurface-parameter",
    "VUID-vkDebugMarkerSetObjectNameEXT-device-parameter",
    "VUID-vkDebugMarkerSetObjectNameEXT-pNameInfo-parameter",
    "VUID-vkDebugMarkerSetObjectTagEXT-device-parameter",
    "VUID-vkDebugMarkerSetObjectTagEXT-pTagInfo-parameter",
    "VUID-vkDebugReportMessageEXT-flags-parameter",
    "VUID-vkDebugReportMessageEXT-flags-requiredbitmask",
    "VUID-vkDebugReportMessageEXT-instance-parameter",
    "VUID-vkDebugReportMessageEXT-object-01241",
    "VUID-vkDebugReportMessageEXT-objectType-01498",
    "VUID-vkDebugReportMessageEXT-objectType-parameter",
    "VUID-vkDebugReportMessageEXT-pLayerPrefix-parameter",
    "VUID-vkDebugReportMessageEXT-pMessage-parameter",
    "VUID-vkDeferredOperationJoinKHR-device-parameter",
    "VUID-vkDeferredOperationJoinKHR-operation-parameter",
    "VUID-vkDeferredOperationJoinKHR-operation-parent",
    "VUID-vkDestroyAccelerationStructureKHR-accelerationStructure-02442",
    "VUID-vkDestroyAccelerationStructureKHR-accelerationStructure-02443",
    "VUID-vkDestroyAccelerationStructureKHR-accelerationStructure-02444",
    "VUID-vkDestroyAccelerationStructureKHR-accelerationStructure-parameter",
    "VUID-vkDestroyAccelerationStructureKHR-accelerationStructure-parent",
    "VUID-vkDestroyAccelerationStructureKHR-device-parameter",
    "VUID-vkDestroyAccelerationStructureKHR-pAllocator-parameter",
    "VUID-vkDestroyBuffer-buffer-00922",
    "VUID-vkDestroyBuffer-buffer-00923",
    "VUID-vkDestroyBuffer-buffer-00924",
    "VUID-vkDestroyBuffer-buffer-parameter",
    "VUID-vkDestroyBuffer-buffer-parent",
    "VUID-vkDestroyBuffer-device-parameter",
    "VUID-vkDestroyBuffer-pAllocator-parameter",
    "VUID-vkDestroyBufferView-bufferView-00936",
    "VUID-vkDestroyBufferView-bufferView-00937",
    "VUID-vkDestroyBufferView-bufferView-00938",
    "VUID-vkDestroyBufferView-bufferView-parameter",
    "VUID-vkDestroyBufferView-bufferView-parent",
    "VUID-vkDestroyBufferView-device-parameter",
    "VUID-vkDestroyBufferView-pAllocator-parameter",
    "VUID-vkDestroyCommandPool-commandPool-00041",
    "VUID-vkDestroyCommandPool-commandPool-00042",
    "VUID-vkDestroyCommandPool-commandPool-00043",
    "VUID-vkDestroyCommandPool-commandPool-parameter",
    "VUID-vkDestroyCommandPool-commandPool-parent",
    "VUID-vkDestroyCommandPool-device-parameter",
    "VUID-vkDestroyCommandPool-pAllocator-parameter",
    "VUID-vkDestroyDebugReportCallbackEXT-callback-parameter",
    "VUID-vkDestroyDebugReportCallbackEXT-callback-parent",
    "VUID-vkDestroyDebugReportCallbackEXT-instance-01242",
    "VUID-vkDestroyDebugReportCallbackEXT-instance-01243",
    "VUID-vkDestroyDebugReportCallbackEXT-instance-parameter",
    "VUID-vkDestroyDebugReportCallbackEXT-pAllocator-parameter",
    "VUID-vkDestroyDebugUtilsMessengerEXT-instance-parameter",
    "VUID-vkDestroyDebugUtilsMessengerEXT-messenger-01915",
    "VUID-vkDestroyDebugUtilsMessengerEXT-messenger-01916",
    "VUID-vkDestroyDebugUtilsMessengerEXT-messenger-parameter",
    "VUID-vkDestroyDebugUtilsMessengerEXT-messenger-parent",
    "VUID-vkDestroyDebugUtilsMessengerEXT-pAllocator-parameter",
    "VUID-vkDestroyDeferredOperationKHR-device-parameter",
    "VUID-vkDestroyDeferredOperationKHR-operation-03434",
    "VUID-vkDestroyDeferredOperationKHR-operation-03435",
    "VUID-vkDestroyDeferredOperationKHR-operation-03436",
    "VUID-vkDestroyDeferredOperationKHR-operation-parameter",
    "VUID-vkDestroyDeferredOperationKHR-operation-parent",
    "VUID-vkDestroyDeferredOperationKHR-pAllocator-parameter",
    "VUID-vkDestroyDescriptorPool-descriptorPool-00303",
    "VUID-vkDestroyDescriptorPool-descriptorPool-00304",
    "VUID-vkDestroyDescriptorPool-descriptorPool-00305",
    "VUID-vkDestroyDescriptorPool-descriptorPool-parameter",
    "VUID-vkDestroyDescriptorPool-descriptorPool-parent",
    "VUID-vkDestroyDescriptorPool-device-parameter",
    "VUID-vkDestroyDescriptorPool-pAllocator-parameter",
    "VUID-vkDestroyDescriptorSetLayout-descriptorSetLayout-00284",
    "VUID-vkDestroyDescriptorSetLayout-descriptorSetLayout-00285",
    "VUID-vkDestroyDescriptorSetLayout-descriptorSetLayout-parameter",
    "VUID-vkDestroyDescriptorSetLayout-descriptorSetLayout-parent",
    "VUID-vkDestroyDescriptorSetLayout-device-parameter",
    "VUID-vkDestroyDescriptorSetLayout-pAllocator-parameter",
    "VUID-vkDestroyDescriptorUpdateTemplate-descriptorSetLayout-00356",
    "VUID-vkDestroyDescriptorUpdateTemplate-descriptorSetLayout-00357",
    "VUID-vkDestroyDescriptorUpdateTemplate-descriptorUpdateTemplate-parameter",
    "VUID-vkDestroyDescriptorUpdateTemplate-descriptorUpdateTemplate-parent",
    "VUID-vkDestroyDescriptorUpdateTemplate-device-parameter",
    "VUID-vkDestroyDescriptorUpdateTemplate-pAllocator-parameter",
    "VUID-vkDestroyDevice-device-00378",
    "VUID-vkDestroyDevice-device-00379",
    "VUID-vkDestroyDevice-device-00380",
    "VUID-vkDestroyDevice-device-parameter",
    "VUID-vkDestroyDevice-pAllocator-parameter",
    "VUID-vkDestroyEvent-device-parameter",
    "VUID-vkDestroyEvent-event-01145",
    "VUID-vkDestroyEvent-event-01146",
    "VUID-vkDestroyEvent-event-01147",
    "VUID-vkDestroyEvent-event-parameter",
    "VUID-vkDestroyEvent-event-parent",
    "VUID-vkDestroyEvent-pAllocator-parameter",
    "VUID-vkDestroyFence-device-parameter",
    "VUID-vkDestroyFence-fence-01120",
    "VUID-vkDestroyFence-fence-01121",
    "VUID-vkDestroyFence-fence-01122",
    "VUID-vkDestroyFence-fence-parameter",
    "VUID-vkDestroyFence-fence-parent",
    "VUID-vkDestroyFence-pAllocator-parameter",
    "VUID-vkDestroyFramebuffer-device-parameter",
    "VUID-vkDestroyFramebuffer-framebuffer-00892",
    "VUID-vkDestroyFramebuffer-framebuffer-00893",
    "VUID-vkDestroyFramebuffer-framebuffer-00894",
    "VUID-vkDestroyFramebuffer-framebuffer-parameter",
    "VUID-vkDestroyFramebuffer-framebuffer-parent",
    "VUID-vkDestroyFramebuffer-pAllocator-parameter",
    "VUID-vkDestroyImage-device-parameter",
    "VUID-vkDestroyImage-image-01000",
    "VUID-vkDestroyImage-image-01001",
    "VUID-vkDestroyImage-image-01002",
    "VUID-vkDestroyImage-image-parameter",
    "VUID-vkDestroyImage-image-parent",
    "VUID-vkDestroyImage-pAllocator-parameter",
    "VUID-vkDestroyImageView-device-parameter",
    "VUID-vkDestroyImageView-imageView-01026",
    "VUID-vkDestroyImageView-imageView-01027",
    "VUID-vkDestroyImageView-imageView-01028",
    "VUID-vkDestroyImageView-imageView-parameter",
    "VUID-vkDestroyImageView-imageView-parent",
    "VUID-vkDestroyImageView-pAllocator-parameter",
    "VUID-vkDestroyIndirectCommandsLayoutNV-device-parameter",
    "VUID-vkDestroyIndirectCommandsLayoutNV-deviceGeneratedCommands-02941",
    "VUID-vkDestroyIndirectCommandsLayoutNV-indirectCommandsLayout-02938",
    "VUID-vkDestroyIndirectCommandsLayoutNV-indirectCommandsLayout-02939",
    "VUID-vkDestroyIndirectCommandsLayoutNV-indirectCommandsLayout-02940",
    "VUID-vkDestroyIndirectCommandsLayoutNV-indirectCommandsLayout-parameter",
    "VUID-vkDestroyIndirectCommandsLayoutNV-indirectCommandsLayout-parent",
    "VUID-vkDestroyIndirectCommandsLayoutNV-pAllocator-parameter",
    "VUID-vkDestroyInstance-instance-00629",
    "VUID-vkDestroyInstance-instance-00630",
    "VUID-vkDestroyInstance-instance-00631",
    "VUID-vkDestroyInstance-instance-parameter",
    "VUID-vkDestroyInstance-pAllocator-parameter",
    "VUID-vkDestroyPipeline-device-parameter",
    "VUID-vkDestroyPipeline-pAllocator-parameter",
    "VUID-vkDestroyPipeline-pipeline-00765",
    "VUID-vkDestroyPipeline-pipeline-00766",
    "VUID-vkDestroyPipeline-pipeline-00767",
    "VUID-vkDestroyPipeline-pipeline-parameter",
    "VUID-vkDestroyPipeline-pipeline-parent",
    "VUID-vkDestroyPipelineCache-device-parameter",
    "VUID-vkDestroyPipelineCache-pAllocator-parameter",
    "VUID-vkDestroyPipelineCache-pipelineCache-00771",
    "VUID-vkDestroyPipelineCache-pipelineCache-00772",
    "VUID-vkDestroyPipelineCache-pipelineCache-parameter",
    "VUID-vkDestroyPipelineCache-pipelineCache-parent",
    "VUID-vkDestroyPipelineLayout-device-parameter",
    "VUID-vkDestroyPipelineLayout-pAllocator-parameter",
    "VUID-vkDestroyPipelineLayout-pipelineLayout-00299",
    "VUID-vkDestroyPipelineLayout-pipelineLayout-00300",
    "VUID-vkDestroyPipelineLayout-pipelineLayout-02004",
    "VUID-vkDestroyPipelineLayout-pipelineLayout-parameter",
    "VUID-vkDestroyPipelineLayout-pipelineLayout-parent",
    "VUID-vkDestroyPrivateDataSlotEXT-device-parameter",
    "VUID-vkDestroyPrivateDataSlotEXT-pAllocator-parameter",
    "VUID-vkDestroyPrivateDataSlotEXT-privateDataSlot-04062",
    "VUID-vkDestroyPrivateDataSlotEXT-privateDataSlot-04063",
    "VUID-vkDestroyPrivateDataSlotEXT-privateDataSlot-parameter",
    "VUID-vkDestroyPrivateDataSlotEXT-privateDataSlot-parent",
    "VUID-vkDestroyQueryPool-device-parameter",
    "VUID-vkDestroyQueryPool-pAllocator-parameter",
    "VUID-vkDestroyQueryPool-queryPool-00793",
    "VUID-vkDestroyQueryPool-queryPool-00794",
    "VUID-vkDestroyQueryPool-queryPool-00795",
    "VUID-vkDestroyQueryPool-queryPool-parameter",
    "VUID-vkDestroyQueryPool-queryPool-parent",
    "VUID-vkDestroyRenderPass-device-parameter",
    "VUID-vkDestroyRenderPass-pAllocator-parameter",
    "VUID-vkDestroyRenderPass-renderPass-00873",
    "VUID-vkDestroyRenderPass-renderPass-00874",
    "VUID-vkDestroyRenderPass-renderPass-00875",
    "VUID-vkDestroyRenderPass-renderPass-parameter",
    "VUID-vkDestroyRenderPass-renderPass-parent",
    "VUID-vkDestroySampler-device-parameter",
    "VUID-vkDestroySampler-pAllocator-parameter",
    "VUID-vkDestroySampler-sampler-01082",
    "VUID-vkDestroySampler-sampler-01083",
    "VUID-vkDestroySampler-sampler-01084",
    "VUID-vkDestroySampler-sampler-parameter",
    "VUID-vkDestroySampler-sampler-parent",
    "VUID-vkDestroySamplerYcbcrConversion-device-parameter",
    "VUID-vkDestroySamplerYcbcrConversion-pAllocator-parameter",
    "VUID-vkDestroySamplerYcbcrConversion-ycbcrConversion-parameter",
    "VUID-vkDestroySamplerYcbcrConversion-ycbcrConversion-parent",
    "VUID-vkDestroySemaphore-device-parameter",
    "VUID-vkDestroySemaphore-pAllocator-parameter",
    "VUID-vkDestroySemaphore-semaphore-01137",
    "VUID-vkDestroySemaphore-semaphore-01138",
    "VUID-vkDestroySemaphore-semaphore-01139",
    "VUID-vkDestroySemaphore-semaphore-parameter",
    "VUID-vkDestroySemaphore-semaphore-parent",
    "VUID-vkDestroyShaderModule-device-parameter",
    "VUID-vkDestroyShaderModule-pAllocator-parameter",
    "VUID-vkDestroyShaderModule-shaderModule-01092",
    "VUID-vkDestroyShaderModule-shaderModule-01093",
    "VUID-vkDestroyShaderModule-shaderModule-parameter",
    "VUID-vkDestroyShaderModule-shaderModule-parent",
    "VUID-vkDestroySurfaceKHR-instance-parameter",
    "VUID-vkDestroySurfaceKHR-pAllocator-parameter",
    "VUID-vkDestroySurfaceKHR-surface-01266",
    "VUID-vkDestroySurfaceKHR-surface-01267",
    "VUID-vkDestroySurfaceKHR-surface-01268",
    "VUID-vkDestroySurfaceKHR-surface-parameter",
    "VUID-vkDestroySurfaceKHR-surface-parent",
    "VUID-vkDestroySwapchainKHR-commonparent",
    "VUID-vkDestroySwapchainKHR-device-parameter",
    "VUID-vkDestroySwapchainKHR-pAllocator-parameter",
    "VUID-vkDestroySwapchainKHR-swapchain-01282",
    "VUID-vkDestroySwapchainKHR-swapchain-01283",
    "VUID-vkDestroySwapchainKHR-swapchain-01284",
    "VUID-vkDestroySwapchainKHR-swapchain-parameter",
    "VUID-vkDestroyValidationCacheEXT-device-parameter",
    "VUID-vkDestroyValidationCacheEXT-pAllocator-parameter",
    "VUID-vkDestroyValidationCacheEXT-validationCache-01537",
    "VUID-vkDestroyValidationCacheEXT-validationCache-01538",
    "VUID-vkDestroyValidationCacheEXT-validationCache-parameter",
    "VUID-vkDestroyValidationCacheEXT-validationCache-parent",
    "VUID-vkDeviceWaitIdle-device-parameter",
    "VUID-vkDisplayPowerControlEXT-commonparent",
    "VUID-vkDisplayPowerControlEXT-device-parameter",
    "VUID-vkDisplayPowerControlEXT-display-parameter",
    "VUID-vkDisplayPowerControlEXT-pDisplayPowerInfo-parameter",
    "VUID-vkEndCommandBuffer-None-01978",
    "VUID-vkEndCommandBuffer-commandBuffer-00059",
    "VUID-vkEndCommandBuffer-commandBuffer-00060",
    "VUID-vkEndCommandBuffer-commandBuffer-00061",
    "VUID-vkEndCommandBuffer-commandBuffer-00062",
    "VUID-vkEndCommandBuffer-commandBuffer-01815",
    "VUID-vkEndCommandBuffer-commandBuffer-parameter",
    "VUID-vkEnumerateDeviceExtensionProperties-pLayerName-parameter",
    "VUID-vkEnumerateDeviceExtensionProperties-pProperties-parameter",
    "VUID-vkEnumerateDeviceExtensionProperties-pPropertyCount-parameter",
    "VUID-vkEnumerateDeviceExtensionProperties-physicalDevice-parameter",
    "VUID-vkEnumerateDeviceLayerProperties-pProperties-parameter",
    "VUID-vkEnumerateDeviceLayerProperties-pPropertyCount-parameter",
    "VUID-vkEnumerateDeviceLayerProperties-physicalDevice-parameter",
    "VUID-vkEnumerateInstanceExtensionProperties-pLayerName-parameter",
    "VUID-vkEnumerateInstanceExtensionProperties-pProperties-parameter",
    "VUID-vkEnumerateInstanceExtensionProperties-pPropertyCount-parameter",
    "VUID-vkEnumerateInstanceLayerProperties-pProperties-parameter",
    "VUID-vkEnumerateInstanceLayerProperties-pPropertyCount-parameter",
    "VUID-vkEnumerateInstanceVersion-pApiVersion-parameter",
    "VUID-vkEnumeratePhysicalDeviceGroups-instance-parameter",
    "VUID-vkEnumeratePhysicalDeviceGroups-pPhysicalDeviceGroupCount-parameter",
    "VUID-vkEnumeratePhysicalDeviceGroups-pPhysicalDeviceGroupProperties-parameter",
    "VUID-vkEnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR-pCounterCount-parameter",
    "VUID-vkEnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR-pCounterDescriptions-parameter",
    "VUID-vkEnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR-pCounters-parameter",
    "VUID-vkEnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR-physicalDevice-parameter",
    "VUID-vkEnumeratePhysicalDevices-instance-parameter",
    "VUID-vkEnumeratePhysicalDevices-pPhysicalDeviceCount-parameter",
    "VUID-vkEnumeratePhysicalDevices-pPhysicalDevices-parameter",
    "VUID-vkFlushMappedMemoryRanges-device-parameter",
    "VUID-vkFlushMappedMemoryRanges-memoryRangeCount-arraylength",
    "VUID-vkFlushMappedMemoryRanges-pMemoryRanges-parameter",
    "VUID-vkFreeCommandBuffers-commandBufferCount-arraylength",
    "VUID-vkFreeCommandBuffers-commandPool-parameter",
    "VUID-vkFreeCommandBuffers-commandPool-parent",
    "VUID-vkFreeCommandBuffers-device-parameter",
    "VUID-vkFreeCommandBuffers-pCommandBuffers-00047",
    "VUID-vkFreeCommandBuffers-pCommandBuffers-00048",
    "VUID-vkFreeCommandBuffers-pCommandBuffers-parent",
    "VUID-vkFreeDescriptorSets-descriptorPool-00312",
    "VUID-vkFreeDescriptorSets-descriptorPool-parameter",
    "VUID-vkFreeDescriptorSets-descriptorPool-parent",
    "VUID-vkFreeDescriptorSets-descriptorSetCount-arraylength",
    "VUID-vkFreeDescriptorSets-device-parameter",
    "VUID-vkFreeDescriptorSets-pDescriptorSets-00309",
    "VUID-vkFreeDescriptorSets-pDescriptorSets-00310",
    "VUID-vkFreeDescriptorSets-pDescriptorSets-00311",
    "VUID-vkFreeDescriptorSets-pDescriptorSets-parent",
    "VUID-vkFreeMemory-device-parameter",
    "VUID-vkFreeMemory-memory-00677",
    "VUID-vkFreeMemory-memory-parameter",
    "VUID-vkFreeMemory-memory-parent",
    "VUID-vkFreeMemory-pAllocator-parameter",
    "VUID-vkGetAccelerationStructureDeviceAddressKHR-device-03504",
    "VUID-vkGetAccelerationStructureDeviceAddressKHR-device-parameter",
    "VUID-vkGetAccelerationStructureDeviceAddressKHR-pInfo-parameter",
    "VUID-vkGetAccelerationStructureHandleNV-accelerationStructure-02787",
    "VUID-vkGetAccelerationStructureHandleNV-accelerationStructure-parameter",
    "VUID-vkGetAccelerationStructureHandleNV-accelerationStructure-parent",
    "VUID-vkGetAccelerationStructureHandleNV-dataSize-02240",
    "VUID-vkGetAccelerationStructureHandleNV-dataSize-arraylength",
    "VUID-vkGetAccelerationStructureHandleNV-device-parameter",
    "VUID-vkGetAccelerationStructureHandleNV-pData-parameter",
    "VUID-vkGetAccelerationStructureMemoryRequirementsKHR-device-parameter",
    "VUID-vkGetAccelerationStructureMemoryRequirementsKHR-pInfo-parameter",
    "VUID-vkGetAccelerationStructureMemoryRequirementsKHR-pMemoryRequirements-parameter",
    "VUID-vkGetAccelerationStructureMemoryRequirementsNV-device-parameter",
    "VUID-vkGetAccelerationStructureMemoryRequirementsNV-pInfo-parameter",
    "VUID-vkGetAccelerationStructureMemoryRequirementsNV-pMemoryRequirements-parameter",
    "VUID-vkGetAndroidHardwareBufferPropertiesANDROID-buffer-01884",
    "VUID-vkGetAndroidHardwareBufferPropertiesANDROID-buffer-parameter",
    "VUID-vkGetAndroidHardwareBufferPropertiesANDROID-device-parameter",
    "VUID-vkGetAndroidHardwareBufferPropertiesANDROID-pProperties-parameter",
    "VUID-vkGetBufferDeviceAddress-bufferDeviceAddress-03324",
    "VUID-vkGetBufferDeviceAddress-device-03325",
    "VUID-vkGetBufferDeviceAddress-device-parameter",
    "VUID-vkGetBufferDeviceAddress-pInfo-parameter",
    "VUID-vkGetBufferMemoryRequirements-buffer-04003",
    "VUID-vkGetBufferMemoryRequirements-buffer-parameter",
    "VUID-vkGetBufferMemoryRequirements-buffer-parent",
    "VUID-vkGetBufferMemoryRequirements-device-parameter",
    "VUID-vkGetBufferMemoryRequirements-pMemoryRequirements-parameter",
    "VUID-vkGetBufferMemoryRequirements2-device-parameter",
    "VUID-vkGetBufferMemoryRequirements2-pInfo-parameter",
    "VUID-vkGetBufferMemoryRequirements2-pMemoryRequirements-parameter",
    "VUID-vkGetBufferOpaqueCaptureAddress-None-03326",
    "VUID-vkGetBufferOpaqueCaptureAddress-device-03327",
    "VUID-vkGetBufferOpaqueCaptureAddress-device-parameter",
    "VUID-vkGetBufferOpaqueCaptureAddress-pInfo-parameter",
    "VUID-vkGetCalibratedTimestampsEXT-device-parameter",
    "VUID-vkGetCalibratedTimestampsEXT-pMaxDeviation-parameter",
    "VUID-vkGetCalibratedTimestampsEXT-pTimestampInfos-parameter",
    "VUID-vkGetCalibratedTimestampsEXT-pTimestamps-parameter",
    "VUID-vkGetCalibratedTimestampsEXT-timestampCount-arraylength",
    "VUID-vkGetDeferredOperationMaxConcurrencyKHR-device-parameter",
    "VUID-vkGetDeferredOperationMaxConcurrencyKHR-operation-parameter",
    "VUID-vkGetDeferredOperationMaxConcurrencyKHR-operation-parent",
    "VUID-vkGetDeferredOperationResultKHR-device-parameter",
    "VUID-vkGetDeferredOperationResultKHR-operation-parameter",
    "VUID-vkGetDeferredOperationResultKHR-operation-parent",
    "VUID-vkGetDescriptorSetLayoutSupport-device-parameter",
    "VUID-vkGetDescriptorSetLayoutSupport-pCreateInfo-parameter",
    "VUID-vkGetDescriptorSetLayoutSupport-pSupport-parameter",
    "VUID-vkGetDeviceAccelerationStructureCompatibilityKHR-device-parameter",
    "VUID-vkGetDeviceAccelerationStructureCompatibilityKHR-rayTracing-03565",
    "VUID-vkGetDeviceAccelerationStructureCompatibilityKHR-version-parameter",
    "VUID-vkGetDeviceGroupPeerMemoryFeatures-device-parameter",
    "VUID-vkGetDeviceGroupPeerMemoryFeatures-heapIndex-00691",
    "VUID-vkGetDeviceGroupPeerMemoryFeatures-localDeviceIndex-00692",
    "VUID-vkGetDeviceGroupPeerMemoryFeatures-localDeviceIndex-00694",
    "VUID-vkGetDeviceGroupPeerMemoryFeatures-pPeerMemoryFeatures-parameter",
    "VUID-vkGetDeviceGroupPeerMemoryFeatures-remoteDeviceIndex-00693",
    "VUID-vkGetDeviceGroupPresentCapabilitiesKHR-device-parameter",
    "VUID-vkGetDeviceGroupPresentCapabilitiesKHR-pDeviceGroupPresentCapabilities-parameter",
    "VUID-vkGetDeviceGroupSurfacePresentModes2EXT-device-parameter",
    "VUID-vkGetDeviceGroupSurfacePresentModes2EXT-pModes-parameter",
    "VUID-vkGetDeviceGroupSurfacePresentModes2EXT-pSurfaceInfo-parameter",
    "VUID-vkGetDeviceGroupSurfacePresentModesKHR-commonparent",
    "VUID-vkGetDeviceGroupSurfacePresentModesKHR-device-parameter",
    "VUID-vkGetDeviceGroupSurfacePresentModesKHR-pModes-parameter",
    "VUID-vkGetDeviceGroupSurfacePresentModesKHR-surface-parameter",
    "VUID-vkGetDeviceMemoryCommitment-device-parameter",
    "VUID-vkGetDeviceMemoryCommitment-memory-00690",
    "VUID-vkGetDeviceMemoryCommitment-memory-parameter",
    "VUID-vkGetDeviceMemoryCommitment-memory-parent",
    "VUID-vkGetDeviceMemoryCommitment-pCommittedMemoryInBytes-parameter",
    "VUID-vkGetDeviceMemoryOpaqueCaptureAddress-None-03334",
    "VUID-vkGetDeviceMemoryOpaqueCaptureAddress-device-03335",
    "VUID-vkGetDeviceMemoryOpaqueCaptureAddress-device-parameter",
    "VUID-vkGetDeviceMemoryOpaqueCaptureAddress-pInfo-parameter",
    "VUID-vkGetDeviceProcAddr-device-parameter",
    "VUID-vkGetDeviceProcAddr-pName-parameter",
    "VUID-vkGetDeviceQueue-device-parameter",
    "VUID-vkGetDeviceQueue-flags-01841",
    "VUID-vkGetDeviceQueue-pQueue-parameter",
    "VUID-vkGetDeviceQueue-queueFamilyIndex-00384",
    "VUID-vkGetDeviceQueue-queueIndex-00385",
    "VUID-vkGetDeviceQueue2-device-parameter",
    "VUID-vkGetDeviceQueue2-pQueue-parameter",
    "VUID-vkGetDeviceQueue2-pQueueInfo-parameter",
    "VUID-vkGetDisplayModeProperties2KHR-display-parameter",
    "VUID-vkGetDisplayModeProperties2KHR-display-parent",
    "VUID-vkGetDisplayModeProperties2KHR-pProperties-parameter",
    "VUID-vkGetDisplayModeProperties2KHR-pPropertyCount-parameter",
    "VUID-vkGetDisplayModeProperties2KHR-physicalDevice-parameter",
    "VUID-vkGetDisplayModePropertiesKHR-display-parameter",
    "VUID-vkGetDisplayModePropertiesKHR-display-parent",
    "VUID-vkGetDisplayModePropertiesKHR-pProperties-parameter",
    "VUID-vkGetDisplayModePropertiesKHR-pPropertyCount-parameter",
    "VUID-vkGetDisplayModePropertiesKHR-physicalDevice-parameter",
    "VUID-vkGetDisplayPlaneCapabilities2KHR-pCapabilities-parameter",
    "VUID-vkGetDisplayPlaneCapabilities2KHR-pDisplayPlaneInfo-parameter",
    "VUID-vkGetDisplayPlaneCapabilities2KHR-physicalDevice-parameter",
    "VUID-vkGetDisplayPlaneCapabilitiesKHR-mode-parameter",
    "VUID-vkGetDisplayPlaneCapabilitiesKHR-pCapabilities-parameter",
    "VUID-vkGetDisplayPlaneCapabilitiesKHR-physicalDevice-parameter",
    "VUID-vkGetDisplayPlaneSupportedDisplaysKHR-pDisplayCount-parameter",
    "VUID-vkGetDisplayPlaneSupportedDisplaysKHR-pDisplays-parameter",
    "VUID-vkGetDisplayPlaneSupportedDisplaysKHR-physicalDevice-parameter",
    "VUID-vkGetDisplayPlaneSupportedDisplaysKHR-planeIndex-01249",
    "VUID-vkGetEventStatus-device-parameter",
    "VUID-vkGetEventStatus-event-parameter",
    "VUID-vkGetEventStatus-event-parent",
    "VUID-vkGetFenceFdKHR-device-parameter",
    "VUID-vkGetFenceFdKHR-pFd-parameter",
    "VUID-vkGetFenceFdKHR-pGetFdInfo-parameter",
    "VUID-vkGetFenceStatus-device-parameter",
    "VUID-vkGetFenceStatus-fence-parameter",
    "VUID-vkGetFenceStatus-fence-parent",
    "VUID-vkGetFenceWin32HandleKHR-device-parameter",
    "VUID-vkGetFenceWin32HandleKHR-pGetWin32HandleInfo-parameter",
    "VUID-vkGetFenceWin32HandleKHR-pHandle-parameter",
    "VUID-vkGetGeneratedCommandsMemoryRequirementsNV-device-parameter",
    "VUID-vkGetGeneratedCommandsMemoryRequirementsNV-deviceGeneratedCommands-02906",
    "VUID-vkGetGeneratedCommandsMemoryRequirementsNV-pInfo-parameter",
    "VUID-vkGetGeneratedCommandsMemoryRequirementsNV-pMemoryRequirements-parameter",
    "VUID-vkGetImageDrmFormatModifierPropertiesEXT-device-parameter",
    "VUID-vkGetImageDrmFormatModifierPropertiesEXT-image-02272",
    "VUID-vkGetImageDrmFormatModifierPropertiesEXT-image-parameter",
    "VUID-vkGetImageDrmFormatModifierPropertiesEXT-image-parent",
    "VUID-vkGetImageDrmFormatModifierPropertiesEXT-pProperties-parameter",
    "VUID-vkGetImageMemoryRequirements-device-parameter",
    "VUID-vkGetImageMemoryRequirements-image-01588",
    "VUID-vkGetImageMemoryRequirements-image-04004",
    "VUID-vkGetImageMemoryRequirements-image-parameter",
    "VUID-vkGetImageMemoryRequirements-image-parent",
    "VUID-vkGetImageMemoryRequirements-pMemoryRequirements-parameter",
    "VUID-vkGetImageMemoryRequirements2-device-parameter",
    "VUID-vkGetImageMemoryRequirements2-pInfo-parameter",
    "VUID-vkGetImageMemoryRequirements2-pMemoryRequirements-parameter",
    "VUID-vkGetImageSparseMemoryRequirements-device-parameter",
    "VUID-vkGetImageSparseMemoryRequirements-image-parameter",
    "VUID-vkGetImageSparseMemoryRequirements-image-parent",
    "VUID-vkGetImageSparseMemoryRequirements-pSparseMemoryRequirementCount-parameter",
    "VUID-vkGetImageSparseMemoryRequirements-pSparseMemoryRequirements-parameter",
    "VUID-vkGetImageSparseMemoryRequirements2-device-parameter",
    "VUID-vkGetImageSparseMemoryRequirements2-pInfo-parameter",
    "VUID-vkGetImageSparseMemoryRequirements2-pSparseMemoryRequirementCount-parameter",
    "VUID-vkGetImageSparseMemoryRequirements2-pSparseMemoryRequirements-parameter",
    "VUID-vkGetImageSubresourceLayout-arrayLayer-01717",
    "VUID-vkGetImageSubresourceLayout-aspectMask-00997",
    "VUID-vkGetImageSubresourceLayout-device-parameter",
    "VUID-vkGetImageSubresourceLayout-format-01581",
    "VUID-vkGetImageSubresourceLayout-format-01582",
    "VUID-vkGetImageSubresourceLayout-image-00996",
    "VUID-vkGetImageSubresourceLayout-image-01895",
    "VUID-vkGetImageSubresourceLayout-image-02270",
    "VUID-vkGetImageSubresourceLayout-image-parameter",
    "VUID-vkGetImageSubresourceLayout-image-parent",
    "VUID-vkGetImageSubresourceLayout-mipLevel-01716",
    "VUID-vkGetImageSubresourceLayout-pLayout-parameter",
    "VUID-vkGetImageSubresourceLayout-pSubresource-parameter",
    "VUID-vkGetImageSubresourceLayout-tiling-02271",
    "VUID-vkGetImageViewAddressNVX-device-parameter",
    "VUID-vkGetImageViewAddressNVX-imageView-parameter",
    "VUID-vkGetImageViewAddressNVX-imageView-parent",
    "VUID-vkGetImageViewAddressNVX-pProperties-parameter",
    "VUID-vkGetImageViewHandleNVX-device-parameter",
    "VUID-vkGetImageViewHandleNVX-pInfo-parameter",
    "VUID-vkGetInstanceProcAddr-instance-parameter",
    "VUID-vkGetInstanceProcAddr-pName-parameter",
    "VUID-vkGetMemoryAndroidHardwareBufferANDROID-device-parameter",
    "VUID-vkGetMemoryAndroidHardwareBufferANDROID-pBuffer-parameter",
    "VUID-vkGetMemoryAndroidHardwareBufferANDROID-pInfo-parameter",
    "VUID-vkGetMemoryFdKHR-device-parameter",
    "VUID-vkGetMemoryFdKHR-pFd-parameter",
    "VUID-vkGetMemoryFdKHR-pGetFdInfo-parameter",
    "VUID-vkGetMemoryFdPropertiesKHR-device-parameter",
    "VUID-vkGetMemoryFdPropertiesKHR-fd-00673",
    "VUID-vkGetMemoryFdPropertiesKHR-handleType-00674",
    "VUID-vkGetMemoryFdPropertiesKHR-handleType-parameter",
    "VUID-vkGetMemoryFdPropertiesKHR-pMemoryFdProperties-parameter",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-device-parameter",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-handleType-01752",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-handleType-01754",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-handleType-01755",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-handleType-parameter",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-pHostPointer-01753",
    "VUID-vkGetMemoryHostPointerPropertiesEXT-pMemoryHostPointerProperties-parameter",
    "VUID-vkGetMemoryWin32HandleKHR-device-parameter",
    "VUID-vkGetMemoryWin32HandleKHR-pGetWin32HandleInfo-parameter",
    "VUID-vkGetMemoryWin32HandleKHR-pHandle-parameter",
    "VUID-vkGetMemoryWin32HandleNV-device-parameter",
    "VUID-vkGetMemoryWin32HandleNV-handleType-01326",
    "VUID-vkGetMemoryWin32HandleNV-handleType-parameter",
    "VUID-vkGetMemoryWin32HandleNV-handleType-requiredbitmask",
    "VUID-vkGetMemoryWin32HandleNV-memory-parameter",
    "VUID-vkGetMemoryWin32HandleNV-memory-parent",
    "VUID-vkGetMemoryWin32HandleNV-pHandle-parameter",
    "VUID-vkGetMemoryWin32HandlePropertiesKHR-device-parameter",
    "VUID-vkGetMemoryWin32HandlePropertiesKHR-handle-00665",
    "VUID-vkGetMemoryWin32HandlePropertiesKHR-handleType-00666",
    "VUID-vkGetMemoryWin32HandlePropertiesKHR-handleType-parameter",
    "VUID-vkGetMemoryWin32HandlePropertiesKHR-pMemoryWin32HandleProperties-parameter",
    "VUID-vkGetPastPresentationTimingGOOGLE-commonparent",
    "VUID-vkGetPastPresentationTimingGOOGLE-device-parameter",
    "VUID-vkGetPastPresentationTimingGOOGLE-pPresentationTimingCount-parameter",
    "VUID-vkGetPastPresentationTimingGOOGLE-pPresentationTimings-parameter",
    "VUID-vkGetPastPresentationTimingGOOGLE-swapchain-parameter",
    "VUID-vkGetPerformanceParameterINTEL-device-parameter",
    "VUID-vkGetPerformanceParameterINTEL-pValue-parameter",
    "VUID-vkGetPerformanceParameterINTEL-parameter-parameter",
    "VUID-vkGetPhysicalDeviceCalibrateableTimeDomainsEXT-pTimeDomainCount-parameter",
    "VUID-vkGetPhysicalDeviceCalibrateableTimeDomainsEXT-pTimeDomains-parameter",
    "VUID-vkGetPhysicalDeviceCalibrateableTimeDomainsEXT-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceCooperativeMatrixPropertiesNV-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceCooperativeMatrixPropertiesNV-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceCooperativeMatrixPropertiesNV-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPlaneProperties2KHR-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPlaneProperties2KHR-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPlaneProperties2KHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPlanePropertiesKHR-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPlanePropertiesKHR-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPlanePropertiesKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceDisplayProperties2KHR-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceDisplayProperties2KHR-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceDisplayProperties2KHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPropertiesKHR-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPropertiesKHR-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceDisplayPropertiesKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceExternalBufferProperties-pExternalBufferInfo-parameter",
    "VUID-vkGetPhysicalDeviceExternalBufferProperties-pExternalBufferProperties-parameter",
    "VUID-vkGetPhysicalDeviceExternalBufferProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceExternalFenceProperties-pExternalFenceInfo-parameter",
    "VUID-vkGetPhysicalDeviceExternalFenceProperties-pExternalFenceProperties-parameter",
    "VUID-vkGetPhysicalDeviceExternalFenceProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-externalHandleType-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-flags-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-format-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-pExternalImageFormatProperties-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-tiling-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-type-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-usage-parameter",
    "VUID-vkGetPhysicalDeviceExternalImageFormatPropertiesNV-usage-requiredbitmask",
    "VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-pExternalSemaphoreInfo-parameter",
    "VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-pExternalSemaphoreProperties-parameter",
    "VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceFeatures-pFeatures-parameter",
    "VUID-vkGetPhysicalDeviceFeatures-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceFeatures2-pFeatures-parameter",
    "VUID-vkGetPhysicalDeviceFeatures2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceFormatProperties-format-parameter",
    "VUID-vkGetPhysicalDeviceFormatProperties-pFormatProperties-parameter",
    "VUID-vkGetPhysicalDeviceFormatProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceFormatProperties2-format-parameter",
    "VUID-vkGetPhysicalDeviceFormatProperties2-pFormatProperties-parameter",
    "VUID-vkGetPhysicalDeviceFormatProperties2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-flags-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-format-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-pImageFormatProperties-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-tiling-02248",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-tiling-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-type-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-usage-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties-usage-requiredbitmask",
    "VUID-vkGetPhysicalDeviceImageFormatProperties2-pImageFormatInfo-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties2-pImageFormatProperties-parameter",
    "VUID-vkGetPhysicalDeviceImageFormatProperties2-pNext-01868",
    "VUID-vkGetPhysicalDeviceImageFormatProperties2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceMemoryProperties-pMemoryProperties-parameter",
    "VUID-vkGetPhysicalDeviceMemoryProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceMemoryProperties2-pMemoryProperties-parameter",
    "VUID-vkGetPhysicalDeviceMemoryProperties2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceMultisamplePropertiesEXT-pMultisampleProperties-parameter",
    "VUID-vkGetPhysicalDeviceMultisamplePropertiesEXT-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceMultisamplePropertiesEXT-samples-parameter",
    "VUID-vkGetPhysicalDevicePresentRectanglesKHR-commonparent",
    "VUID-vkGetPhysicalDevicePresentRectanglesKHR-pRectCount-parameter",
    "VUID-vkGetPhysicalDevicePresentRectanglesKHR-pRects-parameter",
    "VUID-vkGetPhysicalDevicePresentRectanglesKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDevicePresentRectanglesKHR-surface-parameter",
    "VUID-vkGetPhysicalDeviceProperties-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceProperties2-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceProperties2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyPerformanceQueryPassesKHR-pNumPasses-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyPerformanceQueryPassesKHR-pPerformanceQueryCreateInfo-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyPerformanceQueryPassesKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyProperties-pQueueFamilyProperties-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyProperties-pQueueFamilyPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyProperties2-pQueueFamilyProperties-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyProperties2-pQueueFamilyPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceQueueFamilyProperties2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-format-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-samples-01094",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-samples-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-tiling-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-type-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-usage-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties-usage-requiredbitmask",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties2-pFormatInfo-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties2-pProperties-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties2-pPropertyCount-parameter",
    "VUID-vkGetPhysicalDeviceSparseImageFormatProperties2-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSupportedFramebufferMixedSamplesCombinationsNV-pCombinationCount-parameter",
    "VUID-vkGetPhysicalDeviceSupportedFramebufferMixedSamplesCombinationsNV-pCombinations-parameter",
    "VUID-vkGetPhysicalDeviceSupportedFramebufferMixedSamplesCombinationsNV-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2EXT-commonparent",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2EXT-pSurfaceCapabilities-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2EXT-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2EXT-surface-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2KHR-pNext-02671",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2KHR-pSurfaceCapabilities-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2KHR-pSurfaceInfo-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilities2KHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-commonparent",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-pSurfaceCapabilities-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-surface-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormats2KHR-pSurfaceFormatCount-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormats2KHR-pSurfaceFormats-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormats2KHR-pSurfaceInfo-02740",
    "VUID-vkGetPhysicalDeviceSurfaceFormats2KHR-pSurfaceInfo-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormats2KHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-commonparent",
    "VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-pSurfaceFormatCount-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-pSurfaceFormats-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-surface-02739",
    "VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-surface-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModes2EXT-pPresentModeCount-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModes2EXT-pPresentModes-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModes2EXT-pSurfaceInfo-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModes2EXT-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-commonparent",
    "VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-pPresentModeCount-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-pPresentModes-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-surface-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceSupportKHR-commonparent",
    "VUID-vkGetPhysicalDeviceSurfaceSupportKHR-pSupported-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceSupportKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceSurfaceSupportKHR-queueFamilyIndex-01269",
    "VUID-vkGetPhysicalDeviceSurfaceSupportKHR-surface-parameter",
    "VUID-vkGetPhysicalDeviceToolPropertiesEXT-pToolCount-parameter",
    "VUID-vkGetPhysicalDeviceToolPropertiesEXT-pToolProperties-parameter",
    "VUID-vkGetPhysicalDeviceToolPropertiesEXT-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceWaylandPresentationSupportKHR-display-parameter",
    "VUID-vkGetPhysicalDeviceWaylandPresentationSupportKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceWaylandPresentationSupportKHR-queueFamilyIndex-01306",
    "VUID-vkGetPhysicalDeviceWin32PresentationSupportKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceWin32PresentationSupportKHR-queueFamilyIndex-01309",
    "VUID-vkGetPhysicalDeviceXcbPresentationSupportKHR-connection-parameter",
    "VUID-vkGetPhysicalDeviceXcbPresentationSupportKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceXcbPresentationSupportKHR-queueFamilyIndex-01312",
    "VUID-vkGetPhysicalDeviceXlibPresentationSupportKHR-dpy-parameter",
    "VUID-vkGetPhysicalDeviceXlibPresentationSupportKHR-physicalDevice-parameter",
    "VUID-vkGetPhysicalDeviceXlibPresentationSupportKHR-queueFamilyIndex-01315",
    "VUID-vkGetPipelineCacheData-device-parameter",
    "VUID-vkGetPipelineCacheData-pData-parameter",
    "VUID-vkGetPipelineCacheData-pDataSize-parameter",
    "VUID-vkGetPipelineCacheData-pipelineCache-parameter",
    "VUID-vkGetPipelineCacheData-pipelineCache-parent",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-device-parameter",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-pExecutableInfo-parameter",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-pInternalRepresentationCount-parameter",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-pInternalRepresentations-parameter",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-pipeline-03277",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-pipeline-03278",
    "VUID-vkGetPipelineExecutableInternalRepresentationsKHR-pipelineExecutableInfo-03276",
    "VUID-vkGetPipelineExecutablePropertiesKHR-device-parameter",
    "VUID-vkGetPipelineExecutablePropertiesKHR-pExecutableCount-parameter",
    "VUID-vkGetPipelineExecutablePropertiesKHR-pPipelineInfo-parameter",
    "VUID-vkGetPipelineExecutablePropertiesKHR-pProperties-parameter",
    "VUID-vkGetPipelineExecutablePropertiesKHR-pipeline-03271",
    "VUID-vkGetPipelineExecutablePropertiesKHR-pipelineExecutableInfo-03270",
    "VUID-vkGetPipelineExecutableStatisticsKHR-device-parameter",
    "VUID-vkGetPipelineExecutableStatisticsKHR-pExecutableInfo-parameter",
    "VUID-vkGetPipelineExecutableStatisticsKHR-pStatisticCount-parameter",
    "VUID-vkGetPipelineExecutableStatisticsKHR-pStatistics-parameter",
    "VUID-vkGetPipelineExecutableStatisticsKHR-pipeline-03273",
    "VUID-vkGetPipelineExecutableStatisticsKHR-pipeline-03274",
    "VUID-vkGetPipelineExecutableStatisticsKHR-pipelineExecutableInfo-03272",
    "VUID-vkGetPrivateDataEXT-device-parameter",
    "VUID-vkGetPrivateDataEXT-objectType-04018",
    "VUID-vkGetPrivateDataEXT-objectType-parameter",
    "VUID-vkGetPrivateDataEXT-pData-parameter",
    "VUID-vkGetPrivateDataEXT-privateDataSlot-parameter",
    "VUID-vkGetPrivateDataEXT-privateDataSlot-parent",
    "VUID-vkGetQueryPoolResults-dataSize-00817",
    "VUID-vkGetQueryPoolResults-dataSize-arraylength",
    "VUID-vkGetQueryPoolResults-device-parameter",
    "VUID-vkGetQueryPoolResults-firstQuery-00813",
    "VUID-vkGetQueryPoolResults-firstQuery-00816",
    "VUID-vkGetQueryPoolResults-flags-00815",
    "VUID-vkGetQueryPoolResults-flags-02827",
    "VUID-vkGetQueryPoolResults-flags-02828",
    "VUID-vkGetQueryPoolResults-flags-parameter",
    "VUID-vkGetQueryPoolResults-pData-parameter",
    "VUID-vkGetQueryPoolResults-queryPool-parameter",
    "VUID-vkGetQueryPoolResults-queryPool-parent",
    "VUID-vkGetQueryPoolResults-queryType-00818",
    "VUID-vkGetQueryPoolResults-queryType-03229",
    "VUID-vkGetQueryPoolResults-queryType-03230",
    "VUID-vkGetQueryPoolResults-queryType-03231",
    "VUID-vkGetQueueCheckpointDataNV-pCheckpointData-parameter",
    "VUID-vkGetQueueCheckpointDataNV-pCheckpointDataCount-parameter",
    "VUID-vkGetQueueCheckpointDataNV-queue-02025",
    "VUID-vkGetQueueCheckpointDataNV-queue-parameter",
    "VUID-vkGetRandROutputDisplayEXT-dpy-parameter",
    "VUID-vkGetRandROutputDisplayEXT-pDisplay-parameter",
    "VUID-vkGetRandROutputDisplayEXT-physicalDevice-parameter",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-dataSize-03484",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-dataSize-arraylength",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-device-parameter",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-firstGroup-03483",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-firstGroup-04051",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-pData-parameter",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-pipeline-parameter",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-pipeline-parent",
    "VUID-vkGetRayTracingCaptureReplayShaderGroupHandlesKHR-rayTracingShaderGroupHandleCaptureReplay-03485",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-dataSize-02420",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-dataSize-arraylength",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-device-parameter",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-firstGroup-02419",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-firstGroup-04050",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-pData-parameter",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-pipeline-03482",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-pipeline-parameter",
    "VUID-vkGetRayTracingShaderGroupHandlesKHR-pipeline-parent",
    "VUID-vkGetRefreshCycleDurationGOOGLE-commonparent",
    "VUID-vkGetRefreshCycleDurationGOOGLE-device-parameter",
    "VUID-vkGetRefreshCycleDurationGOOGLE-pDisplayTimingProperties-parameter",
    "VUID-vkGetRefreshCycleDurationGOOGLE-swapchain-parameter",
    "VUID-vkGetRenderAreaGranularity-device-parameter",
    "VUID-vkGetRenderAreaGranularity-pGranularity-parameter",
    "VUID-vkGetRenderAreaGranularity-renderPass-parameter",
    "VUID-vkGetRenderAreaGranularity-renderPass-parent",
    "VUID-vkGetSemaphoreCounterValue-device-parameter",
    "VUID-vkGetSemaphoreCounterValue-pValue-parameter",
    "VUID-vkGetSemaphoreCounterValue-semaphore-03255",
    "VUID-vkGetSemaphoreCounterValue-semaphore-parameter",
    "VUID-vkGetSemaphoreCounterValue-semaphore-parent",
    "VUID-vkGetSemaphoreFdKHR-device-parameter",
    "VUID-vkGetSemaphoreFdKHR-pFd-parameter",
    "VUID-vkGetSemaphoreFdKHR-pGetFdInfo-parameter",
    "VUID-vkGetSemaphoreWin32HandleKHR-device-parameter",
    "VUID-vkGetSemaphoreWin32HandleKHR-pGetWin32HandleInfo-parameter",
    "VUID-vkGetSemaphoreWin32HandleKHR-pHandle-parameter",
    "VUID-vkGetShaderInfoAMD-device-parameter",
    "VUID-vkGetShaderInfoAMD-infoType-parameter",
    "VUID-vkGetShaderInfoAMD-pInfo-parameter",
    "VUID-vkGetShaderInfoAMD-pInfoSize-parameter",
    "VUID-vkGetShaderInfoAMD-pipeline-parameter",
    "VUID-vkGetShaderInfoAMD-pipeline-parent",
    "VUID-vkGetShaderInfoAMD-shaderStage-parameter",
    "VUID-vkGetSwapchainCounterEXT-commonparent",
    "VUID-vkGetSwapchainCounterEXT-counter-parameter",
    "VUID-vkGetSwapchainCounterEXT-device-parameter",
    "VUID-vkGetSwapchainCounterEXT-pCounterValue-parameter",
    "VUID-vkGetSwapchainCounterEXT-swapchain-01245",
    "VUID-vkGetSwapchainCounterEXT-swapchain-parameter",
    "VUID-vkGetSwapchainImagesKHR-commonparent",
    "VUID-vkGetSwapchainImagesKHR-device-parameter",
    "VUID-vkGetSwapchainImagesKHR-pSwapchainImageCount-parameter",
    "VUID-vkGetSwapchainImagesKHR-pSwapchainImages-parameter",
    "VUID-vkGetSwapchainImagesKHR-swapchain-parameter",
    "VUID-vkGetSwapchainStatusKHR-commonparent",
    "VUID-vkGetSwapchainStatusKHR-device-parameter",
    "VUID-vkGetSwapchainStatusKHR-swapchain-parameter",
    "VUID-vkGetValidationCacheDataEXT-device-parameter",
    "VUID-vkGetValidationCacheDataEXT-pData-parameter",
    "VUID-vkGetValidationCacheDataEXT-pDataSize-parameter",
    "VUID-vkGetValidationCacheDataEXT-validationCache-parameter",
    "VUID-vkGetValidationCacheDataEXT-validationCache-parent",
    "VUID-vkImportFenceFdKHR-device-parameter",
    "VUID-vkImportFenceFdKHR-fence-01463",
    "VUID-vkImportFenceFdKHR-pImportFenceFdInfo-parameter",
    "VUID-vkImportFenceWin32HandleKHR-device-parameter",
    "VUID-vkImportFenceWin32HandleKHR-pImportFenceWin32HandleInfo-parameter",
    "VUID-vkImportSemaphoreFdKHR-device-parameter",
    "VUID-vkImportSemaphoreFdKHR-pImportSemaphoreFdInfo-parameter",
    "VUID-vkImportSemaphoreFdKHR-semaphore-01142",
    "VUID-vkImportSemaphoreWin32HandleKHR-device-parameter",
    "VUID-vkImportSemaphoreWin32HandleKHR-pImportSemaphoreWin32HandleInfo-parameter",
    "VUID-vkInitializePerformanceApiINTEL-device-parameter",
    "VUID-vkInitializePerformanceApiINTEL-pInitializeInfo-parameter",
    "VUID-vkInvalidateMappedMemoryRanges-device-parameter",
    "VUID-vkInvalidateMappedMemoryRanges-memoryRangeCount-arraylength",
    "VUID-vkInvalidateMappedMemoryRanges-pMemoryRanges-parameter",
    "VUID-vkMapMemory-device-parameter",
    "VUID-vkMapMemory-flags-zerobitmask",
    "VUID-vkMapMemory-memory-00678",
    "VUID-vkMapMemory-memory-00682",
    "VUID-vkMapMemory-memory-00683",
    "VUID-vkMapMemory-memory-parameter",
    "VUID-vkMapMemory-memory-parent",
    "VUID-vkMapMemory-offset-00679",
    "VUID-vkMapMemory-ppData-parameter",
    "VUID-vkMapMemory-size-00680",
    "VUID-vkMapMemory-size-00681",
    "VUID-vkMergePipelineCaches-device-parameter",
    "VUID-vkMergePipelineCaches-dstCache-00770",
    "VUID-vkMergePipelineCaches-dstCache-parameter",
    "VUID-vkMergePipelineCaches-dstCache-parent",
    "VUID-vkMergePipelineCaches-pSrcCaches-parameter",
    "VUID-vkMergePipelineCaches-pSrcCaches-parent",
    "VUID-vkMergePipelineCaches-srcCacheCount-arraylength",
    "VUID-vkMergeValidationCachesEXT-device-parameter",
    "VUID-vkMergeValidationCachesEXT-dstCache-01536",
    "VUID-vkMergeValidationCachesEXT-dstCache-parameter",
    "VUID-vkMergeValidationCachesEXT-dstCache-parent",
    "VUID-vkMergeValidationCachesEXT-pSrcCaches-parameter",
    "VUID-vkMergeValidationCachesEXT-pSrcCaches-parent",
    "VUID-vkMergeValidationCachesEXT-srcCacheCount-arraylength",
    "VUID-vkQueueBeginDebugUtilsLabelEXT-pLabelInfo-parameter",
    "VUID-vkQueueBeginDebugUtilsLabelEXT-queue-parameter",
    "VUID-vkQueueBindSparse-commonparent",
    "VUID-vkQueueBindSparse-fence-01113",
    "VUID-vkQueueBindSparse-fence-01114",
    "VUID-vkQueueBindSparse-fence-parameter",
    "VUID-vkQueueBindSparse-pBindInfo-parameter",
    "VUID-vkQueueBindSparse-pSignalSemaphores-01115",
    "VUID-vkQueueBindSparse-pWaitSemaphores-01116",
    "VUID-vkQueueBindSparse-pWaitSemaphores-01117",
    "VUID-vkQueueBindSparse-pWaitSemaphores-03245",
    "VUID-vkQueueBindSparse-queue-parameter",
    "VUID-vkQueueBindSparse-queuetype",
    "VUID-vkQueueEndDebugUtilsLabelEXT-None-01911",
    "VUID-vkQueueEndDebugUtilsLabelEXT-queue-parameter",
    "VUID-vkQueueInsertDebugUtilsLabelEXT-pLabelInfo-parameter",
    "VUID-vkQueueInsertDebugUtilsLabelEXT-queue-parameter",
    "VUID-vkQueuePresentKHR-pPresentInfo-parameter",
    "VUID-vkQueuePresentKHR-pSwapchains-01292",
    "VUID-vkQueuePresentKHR-pSwapchains-01293",
    "VUID-vkQueuePresentKHR-pWaitSemaphores-01294",
    "VUID-vkQueuePresentKHR-pWaitSemaphores-01295",
    "VUID-vkQueuePresentKHR-pWaitSemaphores-03267",
    "VUID-vkQueuePresentKHR-pWaitSemaphores-03268",
    "VUID-vkQueuePresentKHR-queue-parameter",
    "VUID-vkQueueSetPerformanceConfigurationINTEL-commonparent",
    "VUID-vkQueueSetPerformanceConfigurationINTEL-configuration-parameter",
    "VUID-vkQueueSetPerformanceConfigurationINTEL-queue-parameter",
    "VUID-vkQueueSubmit-commonparent",
    "VUID-vkQueueSubmit-fence-00063",
    "VUID-vkQueueSubmit-fence-00064",
    "VUID-vkQueueSubmit-fence-parameter",
    "VUID-vkQueueSubmit-pCommandBuffers-00065",
    "VUID-vkQueueSubmit-pCommandBuffers-00070",
    "VUID-vkQueueSubmit-pCommandBuffers-00071",
    "VUID-vkQueueSubmit-pCommandBuffers-00072",
    "VUID-vkQueueSubmit-pCommandBuffers-00073",
    "VUID-vkQueueSubmit-pCommandBuffers-00074",
    "VUID-vkQueueSubmit-pCommandBuffers-03220",
    "VUID-vkQueueSubmit-pSignalSemaphores-00067",
    "VUID-vkQueueSubmit-pSubmits-02207",
    "VUID-vkQueueSubmit-pSubmits-02808",
    "VUID-vkQueueSubmit-pSubmits-parameter",
    "VUID-vkQueueSubmit-pWaitDstStageMask-00066",
    "VUID-vkQueueSubmit-pWaitSemaphores-00068",
    "VUID-vkQueueSubmit-pWaitSemaphores-00069",
    "VUID-vkQueueSubmit-pWaitSemaphores-03238",
    "VUID-vkQueueSubmit-queue-parameter",
    "VUID-vkQueueWaitIdle-queue-parameter",
    "VUID-vkRegisterDeviceEventEXT-device-parameter",
    "VUID-vkRegisterDeviceEventEXT-pAllocator-parameter",
    "VUID-vkRegisterDeviceEventEXT-pDeviceEventInfo-parameter",
    "VUID-vkRegisterDeviceEventEXT-pFence-parameter",
    "VUID-vkRegisterDisplayEventEXT-commonparent",
    "VUID-vkRegisterDisplayEventEXT-device-parameter",
    "VUID-vkRegisterDisplayEventEXT-display-parameter",
    "VUID-vkRegisterDisplayEventEXT-pAllocator-parameter",
    "VUID-vkRegisterDisplayEventEXT-pDisplayEventInfo-parameter",
    "VUID-vkRegisterDisplayEventEXT-pFence-parameter",
    "VUID-vkReleaseDisplayEXT-display-parameter",
    "VUID-vkReleaseDisplayEXT-display-parent",
    "VUID-vkReleaseDisplayEXT-physicalDevice-parameter",
    "VUID-vkReleaseFullScreenExclusiveModeEXT-swapchain-02677",
    "VUID-vkReleaseFullScreenExclusiveModeEXT-swapchain-02678",
    "VUID-vkReleasePerformanceConfigurationINTEL-configuration-02737",
    "VUID-vkReleasePerformanceConfigurationINTEL-configuration-parameter",
    "VUID-vkReleasePerformanceConfigurationINTEL-configuration-parent",
    "VUID-vkReleasePerformanceConfigurationINTEL-device-parameter",
    "VUID-vkReleaseProfilingLockKHR-device-03235",
    "VUID-vkReleaseProfilingLockKHR-device-parameter",
    "VUID-vkResetCommandBuffer-commandBuffer-00045",
    "VUID-vkResetCommandBuffer-commandBuffer-00046",
    "VUID-vkResetCommandBuffer-commandBuffer-parameter",
    "VUID-vkResetCommandBuffer-flags-parameter",
    "VUID-vkResetCommandPool-commandPool-00040",
    "VUID-vkResetCommandPool-commandPool-parameter",
    "VUID-vkResetCommandPool-commandPool-parent",
    "VUID-vkResetCommandPool-device-parameter",
    "VUID-vkResetCommandPool-flags-parameter",
    "VUID-vkResetDescriptorPool-descriptorPool-00313",
    "VUID-vkResetDescriptorPool-descriptorPool-parameter",
    "VUID-vkResetDescriptorPool-descriptorPool-parent",
    "VUID-vkResetDescriptorPool-device-parameter",
    "VUID-vkResetDescriptorPool-flags-zerobitmask",
    "VUID-vkResetEvent-device-parameter",
    "VUID-vkResetEvent-event-01148",
    "VUID-vkResetEvent-event-parameter",
    "VUID-vkResetEvent-event-parent",
    "VUID-vkResetFences-device-parameter",
    "VUID-vkResetFences-fenceCount-arraylength",
    "VUID-vkResetFences-pFences-01123",
    "VUID-vkResetFences-pFences-parameter",
    "VUID-vkResetFences-pFences-parent",
    "VUID-vkResetQueryPool-None-02665",
    "VUID-vkResetQueryPool-device-parameter",
    "VUID-vkResetQueryPool-firstQuery-02666",
    "VUID-vkResetQueryPool-firstQuery-02667",
    "VUID-vkResetQueryPool-firstQuery-02741",
    "VUID-vkResetQueryPool-firstQuery-02742",
    "VUID-vkResetQueryPool-queryPool-parameter",
    "VUID-vkResetQueryPool-queryPool-parent",
    "VUID-vkSetDebugUtilsObjectNameEXT-device-parameter",
    "VUID-vkSetDebugUtilsObjectNameEXT-pNameInfo-02587",
    "VUID-vkSetDebugUtilsObjectNameEXT-pNameInfo-02588",
    "VUID-vkSetDebugUtilsObjectNameEXT-pNameInfo-parameter",
    "VUID-vkSetDebugUtilsObjectTagEXT-device-parameter",
    "VUID-vkSetDebugUtilsObjectTagEXT-pTagInfo-parameter",
    "VUID-vkSetEvent-device-parameter",
    "VUID-vkSetEvent-event-parameter",
    "VUID-vkSetEvent-event-parent",
    "VUID-vkSetHdrMetadataEXT-commonparent",
    "VUID-vkSetHdrMetadataEXT-device-parameter",
    "VUID-vkSetHdrMetadataEXT-pMetadata-parameter",
    "VUID-vkSetHdrMetadataEXT-pSwapchains-parameter",
    "VUID-vkSetHdrMetadataEXT-swapchainCount-arraylength",
    "VUID-vkSetLocalDimmingAMD-XXXXX",
    "VUID-vkSetLocalDimmingAMD-commonparent",
    "VUID-vkSetLocalDimmingAMD-device-parameter",
    "VUID-vkSetLocalDimmingAMD-swapChain-parameter",
    "VUID-vkSetPrivateDataEXT-device-parameter",
    "VUID-vkSetPrivateDataEXT-objectHandle-04016",
    "VUID-vkSetPrivateDataEXT-objectHandle-04017",
    "VUID-vkSetPrivateDataEXT-objectType-parameter",
    "VUID-vkSetPrivateDataEXT-privateDataSlot-parameter",
    "VUID-vkSetPrivateDataEXT-privateDataSlot-parent",
    "VUID-vkSignalSemaphore-device-parameter",
    "VUID-vkSignalSemaphore-pSignalInfo-parameter",
    "VUID-vkSubmitDebugUtilsMessageEXT-instance-parameter",
    "VUID-vkSubmitDebugUtilsMessageEXT-messageSeverity-parameter",
    "VUID-vkSubmitDebugUtilsMessageEXT-messageTypes-parameter",
    "VUID-vkSubmitDebugUtilsMessageEXT-messageTypes-requiredbitmask",
    "VUID-vkSubmitDebugUtilsMessageEXT-objectType-02591",
    "VUID-vkSubmitDebugUtilsMessageEXT-pCallbackData-parameter",
    "VUID-vkTrimCommandPool-commandPool-parameter",
    "VUID-vkTrimCommandPool-commandPool-parent",
    "VUID-vkTrimCommandPool-device-parameter",
    "VUID-vkTrimCommandPool-flags-zerobitmask",
    "VUID-vkUninitializePerformanceApiINTEL-device-parameter",
    "VUID-vkUnmapMemory-device-parameter",
    "VUID-vkUnmapMemory-memory-00689",
    "VUID-vkUnmapMemory-memory-parameter",
    "VUID-vkUnmapMemory-memory-parent",
    "VUID-vkUpdateDescriptorSetWithTemplate-descriptorSet-parameter",
    "VUID-vkUpdateDescriptorSetWithTemplate-descriptorUpdateTemplate-parameter",
    "VUID-vkUpdateDescriptorSetWithTemplate-descriptorUpdateTemplate-parent",
    "VUID-vkUpdateDescriptorSetWithTemplate-device-parameter",
    "VUID-vkUpdateDescriptorSetWithTemplate-pData-01685",
    "VUID-vkUpdateDescriptorSets-None-03047",
    "VUID-vkUpdateDescriptorSets-device-parameter",
    "VUID-vkUpdateDescriptorSets-dstSet-00314",
    "VUID-vkUpdateDescriptorSets-pDescriptorCopies-parameter",
    "VUID-vkUpdateDescriptorSets-pDescriptorWrites-parameter",
    "VUID-vkWaitForFences-device-parameter",
    "VUID-vkWaitForFences-fenceCount-arraylength",
    "VUID-vkWaitForFences-pFences-parameter",
    "VUID-vkWaitForFences-pFences-parent",
    "VUID-vkWaitSemaphores-device-parameter",
    "VUID-vkWaitSemaphores-pWaitInfo-parameter",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-accelerationStructureCount-arraylength",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-accelerationStructures-03431",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-dataSize-03452",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-dataSize-arraylength",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-device-parameter",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-pAccelerationStructures-03453",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-pAccelerationStructures-parameter",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-pAccelerationStructures-parent",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-pData-parameter",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-queryType-03432",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-queryType-03448",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-queryType-03449",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-queryType-03450",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-queryType-03451",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-queryType-parameter",
    "VUID-vkWriteAccelerationStructuresPropertiesKHR-rayTracingHostAccelerationStructureCommands-03454",
    "UNASSIGNED-CoreValidation-BindImageMemory-Swapchain",
    "UNASSIGNED-CoreValidation-BoundResourceFreedMemoryAccess",
    "UNASSIGNED-CoreValidation-DevLimit-MustQueryCount",
    "UNASSIGNED-CoreValidation-DrawState-CommandBufferSingleSubmitViolation",
    "UNASSIGNED-CoreValidation-DrawState-DescriptorSetNotBound",
    "UNASSIGNED-CoreValidation-DrawState-DescriptorSetNotUpdated",
    "UNASSIGNED-CoreValidation-DrawState-DoubleDestroy",
    "UNASSIGNED-CoreValidation-DrawState-ExtensionNotEnabled",
    "UNASSIGNED-CoreValidation-DrawState-InternalError",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkAccelerationStructureNV",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBufferSimultaneousUse",
    "UNASSIGNED-CoreValidation-DrawState-InvalidDescriptorSet",
    "UNASSIGNED-CoreValidation-DrawState-InvalidEvent",
    "UNASSIGNED-CoreValidation-DrawState-InvalidExtents",
    "UNASSIGNED-CoreValidation-DrawState-InvalidFeature",
    "UNASSIGNED-CoreValidation-DrawState-InvalidFence",
    "UNASSIGNED-CoreValidation-DrawState-InvalidImageAspect",
    "UNASSIGNED-CoreValidation-DrawState-InvalidImageLayout",
    "UNASSIGNED-CoreValidation-DrawState-InvalidImageView",
    "UNASSIGNED-CoreValidation-DrawState-InvalidPipelineCreateState",
    "UNASSIGNED-CoreValidation-DrawState-InvalidQuery",
    "UNASSIGNED-CoreValidation-DrawState-InvalidQueueFamily",
    "UNASSIGNED-CoreValidation-DrawState-InvalidRenderArea",
    "UNASSIGNED-CoreValidation-DrawState-InvalidRenderpass",
    "UNASSIGNED-CoreValidation-DrawState-InvalidSecondaryCommandBuffer",
    "UNASSIGNED-CoreValidation-DrawState-InvalidSet",
    "UNASSIGNED-CoreValidation-DrawState-InvalidVtxAttributeAlignment",
    "UNASSIGNED-CoreValidation-DrawState-MismatchedImageType",
    "UNASSIGNED-CoreValidation-DrawState-MissingAttachmentReference",
    "UNASSIGNED-CoreValidation-DrawState-NoActiveRenderpass",
    "UNASSIGNED-CoreValidation-DrawState-NoEndCommandBuffer",
    "UNASSIGNED-CoreValidation-DrawState-NumSamplesMismatch",
    "UNASSIGNED-CoreValidation-DrawState-PipelineLayoutsIncompatible",
    "UNASSIGNED-CoreValidation-DrawState-QueryNotReset",
    "UNASSIGNED-CoreValidation-DrawState-QueueForwardProgress",
    "UNASSIGNED-CoreValidation-DrawState-SwapchainImageNotAcquired",
    "UNASSIGNED-CoreValidation-DrawState-SwapchainImagesNotFound",
    "UNASSIGNED-CoreValidation-DrawState-SwapchainInvalidImage",
    "UNASSIGNED-CoreValidation-DrawState-SwapchainUnsupportedQueue",
    "UNASSIGNED-CoreValidation-DrawState-ViewportScissorMismatch",
    "UNASSIGNED-CoreValidation-Image-InvalidFormatLimitsViolation",
    "UNASSIGNED-CoreValidation-Image-ZeroAreaSubregion",
    "UNASSIGNED-CoreValidation-MemTrack-FenceState",
    "UNASSIGNED-CoreValidation-MemTrack-InvalidMap",
    "UNASSIGNED-CoreValidation-MemTrack-InvalidUsageFlag",
    "UNASSIGNED-CoreValidation-MemTrack-RebindObject",
    "UNASSIGNED-CoreValidation-Shader-CooperativeMatrixMulAdd",
    "UNASSIGNED-CoreValidation-Shader-CooperativeMatrixSupportedStages",
    "UNASSIGNED-CoreValidation-Shader-CooperativeMatrixType",
    "UNASSIGNED-CoreValidation-Shader-DescriptorNotAccessibleFromStage",
    "UNASSIGNED-CoreValidation-Shader-DescriptorTypeMismatch",
    "UNASSIGNED-CoreValidation-Shader-ExceedDeviceLimit",
    "UNASSIGNED-CoreValidation-Shader-FeatureNotEnabled",
    "UNASSIGNED-CoreValidation-Shader-InconsistentSpirv",
    "UNASSIGNED-CoreValidation-Shader-InconsistentVi",
    "UNASSIGNED-CoreValidation-Shader-InputAttachmentTypeMismatch",
    "UNASSIGNED-CoreValidation-Shader-InputNotProduced",
    "UNASSIGNED-CoreValidation-Shader-InterfaceTypeMismatch",
    "UNASSIGNED-CoreValidation-Shader-MissingDescriptor",
    "UNASSIGNED-CoreValidation-Shader-MissingInputAttachment",
    "UNASSIGNED-CoreValidation-Shader-NoAlphaAtLocation0WithAlphaToCoverage",
    "UNASSIGNED-CoreValidation-Shader-OutputNotConsumed",
    "UNASSIGNED-CoreValidation-Shader-PointSizeMissing",
    "UNASSIGNED-CoreValidation-Shader-PointSizeOverSpecified",
    "UNASSIGNED-CoreValidation-Shader-PushConstantOutOfRange",
    "UNASSIGNED-CoreValidation-SwapchainInvalidCount",
    "UNASSIGNED-CoreValidation-SwapchainPreTransform",
    "UNASSIGNED-CoreValidation-vkBufferMemoryBarrier-sharing-mode-exclusive-same-family",
    "UNASSIGNED-CoreValidation-vkCmdBuildAccelerationStructureNV-scratch-requirements",
    "UNASSIGNED-CoreValidation-vkCmdBuildAccelerationStructureNV-update-requirements",
    "UNASSIGNED-CoreValidation-vkCmdPushDescriptorSetWithTemplateKHR-descriptorUpdateTemplate-templateType",
    "UNASSIGNED-CoreValidation-vkCmdPushDescriptorSetWithTemplateKHR-layout",
    "UNASSIGNED-CoreValidation-vkCmdPushDescriptorSetWithTemplateKHR-set",
    "UNASSIGNED-CoreValidation-vkImageMemoryBarrier-sharing-mode-exclusive-same-family",
    "UNASSIGNED-Extension",
    "UNASSIGNED-GeneralParameterError-DeviceFeature",
    "UNASSIGNED-GeneralParameterError-DeviceLimit",
    "UNASSIGNED-GeneralParameterError-ExtensionNotEnabled",
    "UNASSIGNED-GeneralParameterError-FailureCode",
    "UNASSIGNED-GeneralParameterError-Info",
    "UNASSIGNED-GeneralParameterError-InvalidStructPNext",
    "UNASSIGNED-GeneralParameterError-InvalidStructSType",
    "UNASSIGNED-GeneralParameterError-InvalidUsage",
    "UNASSIGNED-GeneralParameterError-RequiredParameter",
    "UNASSIGNED-GeneralParameterError-ReservedParameter",
    "UNASSIGNED-GeneralParameterError-UnrecognizedValue",
    "UNASSIGNED-ObjectTracker-ObjectLeak",
    "UNASSIGNED-features-limits-maxComputeWorkGroupInvocations",
    "UNASSIGNED-features-limits-maxComputeWorkGroupSize",
    "UNASSIGNED-vkCmdExecuteCommands-commandBuffer-00001",
    "UNASSIGNED-vkGetAccelerationStructureHandleNV-accelerationStructure-XXXX",
    "UNASSIGNED-BestPractices-DrawState-ClearCmdBeforeDraw",
    "UNASSIGNED-BestPractices-DrawState-VtxIndexOutOfBounds",
    "UNASSIGNED-BestPractices-Error-Result",
    "UNASSIGNED-BestPractices-NonSuccess-Result",
    "UNASSIGNED-BestPractices-vkAllocateDescriptorSets-suboptimal-reuse",
    "UNASSIGNED-BestPractices-vkAllocateMemory-small-allocation",
    "UNASSIGNED-BestPractices-vkBeginCommandBuffer-one-time-submit",
    "UNASSIGNED-BestPractices-vkBeginCommandBuffer-simultaneous-use",
    "UNASSIGNED-BestPractices-vkBindImageMemory-non-lazy-transient-image",
    "UNASSIGNED-BestPractices-vkBindMemory-small-dedicated-allocation",
    "UNASSIGNED-BestPractices-vkCmdBeginRenderPass-attachment-needs-readback",
    "UNASSIGNED-BestPractices-vkCmdClearAttachments-clear-after-load",
    "UNASSIGNED-BestPractices-vkCmdDrawIndexed-many-small-indexed-drawcalls",
    "UNASSIGNED-BestPractices-vkCmdDrawIndexed-post-transform-cache-thrashing",
    "UNASSIGNED-BestPractices-vkCmdDrawIndexed-sparse-index-buffer",
    "UNASSIGNED-BestPractices-vkCmdEndRenderPass-depth-pre-pass-usage",
    "UNASSIGNED-BestPractices-vkCreateCommandPool-command-buffer-reset",
    "UNASSIGNED-BestPractices-vkCreateDevice-RobustBufferAccess",
    "UNASSIGNED-BestPractices-vkCreateDevice-deprecated-extension",
    "UNASSIGNED-BestPractices-vkCreateFramebuffer-attachment-should-not-be-transient",
    "UNASSIGNED-BestPractices-vkCreateGraphicsPipelines-too-many-instanced-vertex-buffers",
    "UNASSIGNED-BestPractices-vkCreateImage-non-transient-ms-image",
    "UNASSIGNED-BestPractices-vkCreateImage-too-large-sample-count",
    "UNASSIGNED-BestPractices-vkCreateInstance-deprecated-extension",
    "UNASSIGNED-BestPractices-vkCreatePipelines-depthbias-zero",
    "UNASSIGNED-BestPractices-vkCreatePipelines-multisampled-blending",
    "UNASSIGNED-BestPractices-vkCreateRenderPass-image-requires-memory",
    "UNASSIGNED-BestPractices-vkCreateSampler-anisotropy",
    "UNASSIGNED-BestPractices-vkCreateSampler-border-clamp-color",
    "UNASSIGNED-BestPractices-vkCreateSampler-different-wrapping-modes",
    "UNASSIGNED-BestPractices-vkCreateSampler-lod-bias",
    "UNASSIGNED-BestPractices-vkCreateSampler-lod-clamping",
    "UNASSIGNED-BestPractices-vkCreateSampler-unnormalized-coordinates",
    "UNASSIGNED-BestPractices-vkCreateSwapchainKHR-suboptimal-swapchain-image-count",
    "UNASSIGNED-BestPractices-vkCreateSwapchainKHR-swapchain-presentmode-not-fifo",
    "UNASSIGNED-CoreValidation-BoundResourceFreedMemoryAccess",
    "UNASSIGNED-CoreValidation-DrawState-DescriptorSetNotBound",
    "UNASSIGNED-CoreValidation-DrawState-DescriptorSetNotUpdated",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffe",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkAccelerationStructureNV",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkBuffer",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkBufferView",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkDescriptorSet",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkDeviceMemory",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkEvent",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkImage",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkPipeline",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkQueryPool",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBuffer-VkSampler",
    "UNASSIGNED-CoreValidation-DrawState-InvalidCommandBufferSimultaneousUse",
    "UNASSIGNED-CoreValidation-DrawState-InvalidImageAspect",
    "UNASSIGNED-CoreValidation-DrawState-InvalidImageLayout",
    "UNASSIGNED-CoreValidation-DrawState-InvalidImageView",
    "UNASSIGNED-CoreValidation-DrawState-InvalidQuery",
    "UNASSIGNED-CoreValidation-DrawState-MismatchedImageType",
    "UNASSIGNED-CoreValidation-DrawState-PipelineLayoutsIncompatible",
    "UNASSIGNED-CoreValidation-DrawState-QueueForwardProgress",
    "UNASSIGNED-CoreValidation-Image-FormatNotSupported",
    "UNASSIGNED-CoreValidation-MemTrack-InvalidUsageFlag",
    "UNASSIGNED-CoreValidation-Shader-CooperativeMatrixMulAdd",
    "UNASSIGNED-CoreValidation-Shader-CooperativeMatrixType",
    "UNASSIGNED-CoreValidation-Shader-InputNotProduced",
    "UNASSIGNED-CoreValidation-SwapchainPreTransform",
    "UNASSIGNED-CoreValidation-vkBufferMemoryBarrier-sharing-mode-exclusive-same-family",
    "UNASSIGNED-CoreValidation-vkImageMemoryBarrier-sharing-mode-exclusive-same-family",
    "UNASSIGNED-Khronos-validation-createinstance-status-message-not-found",
    "UNASSIGNED-ObjectTracker-ObjectLeak",
    "UNASSIGNED-VkBufferMemoryBarrier-buffer-00001",
    "UNASSIGNED-VkBufferMemoryBarrier-buffer-00002",
    "UNASSIGNED-VkBufferMemoryBarrier-buffer-00003",
    "UNASSIGNED-VkBufferMemoryBarrier-buffer-00004",
    "UNASSIGNED-VkImageMemoryBarrier-image-00001",
    "UNASSIGNED-VkImageMemoryBarrier-image-00002",
    "UNASSIGNED-VkImageMemoryBarrier-image-00003",
    "UNASSIGNED-VkImageMemoryBarrier-image-00004",
    "UNASSIGNED-khronos-Validation-debug-build-warning-message",
    "UNASSIGNED-khronos-validation-createinstance-debug-warning-message-not-found",
    "UNASSIGNED-khronos-validation-createinstance-status-message",
    "UNASSIGNED-vkCmdExecuteCommands-commandBuffer-00001",
    "UNASSIGNED-vkGetAccelerationStructureHandleNV-accelerationStructure-XXXX"};
